/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file ANIMATE.H  */

/* This file is the main header file for the ANIMATION module     */
/* it declares all the GLOBAL variables and is the file included  */
/* in all files for the ANIMATOR module                           */


#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <setjmp.h>
#include <windows.h>
#include <commctrl.h>

#include "menuid.h"
#include "strings.h"
#include "astruct.h"
#include "memory.h"
#include "supercls.h"

#define WM_DRAWROBOT (WM_USER+1000)

#define WINDOW_ID_XSIZE 48
#define WINDOW_ID_YSIZE 20
#define WINDOW_ID_VSIZE 60

#ifdef MODULE_ANIMATE
char IniFilename[] = "OPENFX_.INI",
     IniSection[]  = "APREFERENCES",
     IniRenderSection[]  = "RPREFERENCES";
char szMainClass[]="OFX:AnimatorClass",
     szViewClass[]="OFX:AnimatorViewClass",
     szTriViewClass[]="OFX:AnimatorTriViewClass",
     szToolboxClass[]="OFX:AnimatorToolboxClass",
     szToolBtnClass[]="OFX:AnimatorToolBtnClass",
     szQuicktimeClass[]="OFX:AnimatorQuicktimeClass";
HDC  ghdc_triview_Bitmap[3]={NULL,NULL,NULL},ghdc_view_Bitmap=NULL;
HBITMAP ghbm_triview[3]={NULL,NULL,NULL},ghbm_view=NULL,
        ghCameraBitmap=NULL,ghLightBitmap=NULL;
int   EDIT_ACTION=NO,LOADOPERATION=NO,CursorToggle=0,current_message = -1,
      icon_arrow_ids=YES,do_NOT_abort=FALSE,EditUpdateInUse=FALSE,
      UNDO_ACTIVE=NO,UNDO_TYPE=0;
char   *WorkDrive;                      /* from TEMP environment */
char   ruler_name[8];
double ruler=(double)UNIT;
long   rulerx=0,rulery=0,rulerz=0,    /* relative */
       lrulerx=0,lrulery=0,lrulerz=0, /* origin of ruler */
       draw_grid_on=0,grid_on=0,grid_size=UNIT;
long   NpointerX=0,NpointerY=0,NpointerZ=0;
unsigned int FirstTimeRender=1,rendered_flag=0,fail_op=NO,
         tool=NOTOOL,subtool=NOTOOL,
         DrawStatus=0,AllDrawStatus=3,LastAnimatorTool=NOTOOL;
long Nframes=1,CurrentFrame=1,
     global_quickdraw=1,preview_playing=NO,
     show_camera_fov=1,show_light_cones=1,opengl_visible=0,
     coords_visible=0,tools_visible=1,select_visible=0,
     keyframer_docked=1,keyframer_docked_and_visible=0,
     edit_splinetween=0,MaxNodeID=0,FramesPerSec=30,
     use_director=1;
short APsliderH;
double    PIo180,
          SelectedPathPhi=0.0,
          SelectedPathTheta=0.0,
          SelectedPathAlpha=0.0;
point     SelectedPathOffset={0,0,0};
node      *MainNp=NULL,*FirstNp=NULL,
          *SelectedNode=NULL,*SelectedCamera=NULL;
XIP       *MainIp=NULL,*FirstIp=NULL;
object    *SelectedPath=NULL;
pathpoint *SelectedPathPoint=NULL;
short      Nnodes=0,Nground=0,Ncameras=0,Nskys=0,Nrobots=0,
           fileID=0,ANIM=0,NimageProcesses=0;
long       Ndirectors=0;
HBITMAP hbmName[6]={NULL,NULL,NULL,NULL,NULL,NULL};
char    res_str[256];
#define WHERE
#else
extern char IniFilename[],
            IniSection[],
            IniRenderSection[];
extern char szMainClass[],
            szViewClass[],
            szTriViewClass[],
            szToolboxClass[],
            szToolBtnClass[],
            szQuicktimeClass[];
extern HDC ghdc_triview_Bitmap[],ghdc_view_Bitmap;
extern HBITMAP ghbm_triview[],ghbm_view,ghCameraBitmap,ghLightBitmap;
extern int    EDIT_ACTION,LOADOPERATION,CursorToggle,current_message,
              icon_arrow_ids,do_NOT_abort,EditUpdateInUse,
              UNDO_ACTIVE,UNDO_TYPE;
extern char   *WorkDrive;
extern char   ruler_name[];
extern double ruler;
extern long   rulerx,rulery,rulerz,
              lrulerx,lrulery,lrulerz,
              draw_grid_on,grid_on,grid_size;
extern long   NpointerX,NpointerY,NpointerZ,
              TVpointX,TVpointY,TVpointZ,
              TVsizeX,TVsizeY,TVsizeZ,
              Nframes,CurrentFrame,
              global_quickdraw,preview_playing,
              show_camera_fov,show_light_cones,opengl_visible,
              coords_visible,tools_visible,select_visible,
              keyframer_docked,keyframer_docked_and_visible,
              edit_splinetween,MaxNodeID,FramesPerSec,
              use_director;
extern unsigned int FirstTimeRender,rendered_flag,fail_op,
                    tool,subtool,DrawStatus,AllDrawStatus,LastAnimatorTool;
extern double    PIo180,
                 SelectedPathPhi,
                 SelectedPathTheta,
                 SelectedPathAlpha;
extern point     SelectedPathOffset;
extern node      *MainNp,*FirstNp,*SelectedNode,*SelectedCamera;
extern XIP       *MainIp,*FirstIp;
extern object    *SelectedPath;
extern pathpoint *SelectedPathPoint;
extern short      Nnodes,Nground,Nrobots,
                  Nskys,Ncameras,fileID,ANIM,NimageProcesses;
extern long       Ndirectors;
extern HBITMAP hbmName[];
extern char res_str[];
#define WHERE extern
#endif
WHERE FILE *debug;
WHERE ANI_STRUCTURE AniStructure;
WHERE X__MEMORY_MANAGER EviMemoryManager;
WHERE jmp_buf r_buf;
WHERE int stackdepth;
WHERE HMODULE hLibSpin;
WHERE HWND ghwnd_main,ghwnd_triview[3],ghwnd_current,
           ghwnd_view,ghwnd_xscl,ghwnd_info,ghwndTools,
           ghwndCoord1,
           ghwndTimeline,ghwndTimelineChild,ghwndDlgTools,
           ghwndQuicktime,ghwndOpenGLview,ghwndTooltip,
           ghwndSkEdit,ghwndRobotView;
WHERE HPALETTE ghpaletteScreen;
WHERE HFONT  ghFont1,ghFont2;
WHERE HBRUSH ghbrushScreen,ghbrushWindow,
             ghSelectedBrush,ghDeselectedBrush,ghInvertBrush,
             ghRobotBrush;
WHERE HPEN   ghSelectedPen,ghDeselectedPen,ghEditPen,
             ghInvertPen,ghWireframePen,ghCursorPen,
             ghDotSelectedPen,ghDotDeselectedPen,ghDotInvertPen;
WHERE COLORREF gScreenColourRef,gGridColourRef1,gGridColourRef2;
WHERE HINSTANCE ghinst_main;
WHERE BOOL StartedInAnimator,bToolpannelLeft,bToolpannelSmall,
           bBackgroundImage,bAbortedDrawing;
WHERE BOOL tool_move_flag,tool_down_flag;
WHERE long Xres,Yres;
WHERE long WindowBox_view;
WHERE int View,ActiveView,BigCameraView,
          ToolbuttonSize,ToolpannelSpace,
          WindowLeftOrigin,WindowTopOrigin,
          WindowGap,
          TriviewSpaceX,TriviewSpaceY,
          Window0sizeX,Window0sizeY,
          Textheight,Textwidth,
          WindowSizeX[3],WindowSizeY[3],
          WindowCentreX[3],WindowCentreY[3],
          WindowViewXsize,WindowViewYsize,
          InfoWindowSize,KeyframerSize,KeyframerYpos,
          WindowsXmin[3],WindowsYmin[3],
          WindowViewXmin,WindowViewYmin,
          WindowViewSliderXsize,WindowViewSliderYsize,
          WindowViewSliderXpos,WindowViewSliderYpos,
          SelectPointSize;
WHERE double WindowPixelSize;
WHERE long TVpointX,TVpointY,TVpointZ,
           TVcentreX,TVcentreY,TVcentreZ,
           TVsizeX,TVsizeY,TVsizeZ;
WHERE jmp_buf j_buf;
WHERE HCURSOR ghcurWait,ghcurCross,ghcurX,
              ghcurPan,ghcurZout,ghcurZin,ghcurZoom,
              ghcurArrow,ghcurArrow1,
              ghcurMove,ghcurRotate,ghcurScale,
              ghcurTracker,ghcurDirector,
              ghcurPathed,ghcurSkeletor,
              ghcurSave,ghcurInsert,
              ghcurTools[NTOOLS];
WHERE char gszHomeDir[MAX_DIR],gszUndoFile[MAX_FILE];
WHERE char gszSTGfile[MAX_FILE],gszSTGdir[MAX_DIR];
WHERE char gszSCEfile[MAX_FILE],gszSCEdir[MAX_DIR];
WHERE char gszPTHfile[MAX_FILE],gszPTHdir[MAX_DIR];
WHERE char gszSCRfile[MAX_FILE],gszSCRdir[MAX_DIR];
WHERE char gszIMGfile[MAX_FILE],gszIMGdir[MAX_DIR];
WHERE char gszMAPfile[MAX_FILE],gszMAPdir[MAX_DIR];
WHERE char gszDLLfile[MAX_FILE],gszDLLdir[MAX_DIR];
WHERE char gszXIPfile[MAX_FILE],gszXIPdir[MAX_DIR];
WHERE char gszANIfile[MAX_FILE],gszANIdir[MAX_DIR];
WHERE char gszPSTfile[MAX_FILE],gszPSTdir[MAX_DIR];
WHERE char gszPZEfile[MAX_FILE],gszPZEdir[MAX_DIR];
WHERE int gCurTool,gCurCommand,gCurSelect;
WHERE TOOLFLAGS gToolFlags;
WHERE PREFERENCES Preferences;
#undef WHERE

#include "protos.h"
#include "lists.h"
