/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file DIALOGS.H */

/* NB any RADIOBUTTON groups MUST have sequential numbering  */

#define DLG_CHOOSE                  5000
#define DLG_CHOOSE_LIST             5001
#define DLG_CHOOSE_OK               5002
#define DLG_CHOOSE_CANCEL           5003
#define DLG_STRING                  5004
#define DLG_STRING_EDIT             5005
#define DLG_STRING_OK               5006
#define DLG_NUMENTRY                5007
#define DLG_NUMENTRY_EDIT           5008
#define DLG_NUMENTRY_OK             5009
#define DLG_NUMENTRY_CANCEL         5010
#define DLG_NUMENTRY_TEXT           5011
#define DLG_NUMENTRY_SPIN           5012
#define DLG_TIMELINE                5013
#define DLG_TIMELINE_F              5014
#define DLG_TIMELINE_L              5015
#define DLG_TIMELINE_FS             5016
#define DLG_TIMELINE_LS             5017
#define DLG_TIMELINE_UPTO           5018
#define DLG_TIMELINE_FROM           5019
#define DLG_TIMELINE_OK             5020
#define DLG_TIMELINE_CANCEL         5021
#define DLG_GRIDSIZE                5022
#define DLG_GRIDSIZE_ON             5023
#define DLG_GRIDSIZE_OFF            5024
#define DLG_GRIDSIZE_EDIT           5025
#define DLG_GRIDSIZE_OK             5026
#define DLG_GRIDSIZE_CANCEL         5027
#define DLG_COORD                   5028
#define DLG_COORD_NAME              5029
#define DLG_COORD_CAL               5030
#define DLG_COORD_OK                5031
#define DLG_COORD_CANCEL            5032
#define DLG_3REALS                  5033
#define DLG_3REALS_NAME1            5034
#define DLG_3REALS_NAME2            5035
#define DLG_3REALS_NAME3            5036
#define DLG_3REALS_CAL1             5037
#define DLG_3REALS_CAL2             5038
#define DLG_3REALS_CAL3             5039
#define DLG_3REALS_OK               5040
#define DLG_3REALS_CANCEL           5041

#define DLG_LIGHT                   5060
#define DLG_LIGHT_COLOUR            5061
#define DLG_LIGHT_NORMAL            5062
#define DLG_LIGHT_NOSHADOW          5063
#define DLG_LIGHT_SHADOWONLY        5064
#define DLG_LIGHT_SPOTLIGHT         5065
#define DLG_LIGHT_DUMMY             5066
#define DLG_LIGHT_DEPTHCUE          5067
#define DLG_LIGHT_DEPTHCUE_C        5068
#define DLG_LIGHT_DEPTHCUE_L        5069
#define DLG_LIGHT_DEPTHCUE_Q        5070
#define DLG_LIGHTOLD                5071
/* some gaps */
#define DLG_LIGHT_FRAME_FROM        5082
#define DLG_LIGHT_FRAME_SPINF       5083
#define DLG_LIGHT_FRAME_TO          5084
#define DLG_LIGHT_FRAME_SPINT       5085
#define DLG_LIGHT_CANCEL            5086
#define DLG_LIGHT_OK                5087

#define DLG_LINEXTNT                5088
#define DLG_LINEXTNT_OK             5089
#define DLG_LINEXTNT_CANCEL         5090
#define DLG_LINEXTNT_FROM           5091
#define DLG_LINEXTNT_FROM_S         5092
#define DLG_LINEXTNT_TO             5093
#define DLG_LINEXTNT_TO_S           5094
#define DLG_FOLLOWAT                5095
#define DLG_FOLLOWAT_OK             5096
#define DLG_FOLLOWAT_CANCEL         5097
#define DLG_FOLLOWAT_LR             5098
#define DLG_FOLLOWAT_FB             5099
#define DLG_FOLLOWAT_UD             5100
#define DLG_SCALE                   5101
#define DLG_SCALE_OK                5102
#define DLG_SCALE_CANCEL            5103
#define DLG_SCALE_FROM              5104
#define DLG_SCALE_FROM_S            5105
#define DLG_SCALE_TO                5106
#define DLG_SCALE_TO_S              5107
#define DLG_SCALE_W                 5108
#define DLG_SCALE_L                 5109
#define DLG_SCALE_H                 5110
#define DLG_SCALE_RESET             5111
#define DLG_SCALE_STORE             5112
#define DLG_SCALE_SET               5113
#define DLG_SCALE_BOUNCY_OFF        5114
#define DLG_SCALE_BOUNCY_ON         5115
#define DLG_SCALE_DELETE            5282
#define DLG_SCALE_CUT               5116
#define DLG_SCALE_COPY              5349
#define DLG_SCALEC                  5117
#define DLG_SCALEC_OK               5118
#define DLG_SCALEC_CANCEL           5119
#define DLG_SCALEC_FROM             5120
#define DLG_SCALEC_FROM_S           5121
#define DLG_SCALEC_TO               5122
#define DLG_SCALEC_TO_S             5123
#define DLG_SCALEC_PRESET           5124
#define DLG_SCALEC_LENS             5125
#define DLG_SCALEC_LENS_S           5126
#define DLG_SCALEC_FOV              5127
#define DLG_SCALEC_AR               5128
#define DLG_SCALEC_DELETE           5129
#define DLG_SCALEC_CUT              5130
#define DLG_SIZER                   5145
#define DLG_SIZER_X                 5146
#define DLG_SIZER_Y                 5147
#define DLG_SIZER_Z                 5148
#define DLG_ROTATOR                 5149
#define DLG_ROTATOR_X               5150
#define DLG_ROTATOR_Y               5151
#define DLG_ROTATOR_Z               5152
#define DLG_TRACK                   5153
#define DLG_TRACK_MOVE              5154
#define DLG_TRACK_TIMESHIFT         5155
#define DLG_TRACK_DELETE            5156
#define DLG_TRACK_TENSION           5157
#define DLG_ADDACTOR                5158
#define DLG_ADDACTOR_LISTBOX        5159
#define DLG_ADDACTOR_NAME           5160
#define DLG_ADDACTOR_CANCEL         5161
#define DLG_ADDACTOR_OK             5162
#define DLG_DIRECT                  5163
#define DLG_DIRECT_MOVE             5164
#define DLG_DIRECT_TIMESHIFT        5165
#define DLG_DIRECT_DELETE           5166
#define DLG_DIRECT_TENSION          5167
#define DLG_CHOOSE_WIDE             5168
#define DLG_SETFRAMES               5169
#define DLG_SETFRAMES_EDIT          5170
#define DLG_SETFRAMES_SPIN          5171
#define DLG_SETFRAMES_OK            5172
#define DLG_SETFRAMES_CANCEL        5173
#define DLG_SETFRAMES_EXTEND        5174
#define DLG_SETFRAMES_BLANKS        5175
#define DLG_SETFRAMES_SCALE         5176
#define DLG_SETFRAMES_CHOP          5177
#define DLG_SETFRAMES_TYPE          5393
#define DLG_SETFRAMES_TIME          5394

#define DLG_TIMELINE_POSITION       5178
#define DLG_TIMELINE_FOLLOW         5179
#define DLG_TIMELINE_ST             5180
#define DLG_TIMELINE_FO             5181
#define DLG_TIMELINE_FON            5182
#define DLG_TIMELINE_FAT            5183
#define DLG_TIMELINE_PT             5184
#define DLG_TIMELINE_FOFF           5185
#define DLG_TIMELINE_ROTATION       5186
#define DLG_KEYMAKER                5187
#define DLG_KEYMAKER_GOTO           5188
#define DLG_KEYMAKER_MAKE           5189
#define DLG_KEYMAKER_CANCEL         5190
#define DLG_LINEOPT                 5191
#define DLG_LINEOPT_T1              5192
#define DLG_LINEOPT_T2              5193
#define DLG_LINEOPT_T3              5194
#define DLG_LINEOPT_CANCEL          5195
#define DLG_LINEOPT_EDIT            5196
#define DLG_LINEOPT_DELETE          5197
#define DLG_LINEOPT_CUT             5198
#define DLG_LINEOPT_COPY            5199


#define DLG_TLEP                    5215
#define DLG_TLEP_F                  5216
#define DLG_TLEP_L                  5217
#define DLG_TLEP_FS                 5218
#define DLG_TLEP_LS                 5219
#define DLG_TLEP_OK                 5220
#define DLG_TLEP_CANCEL             5221
#define DLG_TLEP_PT                 5222
#define DLG_TLEP_FOLLOW             5223
#define DLG_TLEP_ST                 5224
#define DLG_TLEP_FOFF               5225
#define DLG_TLEP_FON                5226
#define DLG_TLEP_FAT                5227
#define DLG_TLEP_FOLLOWED           5228
#define DLG_TLEP_DELETE             5229
#define DLG_TLEP_CUT                5230
#define DLG_TLEP_SELECT             5231
#define DLG_TLEP_X                  5232
#define DLG_TLEP_Y                  5233
#define DLG_TLEP_Z                  5234
#define DLG_TLEP_COPY               5347

#define DLG_MORPH                   5235
#define DLG_MORPH_OFF               5236
#define DLG_MORPH_LINEAR            5237
#define DLG_MORPH_QUADRATIC         5238
#define DLG_TLER                    5239
#define DLG_TLER_PT                 5240
#define DLG_TLER_ST                 5241
#define DLG_TLER_TOPATH             5242
#define DLG_TLER_LOOKAT             5243
#define DLG_TLER_MIMIC              5244
#define DLG_TLER_FOLLOWED           5245
#define DLG_TLER_SELECT             5246
#define DLG_TLER_F                  5247
#define DLG_TLER_L                  5248
#define DLG_TLER_FS                 5249
#define DLG_TLER_LS                 5250
#define DLG_TLER_NA                 5251
#define DLG_TLER_VA                 5252
#define DLG_TLER_SA                 5253
#define DLG_TLER_FA                 5254
#define DLG_TLER_CLOCK              5255
#define DLG_TLER_ACLOCK             5256
#define DLG_TLER_OK                 5257
#define DLG_TLER_CANCEL             5258
#define DLG_TLER_DELETE             5259
#define DLG_TLER_CUT                5260
#define DLG_TLER_PHI                5261
#define DLG_TLER_ALPHA              5262
#define DLG_TLER_THETA              5263
#define DLG_TLER_COPY               5348
#define DLG_PATHTYPE                5264
#define DLG_PATHTYPE_OPEN           5265
#define DLG_PATHTYPE_CLOSED         5266
#define DLG_PATHTYPE_LOAD           5267
#define DLG_PATHTYPE_COPY           5268
#define DLG_CSG                     5269
#define DLG_CSG_SPHERE              5270
#define DLG_CSG_TUBE                5271
#define DLG_CSG_CYLINDER            5272
#define DLG_CSG_DISK                5273
#define DLG_CSG_COLOUR              5274
#define DLG_CSG_ADD                 5275
#define DLG_CSG_SUB                 5276
#define DLG_CSG_DELETE              5277
#define DLG_CSG_FROM                5278
#define DLG_CSG_FROMS               5279
#define DLG_CSG_TO                  5280
#define DLG_CSG_TOS                 5281
#define DLG_QUICKPLAY               5290

#define DLG_PATHTOOL                5342
#define DLG_PATHTOOL_MOVE           5343
#define DLG_PATHTOOL_ADD            5344
#define DLG_PATHTOOL_DELETE         5345
#define DLG_PATHTOOL_TENSION        5346

#define DLG_ROBOT                   5295
#define DLG_ROBOT_X                 5296
#define DLG_ROBOT_Y                 5297
#define DLG_ROBOT_Z                 5298

#define DLG_COORDS                  5299
#define DLG_COORDS_X                5300
#define DLG_COORDS_Y                5301
#define DLG_COORDS_Z                5302
#define DLG_COORDS_DX               5303
#define DLG_COORDS_DY               5304
#define DLG_COORD_DZ                5305
#define DLG_COORD_SETREL            5306
#define DLG_COORD_SETCENTRE         5307
#define DLG_COORD_DEFINE            5308
#define DLG_COORD_GOTO              5309
#define DLG_COORDS_DZ               5310
#define DLG_COORDS_GOTO             5311
#define DLG_COORDS_CANCEL           5312
#define DLG_COORDS_SETCENTRE        5313
#define DLG_COORDS_DEFINE           5314
#define DLG_COORDS_MEASURE          5352
#define DLG_COORDS_DIST             5354

#define DLG_XIP                     5315
#define DLG_XIP_LIST                5316
#define DLG_XIP_DELETE              5317
#define DLG_XIP_ADD                 5318
#define DLG_XIP_EDIT                5319
#define DLG_XIP_VECTOR              5350
#define DLG_XIP_MOVE_FIRST          5351
#define DLG_XIP_MOVE_LAST           5353

#define DLG_KEYF_COMMAND            5320
#define DLG_KEYF_COMMAND_DELETE     5321
#define DLG_KEYF_COMMAND_RENAME     5322
#define DLG_KEYF_COMMAND_INFO       5323
#define DLG_KEYF_COMMAND_SAVEANI    5324

#define DLG_REORDER                 5331
#define DLG_REORDER_LIST            5332

#define DLG_COSTUMEXIP              5355
#define DLG_COSTUMEXIP_MORPH_NO     5356
#define DLG_COSTUMEXIP_MORPH_YES    5357
#define DLG_COSTUMEXIP_FROM         5358
#define DLG_COSTUMEXIP_FROMS        5359
#define DLG_COSTUMEXIP_TO           5360
#define DLG_COSTUMEXIP_TOS          5361
#define DLG_COSTUMEXIP_NAME         5362
#define DLG_COSTUMEXIP_PATH         5363
#define DLG_COSTUMEXIP_SET          5364
#define DLG_COSTUMEXIP_EDIT         5365
#define DLG_COSTUMEXIP_DELETE       5390
#define DLG_COSTUMEXIP_CUTOUT       5391
#define DLG_COSTUMEXIP_COPY         5392

#define DLG_SHIFTKEYS               5397
#define DLG_SHIFTKEYS_NUMBER        5398
#define DLG_SHIFTKEYS_UP            5399
#define DLG_SHIFTKEYS_DOWN          5400

#define DLG_TRACK_DIRECT            5401

#define DLG_PREFERENCES             5423
#define DLG_PREFERENCES_GENERAL     5424
#define DLG_PREFERENCES_START       5425
#define DLG_PREFERENCES_MODPATH     5426
#define DLG_PREFERENCES_MAPPATH     5427

#define DLG_PREFERENCES_SELECT      5430
#define DLG_PREFERENCES_BUTTONS     5431
#define DLG_PREFERENCES_QUICKTRICK  5432
#define DLG_PREFERENCES_STARTUP     5433
#define DLG_PREFERENCES_DLG3D       5434
#define DLG_PREFERENCES_UNDO        5435
#define DLG_PREFERENCES_POSITIONS   5436
#define DLG_PREFERENCES_GROUND      5437
#define DLG_PREFERENCES_TOOLTIPS    5438
#define DLG_PREFERENCES_TOOLLEFT    5439
#define DLG_PREFERENCES_TOOLSMALL   5440
#define DLG_PREFERENCES_AUTOCENTRE  5441
#define DLG_PREFERENCES_AUTODETAIL  5442
#define DLG_PREFERENCES_STEPDETAIL  5443
#define DLG_PREFERENCES_STEPDETAILS 5444
#define DLG_PREFERENCES_BACKGROUND  5503
#define DLG_PREFERENCES_UPDATEKEYF  5504
#define DLG_PREFERENCES_MODPATH1    5445
#define DLG_PREFERENCES_MODPATH1_B  5446
#define DLG_PREFERENCES_MODPATH1_D  5447
#define DLG_PREFERENCES_MODPATH2    5448
#define DLG_PREFERENCES_MODPATH2_B  5449
#define DLG_PREFERENCES_MODPATH2_D  5450
#define DLG_PREFERENCES_MODPATH3    5451
#define DLG_PREFERENCES_MODPATH3_B  5452
#define DLG_PREFERENCES_MODPATH3_D  5453
#define DLG_PREFERENCES_MODPATH4    5454
#define DLG_PREFERENCES_MODPATH4_B  5455
#define DLG_PREFERENCES_MODPATH4_D  5456
#define DLG_PREFERENCES_MAPPATH1    5457
#define DLG_PREFERENCES_MAPPATH1_B  5458
#define DLG_PREFERENCES_MAPPATH1_D  5459
#define DLG_PREFERENCES_MAPPATH2    5460
#define DLG_PREFERENCES_MAPPATH2_B  5461
#define DLG_PREFERENCES_MAPPATH2_D  5462
#define DLG_PREFERENCES_MAPPATH3    5463
#define DLG_PREFERENCES_MAPPATH3_B  5464
#define DLG_PREFERENCES_MAPPATH3_D  5465
#define DLG_PREFERENCES_MAPPATH4    5466
#define DLG_PREFERENCES_MAPPATH4_B  5467
#define DLG_PREFERENCES_MAPPATH4_D  5468
#define DLG_PREFERENCES_ROBOTGL     5469
#define DLG_PREFERENCES_SPLASH      5470
#define DLG_PREFERENCES_EDITAPP     5471
#define DLG_PREFERENCES_EDITAPPSET  5472

#define DLG_ABOUT                   5480
#define DLG_ABOUT_ANIMATE           5481
#define DLG_ABOUT_VERSION           5482

#define DLG_PATHEDITOR              5490
#define DLG_PATHEDITOR_FRAME        5491
#define DLG_PATHEDITOR_DISTANCE     5492
#define DLG_PATHEDITOR_LOOP         5493
#define DLG_PATHEDITOR_FRAME1       5494
#define DLG_PATHEDITOR_FRAMEN       5495
#define DLG_PATHEDITOR_HELPTEXT     5496
#define DLG_PATHEDITOR_EDITWINDOW   5497
#define DLG_PATHEDITOR_ENDTEXT      5498
#define DLG_PATHEDITOR_STARTTEXT    5499
#define DLG_PATHEDITOR_FRAMESTEXT   5500
#define DLG_PATHEDITOR_FRAMETEXT    5501
#define DLG_PATHEDITOR_DISTANCETEXT 5502

#define DLG_SELECT                  5505
#define DLG_SELECT_LIST             5506
#define DLG_SELECT_INFO             5507

#define DLG_COSTUME                 5510
#define DLG_COSTUME_NAME            5511
#define DLG_COSTUME_PATH            5512
#define DLG_COSTUME_CHANGE          5513
#define DLG_COSTUME_MORPH_NO        5514
#define DLG_COSTUME_MORPH_LINEAR    5515
#define DLG_COSTUME_MORPH_Q         5516
#define DLG_COSTUME_EFFECT_NAME     5517
#define DLG_COSTUME_EFFECT_PATH     5518
#define DLG_COSTUME_EFFECT_SET      5519
#define DLG_COSTUME_EFFECT_EDIT     5520
#define DLG_COSTUME_OK              5521
#define DLG_COSTUME_CANCEL          5522
#define DLG_COSTUME_FROM            5523
#define DLG_COSTUME_FROMS           5524
#define DLG_COSTUME_TO              5525
#define DLG_COSTUME_TOS             5526
#define DLG_COSTUME_WIREFRAME       5527
#define DLG_COSTUME_HIDDEN          5528
#define DLG_COSTUME_SOLID           5529
#define DLG_COSTUME_SHOW_SHADOWS    5530
#define DLG_COSTUME_CAST_SHADOWS    5531
#define DLG_COSTUME_SELF_SHADOWS    5532

#define DLG_SIZERL                  5550
#define DLG_SIZERL_X                5551
#define DLG_SIZERL_Z                5552

#define DLG_SCALEL                  5560
#define DLG_SCALEL_OK               5561
#define DLG_SCALEL_CANCEL           5562
#define DLG_SCALEL_FROM             5563
#define DLG_SCALEL_FROM_S           5564
#define DLG_SCALEL_TO               5565
#define DLG_SCALEL_TO_S             5566
#define DLG_SCALEL_CONE             5567
#define DLG_SCALEL_EDGE             5568
#define DLG_SCALEL_RANGE            5569
#define DLG_SCALEL_RESET            5570
#define DLG_SCALEL_STORE            5571
#define DLG_SCALEL_SET              5572
#define DLG_SCALEL_DELETE           5573
#define DLG_SCALEL_CUT              5574

#define DLG_GROUND                  5600
#define DLG_GROUND_OK               5601
#define DLG_GROUND_CANCEL           5602
#define DLG_GROUND_GC               5603
#define DLG_GROUND_SC               5604
#define DLG_GROUND_REFL             5605
#define DLG_GROUND_PLAIN            5606
#define DLG_GROUND_SHADER           5607
#define DLG_GROUND_MAPPED           5608
#define DLG_GROUND_SHADER_NAME      5609
#define DLG_GROUND_MAP_SINGLE       5610
#define DLG_GROUND_MAP_TILE         5611
#define DLG_GROUND_MAP_MOZAIC       5612
#define DLG_GROUND_MAP_NAME         5613
#define DLG_GROUND_MAP_PATH         5614
#define DLG_GROUND_FRAME_FROM       5615
#define DLG_GROUND_FRAME_SPINF      5616
#define DLG_GROUND_FRAME_TO         5617
#define DLG_GROUND_FRAME_SPINT      5618
#define DLG_GROUND_VIEW             5619
#define DLG_GROUND_EDITAPP          5620
#define DLG_GROUND_CHOOSE           5621
#define DLG_GROUND_CHOOSE_SHA       5622

#define DLG_SKY                     5630
#define DLG_SKY_CANCEL              5631
#define DLG_SKY_OK                  5632
#define DLG_SKY_ZC                  5633
#define DLG_SKY_HC                  5634
#define DLG_SKY_AMB_GROUND          5635
#define DLG_SKY_AMB_MODEL           5636
#define DLG_SKY_PLAIN               5637
#define DLG_SKY_GRADED              5638
#define DLG_SKY_ENVIRON             5639
#define DLG_SKY_BACKDROP            5640
#define DLG_SKY_ANIMATED            5641
#define DLG_SKY_MAP_NAME            5642
#define DLG_SKY_MAP_PATH            5643
#define DLG_SKY_FRAME_FROM          5644
#define DLG_SKY_FRAME_SPINF         5645
#define DLG_SKY_FRAME_TO            5646
#define DLG_SKY_FRAME_SPINT         5647
#define DLG_SKY_ANIM_START          5648
#define DLG_SKY_ANIM_START_S        5649
#define DLG_SKY_ANIM_START_T        5650
#define DLG_SKY_ANIM_END            5651
#define DLG_SKY_ANIM_END_S          5652
#define DLG_SKY_ANIM_END_T          5653
#define DLG_SKY_ANIM_STEP           5654
#define DLG_SKY_ANIM_STEP_S         5655
#define DLG_SKY_ANIM_STEP_T         5656
#define DLG_SKY_VIEW                5657
#define DLG_SKY_EDITAPP             5658
#define DLG_SKY_CHOOSE              5659

#define DLG_PREVIEW                 5670
#define DLG_PREVIEW_MAKE            5671
#define DLG_PREVIEW_QUICK           5672
#define DLG_PREVIEW_FULL            5673
#define DLG_PREVIEW_30              5674
#define DLG_PREVIEW_25              5675
#define DLG_PREVIEW_15              5676
#define DLG_PREVIEW_5               5677
#define DLG_PREVIEW_1               5678
#define DLG_PREVIEW_SCROLL          5679
#define DLG_PREVIEW_WIN             5680
#define DLG_PREVIEW_TX1             5681
#define DLG_PREVIEW_TX2             5682
#define DLG_PREVIEW_TX3             5683
#define DLG_PREVIEW_PLAY            5684
#define DLG_PREVIEW_FIRST           5685
#define DLG_PREVIEW_LAST            5686
#define DLG_PREVIEW_NEXT            5687
#define DLG_PREVIEW_PREVIOUS        5688
#define DLG_PREVIEW_3_5             5689
#define DLG_PREVIEW_PROGRESS        5690
#define DLG_PREVIEW_RANGE1          5691
#define DLG_PREVIEW_RANGEN          5692
#define DLG_PREVIEW_DETAIL          5693
#define DLG_PREVIEW_TX4             5694
#define DLG_PREVIEW_TX5             5695
#define DLG_PREVIEW_TX6             5696

#define DLG_DIRECTOR                5700
#define DLG_DIRECTOR_TARGET         5701
#define DLG_DIRECTOR_SELECT         5702
#define DLG_DIRECTOR_FRAME_FROM     5703
#define DLG_DIRECTOR_FRAME_SPINF    5704
#define DLG_DIRECTOR_FRAME_TO       5705
#define DLG_DIRECTOR_FRAME_SPINT    5706





