/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file INFO.C */

// Functions that provide information on the selected actors and
// to update the GRAYED state of the menus and commands so that
// commands that do not apply to the selected actor cannon be
// implemented.

#define MODULE_INFO 1

#include "animate.h"

//
// This is the function that updates the activiity of the menus as necessary
//
void UpdateSelectedActor(BOOL auto_update){
 int status,s1;
 object   *Op=NULL;
 position *Pp=NULL;
 align    *Ap=NULL;
 size     *Sp=NULL;
 HMENU hm;
 char infostr[256],infofor[256];
 if(SelectedNode == NULL)LoadString(ghinst_main,IDX_MISC_NOACTSEL,infostr,32);
 else{
   LoadString(ghinst_main,IDX_MISC_ACTSEL,infofor,32);
   sprintf(infostr,infofor,SelectedNode->actorname);
   if(auto_update)AutoUpdateKeyframerVpos();
 }
 SendMessage(ghwnd_info,SB_SETTEXT,(WPARAM)0,(LPARAM)infostr);
 hm=GetMenu(ghwnd_main);
 if(SelectedNode == NULL)s1=1;
 else {
   s1=0;
   GetTimelinesAtFrame(SelectedNode,CurrentFrame,&Op,&Pp,&Ap,&Sp);
 }
 UpdateRobot(Op);
 if(s1 || (SelectedNode->type == CAMERA && SelectedNode == FirstNp))
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_DEL_A,status);

 if(s1 || SelectedNode->type != CAMERA)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_ACTCAMERA,status);

 if(s1)status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_INFO,status);

 if(s1 || Pp == NULL || Pp->lastframe != CurrentFrame ||
    (Pp->type != TWEEN && Pp->type != SPLINE))
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_TOOL_GRABABS,status);
 EnableMenuItem(hm,IDM_TIMELINE_KEY_RESETP,status);
 if(s1 || Pp != NULL)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_TIMELINE_LINE_ADDP,status);
 if(s1 || Pp == NULL || Pp->lastframe == CurrentFrame ||
    (Pp->type != TWEEN && Pp->type != SPLINE))
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_TIMELINE_KEY_ADDP,status);

 if(s1 ||
    SelectedNode->type == PATH   ||
    SelectedNode->type == TARGET ||
    Ap == NULL || Ap->lastframe != CurrentFrame ||
   (Ap->type != TWEEN && Ap->type != SPLINEA))
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_TOOL_ROTATEABS,status);
 EnableMenuItem(hm,IDM_TIMELINE_KEY_RESETR,status);
 if(s1 || Ap != NULL ||
    SelectedNode->type == PATH ||
    SelectedNode->type == TARGET)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_TIMELINE_LINE_ADDR,status);
 if(s1 || Ap == NULL || Ap->lastframe == CurrentFrame)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_TIMELINE_KEY_ADDR,status);

 if(s1 ||
    SelectedNode->type == PATH ||
    SelectedNode->type == TARGET ||
    Sp == NULL || Sp->lastframe != CurrentFrame)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_TOOL_SIZEABS,status);
 EnableMenuItem(hm,IDM_TIMELINE_KEY_RESETX,status);
 if(s1 || Sp != NULL ||
    SelectedNode->type == PATH ||
    SelectedNode->type == TARGET)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_TIMELINE_LINE_ADDX,status);
 if(s1 || Sp == NULL || Sp->lastframe == CurrentFrame ||
    SelectedNode->type == PATH ||
    SelectedNode->type == TARGET)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_TIMELINE_KEY_ADDX,status);

 if(s1 || (SelectedNode->type == CAMERA && SelectedNode == FirstNp))
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_RENAME,status);

 if(s1 || SelectedNode->type == CAMERA
       || Op != NULL)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_ADD_C,status);

 if(s1 || SelectedNode->type == CAMERA
       || Op == NULL)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_DEL_C,status);

 if(s1 || SelectedNode->type != NORMAL || Op == NULL)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_ADD_E,status);

 if(s1 || (SelectedNode->type != NORMAL && SelectedNode->type != ROBOT) || Op == NULL)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_EDIT_MODEL,status);

 if(s1 || (SelectedNode->type != NORMAL && SelectedNode->type != ROBOT) || Op == NULL)
    status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_ACTOR_SWAP,status);
 EnableMenuItem(hm,IDM_ACTOR_SWAP_ALL,status);

 if(s1 || SelectedNode->type != PATH || Op == NULL)
   status=MF_GRAYED; else status=MF_ENABLED;
 EnableMenuItem(hm,IDM_PATH_GRAPH_POSITION,status);
 EnableMenuItem(hm,IDM_PATH_REVERSE,status);
}

void SelectedInfo(void){
 if(SelectedNode == NULL){
   SendPrgmQuery(IDQ_NOACTORSELECTED,0);
 }
 else if(SelectedNode->type == CAMERA){
   SendPrgmQuery(IDQ_CAMERASELECTED,0);
 }
 else if(SelectedNode->type == DIRECTOR){
   SendPrgmQuery(IDQ_CAMERASELECTED,0); /* should really be director */
 }
 else ActorInfo(SelectedNode, (short)CurrentFrame);
}

void SkyInfo(node *Np, short frame){
 sky *Op;
 int fo=0;
 char title[60];
 char strng[128];
 LoadString(ghinst_main,IDX_MISC_SKYINFORMATION,res_str,256);
 strcpy(title,res_str);
 if((Op=Np->fsky) != NULL)while(Op != NULL){
    if(frame >= Op->firstframe && frame <= Op->lastframe){
      if(Op->type == SKYCOLOURED){
        LoadString(ghinst_main,IDX_MISC_SKYPLAIN,res_str,256);
        strcpy(strng,res_str); fo=1;
      }
      else if(Op->type == SKYGRADED){
        LoadString(ghinst_main,IDX_MISC_SKYGRADED,res_str,256);
        strcpy(strng,res_str); fo=1;
      }
      else if(Op->type == SKYMAPPED){
        LoadString(ghinst_main,IDX_MISC_ENVIRONMENT,res_str,256);
        sprintf(strng,res_str,Op->name); fo=1;
      }
      else if(Op->type == BACKDROP){
        LoadString(ghinst_main,IDX_MISC_BACKDROP,res_str,256);
        sprintf(strng,res_str,Op->name); fo=1;
      }
      else if(Op->type == SKYANIMATED){
        LoadString(ghinst_main,IDX_MISC_ANIMBACKDROP,res_str,256);
        sprintf(strng,res_str,Op->name); fo=1;
      }
      break;
    }
    Op=Op->next;
 }
 if(fo)MessageBox (NULL,strng,title,
    MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
 return;
}

void SkyCostumeInfo(node *Np, short frame, char *line){
 sky *Op;
 if((Op=Np->fsky) != NULL)while(Op != NULL){
    if(frame >= Op->firstframe && frame <= Op->lastframe){
      if(Op->type == SKYCOLOURED){
        LoadString(ghinst_main,IDX_MISC_SKYPLAIN,res_str,256);
        strcpy(line,res_str);
      }
      else if(Op->type == SKYGRADED){
        LoadString(ghinst_main,IDX_MISC_SKYGRADED,res_str,256);
        strcpy(line,res_str);
      }
      else if(Op->type == SKYMAPPED){
        LoadString(ghinst_main,IDX_MISC_ENVIRONMENT,res_str,256);
        sprintf(line,res_str,Op->name);
      }
      else if(Op->type == BACKDROP){
        LoadString(ghinst_main,IDX_MISC_BACKDROP,res_str,256);
        sprintf(line,res_str,Op->name);
      }
      else if(Op->type == SKYANIMATED){
        LoadString(ghinst_main,IDX_MISC_ANIMBACKDROP,res_str,256);
        sprintf(line,res_str,Op->name);
      }
      break;
    }
    Op=Op->next;
 }
 return;
}

void DirectorCostumeInfo(node *Np, short frame, char *line){
 director *Dp;
 if((Dp=Np->fdirector) != NULL)while(Dp != NULL){
    if(frame >= Dp->firstframe && frame <= Dp->lastframe){
      node *Np;
      Np=Dp->ActiveCamera;
      LoadString(ghinst_main,IDX_MISC_DIRECTORINFO1,res_str,256);
      sprintf(line,"%s %s",res_str,Np->actorname);
      break;
    }
    Dp=Dp->next;
 }
 return;
}

void ActorInfo(node *Np, short frame){
 object *Op;
 int fo=0;
 char title[60];
 char strng[128],temp[128];
 LoadString(ghinst_main,IDX_MISC_MODELINFORMATION,res_str,256);
 strcpy(title,res_str);
 if((Op=Np->fobj) != NULL)while(Op != NULL){
   if(frame >= Op->firstframe && frame <= Op->lastframe){
     if(Op->type == NORMAL){
        fo=1;
        if(Op->morph == QMORPH){
          LoadString(ghinst_main,IDX_MISC_NORMALQON,res_str,256);
          sprintf(temp,res_str,Op->name);
        }
        else if(Op->morph != NO){
          LoadString(ghinst_main,IDX_MISC_NORMALQOFF,res_str,256);
          sprintf(temp,res_str,Op->name);
        }
        else{
          LoadString(ghinst_main,IDX_MISC_NORMALMODEL,res_str,256);
          sprintf(temp,res_str,Op->name);
        }
        if(Op->quick_only){
          LoadString(ghinst_main,IDX_MISC_BOXDRAW,res_str,256);
          sprintf(strng,res_str,temp);
        }
        else strcpy(strng,temp);
     }
     else if(Op->type == ANIMOBJ){
        fo=1;
        if(Op->morph != NO){
          LoadString(ghinst_main,IDX_MISC_ANIMSEQ1,res_str,256);
          sprintf(strng,res_str,Op->name);
        }
        else{
          LoadString(ghinst_main,IDX_MISC_ANIMSEQ2,res_str,256);
          sprintf(strng,res_str,Op->name);
        }
     }
     else if(Op->type == GROUND){
        fo=1;
        if(Op->groundtype == PLAIN){
          LoadString(ghinst_main,IDX_MISC_GROUNDPLAIN,res_str,256);
          strcpy(strng,res_str);
        }
        else if(Op->groundtype == BRUM || Op->groundtype == TBRUM){
          if(Op->groundtype == BRUM){
            LoadString(ghinst_main,IDX_MISC_GROUNDMAP,res_str,256);
            sprintf(strng,res_str,Op->name);
          }
          else{
           LoadString(ghinst_main,IDX_MISC_GROUNDTILE,res_str,256);
            sprintf(strng,res_str,Op->name);
          }
        }
        else if(Op->groundtype == MBRUM){
         LoadString(ghinst_main,IDX_MISC_GROUNDMOZAIC,res_str,256);
          sprintf(strng,res_str,Op->name);
        }
        else if(Op->groundtype > 127){
          LoadString(ghinst_main,IDX_MISC_GROUNDSHADER,res_str,256);
          sprintf(strng,res_str,
                  GroundTextList[Op->groundtype-128]);
        }
     }
     else if(Op->type == LIGHT){
        fo=1;
        if     (Op->lighttype == SPHERE){
          LoadString(ghinst_main,IDX_MISC_NORMALLIGHT,res_str,256);
          strcpy(strng,res_str);
        }
        else if(Op->lighttype == NOSHADOW){
          LoadString(ghinst_main,IDX_MISC_NOSHADOW,res_str,256);
          strcpy(strng,res_str);
        }
        else if(Op->lighttype == SHADOWONLY){
          LoadString(ghinst_main,IDX_MISC_SHADOWONLY,res_str,256);
          strcpy(strng,res_str);
        }
        else if(Op->lighttype == SPOTLIGHT){
          LoadString(ghinst_main,IDX_MISC_SPOTLIGHT,res_str,256);
          strcpy(strng,res_str);
        }
     }
     else if(Op->type == CSG){
        fo=1;
        if(Op->lighttype      == SPHERE){
          LoadString(ghinst_main,IDX_MISC_CSGSPHERE,res_str,256);
          strcpy(temp,res_str);
        }
        else if(Op->lighttype == TUBE){
          LoadString(ghinst_main,IDX_MISC_CSGTUBE,res_str,256);
          strcpy(temp,res_str);
        }
        else if(Op->lighttype == CYLIND){
          LoadString(ghinst_main,IDX_MISC_CSGCYLINDER,res_str,256);
          strcpy(temp,res_str);
        }
        else if(Op->lighttype == DISK){
          LoadString(ghinst_main,IDX_MISC_CSGDISK,res_str,256);
          strcpy(temp,res_str);
        }
        if(Op->groundtype == 0){
          LoadString(ghinst_main,IDX_MISC_CSGADDITIVE,res_str,256);
          strcpy(temp,res_str);
        }
        else{
          LoadString(ghinst_main,IDX_MISC_CSGSUBTRACTIVE,res_str,256);
          strcpy(temp,res_str);
        }
     }
     else if(Op->type == TARGET){
        LoadString(ghinst_main,IDX_MISC_TARGET1,res_str,256);
        strcpy(strng,res_str); fo=1;
     }
     else if(Op->type == IMAGEP){
        LoadString(ghinst_main,IDX_MISC_IMAGEPROC,res_str,256);
        strcpy(strng,res_str); fo=1;
     }
     else if(Op->type == PATH){
        fo=1;
        if     (Op->pathtype == OPEN){
          LoadString(ghinst_main,IDX_MISC_OPENPATH1,res_str,256);
          strcpy(strng,res_str);
        }
        else if(Op->pathtype == CLOSED){
          LoadString(ghinst_main,IDX_MISC_CLOSEDPATH,res_str,256);
          strcpy(strng,res_str);
        }
     }
     else if(Op->type == ROBOT){
        fo=1;
        if(Op->morph == QMORPH){
          LoadString(ghinst_main,IDX_MISC_ROBOT1,res_str,256);
          sprintf(strng,res_str,Op->name);
        }
        else if(Op->morph != NO){
          LoadString(ghinst_main,IDX_MISC_ROBOT1,res_str,256);
          sprintf(strng,res_str,Op->name);
        }
        else{
          LoadString(ghinst_main,IDX_MISC_ROBOT1,res_str,256);
          sprintf(strng,res_str,Op->name);
        }
     }
     break;
   }
   Op=Op->next;
 }
 if(fo)MessageBox (NULL,strng,title,
    MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
 return;
}

void CostumeInfo(object *Op, char *line1, char *line2, char *line3){
 if(Op->type == NORMAL){
   LoadString(ghinst_main,IDX_MISC_COSTUMEI1,res_str,256);
   strcpy(line1,res_str);
   sprintf(line2,"%s",Op->name);
   if(Op->morph == QMORPH){
     LoadString(ghinst_main,IDX_MISC_COSTUMEI2,res_str,256);
     strcpy(line3,res_str);
   }
 }
 else if(Op->type == ANIMOBJ){
   LoadString(ghinst_main,IDX_MISC_COSTUMEI3,res_str,256);
   strcpy(line1,res_str);
   strcpy(line2,Op->name);
   if(Op->morph != NO){
     LoadString(ghinst_main,IDX_MISC_COSTUMEI4,res_str,256);
     strcpy(line3,res_str);
   }
 }
 else if(Op->type == GROUND){
   if(Op->groundtype == PLAIN){
     LoadString(ghinst_main,IDX_MISC_COSTUMEI5,res_str,256);
     strcpy(line1,res_str);
   }
   else if(Op->groundtype == BRUM || Op->groundtype == TBRUM){
     if(Op->groundtype == BRUM){
       LoadString(ghinst_main,IDX_MISC_COSTUMEI6,res_str,256);
       sprintf(line1,res_str);
     }
     else{
       LoadString(ghinst_main,IDX_MISC_COSTUMEI7,res_str,256);
       sprintf(line1,res_str);
     }
     sprintf(line2,"%s",Op->name);
   }
   else if(Op->groundtype == MBRUM){
     LoadString(ghinst_main,IDX_MISC_COSTUMEI8,res_str,256);
     sprintf(line1,res_str);
     sprintf(line2,"%s",Op->name);
   }
   else if(Op->groundtype > 127){
     LoadString(ghinst_main,IDX_MISC_COSTUMEI9,res_str,256);
     sprintf(line1,res_str);
     sprintf(line2,"%s",GroundTextList[Op->groundtype-128]);
   }
 }
 else if(Op->type == LIGHT){
   if     (Op->lighttype == SPHERE){
     LoadString(ghinst_main,IDX_MISC_NORMALLIGHT,res_str,256);
     strcpy(line1,res_str);
   }
   else if(Op->lighttype == NOSHADOW){
     LoadString(ghinst_main,IDX_MISC_NOSHADOW,res_str,256);
     strcpy(line1,res_str);
   }
   else if(Op->lighttype == SHADOWONLY){
     LoadString(ghinst_main,IDX_MISC_SHADOWONLY,res_str,256);
     strcpy(line1,res_str);
   }
   else if(Op->lighttype == SPOTLIGHT){
     LoadString(ghinst_main,IDX_MISC_SPOTLIGHT,res_str,256);
     strcpy(line1,res_str);
   }
 }
 else if(Op->type == CSG){
   if(Op->lighttype      == SPHERE){
     LoadString(ghinst_main,IDX_MISC_CSGSPHERE,res_str,256);
     strcpy(line1,res_str);
   }
   else if(Op->lighttype == TUBE){
     LoadString(ghinst_main,IDX_MISC_CSGTUBE,res_str,256);
     strcpy(line1,res_str);
   }
   else if(Op->lighttype == CYLIND){
     LoadString(ghinst_main,IDX_MISC_CSGCYLINDER,res_str,256);
     strcpy(line1,res_str);
   }
   else if(Op->lighttype == DISK){
     LoadString(ghinst_main,IDX_MISC_CSGDISK,res_str,256);
     strcpy(line1,res_str);
   }
   if(Op->groundtype == 0){
     LoadString(ghinst_main,IDX_MISC_CSGADDITIVE1,res_str,256);
     strcpy(line2,res_str);
   }
   else{
     LoadString(ghinst_main,IDX_MISC_CSGSUBTRACTIVE1,res_str,256);
     strcpy(line2,res_str);
   }
 }
 else if(Op->type == TARGET){
     LoadString(ghinst_main,IDX_MISC_TARGET1,res_str,256);
   strcpy(line1,res_str);
 }
 else if(Op->type == IMAGEP){
   LoadString(ghinst_main,IDX_MISC_IMAGEPROC,res_str,256);
   strcpy(line1,res_str);
 }
 else if(Op->type == PATH){
   if     (Op->pathtype == OPEN){
     LoadString(ghinst_main,IDX_MISC_OPENPATH1,res_str,256);
     strcpy(line1,res_str);
   }
   else if(Op->pathtype == CLOSED){
     LoadString(ghinst_main,IDX_MISC_CLOSEDPATH,res_str,256);
     strcpy(line1,res_str);
   }
 }
 else if(Op->type == ROBOT){
   LoadString(ghinst_main,IDX_MISC_ROBOT3,res_str,256);
   sprintf(line1,res_str," ");
   sprintf(line2,"%s",Op->name);
   if(Op->morph == QMORPH){
     LoadString(ghinst_main,IDX_MISC_COSTUMEI10,res_str,256);
     strcpy(line3,res_str);
   }
   else{
     LoadString(ghinst_main,IDX_MISC_COSTUMEI11,res_str,256);
     if(Op->morph != NO)strcpy(line3,res_str);
   }
 }
}

void PositionInfo(node *Np, short frame){
 position *Op;
 int fo=0;
 char title[64];
 char strng[256];
 LoadString(ghinst_main,IDX_MISC_POSITIONINFO,res_str,256);
 strcpy(title,res_str);
 if((Op=Np->fpos) != NULL)while(Op != NULL){
    if(frame >= Op->firstframe && frame <= Op->lastframe){
      fo=1;
      if(Op->type == TWEEN){
        LoadString(ghinst_main,IDX_MISC_POSITIONTWEEN,res_str,256);
        strcpy(strng,res_str);
      }
      else if(Op->type == SPLINE){
        LoadString(ghinst_main,IDX_MISC_POSITIONSPLINE,res_str,256);
        strcpy(strng,res_str);
      }
      else if(Op->type == FOLLOW){
        LoadString(ghinst_main,IDX_MISC_POSITIONINFO1,res_str,256);
        sprintf(strng,res_str,Op->onpath->actorname);
      }
      else if(Op->type == FOLLOWOFF){
        LoadString(ghinst_main,IDX_MISC_POSITIONINFO2,res_str,256);
        sprintf(strng,res_str,Op->onpath->actorname);
      }
      else if(Op->type == FOLLOWON){
        LoadString(ghinst_main,IDX_MISC_POSITIONINFO3,res_str,256);
        sprintf(strng,res_str,Op->onpath->actorname);
      }
      else if(Op->type == FOLLOWAT){
        LoadString(ghinst_main,IDX_MISC_POSITIONINFO4,res_str,256);
        sprintf(strng,res_str,Op->onpath->actorname);
      }
      break;
    }
    Op=Op->next;
 }
 if(fo)MessageBox (NULL,strng,title,
    MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
 return;
}

void AlignInfo(node *Np, short frame){
 align *Op;
 int fo=0;
 char title[60];
 char strng[256];
 LoadString(ghinst_main,IDX_MISC_ROTATIONINFO,res_str,256);
 strcpy(title,res_str);
 if((Op=Np->fali) != NULL)while(Op != NULL){
    if(frame >= Op->firstframe && frame <= Op->lastframe){
      fo=1;
      if(Op->type == TWEEN){
        LoadString(ghinst_main,IDX_MISC_ROTATIONTWEEN,res_str,256);
        strcpy(strng,res_str);
      }
      else if(Op->type == TOPATH){
        LoadString(ghinst_main,IDX_MISC_ROTATIONALIGN,res_str,256);
        sprintf(strng,res_str,Op->topath->actorname);
      }
      else if(Op->type == TRACK){
        LoadString(ghinst_main,IDX_MISC_ROTATIONLOOK,res_str,256);
        sprintf(strng,res_str,Op->topath->actorname);
      }
      else if(Op->type == COPY){
        LoadString(ghinst_main,IDX_MISC_ROTATIONCOPY,res_str,256);
        sprintf(strng,res_str,Op->topath->actorname);
      }
      else if(Op->type == SPLINEA){
        LoadString(ghinst_main,IDX_MISC_ROTATIONACCEL,res_str,256);
        strcpy(strng,res_str);
      }
      break;
    }
    Op=Op->next;
 }
 if(fo)MessageBox (NULL,strng,title,
    MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
 return;
}

void SizeInfo(node *Np, short frame){
 size *Op;
 int fo=0;
 char title[60];
 char strng[128];
 LoadString(ghinst_main,IDX_MISC_SCALEINFO,res_str,256);
 strcpy(title,res_str);
 if((Op=Np->fsiz) != NULL)while(Op != NULL){
    if(frame >= Op->firstframe && frame <= Op->lastframe){
      fo=1;
      if(Np->type == LIGHT){
        LoadString(ghinst_main,IDX_MISC_CONEANGLE,res_str,256);
        sprintf(strng,res_str,Op->Sx,Op->Sy);
      }
      else{
        LoadString(ghinst_main,IDX_MISC_SCALEWIDTH,res_str,256);
         sprintf(strng,res_str,Op->Sx,Op->Sy,Op->Sz);
      }
      break;
    }
    Op=Op->next;
 }
 if(fo)MessageBox (NULL,strng,title,
    MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
 return;
}

