/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file LISTS.H   lists of local names */

#define N_OBJECTTYPELIST 12

#ifdef MODULE_ANIMATE
char *internal_effect_list[]={"build.dll","unbuild.dll","buildto.dll",
                              "wave.dll","modulate.dll","squash.dll",
                               "warp.dll","spring.dll","shake.dll"};
char  *ObjectTypeList[]={
  NULL,NULL,NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,NULL,NULL
};

int ObjectTypeListID[]={
   IDX_MISC_MODEL,
   IDX_MISC_PATH,
   IDX_MISC_TARGET,
   IDX_MISC_GROUND,
   IDX_MISC_LIGHT,
   IDX_MISC_MORPH,
   IDX_MISC_CSG,
   IDX_MISC_SKY,
   IDX_MISC_ROBOT,
   IDX_MISC_CAMERA,
   IDX_MISC_XIPC,
   IDX_MISC_DIRECTOR
};

int ObjectTypeListOrder[]={NORMAL,PATH,TARGET,GROUND,LIGHT,ANIMOBJ,CSG,
                           SKY,ROBOT,CAMERA,IMAGEP,DIRECTOR};
int ObjectBitmapIdList[]={
             IDBM_A_MODEL,IDBM_A_PATH,IDBM_A_TARGET,IDBM_A_GROUND,IDBM_A_LIGHT,
             IDBM_A_ANIOBJ,IDBM_A_CSG,IDBM_A_SKY,IDBM_A_ROBOT,IDBM_A_CAMERA,
             IDBM_A_IMAGEP,IDBM_A_DIRECTOR};
int ObjectSmallBitmapIdList[]={
             IDBM_S_MODEL,IDBM_S_PATH,IDBM_S_TARGET,IDBM_S_GROUND,IDBM_S_LIGHT,
             IDBM_S_ANIOBJ,IDBM_S_CSG,IDBM_S_SKY,IDBM_S_ROBOT,IDBM_S_CAMERA,
             IDBM_S_IMAGEP,IDBM_S_DIRECTOR};
char  *GroundTextList[] = {
  NULL,NULL,NULL,NULL,NULL,NULL,
  NULL,NULL,NULL,NULL,NULL
};

int GroundTextureListID[]={
   IDX_MISC_COLORED,
   IDX_MISC_WAVE,
   IDX_MISC_RIPPLES,
   IDX_MISC_OCEAN,
   IDX_MISC_CHECKER,
   IDX_MISC_GRID,
   IDX_MISC_STRIPES,
   IDX_MISC_DOTS,
   IDX_MISC_CROSSES,
   IDX_MISC_BRICK,
   IDX_MISC_ROUGH
};

short NoGroundTexts = 11;

#else
extern char  *internal_effect_list[];
extern char  *ObjectTypeList[];
extern int   ObjectTypeListID[];
extern int   ObjectTypeListOrder[];
extern int   ObjectBitmapIdList[];
extern int   ObjectSmallBitmapIdList[];
extern char  *GroundTextList[];
extern int   GroundTextureListID[];
extern short NoGroundTexts;
#endif
