/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file menuhelp.c */

// This file contains the table that maps the menu commands to their
// help strings, it contains the function that loads the table of data
// with the strings so that they are stored in RAM - this is probably
// not the best way to do it as reading from the resources file is very
// fast now - but in the old days Win 3.0 it was the best !!!!

#define MODULE_MENUHELP 1

#include "animate.h"

typedef struct tagMENUHELPDATA{
  int iCode,sCode;
  char *str;
} MENUHELPDATA;

static MENUHELPDATA MenuHelpData[NMENUHELPDATA]={
  0xFFFF,                      0xFFFF,                     NULL,
  IDM_FILE_LOAD_ANIMATION,     IDH_FILE_LOAD_ANIMATION,    NULL,
  IDM_FILE_LOAD_TEMPLATE,      IDH_FILE_LOAD_TEMPLATE,     NULL,
  IDM_FILE_LOAD_NEW,           IDH_FILE_LOAD_NEW,          NULL,
  IDM_FILE_SAVEOLD,            IDH_FILE_SAVEOLD,           NULL,
  IDM_FILE_SAVE,               IDH_FILE_SAVE,              NULL,
  IDM_FILE_EXP_ASCRIPT,        IDH_FILE_EXP_ASCRIPT,       NULL,
  IDM_FILE_EXP_FSCRIPT,        IDH_FILE_EXP_FSCRIPT,       NULL,
  IDM_FILE_EXP_AMSCRIPT,       IDH_FILE_EXP_AMSCRIPT,      NULL,
  IDM_FILE_EXP_FMSCRIPT,       IDH_FILE_EXP_FMSCRIPT,      NULL,
  IDM_FILE_EXP_VRML,           IDH_FILE_EXP_VRML,          NULL,
  IDM_FILE_MODELER,            IDH_FILE_MODELER,           NULL,
  IDM_FILE_KEYFRAMER,          IDH_FILE_KEYFRAMER,         NULL,
  IDM_FILE_KEYFRAMERDOCK,      IDH_FILE_KEYFRAMERDOCK,     NULL,
  IDM_FILE_VIEWER,             IDH_FILE_VIEWER,            NULL,
  IDM_FILE_PLAYER,             IDH_FILE_PLAYER,            NULL,
  IDM_FILE_PLAYAVI,            IDH_FILE_PLAYAVI,           NULL,
  IDM_FILE_FLI2AVI,            IDH_FILE_FLI2AVI,           NULL,
  IDM_FILE_FLI2GIF,            IDH_FILE_FLI2GIF,           NULL,
  IDM_FILE_ANIM,               IDH_FILE_ANIM,              NULL,
  IDM_FILE_AUDIO,              IDH_FILE_AUDIO,             NULL,
  IDM_FILE_AVI2MPG,            IDH_FILE_AVI2MPG,           NULL,
  IDM_FILE_PLAYMPG,            IDH_FILE_PLAYMPG,           NULL,
  IDM_FILE_GIF2AVI,            IDH_FILE_GIF2AVI,           NULL,
  IDM_FILE_PRINT,              IDH_FILE_PRINT,             NULL,
  IDM_FILE_PRINTSETUP,         IDH_FILE_PRINTSETUP,        NULL,
  IDM_FILE_PREFERENCES,        IDH_FILE_PREFERENCES,       NULL,
  IDM_FILE_EXIT,               IDH_FILE_EXIT,              NULL,

  IDM_ACTOR_ADD_A,             IDH_ACTOR_ADD_A,            NULL,
  IDM_ACTOR_ADD_C,             IDH_ACTOR_ADD_C,            NULL,
  IDM_ACTOR_ADD_E,             IDH_ACTOR_ADD_E,            NULL,
  IDM_ACTOR_ADD_X,             IDH_ACTOR_ADD_X,            NULL,
  IDM_ACTOR_DEL_A,             IDH_ACTOR_DEL_A,            NULL,
  IDM_ACTOR_DEL_C,             IDH_ACTOR_DEL_C,            NULL,
  IDM_ACTOR_DEL_E,             IDH_ACTOR_DEL_E,            NULL,
  IDM_ACTOR_SELECT,            IDH_ACTOR_SELECT,           NULL,
  IDM_ACTOR_INFO,              IDH_ACTOR_INFO,             NULL,
  IDM_ACTOR_AXIS_PLACE,        IDH_ACTOR_AXIS_PLACE,       NULL,
  IDM_ACTOR_TOOL_GRAB,         IDH_ACTOR_TOOL_GRAB,        NULL,
  IDM_ACTOR_TOOL_ROTATE,       IDH_ACTOR_TOOL_ROTATE,      NULL,
  IDM_ACTOR_TOOL_SIZE,         IDH_ACTOR_TOOL_SIZE,        NULL,
  IDM_ACTOR_TOOL_POSE,         IDH_ACTOR_TOOL_POSE,        NULL,
  IDM_ACTOR_TOOL_PLOTPOS,      IDH_ACTOR_TOOL_PLOTPOS,     NULL, // not used
  IDM_ACTOR_TOOL_PLOTROT,      IDH_ACTOR_TOOL_PLOTROT,     NULL, // not used
  IDM_ACTOR_TOOL_UNDO,         IDH_ACTOR_TOOL_UNDO,        NULL,
  IDM_ACTOR_ACTCAMERA,         IDH_ACTOR_ACTCAMERA,        NULL,
  IDM_ACTOR_USEDIRECTOR,       IDH_ACTOR_USEDIRECTOR,      NULL,
  IDM_ACTOR_SWAP,              IDH_ACTOR_SWAP,             NULL,
  IDM_ACTOR_SWAP_ALL,          IDH_ACTOR_SWAP_ALL,         NULL,
  IDM_ACTOR_RENAME,            IDH_ACTOR_RENAME,           NULL,
  IDM_ACTOR_TOOL_GRABABS,      IDH_ACTOR_TOOL_GRABABS,     NULL,
  IDM_ACTOR_TOOL_ROTATEABS,    IDH_ACTOR_TOOL_ROTATEABS,   NULL,
  IDM_ACTOR_TOOL_SIZEABS,      IDH_ACTOR_TOOL_SIZEABS,     NULL,
  IDM_EDIT_MODEL,              IDH_EDIT_MODEL,             NULL,
  IDM_EDIT_XIMAGE,             IDH_EDIT_XIMAGE,            NULL,

  IDM_ACTOR_AXIS_SH,           IDH_ACTOR_AXIS_SH,          NULL,
  IDM_ACTOR_AXIS_SNAP,         IDH_ACTOR_AXIS_SNAP,        NULL,
  IDM_EDIT_SPLINETWEEN,        IDH_EDIT_SPLINETWEEN,       NULL,

  IDM_PATH_EDIT,               IDH_PATH_EDIT,              NULL, //
  IDM_PATH_SUBDIVIDE,          IDH_PATH_SUBDIVIDE,         NULL, //
  IDM_PATH_DELETE,             IDH_PATH_DELETE,            NULL, //
  IDM_PATH_PICK_NEXT,          IDH_PATH_PICKNEXT,          NULL, //
  IDM_PATH_PICK_PREVIOUS,      IDH_PATH_PICKPREVIOUS,      NULL, //
  IDM_PATH_PICK_FIRST,         IDH_PATH_PICKFIRST,         NULL, //
  IDM_PATH_CURSORTO_START,     IDH_PATH_CURSORTO_START,    NULL, //
  IDM_PATH_CURSORTO_END,       IDH_PATH_CURSORTO_END,      NULL, //
  IDM_PATH_CURSORTO_POINT,     IDH_PATH_CURSORTO_POINT,    NULL, //
  IDM_PATH_GRAPH_POSITION,     IDH_PATH_GRAPH_POSITION,    NULL,
  IDM_PATH_REVERSE,            IDH_PATH_REVERSE,           NULL,
  IDM_PATH_GRAPH_POSITION,     IDH_PATH_GRAPH_VELOCITY,    NULL,

  IDM_TIMELINE_LINE_ADDP,      IDH_TIMELINE_LINE_ADDP,     NULL,
  IDM_TIMELINE_LINE_ADDR,      IDH_TIMELINE_LINE_ADDR,     NULL,
  IDM_TIMELINE_LINE_ADDX,      IDH_TIMELINE_LINE_ADDX,     NULL,
  IDM_TIMELINE_KEY_ADDP,       IDH_TIMELINE_KEY_ADDP,      NULL,
  IDM_TIMELINE_KEY_ADDR,       IDH_TIMELINE_KEY_ADDR,      NULL,
  IDM_TIMELINE_KEY_ADDX,       IDH_TIMELINE_KEY_ADDX,      NULL,
  IDM_TIMELINE_KEY_RESETP,     IDH_TIMELINE_KEY_RESETP,    NULL,
  IDM_TIMELINE_KEY_RESETR,     IDH_TIMELINE_KEY_RESETR,    NULL,
  IDM_TIMELINE_KEY_RESETX,     IDH_TIMELINE_KEY_RESETX,    NULL,
  IDM_TIMELINE_KEY_SHIFT,      IDH_TIMELINE_KEY_SHIFT,     NULL,

  IDM_FRAME_GO_FIRST,          IDH_FRAME_GO_FIRST,         NULL,
  IDM_FRAME_GO_PREVIOUS,       IDH_FRAME_GO_PREVIOUS,      NULL,
  IDM_FRAME_GO_NEXT,           IDH_FRAME_GO_NEXT,          NULL,
  IDM_FRAME_GO_LAST,           IDH_FRAME_GO_LAST,          NULL,
  IDM_FRAME_GO_FRAME,          IDH_FRAME_GO_FRAME,         NULL,
  IDM_FRAME_PLAY_WIRE,         IDH_FRAME_PLAY_WIRE,        NULL,
  IDM_FRAME_PLAY_QUICK,        IDH_FRAME_PLAY_QUICK,       NULL,
  IDM_FRAME_PLAY_FULL,         IDH_FRAME_PLAY_FULL,        NULL,
  IDM_FRAME_QUICKRENDER,       IDH_FRAME_QUICKRENDER,      NULL,
  IDM_FRAME_RENDER,            IDH_FRAME_RENDER,           NULL,
  IDM_FRAME_SHOW,              IDH_FRAME_SHOW,             NULL,
  IDM_FRAME_PREVIEW_MAKE,      IDH_FRAME_PREVIEW_MAKE,     NULL,
  IDM_FRAME_PREVIEW_SHOW,      IDH_FRAME_PREVIEW_SHOW,     NULL,
  IDM_FRAME_PREVIEW_FREE,      IDH_FRAME_PREVIEW_FREE,     NULL,
  IDM_FRAME_SETNUMBER,         IDH_FRAME_SETNUMBER,        NULL,

  IDM_VIEW_DRAW_BOUNDED,       IDH_VIEW_DRAW_BOUNDED,      NULL,
  IDM_VIEW_DRAW_SELECTED,      IDH_VIEW_DRAW_SELECTED,     NULL,
  IDM_VIEW_DRAW_DESELECTED,    IDH_VIEW_DRAW_DESELECTED,   NULL,
  IDM_VIEW_DRAW_ALL,           IDH_VIEW_DRAW_ALL,          NULL,
  IDM_VIEW_LOCKBOUNDED,        IDH_VIEW_LOCKBOUNDED,       NULL,
  IDM_VIEW_GLOBALQUICKDRAW,    IDH_VIEW_GLOBALQUICKDRAW,   NULL,
  IDM_VIEW_GRID,               IDH_VIEW_GRID,              NULL,
  IDM_VIEW_DRAW_GRID,          IDH_VIEW_DRAW_GRID,         NULL,
  IDM_VIEW_DEFINEGRID,         IDH_VIEW_DEFINEGRID,        NULL,
  IDM_ZOOM_IN,                 IDH_ZOOM_IN,                NULL,
  IDM_ZOOM_OUT,                IDH_ZOOM_OUT,               NULL,
  IDM_ZOOM_CENTRE,             IDH_ZOOM_CENTRE,            NULL,
  IDM_VIEW_RESTORE,            IDH_VIEW_RESTORE,           NULL,
  IDM_VIEW_FULL,               IDH_VIEW_FULL,              NULL,
  IDM_VIEW_SCREENCOLOURS,      IDH_VIEW_SCREENCOLOURS,     NULL,
  IDM_VIEW_FEEDBACK_CAMERA,    IDH_VIEW_FEEDBACK_CAMERA,   NULL,
  IDM_VIEW_FEEDBACK_LIGHT,     IDH_VIEW_FEEDBACK_LIGHT,    NULL,
  IDM_VIEW_FEEDBACK_CURSOR,    IDH_VIEW_FEEDBACK_CURSOR,   NULL,

  IDM_WINDOW_SWITCHWINDOWS,    IDH_WINDOW_SWITCH,          NULL,
  IDM_VIEW_SWAPVIEWPOINT,      IDH_VIEW_SWAPVIEWPOINT,     NULL,
  IDM_WINDOW_RESET,            IDH_WINDOW_RESET,           NULL,
  IDM_WINDOW_TOOLLEFT,         IDH_WINDOW_TOOLLEFT,        NULL,
  IDM_WINDOW_BIGCAMERA,        IDH_WINDOW_BIGCAMERA,       NULL,
  IDM_WINDOW_COORDS,           IDH_WINDOW_COORDS,          NULL,
  IDM_WINDOW_COORD_DEF,        IDH_WINDOW_COORD_DEF,       NULL,
  IDM_WINDOW_COORD_LAST,       IDH_WINDOW_COORD_LAST,      NULL,
  IDM_WINDOW_CLOSE,            IDH_WINDOW_CLOSE,           NULL,
  IDM_WINDOW_HIDETOOLS,        IDH_WINDOW_HIDETOOLS,       NULL,
  IDM_WINDOW_SELECT,           IDH_WINDOW_SELECT,          NULL,
  IDM_FILE_EXP_OPENGL,         IDH_FILE_EXP_OPENGL,        NULL,
  IDM_WINDOW_SHOWOPENGL,       IDH_WINDOW_SHOWOPENGL,      NULL,

  IDM_STOP,                    IDH_STOP,                   NULL,
  IDM_HELP,                    IDH_EVIHELP,                NULL,
  IDM_HELP_GENERAL,            IDH_HELP_GENERAL,           NULL,
  IDM_HELP_HOME,               IDH_HELP_HOME,              NULL,
  IDM_HELP_SUPPORT,            IDH_HELP_SUPPORT,           NULL,
  IDM_HELP_HELP,               IDH_HELP_HELP,              NULL,
  IDM_HELP_ABOUT,              IDH_HELP_ABOUT,             NULL
};

void LoadMenuHelpTable(HWND hwnd){
 char *p;
 int i,cch;
 MenuHelpData[0].str=(char *)X__Malloc(32);
 strcpy(MenuHelpData[0].str,"      ");
 for(i=1;i<NMENUHELPDATA;i++){
   if((p = (char *)X__Malloc(CCHTEXTMAX)) == NULL)return;
   if((cch = LoadString(ghinst_main,MenuHelpData[i].sCode,p,CCHTEXTMAX)) == 0){
     X__Free(p);
     return;
   }
   p = (char *)X__Realloc(p,cch+1);
   if(p == NULL)return;
   MenuHelpData[i].str=p;
 }
}

UINT CheckMenuHelpData(UINT uItem){
 UINT i,id=0;       
 for(i=0;i<NMENUHELPDATA;i++){
   if(uItem == MenuHelpData[i].iCode){id=i; break;}
 }
 return id;
}

void DisplayMenuHelpData(HWND hwnd,UINT id){
 SendMessage(hwnd,SB_SETTEXT,(WPARAM)1,
             (LPARAM)MenuHelpData[id].str);
 return;
}

void FreeMenuHelpData(void){
 long i;
 for(i=0;i<NMENUHELPDATA;i++)
   if(MenuHelpData[i].str != NULL)X__Free(MenuHelpData[i].str);
 return;
}
