/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file menuid.h   for designer module */

#define ANIMATOR_MENU              10
#define ANIMATOR_ACCEL             11
#define TIMELINE_MENU              12

#define IDC_COORD_UPDATE            102
#define IDC_TIMEL_UPDATE            3

#define IDM_FILE_LOAD                  1000
#define IDM_FILE_LOAD_ANIMATION        1001
#define IDM_FILE_LOAD_TEMPLATE         1002
#define IDM_FILE_LOAD_NEW              1003
#define IDM_FILE_LOAD_STARTUP          1012
#define IDM_FILE_SAVEOLD               1004
#define IDM_FILE_SAVE                  1005
#define IDM_FILE_EXP_ASCRIPT           1006
#define IDM_FILE_EXP_FSCRIPT           1007
#define IDM_FILE_PRINT                 1008
#define IDM_FILE_PRINTSETUP            1009
#define IDM_FILE_PREFERENCES           1010
#define IDM_FILE_EXIT                  1011
#define IDM_FILE_LOAD_STARTUP          1012
#define IDM_FILE_EXP_OPENGL            1013
#define IDM_FILE_LOAD_DIRECT           1014
#define IDM_FILE_EXP_VRML              1015
#define IDM_FILE_EXP_FMSCRIPT          1016
#define IDM_FILE_EXP_AMSCRIPT          1017

#define IDM_ACTOR_TOOL_UNDO            1100
#define IDM_ACTOR_SELECT               1101
#define IDM_ACTOR_ADD_A                1102
#define IDM_ACTOR_DEL_A                1103
#define IDM_ACTOR_INFO                 1104
#define IDM_ACTOR_TOOL_GRABABS         1105
#define IDM_ACTOR_TOOL_ROTATEABS       1106
#define IDM_ACTOR_TOOL_SIZEABS         1107
#define IDM_ACTOR_RENAME               1108
#define IDM_ACTOR_ADD_C                1109
#define IDM_ACTOR_DEL_C                1110
#define IDM_ACTOR_ADD_E                1111
#define IDM_ACTOR_ADD_X                1112
#define IDM_ACTOR_SWAP                 1113
#define IDM_ACTOR_SWAP_ALL             1114
#define IDM_PATH_GRAPH_POSITION        1115
#define IDM_PATH_REVERSE               1116

#define IDM_FILE_MODELER         1040
#define IDM_FILE_KEYFRAMER       1050
#define IDM_FILE_KEYFRAMERDOCK   1051
#define IDM_FILE_VIEWER          1060
#define IDM_FILE_PLAYER          1071
#define IDM_FILE_FLI2AVI         1072
#define IDM_FILE_PLAYAVI         1073
#define IDM_FILE_FLI2GIF         1074
#define IDM_FILE_ANIM            1075
#define IDM_FILE_AUDIO           1076
#define IDM_FILE_AVI2MPG         1077
#define IDM_FILE_PLAYMPG         1078
#define IDM_FILE_GIF2AVI         1079

#define IDM_ACTOR_DEL_E          1123
#define IDM_ACTOR_AXIS_SH        1151
#define IDM_ACTOR_AXIS_SNAP      1152
#define IDM_ACTOR_AXIS_PLACE     1153
#define IDM_ACTOR_TOOL_GRAB      1161
#define IDM_ACTOR_TOOL_ROTATE    1162
#define IDM_ACTOR_TOOL_SIZE      1163
#define IDM_ACTOR_TOOL_POSE      1164
#define IDM_ACTOR_TOOL_PLOTPOS   1165
#define IDM_ACTOR_TOOL_PLOTROT   1166
#define IDM_ACTOR_TOOL_NODE      1167
#define IDM_ACTOR_TOOL_SHIFTER   1168
#define IDM_ACTOR_TOOL_PAN       1170
#define IDM_ACTOR_TOOL_ZOOMIN    1171
#define IDM_ACTOR_TOOL_ZOOMOUT   1172
#define IDM_ACTOR_ACTCAMERA      1180
#define IDM_EDIT_XIMAGE          1190
#define IDM_EDIT_SPLINETWEEN     1191
#define IDM_ACTOR_USEDIRECTOR    1192

#define IDM_PATH                 1200
#define IDM_PATH_EDIT            1210
#define IDM_PATH_SUBDIVIDE       1220
#define IDM_PATH_PICK            1230
#define IDM_PATH_PICK_NEXT       1231
#define IDM_PATH_PICK_PREVIOUS   1232
#define IDM_PATH_PICK_FIRST      1233
#define IDM_PATH_DELETE          1240
#define IDM_PATH_CURSORTO        1250
#define IDM_PATH_CURSORTO_START  1251
#define IDM_PATH_CURSORTO_END    1252
#define IDM_PATH_CURSORTO_POINT  1253

#define IDM_TIMELINE_LINE        1310
#define IDM_TIMELINE_LINE_ADDP   1311
#define IDM_TIMELINE_LINE_ADDR   1312
#define IDM_TIMELINE_LINE_ADDX   1313
#define IDM_TIMELINE_KEY_ADDP    1321
#define IDM_TIMELINE_KEY_ADDR    1322
#define IDM_TIMELINE_KEY_ADDX    1323
#define IDM_TIMELINE_KEY_SHIFT   1324
#define IDM_TIMELINE_KEY_RESETP  1325
#define IDM_TIMELINE_KEY_RESETR  1326
#define IDM_TIMELINE_KEY_RESETX  1327

#define IDM_TIMELINE_ACTOR_ADD         1330
#define IDM_TIMELINE_ACTOR_DELETE      1331
#define IDM_TIMELINE_ACTOR_RENAME      1332
#define IDM_TIMELINE_ACTOR_INFO        1333
#define IDM_TIMELINE_ACTOR_SAVEANIOBJ  1334
#define IDM_TIMELINE_ACTOR_ORDER       1335
#define IDM_TIMELINE_FRAMES            1340
#define IDM_TIMELINE_HIDE              1350

#define IDM_FRAME                1400
#define IDM_FRAME_GO             1410
#define IDM_FRAME_GO_FIRST       1411
#define IDM_FRAME_GO_PREVIOUS    1412
#define IDM_FRAME_GO_NEXT        1413
#define IDM_FRAME_GO_LAST        1414
#define IDM_FRAME_GO_NEXTKEY     1415
#define IDM_FRAME_GO_LASTKEY     1416
#define IDM_FRAME_GO_FRAME       1417
#define IDM_FRAME_PLAY           1420
#define IDM_FRAME_PLAY_WIRE      1421
#define IDM_FRAME_PLAY_QUICK     1422
#define IDM_FRAME_PLAY_FULL      1423
#define IDM_FRAME_RENDER         1430
#define IDM_FRAME_RENDERNOW      1431
#define IDM_FRAME_RENDERIN       1432
#define IDM_FRAME_QUICKRENDER    1433
#define IDM_FRAME_SHOW           1440
#define IDM_FRAME_PREVIEW        1450
#define IDM_FRAME_PREVIEW_MAKE   1451
#define IDM_FRAME_PREVIEW_SHOW   1452
#define IDM_FRAME_PREVIEW_FREE   1453
#define IDM_FRAME_SETNUMBER      1460
#define IDM_FRAME_HIDDENLINE     1470

#define IDM_VIEW                 1500
#define IDM_VIEW_DRAW            1510
#define IDM_VIEW_DRAW_BOUNDED    1511
#define IDM_VIEW_DRAW_SELECTED   1512
#define IDM_VIEW_DRAW_DESELECTED 1513
#define IDM_VIEW_DRAW_ALL        1514
#define IDM_VIEW_GLOBALQUICKDRAW 1515
#define IDM_VIEW_LOCKBOUNDED     1520
#define IDM_VIEW_GRID            1530
#define IDM_VIEW_DRAW_GRID       1531
#define IDM_VIEW_DEFINEGRID      1532
#define IDM_VIEW_RESTORE         1540
#define IDM_VIEW_FULL            1550
#define IDM_VIEW_SWAPVIEWPOINT   1560
#define IDM_VIEW_SCREENCOLOURS   1570
#define IDM_VIEW_FEEDBACK        1580
#define IDM_VIEW_FEEDBACK_CAMERA 1581
#define IDM_VIEW_FEEDBACK_LIGHT  1582
#define IDM_VIEW_FEEDBACK_CURSOR 1583

#define IDM_WINDOW               1600
#define IDM_WINDOW_COORDS        1610
#define IDM_WINDOW_COORD         1620
#define IDM_WINDOW_COORD_DEF     1621
#define IDM_WINDOW_COORD_LAST    1622
#define IDM_WINDOW_SWITCHWINDOWS 1630
#define IDM_WINDOW_SWITCHWINDOW0 1631
#define IDM_WINDOW_SWITCHWINDOW1 1632
#define IDM_WINDOW_BIGCAMERA     1633
#define IDM_WINDOW_ACTIVATE      1660
#define IDM_WINDOW_SHOWOPENGL    1661
#define IDM_WINDOW_TOOLLEFT      1662
#define IDM_WINDOW_RESET         1663
#define IDM_WINDOW_CLOSE         1670
#define IDM_WINDOW_HIDETOOLS     1680
#define IDM_WINDOW_SELECT        1690

#define IDM_STOP                 1700
#define IDM_STOP_TOOL            1701
#define IDM_QUIET_EDITLENS       1702
#define IDM_QUIET_EDITLIGHT      1703
#define IDM_QUIET_EDITCOSTUME    1704

#define IDM_HELP                 1800
#define IDM_HELP_HELP            1810
#define IDM_HELP_GENERAL         1820
#define IDM_HELP_ABOUT           1830
#define IDM_HELP_HOME            1831
#define IDM_HELP_SUPPORT         1832

#define IDM_ZOOM_IN              2021
#define IDM_ZOOM_OUT             2022
#define IDM_ZOOM_CENTRE          2023
#define IDM_ZOOM_WORLD           2024

#define IDM_PAN_UP               2028
#define IDM_PAN_DOWN             2029
#define IDM_PAN_LEFT             2030
#define IDM_PAN_RIGHT            2031
#define IDM_SELECT_ACTOR         2032
#define IDM_SELECT_PATH          2033
#define IDM_SELECT_CAMERA        2034
#define IDM_SELECT_CSG           2035
#define IDM_SELECT_ROBOT         2036
#define IDM_SELECT_LIGHT         2037
#define IDM_SELECT_TARGET        2038
#define IDM_SELECT_GROUND        2039
#define IDM_COORDS_DEFINE        2040
#define IDM_COORDS_ORIGIN        2041
#define IDM_COORDS_RELATIVE      2042
#define IDM_COORDS_MEASURE       2043
#define IDM_EDIT_MODEL           2044

// 2100  used by rengler GL

#define IDM_ACTOR_QADD           2200
#define IDM_ACTOR_QADD_MOD       2201
#define IDM_ACTOR_QADD_MORPH     2202
#define IDM_ACTOR_QADD_CAMERA    2203
#define IDM_ACTOR_QADD_TARGET    2204
#define IDM_ACTOR_QADD_LIGHT     2205
#define IDM_ACTOR_QADD_PATH      2206
#define IDM_ACTOR_QADD_SKY       2207
#define IDM_ACTOR_QADD_GROUND    2208
#define IDM_ACTOR_QADD_XIP       2209
#define IDM_ACTOR_QADD_ROBOT     2210
#define IDM_ACTOR_QADD_CSG       2211
#define IDM_ACTOR_QADD_DIRECTOR  2212

#define IDM_CONTEXT_TOOLSLEFT    2300
#define IDM_CONTEXT_TOOLSSMALL   2301


#define IDBM_TLL0U       2500
#define IDBM_TLL1U       2501
#define IDBM_TLL2U       2502
#define IDBM_TLL3U       2503
#define IDBM_TLL4U       2504
#define IDBM_TLL5U       2505
#define IDBM_TLL6U       2506
#define IDBM_TLL7U       2507
#define IDBM_TLL0D       2508
#define IDBM_TLL1D       2509
#define IDBM_TLL2D       2510
#define IDBM_TLL3D       2511
#define IDBM_TLL4D       2512
#define IDBM_TLL5D       2513
#define IDBM_TLL6D       2514
#define IDBM_TLL7D       2515

#define IDBM_ACT0U       2516
#define IDBM_ACT1U       2517
#define IDBM_ACT2U       2518
#define IDBM_ACT3U       2519
#define IDBM_ACT4U       2520
#define IDBM_ACT5U       2521
#define IDBM_ACT6U       2522
#define IDBM_ACT7U       2523
#define IDBM_ACT0D       2524
#define IDBM_ACT1D       2525
#define IDBM_ACT2D       2526
#define IDBM_ACT3D       2527
#define IDBM_ACT4D       2528
#define IDBM_ACT5D       2529
#define IDBM_ACT6D       2530
#define IDBM_ACT7D       2531

#define IDBM_SEL0U       2532
#define IDBM_SEL1U       2533
#define IDBM_SEL2U       2534
#define IDBM_SEL3U       2535
#define IDBM_SEL4U       2536
#define IDBM_SEL5U       2537
#define IDBM_SEL6U       2538
#define IDBM_SEL7U       2539
#define IDBM_SEL0D       2540
#define IDBM_SEL1D       2541
#define IDBM_SEL2D       2542
#define IDBM_SEL3D       2543
#define IDBM_SEL4D       2544
#define IDBM_SEL5D       2545
#define IDBM_SEL6D       2546
#define IDBM_SEL7D       2547

#define IDBM_ARROW_Zp    2548
#define IDBM_ARROW_Zm    2549
#define IDBM_ARROW_Xp    2550
#define IDBM_ARROW_Xm    2551
#define IDBM_ARROW_Yp    2552
#define IDBM_ARROW_Ym    2553

#define IDBM_WIN_T       2554
#define IDBM_WIN_S       2555
#define IDBM_WIN_R       2556
#define IDBM_WIN_F       2557
#define IDBM_WIN_C       2586

#define IDBM_A_MODEL     2558
#define IDBM_A_SKY       2559
#define IDBM_A_GROUND    2560
#define IDBM_A_LIGHT     2561
#define IDBM_A_ANIOBJ    2562
#define IDBM_A_ROBOT     2563
#define IDBM_A_CAMERA    2564
#define IDBM_A_PATH      2565
#define IDBM_A_CSG       2566
#define IDBM_A_TARGET    2567
#define IDBM_A_IMAGEP    2568
#define IDBM_A_DIRECTOR  2569

#define IDBM_QT1         2600
#define IDBM_QT2         2601
#define IDBM_QT3         2602
#define IDBM_QT4         2603

#define IDBM_CO1         2604
#define IDBM_CO2         2605
#define IDBM_CO3         2606
#define IDBM_CO4         2607
#define IDBM_CO5         2608

#define IDBM_TESTU       2609
#define IDBM_TESTD       2610

#define IDBM_WIN_Th      2611
#define IDBM_WIN_Sh      2612
#define IDBM_WIN_Rh      2613
#define IDBM_WIN_Fh      2614

#define IDBM_SKTOOLBAR   2615
#define IDBM_TIMELINE    2616

#define IDBM_PREV_FIRST  2617
#define IDBM_PREV_LAST   2618
#define IDBM_PREV_NEXT   2619
#define IDBM_PREV_PREV   2620
#define IDBM_PREV_PLAY   2621
#define IDBM_PREV_PAUSE  2622

#define IDBM_CROSS       2623

#define IDBM_TOOLBAR_B   2700
#define IDBM_TOOLBAR_H   2701
#define IDBM_TOOLBAR_D   2702
#define IDBM_TOOLBAR_I   2703
#define IDBM_TOOLBAR_M   2704

#define IDBM_STOOLBAR_B  2705
#define IDBM_STOOLBAR_H  2706
#define IDBM_STOOLBAR_D  2707
#define IDBM_STOOLBAR_I  2708
#define IDBM_STOOLBAR_M  2709

#define IDBM_MENU1_MO    2710
#define IDBM_MENU1_TA    2711
#define IDBM_MENU1_PA    2712
#define IDBM_MENU1_SK    2713
#define IDBM_MENU1_LI    2714
#define IDBM_MENU1_GR    2715
#define IDBM_MENU1_XI    2716
#define IDBM_MENU1_CS    2717
#define IDBM_MENU1_MF    2718
#define IDBM_MENU1_RO    2719
#define IDBM_MENU1_CA    2720
#define IDBM_MENU1_DR    2721

#define IDBM_S_MODEL     2730
#define IDBM_S_SKY       2731
#define IDBM_S_GROUND    2732
#define IDBM_S_LIGHT     2733
#define IDBM_S_ANIOBJ    2734
#define IDBM_S_ROBOT     2735
#define IDBM_S_CAMERA    2736
#define IDBM_S_PATH      2737
#define IDBM_S_CSG       2738
#define IDBM_S_TARGET    2739
#define IDBM_S_IMAGEP    2740
#define IDBM_S_DIRECTOR  2741

#define IDBM_GROUND1     2750
#define IDBM_GROUND2     2751
#define IDBM_GROUND3     2752

#define IDBM_BACKGROUND  2753
#define IDBM_ABOUT       2754

#define IDBM_I_LIGHT     2780
#define IDBM_I_CAMERA    2781

#define IDBM_DLG_BTNS    9999

#define IDC_NONE         3000
#define IDC_GRABBER      3001
#define IDC_ROTATOR      3002
#define IDC_SIZER        3003
#define IDC_TRACKER      3004
#define IDC_DIRECTOR     3005
#define IDC_PAN          3006
#define IDC_ZOOMIN       3007
#define IDC_ZOOMOUT      3008
#define IDC_XCROSS       3009
#define IDC_PATHED       3010
#define IDC_OPENARROW    3011
#define IDC_SKELETOR     3012
#define IDC_INSERT       3013
#define IDC_ZOOM         3014

#include "dialogs.h"


