/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

// file PREFS.C

#define MODULE_PREFS 1

#include "animate.h"

void LoadPreferences(void){
 char pref_id[32];
 Preferences.buttons=TRUE;
 Preferences.quick_trick=TRUE;
 Preferences.show_select=FALSE;
 Preferences.default_start=FALSE;
 Preferences.use_3d_dialogs=TRUE;
 Preferences.use_OpenGL=FALSE;
 Preferences.undo=FALSE;
 Preferences.use_positions=TRUE;
 Preferences.ground=FALSE;
 Preferences.big_camera=FALSE;
 Preferences.tooltips=TRUE;
 Preferences.toolleft=FALSE;
 Preferences.toolsmall=FALSE;
 Preferences.autocentre=TRUE;
 Preferences.detail_auto=TRUE;
 Preferences.detail_step=1;
 Preferences.background=TRUE;
 Preferences.auto_update_keyframer=TRUE;
 Preferences.use_gl_robot=FALSE;
 Preferences.splash = 1000;
 ActiveView=TRITOP;
 select_visible=0;
 GetPrivateProfileString(IniSection,"BUTTONS","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"NO",3) == 0){
   Preferences.buttons=FALSE;
 }
 GetPrivateProfileString(IniSection,"SELECTPANNEL","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0){
   Preferences.show_select=TRUE;
   select_visible=1;
 }
 GetPrivateProfileString(IniSection,"QUICKTRICK","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"NO",3) == 0){
   Preferences.quick_trick=FALSE;
 }
 GetPrivateProfileString(IniSection,"DEFAULTSTART","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0){
   Preferences.default_start=TRUE;
 }
 GetPrivateProfileString(IniSection,"DIALOGS3D","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"NO",3) == 0){
   Preferences.use_3d_dialogs=FALSE;
 }
 GetPrivateProfileString(IniSection,"UNDO","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0){
   Preferences.undo=TRUE;
 }
 GetPrivateProfileString(IniSection,"POSITIONS","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"NO",2) == 0){
   Preferences.use_positions=FALSE;
 }
 GetPrivateProfileString(IniSection,"GROUND","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0){
   Preferences.ground=TRUE;
 }
 GetPrivateProfileString(IniSection,"TOOLTIPS","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"NO",2) == 0){
   Preferences.tooltips=FALSE;
 }
 GetPrivateProfileString(IniSection,"BIGCAMERA","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0){
   Preferences.big_camera=TRUE;
 }
 GetPrivateProfileString(IniSection,"TOOLLEFT","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0)Preferences.toolleft=TRUE;
 if(strncmp(pref_id,"NO",2) == 0)Preferences.toolleft=FALSE;
 GetPrivateProfileString(IniSection,"TOOLSMALL","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0)Preferences.toolsmall=TRUE;
 if(strncmp(pref_id,"NO",2) == 0)Preferences.toolsmall=FALSE;
 GetPrivateProfileString(IniSection,"AUTOCENTRE","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"NO",2) == 0){
   Preferences.autocentre=FALSE;
 }
 Preferences.splash=GetPrivateProfileInt(IniSection,"SPLASH",
                    Preferences.splash,IniFilename);
 GetPrivateProfileString(IniSection,"BACKIMAGE","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0)Preferences.background=TRUE;
 if(strncmp(pref_id,"NO",2) == 0)Preferences.background=FALSE;
 bBackgroundImage=Preferences.background;
 bToolpannelLeft=Preferences.toolleft;
 bToolpannelSmall=Preferences.toolsmall;
 ActiveView=GetPrivateProfileInt(IniSection,"ACTIVEVIEW",TRITOP,
                                 IniFilename);
 FramesPerSec=GetPrivateProfileInt(IniSection,"FPS",FramesPerSec,
                                 IniFilename);
 GetPrivateProfileString(IniSection,"DETAILAUTO","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0)Preferences.detail_auto=1;
 if(strncmp(pref_id,"NO",2) == 0)Preferences.detail_auto=0;
 Preferences.detail_step=GetPrivateProfileInt(IniSection,"DETAILSTEP",
                         Preferences.detail_step,IniFilename);

 GetPrivateProfileString(IniSection,"QUICKDRAW","$$$",
                          pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0)global_quickdraw=1;
 if(strncmp(pref_id,"NO",2) == 0)global_quickdraw=0;
 AllDrawStatus=GetPrivateProfileInt(IniSection,"DRAWFULLTYPE",
                                    3,IniFilename);
 GetPrivateProfileString(IniSection,"DRAWFULL","$$$",
                          pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"NO",3) == 0)DrawStatus=0;
 if(strncmp(pref_id,"YES",2) == 0)DrawStatus=AllDrawStatus;
 GetPrivateProfileString(IniSection,"LIGHTCONES","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 show_camera_fov=1;
 show_light_cones=1;
 if(strncmp(pref_id,"YES",3) == 0)show_light_cones=1;
 if(strncmp(pref_id,"NO",2) == 0)show_light_cones=0;
 GetPrivateProfileString(IniSection,"CAMERAFOV","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0)show_camera_fov=1;
 if(strncmp(pref_id,"NO",2) == 0)show_camera_fov=0;
 GetPrivateProfileString(IniSection,"OPENGL1","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0)opengl_visible=1;
 if(strncmp(pref_id,"NO",2) == 0)opengl_visible=0;
 GetPrivateProfileString(IniSection,"GLROBOT","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0){
   Preferences.use_gl_robot=TRUE;
 }
 coords_visible=GetPrivateProfileInt(IniSection,"COORDSVISIBLE",
                                     coords_visible,IniFilename);
 draw_grid_on=GetPrivateProfileInt(IniSection,"DRAWGRIDON",
                                     draw_grid_on,IniFilename);
 grid_on=GetPrivateProfileInt(IniSection,"GRIDON",
                                     grid_on,IniFilename);
 return;
}

void ActivatePreferences(void){
 char pref_id[32];
 if(Preferences.undo)UNDO_ACTIVE=YES;
 if(Preferences.big_camera)PostMessage(ghwnd_main,WM_COMMAND,
                    (WPARAM)IDM_WINDOW_BIGCAMERA,(LPARAM)0);
 if(GetPrivateProfileInt(IniSection,"VIEW",View,IniFilename)
     == ONEVIEW)PostMessage(ghwnd_main,WM_COMMAND,
                           (WPARAM)IDM_WINDOW_SWITCHWINDOWS,(LPARAM)0);
 if(global_quickdraw)CheckMenuItem(GetMenu(ghwnd_main),
                     IDM_VIEW_GLOBALQUICKDRAW,MF_CHECKED);
 else                CheckMenuItem(GetMenu(ghwnd_main),
                     IDM_VIEW_GLOBALQUICKDRAW,MF_UNCHECKED);
 if(AllDrawStatus == 1)CheckMenuItem(GetMenu(ghwnd_main),
                           IDM_VIEW_DRAW_SELECTED  ,MF_CHECKED);
 if(AllDrawStatus == 2)CheckMenuItem(GetMenu(ghwnd_main),
                           IDM_VIEW_DRAW_DESELECTED,MF_CHECKED);
 if(AllDrawStatus == 3)CheckMenuItem(GetMenu(ghwnd_main),
                           IDM_VIEW_DRAW_ALL       ,MF_CHECKED);
 if(DrawStatus == 0){
   char tt[128];
   LoadString(ghinst_main,IDX_MISC_DRAWFULL,tt,128);
   ModifyMenu(GetMenu(ghwnd_main),IDM_VIEW_DRAW_BOUNDED,
              MF_BYCOMMAND|MF_STRING,IDM_VIEW_DRAW_BOUNDED,tt);
 }
 else{
   char tt[128];
   LoadString(ghinst_main,IDX_MISC_DRAWBOUNDED,tt,128);
   ModifyMenu(GetMenu(ghwnd_main),IDM_VIEW_DRAW_BOUNDED,
              MF_BYCOMMAND|MF_STRING,IDM_VIEW_DRAW_BOUNDED,tt);
   EnableMenuItem(GetMenu(ghwnd_main),IDM_VIEW_DRAW_SELECTED,MF_ENABLED);
   EnableMenuItem(GetMenu(ghwnd_main),IDM_VIEW_DRAW_DESELECTED,MF_ENABLED);
   EnableMenuItem(GetMenu(ghwnd_main),IDM_VIEW_DRAW_ALL,MF_ENABLED);
 }
 if(show_camera_fov)CheckMenuItem(GetMenu(ghwnd_main),
                        IDM_VIEW_FEEDBACK_CAMERA,MF_CHECKED);
 else               CheckMenuItem(GetMenu(ghwnd_main),
                        IDM_VIEW_FEEDBACK_CAMERA,MF_UNCHECKED);
 if(show_light_cones)CheckMenuItem(GetMenu(ghwnd_main),
                         IDM_VIEW_FEEDBACK_LIGHT,MF_CHECKED);
 else                CheckMenuItem(GetMenu(ghwnd_main),
                         IDM_VIEW_FEEDBACK_LIGHT,MF_UNCHECKED);
 GetPrivateProfileString(IniSection,"KEYDOCK","$$$",
                   pref_id,sizeof(pref_id),IniFilename);
 if(strncmp(pref_id,"YES",3) == 0)keyframer_docked=1;
 if(strncmp(pref_id,"NO",2) == 0)keyframer_docked=0;
 if(keyframer_docked)
   CheckMenuItem(GetMenu(ghwnd_main),IDM_FILE_KEYFRAMERDOCK,MF_CHECKED);
 else
   CheckMenuItem(GetMenu(ghwnd_main),IDM_FILE_KEYFRAMERDOCK,MF_UNCHECKED);
 if(coords_visible){
   if(IsWindow(ghwndCoord1))ShowWindow(ghwndCoord1,SW_SHOWNA);
   CheckMenuItem(GetMenu(ghwnd_main),IDM_WINDOW_COORDS,MF_CHECKED);
 }
 if(draw_grid_on)CheckMenuItem(GetMenu(ghwnd_main),IDM_VIEW_DRAW_GRID,MF_CHECKED);
 if(grid_on)CheckMenuItem(GetMenu(ghwnd_main),IDM_VIEW_GRID,MF_CHECKED);
}
