/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file PROTOS.H  prototypes for global functions */

/* Window Class Window handlers */

LRESULT CALLBACK MainAnimatorWndProc(HWND hwnd, UINT msg, WPARAM wparam,
                                    LPARAM lparam);
LRESULT CALLBACK AnimatorTriViewWndProc(HWND hwnd, UINT msg, WPARAM wparam,
                                    LPARAM lparam);
LRESULT CALLBACK AnimatorViewWndProc(HWND hwnd, UINT msg, WPARAM wparam,
                                    LPARAM lparam);
LRESULT CALLBACK AnimatorInfoWndProc(HWND hwnd, UINT msg, WPARAM wparam,
                                    LPARAM lparam);
LRESULT CALLBACK ToolboxWndProc(HWND hwnd,UINT msg,WPARAM wParam,
                                    LPARAM lParam);
LRESULT CALLBACK ToolBtnWndProc(HWND hwnd,UINT msg,WPARAM wParam,
                                    LPARAM lParam);
LRESULT CALLBACK QuicktimeWndProc(HWND hwnd,UINT msg,WPARAM wParam,
                                    LPARAM lParam);

#ifdef MODULE_ANIMATE
#define WHERE
#else
#define WHERE extern
#endif
WHERE void InitializeLastFilesList(void);
#undef WHERE

#ifdef MODULE_TOOLBOX
#define WHERE
#else
#define WHERE extern
#endif
WHERE void ChangeToolboxBitmaps(void);
WHERE void MoveToolsWindow(void);
WHERE void EnableTools(BOOL);
WHERE void ToolboxSelectTool(int);
WHERE void ToolboxShow(BOOL);
WHERE void ToolboxDestroy(void);
WHERE void AugmentToolPannel(BOOL);
WHERE void ToolboxSetPosition(int);
WHERE void UpdateFrameBox(void);
WHERE LRESULT CALLBACK CoordinatesDlgProc(HWND hdlg,UINT msg,
                            WPARAM wparam,LPARAM lparam);
#undef WHERE

#ifdef MODULE_UTILS
#define WHERE
#else
#define WHERE extern
#endif
WHERE void Nudge(int command);
WHERE PATHEDITCONTROL *CreatePathEditControlPoint(int *nPec,
                 PATHEDITCONTROL **Pec,
                 PATHEDITCONTROL *last,
                 PATHEDITCONTROL *next,
                 int frame, double distance);
WHERE void DeletePathEditControlPoint(int *nPec,
                 PATHEDITCONTROL **Pec,
                 PATHEDITCONTROL *here);
WHERE pathpoint *AppendPathPoint(pathpoint *Ppp);
WHERE void CreatePathPoint(void);
WHERE void DeletePathPoint(void);
WHERE pathpoint *CreateIPointPath(short type, node *Np, short firstframe,
                            short *pathtype, short *npathpoints);
WHERE void ReleaseNurbs(nurbs *n);
WHERE BOOL AllocNurbs(nurbs *n, double *ukv, double *vkv);
WHERE void FreeNurbs(long n, nurbs *Np);
WHERE void DeleteActor(node *Np, long frame);
WHERE object *CreateActor(node *Np, long firstframe, long lastframe);
WHERE void DeleteSize(node *Np, long frame);
WHERE size *CreateSize(node *Np, long firstframe, long lastframe);
WHERE void DeleteAlign(node *Np, long frame);
WHERE align *CreateAlign(node *Np, long firstframe, long lastframe);
WHERE void DeletePosition(node *Np, long frame);
WHERE position *CreatePosition(node *Np, long firstframe, long lastframe);
WHERE void DeleteSky(node *Np, long frame);
WHERE sky *CreateSky(node *Np, long firstframe, long lastframe);
WHERE void DeleteDirector(node *Np, long frame);
WHERE director *CreateDirector(node *Np, long firstframe, long lastframe);
WHERE void DeleteNode(node *Np);
WHERE node *CreateNode(void);
WHERE pathpoint *CopyPath(short *pathtype, short *npathpoints, node *Nc,
                    short firstframe, HWND parent);
WHERE void CheckRecursiveFollow(node *Np, short ff, short lf);
WHERE void ScrapEverything(void);
WHERE long SelectNodeID(HWND);
WHERE node *SelectNode(char *, short , HWND);
WHERE void CentreDialogOnCursor(HWND);
WHERE void CentreDialogOnScreen(HWND);
WHERE void AppendFileExtension(char *, char *);
WHERE char *short_form(char *);
WHERE char *truncate_path(char *, int);
WHERE node *GetSelectedCamera(long cf, node *Sc);
#undef WHERE

#ifdef MODULE_LOADER
#define WHERE
#else
#define WHERE extern
#endif
WHERE void RestoreWhiteSpaces(char *s);
WHERE void HideWhiteSpaces(char *s);
WHERE short LoadStage(char *filename);
WHERE short StageLoadObject(char *FileName, object *Op, short report,
                      short check, short robot);
WHERE pathpoint *LoadPath(short *pathtype, short *npathpoints, HWND parent);
WHERE short SaveStage(char *filename, BOOL backup);
WHERE BOOL MakeScript(long type, long nstep);
WHERE BOOL MakeVRMLScript(short type);
WHERE void DeleteEffect(object *op);
WHERE void AddEffect(object *op, HWND parent);
WHERE void EditActorEffect(object *op, HWND parent);
WHERE void LoadAnimObject(node *, short, short, HWND);
WHERE void SaveAnimFile(node *Np);
WHERE void LogOnMessage(void);
WHERE HMODULE LoadEffectLibrary(char *name, object *op);
WHERE void UnloadEffectLibrary(object *op);
WHERE BOOL PrintImageFile(HWND hwnd);
WHERE void DeleteImageProcess(XIP *Ip);
WHERE XIP *CreateImageProcess(HWND parent);
WHERE void EditImageProcess(HWND hdlg, XIP *Ip);
WHERE char *EditObjectImageProcess(HWND parent, char *p);
WHERE void Save_UndoA(void);
WHERE void Restore_UndoA(void);
WHERE void StartExternGL(void);
WHERE void ExecuteModeler(void);
WHERE void UnloadRenderer(void);
WHERE void LoadRenderer(int anim);
WHERE void LoadUtility(char *, char *, int);
WHERE void ReplaceObjectFile(object *Lop, char *NewName);
WHERE void ReplaceOneObjectFile(node *, object *Lop, char *);
#undef WHERE

#ifdef MODULE_LIBS
#define WHERE
#else
#define WHERE extern
#endif
WHERE short RequestNumEntry(long val, long minval, long maxval,
                      char *title, char *message);
WHERE int RequestCharString(int len, char *string, char *title);
WHERE void EnableToolPannels(int what_one, BOOL status);
WHERE void ActivateAllMenus(HWND hwnd, UINT fuFlags);
WHERE int SelectScrolledItemList(int, char **, char *, BOOL, HWND);
WHERE int SelectItemList(int n, char **list, char *title);
WHERE int SelectItems(int n, char **list, char *title, int where);
WHERE PSTR FileInPath(PSTR pstrPath);
WHERE void GetTriview(BOOL reset);
WHERE void ( *GetWorldCoords)(int W, long *x, long *y,
                             long *z, int hpos, int vpos);
WHERE void ( *GetWindowCoords)(int W, long x, long y,
                             long z,  int *hpos,  int *vpos);
WHERE void SetUpWindowBoxView(int view);
WHERE void DrawOne3dCursor(HDC hdc, int i);
WHERE void Draw3dCursor(void);
WHERE void Move3dCursor(int stor, int xw, int yw);
WHERE void LoadArrowIcons(void);
WHERE void DrawArrowIcons(HDC hdc, int id);
WHERE int CheckWindowIcon(int xi, int yi);
WHERE void InvertWindowIcon(int i, HWND hwnd);
WHERE int CheckViewWindowIcon(int xi, int yi);
WHERE void InvertViewWindowIcon(int i, HWND hwnd);
WHERE void DeleteArrowIcons(void);
WHERE void SwapViewBitmaps(void);
WHERE void UpdateRuler(short );
WHERE void SetUpGrid(void);
WHERE int Read3Reals(char *title, double *r1, double *r2, double *r3,
                     int list);
WHERE void DrawGrid(HDC hdc[]);
WHERE void SetColour(unsigned char colour[], char *Title, HWND parent);
WHERE void SetSfxColour(unsigned char colour[], long ID, HWND parent);
WHERE void PaintDialogBackground(HWND hDlg, HINSTANCE hInst);
WHERE void scal(double t[4][4], double sx, double sy, double sz);
WHERE void rotz(double tr[4][4], double ang);
WHERE void roty(double tr[4][4], double ang);
WHERE void rotx(double tr[4][4], double ang);
WHERE void tram(double t[4][4], double dx, double dy, double dz);
WHERE void m4by4(double t1[4][4], double t2[4][4], double tr[4][4]);
WHERE void m4by1(double t4[4][4], double x, double y, double z,
                 double *xx, double *yy, double *zz);
WHERE void null_transform(double t[4][4]);
WHERE void c4to4(double tin[4][4], double tout[4][4]);
WHERE void arbitrary_rotate(double angle, point p1, point p2, double t[4][4]);
WHERE void L_cross(point p1, point p2, point p3, point p4);
#undef WHERE

#ifdef MODULE_DRAW
#define WHERE
#else
#define WHERE extern
#endif
WHERE void ScalePoint(double scalex, double scaley, double scalez,
                point p, point r);
WHERE void CopyPoint(point p1, point p2);
WHERE void AddPoints(point p1, point p2, point result);
WHERE void SubPoints(point p1, point p2, point result);
WHERE short in_stage_triview(point vp);
WHERE void get_centre_stage(point p, point TVp);
WHERE void  Transform(long n ,point Ain[], point Aout[], point Offset,
                double p, double t, double a, short im, double ima);
WHERE double GetOffsetPosition(node *Np,object *Op,
                               long frame, double dframe,
                               point ObjectOffset);
WHERE short GetTransform(short stacking,
             long frame, double dframe,
             node *Np, object *Op,
             point ObjectOffset, point TrackedOffset,
             double *phi, double *theta, double *alpha,
             double *sx,  double *sy,    double *sz,
             short *im, double *ima);
WHERE void DrawArrow(HDC hdc[], point Offset,
                     double p, double t, double a,
                     short im, double ima, double scale);
WHERE void DrawDirectionLine(HDC hdc[],
               point Offset,
               double p, double t, double a,
               short im, double ima, double scale);
WHERE void DrawActorCentre(HDC hdc[],point v1,
                     double p, double t, double a,
                     short im, double ima, double scale);
WHERE void DrawNode(HDC hDC[], node *Np, short status);
WHERE void DrawInvertNode(HDC hDC[], node *Np, short status);
WHERE void ReDrawStageDisplay(BOOL);
WHERE void ReDrawQuickDisplay(BOOL);
WHERE int CheckBoundingObject(int type, int ifd, int hx, int vy,
               object *Op, point Offset, double p,
               double t, double a, short im, double ima,
               double sx, double sy, double sz, double *dc);
#undef WHERE

#ifdef MODULE_PATH
#define WHERE
#else
#define WHERE extern
#endif
WHERE long SplinesP(double k[], double tau);
WHERE double SplinesR(double k[], double tau);
WHERE void SplinesK(double k[], long vl, long v1, long v2, long vn);
WHERE void SplinesG(double k[], double xi, double xi1, double xig, double xig1);
WHERE void DrawPath(HDC hdc[], object *Op, point Offset,
                    double p, double t, double a,
                    short im, double ima, short status);
WHERE void ReversePathDirection(object *op);
WHERE double PathLength(pathpoint *Ppp, short type, short Npoints);
WHERE void PathInterp(double pathposition, pathpoint *Lpp,
                pathpoint *Ppp, point ObjectOffset,
                double distance, pathpoint *Fpp,
                pathpoint *Epp, short type);
WHERE object *GetPathPosition(node *Np, long frame, double dframe,
                        point ObjectOffset,
                        double *position0_1, double *lengthonpath);
WHERE double *ReTweenVelocity(object *op, double *v,
                        int oldn, int newn,
                        double pathlength,
                        int copy);
WHERE void EditPathMovement(short type);
#undef WHERE

#ifdef MODULE_ANI_PRSP
#define WHERE
#else
#define WHERE extern
#endif
WHERE void PerspectiveView(int smab, int DisplayType);
WHERE void DrawPerspectiveView(int smab, int DisplayType,
                           HDC hDC, HWND hWnd, HPEN hPen);
WHERE void DrawViewRobot(HDC hdcView, HBITMAP hbmView, HWND hWnd,
                          node *Np, int arm, int axis,
                          double ra, double ua, BOOL zoom, BOOL zoom_state);
WHERE void FreePreview(void);
WHERE int MakePreview(void);
WHERE void StartPreviewPlayer(HWND hwnd);
WHERE void StopPreviewPlayer(HWND hwnd);
WHERE void MoveCtrlWindow(HWND, int, int, int, int, int, int );
#undef WHERE

#ifdef MODULE_TOOLS
#define WHERE
#else
#define WHERE extern
#endif
WHERE void ExecuteActorsMenu(HWND);
WHERE void DisengageTool(void);
WHERE void EngageTool(int);
WHERE int CheckClosestObject(int w,double *dmin,point vp,int hx,int vy,int r);
WHERE BOOL PickClosestNode(int wid,int hx,int vy, BOOL pick_only);
WHERE BOOL PickClosestPathPoint(int wid, int hx, int vy);
WHERE object *PickNode(short type1, short type2);
WHERE void SetNewPosition(long pX, long pY, long pZ, short abrel);
WHERE void EnterGrabMode(void);
WHERE void LeaveGrabMode(void);
WHERE position *IsValidPosition(void);
WHERE int StageGrabIdentify(void);
WHERE void InstantStageGrab(void);
WHERE void StageGrabOn(void);
WHERE void StageGrabOff(short redraw);
WHERE void StageGrab(short where, short which);
WHERE void InstantStageRotate(void);
WHERE void StageRotateOn(void);
WHERE void RotateOff(long redraw);
WHERE void StageRotate(long window_id);
WHERE void StageStepRotate(int command);
WHERE void Resize(void);
WHERE void InstantStageXpnd(void);
WHERE void SizeOff(short redraw);
WHERE void StageSizeOn(void);
WHERE void AnimatorUndo(void);
WHERE void SnapTo(short option);
WHERE void EditPathOn(void);
WHERE void EditPathOff(short redraw);
WHERE void AdjustPathTension(long window_id);
WHERE void EditPath(void);
WHERE void DrawActorTrack(HDC hdc[], short mode);
WHERE void SwitchTrackerType(void);
WHERE int ShiftKeyFrameActivate(int x, int y);
WHERE void ShiftKeyFrameDeactivate(void);
WHERE void ShiftKeyFrame(int x, int y);
WHERE void ShifterOn(void);
WHERE void ShifterOff(short redraw);
WHERE void AnglerOn(void);
WHERE void AnglerOff(short redraw);
WHERE void AngleKeyFrame(int x, int y);
WHERE void DrawActorRotations(HDC hdc [], short mode);
WHERE BOOL PanToolDown(int , int , BOOL , BOOL, HWND);
WHERE void PanToolMove(int , int , BOOL , BOOL, HWND);
WHERE void PanToolUp(int , int , BOOL , BOOL, HWND);
WHERE void ZoomView(int, int);
WHERE void Zoom(int command, int redraw);
#undef WHERE

#ifdef MODULE_ROBOT
#define WHERE
#else
#define WHERE extern
#endif
WHERE void DrawRobot(HDC hdc[], object *Op, point Offset, double p, double t
             , double a, short im, double ima
             , double sx, double sy, double sz, short status);
WHERE void DrawFullRobot(HDC hdc[], object *Op, point Offset, double p, double t
               , double a, short im, double ima
               , double sx, double sy, double sz, short status);
WHERE long GetRobotVolume(long n, skel *sp, vector c);
WHERE void SkeletorOff(short redraw);
WHERE void SkeletorOn(void);
WHERE int Skeletor(void);
WHERE void RobotTransform(point Offset, double p, double t, double a,
                          double sx, double sy, double sz,
                          short im, double ima, double RoboT[4][4]);
WHERE void GetRobotScriptName(char *, long, short, char *);
WHERE short RobotFileExists(char *);
WHERE void  WriteRobot(object *, char *);
WHERE short OpenRobotDirectory(char * script_file);
WHERE void RemoveRobotDirectory(char *script_file);
WHERE void InterpolateRobot(double mr, object *Op, object *LastOp);
WHERE void UpdateRobot(object *Op);
#undef WHERE

#ifdef MODULE_SCRIPT
#define WHERE
#else
#define WHERE extern
#endif
WHERE node *AddOnlyNewNode(HWND, long);
WHERE void AddQuickActor(long);
WHERE short AddCostumeTimeLine(node *Np);
WHERE short EditObject(node *Np, short firstframe, short lastframe,
                       short in_script, short split);
WHERE object *GetObjectAtFrame(node *Np, long frame);
WHERE void GetTimelinesAtFrame(node *Np, long frame, object **o,
      position **p, align **a, size **s);
WHERE short GetTimeGapAtFrame(node *Np, long frame,
                        short *start_gap, short *end_gap);
WHERE BOOL ActorNameExists(HWND parent,node *this_node,char *name);
WHERE void ShiftAllKeys(void);
WHERE void SetNumberOfFrames(short query);
WHERE void MakeKey(char com, long frame, node *np);
WHERE void NextKey(char com);
WHERE short MakeControl(node *Np, char typ, HWND parent);
WHERE short CheckForControl(node *Np, char typ);
WHERE void EditPosition(node *Np, short firstframe, short lastframe,
                        short type, HWND parent);
WHERE void EditAlign(node *Np, short firstframe, short lastframe,
                        short type, HWND parent);
WHERE void EditSize(node *Np, short firstframe, short lastframe);
WHERE short StartDefault(short what_function);
WHERE void TimelineEditor(void);
WHERE void DestroyTimelineEditor(void);
WHERE void AutoUpdateKeyframerVpos(void);
#undef WHERE

#ifdef MODULE_DIALOGS
#define WHERE
#else
#define WHERE extern
#endif
WHERE void LoadViewer(int);
WHERE short EditGroundDialog(object *op, short in_script);
WHERE short EditSkyDialog(sky *sp, int in_script);
WHERE short EditDirectorDialog(director *dp, int in_script);
WHERE short EditLightDialog(object *op, int in_script);
WHERE short RequestEditSize(double *sx, double *sy, double *sz, size *xp, int d);
WHERE short RequestEditLightSize(double *sx, double *sy, double *sz, size *xp, int d);
WHERE short EditCameraSize(double *sx, double *sy, double *sz, size *xp, int d);
WHERE BOOL CALLBACK RobotToolDlgProc(HWND hdlg,UINT msg,
                                 WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK PathToolDlgProc(HWND hdlg,UINT msg,
                                 WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK RotatorToolDlgProc(HWND hdlg,UINT msg,
                                 WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK SizerToolDlgProc(HWND hdlg,UINT msg,
                                 WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK SplineTweenDlgProc(HWND hdlg, UINT msg, WPARAM wparam,
                                     LPARAM lparam );
WHERE BOOL CALLBACK SelectActorDlgProc(HWND hdlg,UINT msg,
                           WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK SetFramesDlgProc(HWND hdlg,UINT msg,
                           WPARAM wparam,LPARAM lparam);
WHERE int SelectKeyMaker(void);
WHERE BOOL CALLBACK EditObjectDlgProc(HWND hdlg,UINT msg,
                           WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK EditObjectXipDlgProc(HWND hdlg,UINT msg,
                           WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK ObjectTimelineDlgProc(HWND hdlg,UINT msg,
                           WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK MorphSetDlgProc(HWND hdlg,UINT msg,
                           WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK PathSetDlgProc(HWND hdlg,UINT msg,
                             WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK CsgSetDlgProc(HWND hdlg,UINT msg,
                             WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK EditXipDlgProc(HWND hdlg,UINT msg,
                          WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK ShiftKeysDlgProc(HWND hdlg,UINT msg,
                          WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK AboutDlgProc(HWND hdlg,UINT msg,
                          WPARAM wparam,LPARAM lparam);
WHERE void PreferencesPropertyDlgProc(HWND hwndOwner);
WHERE void LensSettings(void);
WHERE void AnimationPlayer(int type, HWND hwnd);
#undef WHERE

#ifdef MODULE_PREFS
#define WHERE
#else
#define WHERE extern
#endif
WHERE void LoadPreferences(void);
WHERE void ActivatePreferences(void);
#undef WHERE

#ifdef MODULE_IK
#define WHERE
#else
#define WHERE extern
#endif
WHERE void AssignIKchain(node *Np, long frame);
WHERE void RemoveIKchain(node *Np, long frame);
WHERE void RemoveAllIKchains(node *Np, long frame);
#undef WHERE

#ifdef MODULE_MENUHELP 
#define WHERE
#else
#define WHERE extern
#endif
WHERE void LoadMenuHelpTable(HWND hwnd);
WHERE UINT CheckMenuHelpData(UINT uItem);
WHERE void DisplayMenuHelpData(HWND hwnd,UINT id);
WHERE void FreeMenuHelpData(void);
#undef WHERE

#ifdef MODULE_WINDOWS
#define WHERE
#else
#define WHERE extern
#endif
WHERE BOOL CreateMemoryWindows(void);
WHERE void DeleteMemoryWindows(void);
WHERE void FocusActiveWindow(HDC, BOOL );
WHERE void SetWindowSize(int x, int y, int view, BOOL reset);
WHERE void SwitchWindow(int button);
WHERE void FormatScreen(void);
WHERE void UpdateIconPositions(void);
WHERE BOOL CursorInTriview(void);
#undef WHERE

#ifdef MODULE_SETUP
#define WHERE
#else
#define WHERE extern
#endif
WHERE HPALETTE CreateAppPalette(int *, int *);
WHERE void SetupStructures(void);
WHERE void UpdateGLview(BOOL);
WHERE BOOL EnableGLview(void);
WHERE void StartGLview(BOOL first_time);
WHERE void SendPrgmText(PSTR p);
WHERE void SendPrgmHelpMessage(int id);
WHERE void SendPrgmMessage(int idString,int where);
WHERE void SetPrgmMessage(int idString, PSTR pstr);
WHERE int  SendPrgmQuery(int idString, int response);
WHERE void SendIconHelpMessage(int idString);
WHERE void CloseUtilities(int);
WHERE BOOL AnimatorStartup(UINT *);
WHERE void AnimatorShutdown(void);
WHERE BOOL SetupMainWindow(HANDLE inst, int cmdshow);
#undef WHERE

#ifdef MODULE_FILES
#define WHERE
#else
#define WHERE extern
#endif
WHERE int SelectFileName(int save, char *szfile, char *szdir,
                   char *szTitle, char *szfilter, HWND parent);
WHERE int SelectDirectoryName(char *szfile, char *szdir,
                   char *szTitle, char *szfilter, HWND parent);
WHERE int SelectSfxFileName(int save, char *szfile, char *szdir,
                   long ID, char *szfilter, HWND parent);
WHERE int SelectMorphFileName(char *szfile, char *szdir,
                   char *szTitle, char *szfilter, HWND parent);
#undef WHERE

#ifdef MODULE_INFO
#define WHERE
#else
#define WHERE extern
#endif
WHERE void UpdateSelectedActor(BOOL );
WHERE void SelectedInfo(void);
WHERE void SizeInfo(node *Np, short frame);
WHERE void AlignInfo(node *Np, short frame);
WHERE void PositionInfo(node *Np, short frame);
WHERE void ActorInfo(node *Np, short frame);
WHERE void CostumeInfo(object *, char *, char *, char *);
WHERE void SkyInfo(node *Np, short frame);
WHERE void DirectorCostumeInfo(node *, short, char *);
WHERE void SkyCostumeInfo(node *, short , char *);
#undef WHERE


