#  makefile for SPIN_DLL

NTT=
SYS=
PROJ = SPIN
LLFLAGS = -align:0x1000 /INCREMENTAL:NO /PDB:NONE /NODEFAULTLIB /NOLOGO /SUBSYSTEM:windows
LFLAGS =


!IFDEF wc
CMP=wc
!ELSEIFDEF sc
CMP=sc
!ELSEIFDEF bc
CMP=vc
!ELSEIFDEF vc
CMP=vc
!ELSE
CMP=cc
!ENDIF


!IF "$(CPU)" == "mips"

c=vc
CC = cl -c -Gs -D__X__NT__=1 -DWIN32
LIBS1 = kernel32.lib user32.lib gdi32.lib
LINK = link
#c=cl
#CC = cl -c -nologo -Gs -D__X__NT__=1 -DWIN32
#LFLAGS = /MACHINE:MIPS  $(LLFLAGS) -entry:DllMain
#LIBS1 = crtdll.lib kernel32.lib user32.lib gdi32.lib shell32.lib

!ELSEIF "$(CPU)" == "alpha"

c=vc
CC = cl -c -Gs -D__X__NT__=1 -DWIN32
LIBS1 = kernel32.lib user32.lib gdi32.lib
LINK = link

!ELSE

!IF "$(CPU)" == "ix86"
NTT = -D__X__NT__=1
!ENDIF

!IF     "$(CMP)" == "wc"
CC= wcc386  -Zp2 -5s -j -fpi87 -s -bd -bt=nt
LINK = wlink
!ELSEIF "$(CMP)" == "sc"
CC = SC -mn -4 -a2 -c -ff
LINK = link386
!ELSEIF "$(CMP)" == "bc"
CC = bcc32 -c -5 -WD -D__BCC__=1 -ff -K-
LINK = tlink32
!ELSEIF "$(CMP)" == "cc"
CC = cl -c -nologo -G5 $(NTT) -DWIN32
LFLAGS = /MACHINE:IX86 $(LLFLAGS)  -entry:DllMain
LIBS1 = crtdll.lib kernel32.lib user32.lib gdi32.lib shell32.lib
LINK = link
!ELSEIF "$(CMP)" == "vc"
CC = cl -c -G5 -Gs -DWIN32
LIBS1 = kernel32.lib user32.lib gdi32.lib
LINK = link
!ELSE
!ERROR Must specify compiler                                      ( c=vc/wc/cl/sc/bc [and or nt=mips/alpha/ix86])
!ENDIF

!ENDIF

INC = spin_dll.h

C0=spin_dll.obj

all: $(C0)
      echo >NUL @<<$(PROJ).DEF
!IF "$(CMP)"  == "vc" || "$(CMP)"  == "cc"
LIBRARY $(PROJ)
!ELSEIF "$(CMP)"  == "sc"
LIBRARY SPIN
DESCRIPTION 'SPINDLL'
EXETYPE NT
SUBSYSTEM WINDOWS
!ELSEIF "$(CMP)"  == "bc"
LIBRARY $(PROJ)
DESCRIPTION 'SPIN'
EXETYPE WINDOWS
!ELSEIF "$(CMP)"  == "wc"
!ENDIF
<<

      echo >NUL @<<$(PROJ).CRF
!IF "$(CMP)" == "vc" || "$(CMP)" == "cc"
$(C0)
-out:..\spin.dll
-dll
-def:$(PROJ).def
$(LIBS1)
!ELSEIF "$(CMP)"  == "sc"
$(C0)
..\spin.DLL
NUL
KERNEL32.LIB GDI32.LIB USER32.LIB
$(PROJ).def
!ELSEIF "$(CMP)"  == "bc"
/Tpd /c \bc4\lib\c0d32+$(C0)
..\spin.dll,
cw32+import32
$(PROJ).def
!ELSEIF "$(CMP)"  == "wc"
system nt_dll initinstance terminstance
file $(C0)
name ..\spin.dll
OPTION CASEEXACT
!ENDIF
<<

  $(LINK) $(LFLAGS) @$(PROJ).CRF

spin_dll.obj: spin_dll.c $(INC)
  $(CC) spin_dll.c

