/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* splash.c     Opening Splash Screen */

#include <stdlib.h>
#include <windows.h>
#include <commctrl.h>

#define X__Malloc(s)    LocalAlloc(LMEM_FIXED,s)
#define X__Free(p)      LocalFree((HLOCAL)p)

#if __ZTC__ || __SC__
#ifndef max
#define max(a,b)  ( ((a) > (b)) ? (a) : (b) )
#endif
#endif

#if __X__MIPS__
BOOL WINAPI _CRT_INIT(HINSTANCE ,DWORD , LPVOID );
#endif

static char IniFilename[] = "OPENFX_.INI",
            IniSection[]  = "LOGON";
static HINSTANCE hDLLinstance=NULL;
static BITMAP    Bitmap;
static HBITMAP   hBitmap=NULL;
static BOOL      showanim=TRUE;
static HCURSOR   ghcurHand=NULL;
#include "splash.h"

#if __WATCOMC__
int APIENTRY LibMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#else
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#endif
  HANDLE ghMod;
  switch (dwReason) {
    case DLL_PROCESS_ATTACH:
#if __X__MIPS__
      if(!_CRT_INIT(hDLL,dwReason,lpReserved))return(int)FALSE;
#endif
      hDLLinstance = hDLL;  /* handle to DLL file */
      break;
    case DLL_PROCESS_DETACH:
#if __X__MIPS__
      if(!_CRT_INIT(hDLL,dwReason,lpReserved))return(int)FALSE;
#endif
      break;
  }
  return (int)TRUE;
}

#if __SC__
#pragma startaddress(DllMain)
#endif

static void CentreDialogOnScreen(HWND hwnd){
 RECT rcDlg;
 long Xres,Yres;
 Yres=GetSystemMetrics(SM_CYSCREEN);
 Xres=GetSystemMetrics(SM_CXSCREEN);
 GetWindowRect(hwnd,&rcDlg);
 OffsetRect(&rcDlg,-rcDlg.left,-rcDlg.top);
 OffsetRect(&rcDlg,(Xres-rcDlg.right)/2,(Yres-rcDlg.bottom)/2);
 SetWindowPos(hwnd,HWND_TOP,rcDlg.left,rcDlg.top,0,0,SWP_NOSIZE);
 return;
}

static int CALLBACK LogonDlgProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam);

int _PrgmLogon(HWND hwnd,int no_wait){
 int retval;
 retval=(int)DialogBoxParam(hDLLinstance,MAKEINTRESOURCE(DLG_LOGON),hwnd,
              (DLGPROC)LogonDlgProc,(LPARAM)no_wait);
 return retval;
}

static int CALLBACK LogonDlgProc(HWND hwnd,UINT msg,WPARAM wparam,
                                 LPARAM lparam){
 static int ilist[3]={DLG_LOGON_IMAGE_NEW,
                      DLG_LOGON_IMAGE_DESIGN,
                      DLG_LOGON_IMAGE_HELP};
 static UINT StartupTimer=0;
 char str[32];
 char ttt[256],name[256];
 char text0[256],text1[256],text2[256],text3[256],text4[256];
 int DisplayBits,bm;
 HDC hDCcaps;
 HWND hDesktopWnd;
 HANDLE hfbm;
 DWORD version;
 switch( msg ) {
   case WM_INITDIALOG:
     hDesktopWnd=GetDesktopWindow();
     hDCcaps=GetDC(hDesktopWnd);
     DisplayBits=GetDeviceCaps(hDCcaps,BITSPIXEL);
     ReleaseDC(hDesktopWnd,hDCcaps);
     version=GetVersion();
     if((version & 0x80000000) == 0x80000000){ /* Not Windows NT */
         if(LOBYTE(LOWORD(version)) < 4){
           showanim=0;
         }
     }
     strcpy(ttt,text3);
     GetPrivateProfileString(IniSection,"USERID","$$$",
                   str,sizeof(str),IniFilename);
     if(strncmp(str,"$$$",3) == 0){
       strcpy(ttt,text4);
     }
     else strcat(ttt,str);
     ghcurHand=LoadCursor(hDLLinstance,MAKEINTRESOURCE(IDC_PAN));
     CentreDialogOnScreen(hwnd);
     StartupTimer=SetTimer(hwnd,1,8000,NULL);
     {
       HWND pw;
       RECT rect;
       POINT p1,p2;
       pw=GetDlgItem(hwnd,DLG_LOGON_IMAGE_DESIGN);
       if(pw != NULL){
         GetWindowRect(pw,&rect);
         p1.x=rect.left;
         p1.y=rect.top;
         p2.x=rect.right;
         p2.y=rect.bottom;
         ScreenToClient(hwnd,&p1);
         ScreenToClient(hwnd,&p2);
         rect.left=p1.x;
         rect.top=p1.y;
         rect.right=p2.x;
         rect.bottom=p2.y;
         OffsetRect(&rect,0,-1);
         MoveWindow(pw,rect.left,rect.top,
                    rect.right-rect.left,
                    rect.bottom-rect.top,FALSE);
       }
       pw=GetDlgItem(hwnd,DLG_LOGON_IMAGE_NEW);
       if(pw != NULL){
         GetWindowRect(pw,&rect);
         p1.x=rect.left;
         p1.y=rect.top;
         p2.x=rect.right;
         p2.y=rect.bottom;
         ScreenToClient(hwnd,&p1);
         ScreenToClient(hwnd,&p2);
         rect.left=p1.x;
         rect.top=p1.y;
         rect.right=p2.x;
         rect.bottom=p2.y;
         OffsetRect(&rect,1,1);
         MoveWindow(pw,rect.left,rect.top,
                    rect.right-rect.left,
                    rect.bottom-rect.top,FALSE);
       }
     }
     return TRUE;
   case WM_DESTROY:
     if(StartupTimer > 0)KillTimer(hwnd,StartupTimer);
     if(hBitmap != NULL)DeleteObject(hBitmap); hBitmap=NULL;
     break;
   case WM_TIMER:
     switch(wparam){
       case 1:
         EndDialog(hwnd,1);
         return(TRUE);
         break;
       case 2:
         EndDialog(hwnd,1);
         return(TRUE);
         break;
       default: break;
     }
     break;
   case WM_LBUTTONDOWN:{
       HWND pw;
       RECT rect;
       POINT p1,p2,pm;
       int i;
       pm.x=LOWORD(lparam);
       pm.y=HIWORD(lparam);
       for(i=0;i<3;i++){
         pw=GetDlgItem(hwnd,ilist[i]);
         if(pw != NULL){
           GetWindowRect(pw,&rect);
           p1.x=rect.left;
           p1.y=rect.top;
           p2.x=rect.right;
           p2.y=rect.bottom;
           ScreenToClient(hwnd,&p1);
           ScreenToClient(hwnd,&p2);
           rect.left=p1.x;
           rect.top=p1.y;
           rect.right=p2.x;
           rect.bottom=p2.y;
           if(PtInRect(&rect,pm)){
             if(i == 0){
               EndDialog(hwnd,1);
               return(TRUE);
             }
             else if(i == 1){
               EndDialog(hwnd,5);
               return(TRUE);
             }
             else if(i == 2){
               EndDialog(hwnd,4);
               return(TRUE);
             }
           }
         }
       }
     }
     break;
   case WM_MOUSEMOVE:{
       HWND pw;
       RECT rect;
       POINT p1,p2,pm;
       int i,cf=0;
       pm.x=LOWORD(lparam);
       pm.y=HIWORD(lparam);
       for(i=0;i<3;i++){
         pw=GetDlgItem(hwnd,ilist[i]);
         if(pw != NULL){
           GetWindowRect(pw,&rect);
           p1.x=rect.left;
           p1.y=rect.top;
           p2.x=rect.right;
           p2.y=rect.bottom;
           ScreenToClient(hwnd,&p1);
           ScreenToClient(hwnd,&p2);
           rect.left=p1.x;
           rect.top=p1.y;
           rect.right=p2.x;
           rect.bottom=p2.y;
           if(PtInRect(&rect,pm)){
             cf=1;
             if(StartupTimer > 0){
               KillTimer(hwnd,StartupTimer);
               StartupTimer=0;
             }
             ShowWindow(pw,SW_SHOW);
           }
           else{
             ShowWindow(pw,SW_HIDE);
           }
           if(cf == 1)SetCursor(ghcurHand);
           else SetCursor(LoadCursor(NULL,IDC_ARROW));
         }
       }
     }
     break;
   case WM_COMMAND:
     switch(LOWORD(wparam)){
        case IDCANCEL:
        case DLG_LOGON_CANCEL:
          EndDialog(hwnd,-1);
          return(TRUE);
        case DLG_LOGON_NEW:
          EndDialog(hwnd,1);
          return(TRUE);
        case DLG_LOGON_LOAD:
          EndDialog(hwnd,2);
          return(TRUE);
        case DLG_LOGON_TEMPLATE:
          EndDialog(hwnd,3);
          return(TRUE);
        case DLG_LOGON_HELP:
          EndDialog(hwnd,4);
          return(TRUE);
        case DLG_LOGON_MODELER:
          EndDialog(hwnd,5);
          return(TRUE);
        default:
          break;
      }
      break;
    default: break;
 }
 return FALSE;
}


