#   makefile for splash screen
#   use parametets CPU= ???  nt=1   sc/wc/cc/vc/bc
NTX=
!IFDEF demo
DEMO=-D__DEMO__=1
!ELSE
DEMO=
!ENDIF
!IFDEF nt
NTX=-D__X__NT__=1
!ENDIF
PROJ = SPLASH
RC = rc
RCFLAGS = -r -D_WIN32
LFLAGS = -align:0x1000 /INCREMENTAL:NO /PDB:NONE -entry:DllMain

!IF "$(CPU)" == "mips"

CC = cl -c -nologo  -D__X__NT__=1 $(DEMO) -DWIN32
LFLAGS = /NOLOGO /SUBSYSTEM:windows,4.0
LIBS =user32.lib gdi32.lib comdlg32.lib shell32.lib comctl32.lib
LINK = link
#LFLAGS = $(LFLAGS) /NOLOGO /SUBSYSTEM:windows /NODEFAULTLIB /MACHINE:MIPS
#LIBS =crtdll.lib kernel32.lib user32.lib gdi32.lib comdlg32.lib shell32.lib comctl32.lib

!ELSEIF "$(CPU)" == "alpha"

CC = cl -c -nologo  -D__X__NT__=1 $(DEMO) -DWIN32 -D__AXP__
LFLAGS = /NOLOGO /SUBSYSTEM:windows,4.0
LIBS =user32.lib gdi32.lib comdlg32.lib shell32.lib comctl32.lib
LINK = link

!ELSE
#                             Ix86 processors
!IFDEF     cc
CC = cl -c -nologo -G5 -D__X__NT__=1 $(DEMO) -DWIN32
LINK = link
LFLAGS = $(LFLAGS) /NOLOGO /SUBSYSTEM:windows /NODEFAULTLIB /MACHINE:IX86
LIBS =crtdll.lib kernel32.lib user32.lib gdi32.lib comdlg32.lib shell32.lib comctl32.lib

!ELSEIFDEF  wc
CC = wcc386  -Zp8 -5s -j -s -oimr -fpi87 -bd -bt=nt  $(NTX) $(DEMO) -DWIN32 -D_WIN32 -DSTRICT
LINK = wlink
RC = WRC

!ELSEIFDEF sc
CC = SC -mn -4 -a4 -c -ff $(NTX) $(DEMO)
LINK = link386

!ELSEIFDEF bc
WARNS=-w-aus -w-par -w-rch  -w-ccc
CC=bcc32 -c -5 -W $(WARNS) -ff -K- -D__WATCOMC__=1 -D__NT__=1 $(NTX) $(DEMO)
LINK = tlink32
RC = BRC32

!ELSE
CC = cl -c -nologo -G5 $(NTX) $(DEMO) -DWIN32
LFLAGS = /NOLOGO /SUBSYSTEM:windows,4.0
LIBS =user32.lib gdi32.lib comdlg32.lib shell32.lib comctl32.lib
LINK = link

!ENDIF

!ENDIF

HH=splash.h
C0=splash.obj

!IFDEF wc
$(PROJ).exe: $(C0)
       echo >NUL @<<$(PROJ).CRF
system nt_dll initinstance terminstance
export _PrgmLogon.1
file $(C0)
lib comctl32.lib
name $(PROJ).exe
option CASEEXACT
RUNTIME windows=4.0
<<
 $(LINK) @$(PROJ).CRF
 $(RC) -bt=nt $(PROJ).rc
 copy $(PROJ).exe ..\$(PROJ).dll
 del $(PROJ).exe

!ELSEIFDEF sc
$(PROJ).exe: $(C0) $(PROJ).res;
       echo >NUL @<<$(PROJ).DEF
LIBRARY dll
DESCRIPTION 'DLL'
EXETYPE NT
SUBSYSTEM WINDOWS
EXPORTS
_PrgmLogon   @1
<<
       echo >NUL @<<$(PROJ).CRF
$(C0)
..\$(PROJ).dll
NUL
KERNEL32.LIB GDI32.LIB USER32.LIB
$(PROJ).def
$(PROJ).res
/NOI
<<
 $(LINK) @$(PROJ).CRF

!ELSEIFDEF bc
$(PROJ).exe: $(C0) $(PROJ).res;
       echo >NUL @<<$(PROJ).DEF
LIBRARY the_dll
DESCRIPTION 'DLL'
EXETYPE WINDOWS
EXPORTS
_PrgmLogon    @1
<<
       echo >NUL @<<$(PROJ).CRF
/Tpd /c \bc4\lib\c0d32+$(C0)
..\$(PROJ).dll,
cw32+import32
$(PROJ).def
$(PROJ).res
<<
 $(LINK) @$(PROJ).CRF

!ELSE
$(PROJ).exe: $(C0) $(PROJ).res;
       echo >NUL @<<$(PROJ).DEF
LIBRARY splash
EXPORTS
_PrgmLogon    @1
<<
       echo >NUL @<<$(PROJ).CRF
$(C0)
-OUT:..\$(PROJ).dll
-DLL
-DEF:$(PROJ).def
$(PROJ).RES
$(LIBS)
<<
 $(LINK) $(LFLAGS) @$(PROJ).CRF

!ENDIF

$(PROJ).obj: $(PROJ).c $(HH)
  $(CC) $(PROJ).c


$(PROJ).res: $(HH) $(PROJ).rc
  $(RC) $(RCFLAGS) $(PROJ).rc


