/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* strings.h     String identifiers */


#define CCHTEXTMAX                120
#define FIRST_IDS_STRING            0

#define IDS_DEFAULT                 0
#define IDS_CURRENT                 1
#define IDS_LOADING                 2
#define IDS_ZERO                    3
#define IDS_SWAPSVIEW               4
#define IDS_SWAP3VIEW               5
#define IDS_SWAPOTHER               6
#define IDS_GRABBERTOOL             7
#define IDS_ROTATORTOOL             8
#define IDS_SIZERTOOL               9
#define IDS_SHIFTERTOOL            10
#define IDS_ANGLERTOOL             11
#define IDS_SKELETORTOOL           12
#define IDS_PATHEDITORTOOL         13
#define IDS_NOZOOMOUT              14
#define IDS_NOZOOMIN               15
#define IDS_PANTOOL                16
#define IDS_INZOOMTOOL             17
#define IDS_SELECTTOOL             18
#define IDS_VIEWUPDATE             19
#define IDS_NODESELECTOR1          20
#define IDS_NODESELECTOR2          21
#define IDS_TRACKER                22
#define IDS_DEFAULT_LITE           23
#define IDS_CURRENT_LITE           24

#define CSTRINGS                   25   /* this must always be last+1 */

#define FIRST_IDQ_STRING         1000
#define IDQ_DUMMY1               1000  /* use again */
#define IDQ_PREVIEW_NOMAKE       1001
#define IDQ_CONFIRM              1002
#define IDQ_CHANGED              1003
#define IDQ_NOMEM1               1004
#define IDQ_NOMEM2               1005
#define IDQ_NODELETEFILE         1006
#define IDQ_FILEOPENFAIL         1007
#define IDQ_TFWE                 1008
#define IDQ_SAVINGERROR          1009
#define IDQ_READERROR            1010
#define IDQ_NOHELP               1011
#define IDQ_NOZOOMOUT            1012
#define IDQ_NOZOOMIN             1013
#define IDQ_NOOPENWORKFILE       1014
#define IDQ_INVALIDDATA          1015
#define IDQ_COORDTOOBIG          1016
#define IDQ_PANTOOFAR            1017
#define IDQ_OLD1                 1018
#define IDQ_OLD2                 1019
#define IDQ_OLD3                 1020
#define IDQ_OLD4                 1021
#define IDQ_OLD5                 1022
#define IDQ_NOMEM3               1023
#define IDQ_NOPATH               1024
#define IDQ_INSHIFTER            1025
#define IDQ_INANGLER             1026
#define IDQ_INPATH               1027
#define IDQ_INTOOL               1028
#define IDQ_CAMERASELECTED       1029
#define IDQ_SCRIPTFAIL           1030
#define IDQ_NOINTERNAL           1031
#define IDQ_PATH2                1032
#define IDQ_PATH1                1033
#define IDQ_CATAF                1034
#define IDQ_NORENDER             1035
#define IDQ_NOREADTFILE          1036
#define IDQ_NOOPENTFILE          1037
#define IDQ_PATH6                1038
#define IDQ_PATH5                1039
#define IDQ_PATH4                1040
#define IDQ_PATH3                1041
#define IDQ_NOPREVIEW            1042
#define IDQ_EXCEEDFRAMELIMIT     1043
#define IDQ_SELFFOLLOW1          1044
#define IDQ_SELFFOLLOW2          1045
#define IDQ_NOFINDMODEL          1046
#define IDQ_ONLYONEALLOWED       1047
#define IDQ_NOACTORSELECTED      1048
#define IDQ_NOADDKEY             1049
#define IDQ_NOKEYFOUND           1050
#define IDQ_NOPATHA              1051
#define IDQ_NOPEDIT              1052
#define IDQ_NOTAPATH             1053
#define IDQ_NPSELECT             1054
#define IDQ_ONLYTWEEN            1055
#define IDQ_NORESIZE             1056
#define IDQ_NOADDCONTROL         1057
#define IDQ_NOPATHOFFSET         1058
#define IDQ_NOTALIGN             1059
#define IDQ_NOTAPPROPRIATE       1060
#define IDQ_MANGLEDPATH          1061
#define IDQ_NOTAMODEL            1062
#define IDQ_NOTALLLOADED         1063
#define IDQ_NOTSTAGEFILE         1064
#define IDQ_STAGELOADFAIL        1065
#define IDQ_SCRIPTOPENFAIL       1066
#define IDQ_SYNTAXERROR          1067
#define IDQ_NOENDCHANGE          1068
#define IDQ_NOSTARTCHANGE        1069
#define IDQ_ANIOBJ1              1070
#define IDQ_ANIOBJ2              1071
#define IDQ_ANIOBJ3              1072
#define IDQ_ANIOBJ4              1073
#define IDQ_COPYFAIL             1074
#define IDQ_NOCOPYSPACE          1075
#define IDQ_NOROBOTA             1076
#define IDQ_NOREDIT              1077
#define IDQ_NOTAROBOT            1078
#define IDQ_NRSELECT             1079
#define IDQ_SKELINCOMPAT         1080
#define IDQ_NOADDTIMELINE        1081
#define IDQ_COSTUMEEXISTS        1082
#define IDQ_CAMERANODELETE       1083
#define IDQ_CAMERANODELCOSTUME   1084
#define IDQ_ONLYKEYFRAME         1085
#define IDQ_MUSTEXCEED1FRAME     1086
#define IDQ_NOGAPINTIMELINE      1087
#define IDQ_NOEFFECT             1088
#define IDQ_NOT_IN_TOOL          1089
#define IDQ_NOLOADMODELER        1090
#define IDQ_EFFECTEXISTS         1091
#define IDQ_MODELERINUSE         1092
#define IDQ_NOTFIRSTCAMERA       1093
#define IDQ_SET_COORD_ORIGIN     1094
#define IDQ_BREAKCHANNEL         1095
#define IDQ_CAMERANOREORDER      1096
#define IDQ_ACTORNAMEEXISTS      1097
#define IDQ_NOTPOSE              1098
#define IDQ_BADPOSE              1099
#define IDQ_OVERWRITE            1100
#define IDQ_FATALERROR           1101
#define IDQ_FAILEDFUNCTION       1102
#define IDQ_FAILEDLIBRARY        1103
#define IDQ_NOEFFECT1            1104
#define IDQ_NOPARAMETERS         1105
#define IDQ_NOSTART              1106
#define IDQ_FAILEDSPIN           1107
#define IDQ_FAILEDTIDE           1108
#define IDQ_FAILEDACCELS         1109
#define IDQ_BADNEXTFILE          1110
#define IDQ_BADFILE              1111
#define IDQ_DELETECAMERA         1112
#define IDQ_DELETEACTOR          1113
#define IDQ_NOLASTIMAGE          1114
#define IDQ_DELETECHANNEL        1115
#define IDQ_DELETECHANNELX       1116
#define IDQ_TOOMANYFRAMES        1117
#define IDQ_COORD_BAD_RANGE      1118

#define QSTRINGS                 119 /* this is the number of Q strings + 1 */

/* ids used for menu help */

#define IDH_FILE_LOAD_ANIMATION  5001
#define IDH_FILE_LOAD_TEMPLATE   5002
#define IDH_FILE_LOAD_NEW        5003
#define IDH_FILE_SAVE            5004
#define IDH_FILE_EXP_ASCRIPT     5005
#define IDH_FILE_EXP_FSCRIPT     5006
#define IDH_FILE_MODELER         5007
#define IDH_FILE_KEYFRAMER       5008
#define IDH_FILE_VIEWER          5009
#define IDH_FILE_PLAYER          5010
#define IDH_FILE_FLI2AVI         5011
#define IDH_FILE_EXIT            5012    /* 12 */
#define IDH_ACTOR_ADD_A          5013
#define IDH_ACTOR_ADD_C          5014
#define IDH_ACTOR_ADD_E          5015
#define IDH_ACTOR_DEL_A          5016
#define IDH_ACTOR_DEL_C          5017
#define IDH_ACTOR_SELECT         5018
#define IDH_ACTOR_INFO           5019
#define IDH_ACTOR_AXIS_SH        5020
#define IDH_ACTOR_AXIS_SNAP      5021
#define IDH_ACTOR_AXIS_PLACE     5022
#define IDH_ACTOR_TOOL_GRAB      5023
#define IDH_ACTOR_TOOL_ROTATE    5024
#define IDH_ACTOR_TOOL_SIZE      5025
#define IDH_ACTOR_TOOL_POSE      5026
#define IDH_ACTOR_TOOL_PLOTPOS   5027
#define IDH_ACTOR_TOOL_PLOTROT   5028
#define IDH_ACTOR_ACTCAMERA      5029   /* 29 */
#define IDH_PATH_EDIT            5030
#define IDH_PATH_SUBDIVIDE       5031
#define IDH_PATH_DELETE          5032
#define IDH_PATH_PICKNEXT        5033
#define IDH_PATH_PICKPREVIOUS    5034
#define IDH_PATH_PICKFIRST       5035
#define IDH_FILE_FLI2GIF         5036
#define IDH_PATH_CURSORTO_START  5037
#define IDH_PATH_CURSORTO_END    5038
#define IDH_PATH_CURSORTO_POINT  5039
#define IDH_PATH_GRAPH_POSITION  5040
#define IDH_PATH_GRAPH_VELOCITY  5041  /* 41 */
#define IDH_TIMELINE_LINE_ADDP   5042
#define IDH_TIMELINE_LINE_ADDR   5043
#define IDH_TIMELINE_LINE_ADDX   5044
#define IDH_TIMELINE_KEY_ADDP    5045
#define IDH_TIMELINE_KEY_ADDR    5046
#define IDH_TIMELINE_KEY_ADDX    5047  /* 47 */
#define IDH_FRAME_GO_FIRST       5048
#define IDH_FRAME_GO_PREVIOUS    5049
#define IDH_FRAME_GO_NEXT        5050
#define IDH_FRAME_GO_LAST        5051
#define IDH_FRAME_GO_FRAME       5052
#define IDH_FRAME_PLAY_WIRE      5053
#define IDH_FRAME_PLAY_QUICK     5054
#define IDH_FRAME_PLAY_FULL      5055
#define IDH_FRAME_RENDER         5056
#define IDH_FRAME_SHOW           5057
#define IDH_FRAME_PREVIEW_MAKE   5058
#define IDH_FRAME_PREVIEW_SHOW   5059
#define IDH_FRAME_PREVIEW_FREE   5060
#define IDH_FRAME_SETNUMBER      5061   /* 61 */
#define IDH_VIEW_DRAW_BOUNDED    5062
#define IDH_VIEW_DRAW_SELECTED   5063
#define IDH_VIEW_DRAW_DESELECTED 5064
#define IDH_VIEW_DRAW_ALL        5065
#define IDH_VIEW_LOCKBOUNDED     5066
#define IDH_VIEW_GLOBALQUICKDRAW 5067
#define IDH_VIEW_GRID            5068
#define IDH_VIEW_DRAW_GRID       5106
#define IDH_VIEW_DEFINEGRID      5069
#define IDH_ZOOM_IN              5070
#define IDH_ZOOM_OUT             5071
#define IDH_ZOOM_CENTRE          5072
#define IDH_VIEW_RESTORE         5073
#define IDH_VIEW_FULL            5074
#define IDH_VIEW_SCREENCOLOURS   5075
#define IDH_VIEW_FEEDBACK_CAMERA 5076
#define IDH_VIEW_FEEDBACK_LIGHT  5077  /* 77 */
#define IDH_WINDOW_SWITCH        5078
#define IDH_VIEW_SWAPVIEWPOINT   5079
#define IDH_WINDOW_COORDS        5080
#define IDH_WINDOW_COORD_DEF     5081
#define IDH_WINDOW_COORD_LAST    5082  /* 82 */
#define IDH_STOP                 5083
#define IDH_EVIHELP              5084  /* 84 */
#define IDH_HELP_HELP            5085  /* 85 */

#define IDH_ACTOR_DEL_E          5086
#define IDH_ACTOR_TOOL_UNDO      5087
#define IDH_VIEW_FEEDBACK_CURSOR 5088
#define IDH_FILE_PRINT           5089
#define IDH_FILE_PRINTSETUP      5090
#define IDH_FILE_PREFERENCES     5091
#define IDH_FILE_SAVEOLD         5092
#define IDH_ACTOR_SWAP           5093
#define IDH_ACTOR_RENAME         5094
#define IDH_ACTOR_TOOL_GRABABS   5095
#define IDH_ACTOR_TOOL_ROTATEABS 5096
#define IDH_ACTOR_TOOL_SIZEABS   5097
#define IDH_EDIT_MODEL           5098
#define IDH_WINDOW_CLOSE         5099
#define IDH_WINDOW_HIDETOOLS     5100
#define IDH_EDIT_XIMAGE          5101
#define IDH_EDIT_SPLINETWEEN     5102
#define IDH_WINDOW_BIGCAMERA     5103
#define IDH_WINDOW_SELECT        5104
#define IDH_HELP_GENERAL         5105
#define IDH_FILE_EXP_OPENGL      5107
#define IDH_WINDOW_SHOWOPENGL    5108
#define IDH_FILE_PLAYAVI         5109
#define IDH_PATH_REVERSE         5110
#define IDH_ACTOR_ADD_X          5111
#define IDH_FILE_ANIM            5112
#define IDH_FILE_AUDIO           5113
#define IDH_WINDOW_TOOLLEFT      5114
#define IDH_WINDOW_RESET         5115
#define IDH_FILE_KEYFRAMERDOCK   5116
#define IDH_TIMELINE_KEY_SHIFT   5117
#define IDH_HELP_ABOUT           5118
#define IDH_FRAME_QUICKRENDER    5119
#define IDH_FILE_EXP_VRML        5120
#define IDH_HELP_HOME            5121
#define IDH_HELP_SUPPORT         5122
#define IDH_TIMELINE_KEY_RESETP  5123
#define IDH_TIMELINE_KEY_RESETR  5124
#define IDH_TIMELINE_KEY_RESETX  5125
#define IDH_ACTOR_SWAP_ALL       5126
#define IDH_FILE_EXP_FMSCRIPT    5127
#define IDH_FILE_EXP_AMSCRIPT    5128
#define IDH_FILE_AVI2MPG         5129
#define IDH_FILE_PLAYMPG         5130
#define IDH_ACTOR_USEDIRECTOR    5131  
#define IDH_FILE_GIF2AVI         5132  // last

/* This is the number of menu help items+1  */
#define NMENUHELPDATA 133

/* These are the ICON help strings */

#define FIRST_IDI_STRING         6000

#define IDI_SELECT_ACTOR         6001
#define IDI_SELECT_PATH          6002
#define IDI_SELECT_CAMERA        6003
#define IDI_SELECT_CSG           6004
#define IDI_SELECT_ROBOT         6005
#define IDI_SELECT_LIGHT         6006
#define IDI_SELECT_TARGET        6007
#define IDI_SELECT_GROUND        6008

#define IDI_TOOL1                6009
#define IDI_TOOL2                6010
#define IDI_TOOL3                6011
#define IDI_TOOL4                6012
#define IDI_TOOL5                6013
#define IDI_TOOL6                6014
#define IDI_TOOL7                6015
#define IDI_TOOL8                6016
#define IDI_TOOL9                6017

#define IDI_COMMAND_RENDER       6018
#define IDI_HIDDENLINE           6019
#define IDI_COMMAND_SHOW         6020
#define IDI_GOFRAME              6021
#define IDI_ZOOM_CENTRE          6022
#define IDI_ZOOM_WORLD           6023
#define IDI_ACTOR_TOOL_SNAP      6024
#define IDI_COMMAND_AXIS         6025

#define IDI_COORD_MEASURE        6026
#define IDI_COORD_RELATIVE       6027
#define IDI_COORD_ORIGIN         6028
#define IDI_COORD_DEFINE         6029
#define IDI_COORD_NEAREST        6030

#define IDI_TIME_PLAYQUICK       6031
#define IDI_TIME_PLAYWIRE        6032
#define IDI_TIME_LASTKEY         6033
#define IDI_TIME_NEXTKEY         6034

#define ISTRINGS                   35    /* this must always be last+1 */

#define IDI_TIP_T_1              6500
#define IDI_TIP_T_2              6501
#define IDI_TIP_T_3              6502
#define IDI_TIP_T_4              6503
#define IDI_TIP_T_5              6504
#define IDI_TIP_T_6              6505
#define IDI_TIP_T_7              6506
#define IDI_TIP_T_8              6507
#define IDI_TIP_T_9              6508

#define IDI_TIP_A_1              6509
#define IDI_TIP_A_2              6510
#define IDI_TIP_A_3              6511
#define IDI_TIP_A_4              6512
#define IDI_TIP_A_5              6513
#define IDI_TIP_A_6              6514
#define IDI_TIP_A_7              6515
#define IDI_TIP_A_8              6516

#define IDI_TIP_S_1              6517
#define IDI_TIP_S_2              6518
#define IDI_TIP_S_3              6519
#define IDI_TIP_S_4              6520
#define IDI_TIP_S_5              6521
#define IDI_TIP_S_6              6522
#define IDI_TIP_S_7              6523
#define IDI_TIP_S_8              6524

#define IDI_TIP_Q_1              6525
#define IDI_TIP_Q_2              6526
#define IDI_TIP_Q_3              6527
#define IDI_TIP_Q_4              6528
#define IDI_TIP_Q_5              6529

#define IDI_TIP_C_1              6530
#define IDI_TIP_C_2              6531
#define IDI_TIP_C_3              6532
#define IDI_TIP_C_4              6533
#define IDI_TIP_C_5              6534

#define IDI_TIP_K_1              6535
#define IDI_TIP_K_2              6536
#define IDI_TIP_K_3              6537
#define IDI_TIP_K_4              6538
#define IDI_TIP_K_5              6539
#define IDI_TIP_K_6              6540
#define IDI_TIP_K_7              6541
#define IDI_TIP_K_8              6542
#define IDI_TIP_K_9              6543
#define IDI_TIP_K_0              6544
#define IDI_TIP_K_A              6545
#define IDI_TIP_K_B              6546
#define IDI_TIP_K_C              6547
#define IDI_TIP_K_D              6548
#define IDI_TIP_K_E              6549
#define IDI_TIP_K_F              6550

#define IDX_MISC_TOOLS           7000
#define IDX_MISC_ACTIONS         7001
#define IDX_MISC_SELECT          7002
#define IDX_MISC_COORDS          7003
#define IDX_MISC_UNDO            7004
#define IDX_MISC_HTOOLS          7005
#define IDX_MISC_STOOLS          7006
#define IDX_MISC_HSELECTORS      7007
#define IDX_MISC_SSELECTORS      7008
#define IDX_MISC_HKEYFRAMER      7009
#define IDX_MISC_SKEYFRAMER      7010
#define IDX_MISC_CROSSHAIR       7011
#define IDX_MISC_CROSSWIRE       7012
#define IDX_MISC_SINGLEVIEW      7013
#define IDX_MISC_QUADVIEW        7014
#define IDX_MISC_DRAWBOUNDED     7015
#define IDX_MISC_DRAWFULL        7016
#define IDX_MISC_SELANIMAP       7017
#define IDX_MISC_SELIMAGEMAP     7018
#define IDX_MISC_SELECTROBOT     7019
#define IDX_MISC_SAVEPOSE        7020
#define IDX_MISC_LOADPOSE        7021
#define IDX_MISC_SAVEANIMATION   7022
#define IDX_MISC_OPENANIMATION   7023
#define IDX_MISC_REPLACEMENT     7024
#define IDX_MISC_SCRIPTFILE      7025
#define IDX_MISC_OPENPATH        7026
#define IDX_MISC_OPENEFFECT      7027
#define IDX_MISC_WRITEMODELSET   7028
#define IDX_MISC_OPENMODELSET    7029
#define IDX_MISC_IMAGEFILE       7030
#define IDX_MISC_XIP             7031
#define IDX_MISC_ERROR1          7032
#define IDX_MISC_GROUND_COLOUR   7033
#define IDX_MISC_GROUND_SHADER   7034
#define IDX_MISC_HORIZON_COLOUR  7035
#define IDX_MISC_ZENITH_COLOUR   7036
#define IDX_MISC_LIGHT_COLOUR    7037
#define IDX_MISC_CSG_COLOUR      7038
#define IDX_MISC_ACTOR           7039
#define IDX_MISC_NOACTSEL        7040
#define IDX_MISC_ACTSEL          7041
#define IDX_MISC_LINE0           7042
#define IDX_MISC_LINE1           7043
#define IDX_MISC_LINE2           7044
#define IDX_MISC_LINE3           7045
#define IDX_MISC_LINE4           7046
#define IDX_MISC_KEYFRAMER       7047
#define IDX_MISC_PLAY            7048
#define IDX_MISC_STOP            7049
#define IDX_MISC_SHOWOPENGL      7050
#define IDX_MISC_HIDEOPENGL      7051
#define IDX_MISC_PREF_TITLE      7052
#define IDX_MISC_NONE            7053
#define IDX_MISC_CHOOSEPATH      7054


#define IDX_MISC_CANCELPREVIEW      7060
#define IDX_MISC_PREVIEWCOMPLETE    7061
#define IDX_MISC_MAKEPREVIEW        7062
#define IDX_MISC_PREPARINGFRAME     7063
#define IDX_MISC_MOVETO             7064
#define IDX_MISC_CREATEKEY          7065
#define IDX_MISC_CONFIRM            7066
#define IDX_MISC_NOTAKEYFRAME       7067
#define IDX_MISC_SETROTATION        7068
#define IDX_MISC_SETSCALE           7069
#define IDX_MISC_LEFT_RIGHT         7070
#define IDX_MISC_BACK_FRONT         7071
#define IDX_MISC_UP_DOWN            7072
#define IDX_MISC_DIRECTION          7073
#define IDX_MISC_ELEVATION          7074
#define IDX_MISC_BANK               7075

#define IDX_MISC_COSTUME            7076
#define IDX_MISC_POSITION           7077
#define IDX_MISC_ROTATION           7078
#define IDX_MISC_SCALE              7079

#define IDX_MISC_MODEL              7080
#define IDX_MISC_PATH               7081
#define IDX_MISC_TARGET             7082
#define IDX_MISC_GROUND             7083
#define IDX_MISC_LIGHT              7084
#define IDX_MISC_MORPH              7085
#define IDX_MISC_CSG                7086
#define IDX_MISC_SKY                7087
#define IDX_MISC_ROBOT              7088
#define IDX_MISC_CAMERA             7089
#define IDX_MISC_XIPC               7090

#define IDX_MISC_COLORED            7091
#define IDX_MISC_WAVE               7092
#define IDX_MISC_RIPPLES            7093
#define IDX_MISC_OCEAN              7094
#define IDX_MISC_CHECKER            7095
#define IDX_MISC_GRID               7096
#define IDX_MISC_STRIPES            7097
#define IDX_MISC_DOTS               7098
#define IDX_MISC_CROSSES            7099
#define IDX_MISC_BRICK              7100
#define IDX_MISC_ROUGH              7101

#define IDX_MISC_DEMO1              7102
#define IDX_MISC_DEMO2              7103
#define IDX_MISC_DEMO3              7104

#define IDX_MISC_PRESET1            7105
#define IDX_MISC_PRESET2            7106
#define IDX_MISC_PRESET3            7107
#define IDX_MISC_PRESET4            7108
#define IDX_MISC_PRESET5            7109
#define IDX_MISC_PRESET6            7110
#define IDX_MISC_PRESET7            7111
#define IDX_MISC_PRESET8            7112

#define IDX_MISC_TEMPLATE           7113
#define IDX_MISC_NAMESKY            7114
#define IDX_MISC_NAMETARGET         7115
#define IDX_MISC_NAMELIGHT          7116
#define IDX_MISC_NAMEGROUND         7117
#define IDX_MISC_NAMEPATH           7118
#define IDX_MISC_SELECTMODEL        7119
#define IDX_MISC_SELECT1            7120
#define IDX_MISC_MODELHEAD          7121
#define IDX_MISC_MODELLOAD          7122
#define IDX_MISC_FRAMES             7123
#define IDX_MISC_NUMFRAMES          7124
#define IDX_MISC_NEXTCANCEL         7125
#define IDX_MISC_ADDNEXT            7126
#define IDX_MISC_ERRORINNEXT        7127
#define IDX_MISC_FILEERROR          7128

#define IDX_MISC_SKYINFORMATION     7129
#define IDX_MISC_SKYPLAIN           7130
#define IDX_MISC_SKYGRADED          7131
#define IDX_MISC_ENVIRONMENT        7132
#define IDX_MISC_BACKDROP           7133
#define IDX_MISC_ANIMBACKDROP       7134
#define IDX_MISC_MODELINFORMATION   7135
#define IDX_MISC_NORMALQON          7136
#define IDX_MISC_NORMALQOFF         7137
#define IDX_MISC_NORMALMODEL        7138
#define IDX_MISC_BOXDRAW            7139
#define IDX_MISC_ANIMSEQ1           7140
#define IDX_MISC_ANIMSEQ2           7141
#define IDX_MISC_GROUNDPLAIN        7142
#define IDX_MISC_GROUNDMAP          7143
#define IDX_MISC_GROUNDTILE         7144
#define IDX_MISC_GROUNDMOZAIC       7145
#define IDX_MISC_GROUNDSHADER       7146
#define IDX_MISC_NORMALLIGHT        7147
#define IDX_MISC_NOSHADOW           7148
#define IDX_MISC_SHADOWONLY         7149
#define IDX_MISC_SPOTLIGHT          7150
#define IDX_MISC_CSGSPHERE          7151
#define IDX_MISC_CSGTUBE            7152
#define IDX_MISC_CSGCYLINDER        7153
#define IDX_MISC_CSGADDITIVE        7154
#define IDX_MISC_TARGET1            7155
#define IDX_MISC_IMAGEPROC          7156
#define IDX_MISC_OPENPATH1          7157
#define IDX_MISC_CLOSEDPATH         7158
#define IDX_MISC_ROBOT1             7159
#define IDX_MISC_ROBOT2             7160
#define IDX_MISC_ROBOT3             7161

#define IDX_MISC_POSITIONINFO       7162
#define IDX_MISC_POSITIONTWEEN      7163
#define IDX_MISC_POSITIONSPLINE     7164
#define IDX_MISC_ROTATIONINFO       7165
#define IDX_MISC_ROTATIONTWEEN      7166
#define IDX_MISC_ROTATIONACCEL      7167
#define IDX_MISC_SCALEINFO          7168
#define IDX_MISC_CONEANGLE          7169
#define IDX_MISC_SCALEWIDTH         7170

#define IDX_MISC_FFNTSC             7171
#define IDX_MISC_FFPAL              7172
#define IDX_MISC_FFFPS              7173
#define IDX_MISC_DSKYINFO           7174
#define IDX_MISC_DCOSTUME           7175
#define IDX_MISC_DCSGSETUP          7176

#define IDX_MISC_ROBOTHIERARCHY     7177
#define IDX_MISC_ROBOTVIEW          7178
#define IDX_MISC_RENAMEACTOR        7179
#define IDX_MISC_GOTOFRAME          7180
#define IDX_MISC_FRAMEID            7181
#define IDX_MISC_QUICKONLYFOR       7182

#define IDX_MISC_RENAMEOBJECT       7183

#define IDX_MISC_HELPFILENAME       7184
#define IDX_MISC_LANGUAGE           7185

#define IDX_MISC_CSGDISK            7186
#define IDX_MISC_CSGSUBTRACTIVE     7188
#define IDX_MISC_COSTUMEI1          7189
#define IDX_MISC_COSTUMEI2          7190
#define IDX_MISC_COSTUMEI3          7191
#define IDX_MISC_COSTUMEI4          7192
#define IDX_MISC_COSTUMEI5          7193
#define IDX_MISC_COSTUMEI6          7194
#define IDX_MISC_COSTUMEI7          7195
#define IDX_MISC_COSTUMEI8          7196
#define IDX_MISC_COSTUMEI9          7197
#define IDX_MISC_CSGSUBTRACTIVE1    7198
#define IDX_MISC_CSGADDITIVE1       7199
#define IDX_MISC_COSTUMEI10         7200
#define IDX_MISC_COSTUMEI11         7201
#define IDX_MISC_POSITIONINFO1      7203
#define IDX_MISC_POSITIONINFO2      7204
#define IDX_MISC_POSITIONINFO3      7205
#define IDX_MISC_POSITIONINFO4      7206

#define IDX_MISC_ROTATIONALIGN      7207
#define IDX_MISC_ROTATIONLOOK       7208
#define IDX_MISC_ROTATIONCOPY       7209

#define IDX_MISC_QUICKDRAW          7210
#define IDX_MISC_HELPFILENAME1      7211
#define IDX_MISC_HELPTITLE1         7212
#define IDX_MISC_HELPTITLE2         7213
#define IDX_MISC_HELPTITLE3         7214
#define IDX_MISC_HOMEPAGE           7215
#define IDX_MISC_SUPPORTPAGE        7216
#define IDX_MISC_HOMEPAGEL          7217
#define IDX_MISC_SUPPORTPAGEL       7218
#define IDX_MISC_SCRIPTID           7219
#define IDX_MISC_SCRIPTTITLE        7220

#define IDX_MISC_DIRECTOR           7221
#define IDX_MISC_DIRECTORINFO       7222
#define IDX_MISC_DIRECTORINFO1      7223



