#   makefile for viewer
#   use parametets CPU= ???  nt=1   sc/wc/cc/vc/bc
NTX=
!IFDEF nt
NTX=-D__X__NT__=1
!ENDIF
PROJ = VIEWER
RC = rc
RCFLAGS = -r

!IF "$(CPU)" == "mips"

CC = cl -c -nologo  -D__X__NT__=1 -DWIN32
LFLAGS = /NOLOGO /SUBSYSTEM:windows
LIBS =user32.lib gdi32.lib comdlg32.lib shell32.lib
LINK = link
#CFLAGS = -align:0x1000 /INCREMENTAL:NO /PDB:NONE
#LFLAGS = $(CFLAGS) /NOLOGO /SUBSYSTEM:windows /NODEFAULTLIB /MACHINE:MIPS
#LIBS =libc.lib kernel32.lib user32.lib gdi32.lib comdlg32.lib shell32.lib

!ELSEIF "$(CPU)" == "alpha"

CC = cl -c -nologo  -D__X__NT__=1 -DWIN32
LFLAGS = /NOLOGO /SUBSYSTEM:windows
LIBS =user32.lib gdi32.lib comdlg32.lib shell32.lib
LINK = link

!ELSE
#                             Ix86 processors
!IFDEF     cc
CC = cl -c -nologo -G5 -D__X__NT__=1 -DWIN32
LINK = link
CFLAGS = -align:0x1000 /INCREMENTAL:NO /PDB:NONE
LFLAGS = $(CFLAGS) /NOLOGO /SUBSYSTEM:windows /NODEFAULTLIB /MACHINE:IX86
LIBS =libc.lib kernel32.lib user32.lib gdi32.lib comdlg32.lib shell32.lib

!ELSEIFDEF  wc
CC = wcc386  -Zp2 -5s -j -fpi87 -s -oimr -bt=nt $(NTX)
LINK = wlink
RC = WRC

!ELSEIFDEF sc
CC=SC -mn -4 -a4 -c -ff $(NTX)
LINK = link386

!ELSEIFDEF bc
WARNS=-w-aus -w-par -w-rch  -w-ccc
CC=bcc32 -c -5 -W $(WARNS) -ff -K- -D__WATCOMC__=1 -D__NT__=1 $(NTX)
LINK = tlink32
RC = BRC32

!ELSE
CC = cl -c -nologo -G5 $(NTX) -DWIN32
LFLAGS = /NOLOGO /SUBSYSTEM:windows
LIBS =user32.lib gdi32.lib comdlg32.lib shell32.lib
LINK = link

!ENDIF

!ENDIF

HH=viewer.h
C0=viewer.obj
C1=gif.obj
C2=tiff.obj
C3=jpeg.obj
C4=png.obj

!IFDEF wc
winview.exe: $(C0) $(C1) $(C2) $(C3) $(C4)
       echo >NUL @<<$(PROJ).CRF
file $(C0)
file $(C1)
file $(C2)
file $(C3)
file $(C4)
name viewer.exe
library ..\tiff\lib_wc.lib
library ..\jpeg\lib_wc.lib
library ..\png\lib_wc.lib
library ..\png\zlib_wc.lib
option CASEEXACT
option osname='Windows NT windowed'
libpath %WATCOM%\lib386
libpath %WATCOM%\lib386\nt
format windows nt ^
lib nt
<<
 $(LINK) @$(PROJ).CRF
 $(RC) -bt=nt viewer.rc
 copy viewer.exe ..\winview.exe
 del viewer.exe

!ELSEIFDEF sc
winview.exe: $(C0) $(C1) $(C2) $(C3) $(C4) viewer.res;
       echo >NUL @<<$(PROJ).DEF
NAME
DESCRIPTION  'VIEWER'
EXETYPE    NT
SUBSYSTEM  WINDOWS
<<
       echo >NUL @<<$(PROJ).CRF
$(C0)+$(C1)+$(C2)+$(C3)+$(C4)
..\winview
NUL
COMDLG32.LIB KERNEL32.LIB GDI32.LIB USER32.LIB
$(PROJ).def
viewer.res
/NOI
<<
 $(LINK) $(LFLAGS) @$(PROJ).CRF

!ELSEIFDEF bc
winview.exe: $(C0) $(C1) $(C2) $(C3) $(C4) viewer.res;
       echo >NUL @<<$(PROJ).DEF
NAME
DESCRIPTION 'Viewer'
EXETYPE    WINDOWS
EXPORTS
<<
       echo >NUL @<<$(PROJ).CRF
/Tpe /c c:\bc4\lib\c0w32+
viewer+gif
..\winview,
c:\bc4\lib\cw32+c:\bc4\lib\import32
$(PROJ).def
viewer.res
<<
 $(LINK) $(LFLAGS) @$(PROJ).CRF

!ELSE
winview.exe: $(C0) $(C1) $(C2) $(C3) $(C4) viewer.res;
       echo >NUL @<<$(PROJ).CRF
$(C0)
$(C1)
$(C2)
$(C3)
$(C4)
-OUT:..\winview.EXE
viewer.RES
..\tiff\lib_ms.lib
..\jpeg\lib_ms.lib
..\png\lib_ms.lib
..\png\zlib_ms.lib
$(LIBS)
<<
 $(LINK) $(LFLAGS) @$(PROJ).CRF

!ENDIF

viewer.obj: viewer.c view_gif.c view_tga.c view_cel.c view_tif.c view_jpg.c $(HH)
  $(CC) viewer.c

gif.obj: gif.c $(HH)
  $(CC) gif.c

tiff.obj: ..\utilities\mdiview\tiff.c
  $(CC) ..\utilities\mdiview\tiff.c -I..\tiff

jpeg.obj: ..\utilities\mdiview\jpeg.c
  $(CC) ..\utilities\mdiview\jpeg.c -I..\jpeg

png.obj: ..\utilities\mdiview\png.c
  $(CC) ..\utilities\mdiview\png.c -I..\png\pnglib -I..\png\zlib

viewer.res: $(HH) viewer.rc
  $(RC) $(RCFLAGS) viewer.rc

clean:
 del viewer.obj
 del gif.obj
 del tiff.obj
 del jpeg.obj
 del png.obj
 del viewer.res
