/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* view_png.c */

void png_display_line(unsigned char *pbgr, long line){
 unsigned char *p;
 register long i,l;
 l = (long)(y_size - 1 - line)*(long)(x4_size);
 p = (unsigned char *)(pixels+l);
 for(i=0;i<x_size;i++){
  *p++ = *(pbgr+2);
  *p++ = *(pbgr+1);
  *p++ = *(pbgr);
  pbgr+=3;
 }
}

extern long ReadPNG(char *filename, short info_only);

static int pngview(HWND hWnd){
 int i;
 long imagesize;
 LPBITMAPINFOHEADER lpbi;
 if(ReadPng(CurrentFile,1) == 0){
   LoadErrMsg(IDX_ERR_NOJPG);
   return 0;
 }
 x4_size=ALIGNULONG(x_size*3);
 FreeDib();
 lpBitmapHeader = (LPSTR)X__Malloc((long)sizeof(BITMAPINFOHEADER));
 if(lpBitmapHeader == NULL){
   LoadErrMsg(IDX_ERR_MEMORY);
   return 0;
 }
 lpbi=(LPBITMAPINFOHEADER)lpBitmapHeader;
 lpbi->biSize=sizeof(BITMAPINFOHEADER);
 lpbi->biWidth=(DWORD)x_size;
 lpbi->biHeight=(DWORD)y_size;
 lpbi->biPlanes=1;
 lpbi->biBitCount=24;
 lpbi->biCompression=BI_RGB;
 imagesize = lpbi->biSizeImage = (DWORD)x4_size*(DWORD)y_size;
 lpbi->biXPelsPerMeter=0;
 lpbi->biYPelsPerMeter=0;
 lpbi->biClrUsed=0;
 lpbi->biClrImportant=0;
 hpalCurrent=CreateImagePalette(lpbi);  /* will set up a dummy palette */
 lpBitmapBits=(LPSTR)X__Malloc(imagesize);
 if(lpBitmapBits == NULL){
   LoadErrMsg(IDX_ERR_MEMORY);
   FreeDib();
   return 0;
 }
 memset(lpBitmapBits,0,imagesize);
 pixels=lpBitmapBits;
 if(ReadPng(CurrentFile,0) == 0){
   LoadErrMsg(IDX_ERR_BADREAD);
   FreeDib();
   return 0;
 }
 hbmCurrent=BitmapFromDib(lpBitmapHeader,lpBitmapBits,hpalCurrent);
 if(hbmCurrent == NULL)LoadErrMsg(IDX_ERR_NOBITMAP);
 SizeWindow(hWnd);
 return 1;
}
