/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* SFXINFO.H  main effects structure   */

typedef struct {
 long nvert;            /* number of vertices that apply to the model     */
 long ltime;            /* integer equivalent of member "time"            */
 long vmin[3];
 long vmax[3];
 long origin[3];
 float time;            /* proportion of elapsed time on actor channel    */
 long Nfaces;
 void *Faces;
 long version;
} sfxinfo;

typedef struct {
 long  size,            /* size of this structure                         */
       version,         /* version of this structure                      */
       pos[3],          /* position of the object (in the scene)          */
       ground_pos[3],
       camera_pos[3],
       internal_axis;
 BOOL  ground,          /* 1 if ground is present in animation            */
       extras;
 float phi,
       theta,
       alpha,
       scale_x,
       scale_y,
       scale_z,
       internal_angle;
} sfxdata;
