/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file XIMAGE.H  */

typedef struct tagXIMAGE {
  double ViewTransform[4][4];  /* viewing transformation matrix            */
  double Xscale,Yscale;        /* scaling values for camera field of view  */
  long Frame;                  /* frame being rendered                     */
  long Xmax,Ymax;              /* dimensions of the image                  */
  long Nlights;                /* number of lights present                 */
  light *Lights;               /* pointer to array of light structures     */
  long Ntargets;               /* not used yet                             */
  vector *Targets;             /* not used yet                             */
  fullscreenbuffer *Screen;    /* pointer to screen buffer                 */
  double *Zbuffer;             /* pointer to Z depth buffer NULL if absent */
  fullscreenbuffer *Blur;      /* pointer to motion blur buffer            */
  unsigned char *ObjectBuffer; /* pointer to objects buffer (if present)   */
  long *AnimatorIdList;        /* pointer to list of ID's in object buffer */
  long shadow_buffer_size;     /* lights shadow buffer size                */
  double *ViewPoint;           /* Camera viewpoint  (vector)               */
  double CamPhi;               /* Camera setting                           */
  double CamTheta;             /*       "                                  */
  double CamAlpha;             /*       "                                  */
  double CamSx;                /*       "                                  */
  double CamSy;                /*       "                                  */
  double CamSz;                /*       "                                  */
  double CamIma;               /*       "                                  */
  long   CamIm;                /*       "                                  */
  char *ModuleName;            /* The filename of DLL executing the PP     */  
  long Pad[5];                 /* for future expansion                     */
  long Morph;                  /* 0 = No morph 1 = Morph                   */
  double MorphRatio;           /* ratio of morphing  0.0 -> 1.00           */
  long first_frame;            /* first frame in channel or 1              */
  long this_frame;             /* frame in anim being rendered             */
  long last_frame;             /* last frame in channel  or Nframes        */
  char *aParameters;           /* parameter list for current effect        */
  char *mParameters;           /* morph parameters (morphing from)         */
  long version;                /* version LITE / PRO /DEMO                 */
  short (*fp_Terminate)(void); /* test for termination                     */
  void  (*fp_Yield)(void);     /* yield for app messages                   */
  void  (*fp_sNoise)(double x, double y, double z, double *result);
  void  (*fp_sTurbulence)(double x, double y, double z, double *result);
  void  (*fp_Cycloidal)(double value, double *result);
  void  (*fp_vNoise)(vector result, double x, double y, double z);
  void  (*fp_vTurbulence)(vector result, double x, double y, double z);
  short (*fp_normalize)(vector n);
  long fPad[16];               /* for futuer expansion (functions)         */
} XIMAGE;
