/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file ATMFONT.C  ATM font builder interface */

#define MODULE_ATMFONT 1

#include "design.h"

#include "atm.h"

BOOL BuildATMfontString(HWND hwnd){
 static HMODULE hLibTrace=NULL;
 static ATM_STRUCTURE AtmStructure,*Atm=NULL;
 int i;
 char lname[255];
 BOOL status=FALSE;
 FARPROC fpFun;
 X__STRUCTURE *Evs;
 BOOL (*fpFun1)(HWND, char *, X__STRUCTURE *, ATM_STRUCTURE *);
 if(hLibTrace != NULL){
   return FALSE;
 }
 EDIT_ACTION=YES;
 Evs=&EviStructure;
 if(Atm == NULL){
   Atm=&AtmStructure;
   ZeroMemory(Atm,sizeof(ATM_STRUCTURE));
   Atm->ATM_face_colour[0]=255;
   Atm->ATM_side_colour[2]=255;
   Atm->ATM_beve_colour[0]=255; Atm->ATM_beve_colour[1]=255;
   Atm->ATM_bevel_angle=45;
   Atm->ATM_char_preview='Q';
   Atm->FORB=1;
   Atm->ATM_cap=1;
 }
 strcpy(Atm->ATM_Letters,"");
 strcpy(lname,gszHomeDir); strcat(lname,"ATM.dll");
 if((hLibTrace=LoadLibrary(lname)) != NULL){
   strcpy(lname,gszHomeDir);
   if((fpFun=GetProcAddress(hLibTrace,"_ATMbuilder")) != NULL){
     fpFun1 = (void *)fpFun;
     status=(*fpFun1)(hwnd,lname,Evs,Atm);
     if(status == TRUE){
     ;
     }
   }
   else MessageBox(hwnd,
        (LPCTSTR) "Failed to get function in Font Builder DLL",
        (LPCTSTR) "",
        MB_OK | MB_TASKMODAL );
   FreeLibrary(hLibTrace);
 }
 else MessageBox(hwnd,
                (LPCTSTR)lname,
                (LPCTSTR) "Failed to load the Font Builder DLL",
                MB_OK | MB_TASKMODAL );
 hLibTrace=NULL;
 return status;
}

#include  "ttf.h"

BOOL BuildTTFfontString(HWND hwnd){
 static HMODULE hLibTrace=NULL;
 static TTF_STRUCTURE TtfStructure,*Ttf=NULL;
 int i;
 char lname[255];
 BOOL status=FALSE;
 FARPROC fpFun;
 X__STRUCTURE *Evs;
 BOOL (*fpFun1)(HWND, char *, X__STRUCTURE *, TTF_STRUCTURE *);
 if(hLibTrace != NULL){
   return FALSE;
 }
 EDIT_ACTION=YES;
 Evs=&EviStructure;
 if(Ttf == NULL){
   Ttf=&TtfStructure;
   ZeroMemory(Ttf,sizeof(TTF_STRUCTURE));
   Ttf->TTF_face_colour[0]=255;
   Ttf->TTF_side_colour[2]=255;
   Ttf->TTF_beve_colour[0]=255;
   Ttf->TTF_beve_colour[1]=255;
   Ttf->TTF_bevel_angle=45;
   Ttf->TTF_char_preview='Q';
   Ttf->FORB=1;
   Ttf->TTF_cap=1;
 }
 strcpy(Ttf->TTF_Letters,"");
 strcpy(lname,gszHomeDir); strcat(lname,"TTF.dll");
 if((hLibTrace=LoadLibrary(lname)) != NULL){
   strcpy(lname,gszHomeDir);
   if((fpFun=GetProcAddress(hLibTrace,"_TTFbuilder")) != NULL){
     fpFun1 = (void *)fpFun;
     status=(*fpFun1)(hwnd,lname,Evs,Ttf);
     if(status == TRUE){
     ;
     }
   }
   else MessageBox(hwnd,
        (LPCTSTR) "Failed to get function in Font Builder DLL",
        (LPCTSTR) "",
        MB_OK | MB_TASKMODAL );
   FreeLibrary(hLibTrace);
 }
 else MessageBox(hwnd,
                (LPCTSTR)lname,
                (LPCTSTR) "Failed to load the Font Builder DLL",
                MB_OK | MB_TASKMODAL );
 hLibTrace=NULL;
 return status;
}
