/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/*  TESSEL.C  */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif

#include "struct.h"
#include "dstruct.h"

#ifdef __cplusplus
}
#endif

#include "copy.h"

#define DESELECTED 0
#define SELECTED   1


static HWND      hParent;
static HINSTANCE hThisInstance;


#if __WATCOMC__
int APIENTRY LibMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#else
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#endif
  switch (dwReason) {
    case DLL_PROCESS_ATTACH: {
      hThisInstance=(HINSTANCE)hDLL;
      if(hDLL == NULL)MessageBox ( GetFocus()," NULL instance",NULL, MB_OK);
      break;
    }
    case DLL_PROCESS_DETACH:
      break;
  }
  return TRUE;
}

#if __SC__
#pragma startaddress(DllMain)
#endif

extern "C" BOOL _Xmodeler
 (HWND parent_window,HWND info_window,X__STRUCTURE *lpevi){
 lpEVI=lpevi;
 hParent=parent_window;
 if(MessageBox(hParent,"Copy selected faces ?","Copy",MB_OKCANCEL)
               == IDCANCEL)return FALSE;
 else{
 HCURSOR hSave;
 vertex *vp,*V0,*V1,*V2,*Vp;
 edge   *ep;
 face   *fp;
 long   i,Nvert1,Nedge1,Nface1;
 long x,y,z;
 if(NvertSelect == 0 || NvertSelect > 32000)return FALSE;
 hSave=SetCursor(LoadCursor(NULL,IDC_WAIT));
 if(!UpdateVertexHeap(Nvert+NvertSelect))return FALSE;
 for(Nedge1=0,ep=MainEp,i=0;i<Nedge;i++){
   V0=(MainVp+ep->V[0]); V1=(MainVp+ep->V[1]);
   if(V0->status == SELECTED && V1->status == SELECTED)Nedge1++;
   ep++;
 }
 if(!UpdateEdgeHeap(Nedge+Nedge1))return FALSE;
 for(Nface1=0,fp=MainFp,i=0;i<Nface;i++){
   V0=(MainVp+fp->V[0]); V1=(MainVp+fp->V[1]); V2=(MainVp+fp->V[2]);
   if(V0->status == SELECTED &&
      V1->status == SELECTED &&
      V2->status == SELECTED)Nface1++;
   fp++;
 }
 if(!UpdateFaceHeap(Nface+Nface1))return FALSE;
 Nvert1=Nvert; Nedge1=Nedge; Nface1=Nface;
 vp=MainVp; for(i=0;i<Nvert1;i++){
   if(vp->status == SELECTED){
     CreateVertex();
     Vp=(MainVp+Nvert-1);
     Vp->xyz[0]=vp->xyz[0];
     Vp->xyz[1]=vp->xyz[1];
     Vp->xyz[2]=vp->xyz[2];
     Vp->gp=vp->gp;
     if(Vp->gp == 1){
       Vp->x=vp->x;
       Vp->y=vp->y;
       NvertGlue++;
     }
     Vp->status=DESELECTED;
     vp->id=Nvert-1;
     NvertSelect--; NvertDeselect++;
   }
   else{
     vp->id = -1;  /* needed by copy+flip+weld */
   }
   vp++;
 }
 if(Nedge > 0)for(ep=MainEp,i=0;i<Nedge1;i++){
   V0=(MainVp+ep->V[0]); V1=(MainVp+ep->V[1]);
   if(V0->status == SELECTED &&
      V1->status == SELECTED){
      CreateEdge(V0->id,V1->id);
   }
   ep++;
 }
 if(Nface > 0)for(fp=MainFp,i=0;i<Nface1;i++){
   V0=(MainVp+fp->V[0]); V1=(MainVp+fp->V[1]); V2=(MainVp+fp->V[2]);
   if(V0->status == SELECTED &&
      V1->status == SELECTED &&
      V2->status == SELECTED) {
     CreateFace(V0->id,V1->id,V2->id);
     CopyFaceProp(fp,(MainFp+Nface-1));
   }
   fp++;
 }
 vp=MainVp; for(i=0;i<Nvert1;i++){
   if(vp->status == SELECTED){
    vp->status=DESELECTED;
    (MainVp+vp->id)->status=SELECTED;
   }
   vp++;
 }
 SetCursor(hSave);
 }
 return TRUE;
}
