/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

// d3dview0.cpp

static PSTR FileInPath(PSTR pstrPath){
 PSTR pstr;
 pstr = pstrPath + strlen(pstrPath);
 while (pstr > pstrPath) {
     pstr = (AnsiPrev(pstrPath, pstr));
     if (*pstr == '\\' || *pstr == ':' || *pstr == '/') {
         pstr = (AnsiNext(pstr));
         break;
     }
 }
 return pstr;
}

static char szFile[256]="*.x";
static char szDir[256]="c:\\evi";

static void LocalCommands(WORD cmd,HWND hWnd){
 switch (cmd){
   case IDM_GLVIEW_PREFS:
     DialogBox(d3dInstance,MAKEINTRESOURCE(DLG_PREFS),hWnd,
               (DLGPROC)PrefsDlgProc);
//     if(mapped)BuildMapList();
     PostMessage(D3dWnd,WM_UPDATE,0,0);
     break;
   case IDM_GLVIEW_HELP:{
       if(ChooseFile(0,szFile,szDir,"Load X File","(X files)|*.x|",hWnd)){
         DeleteObject(active_window);
         InvalidateRect(hWnd,NULL,FALSE);
         UpdateWindow(hWnd);
         OpenNewModel(szFile,active_window);
         InvalidateRect(hWnd,NULL,FALSE);
       }
     }
     break;
   case IDM_GLVIEW_MAP:
     break;
   case IDM_GLVIEW_ABOUT:
     MessageBox(hWnd,ABOUT_VERSION,"About SoftF/X ViewGL",MB_OK);
     break;
   case IDM_GLVIEW_SCROLLBARS:
     if(ChooseFile(1,szFile,szDir,"Save as X File","(X files)|*.x|",hWnd)){
       SaveModel(szFile,active_window);
     }
     break;
     ScrollBars ^= 1;
     if(ScrollBars){
       SetScrollRange(hWnd, SB_VERT, -89,89,TRUE);
       SetScrollRange(hWnd, SB_HORZ, -179,179,TRUE);
       SetScrollPos(hWnd,SB_HORZ,(int)round_angle,TRUE);
       SetScrollPos(hWnd,SB_VERT,(int)up_angle,TRUE);
     }
     else{
       SetScrollRange(hWnd, SB_VERT, 0,0,TRUE);
       SetScrollRange(hWnd, SB_HORZ, 0,0,TRUE);
       SetScrollPos(hWnd,SB_HORZ,0,TRUE);
       SetScrollPos(hWnd,SB_VERT,0,TRUE);
     }
     if(ScrollBars)CheckMenuItem(D3dMenu,IDM_GLVIEW_SCROLLBARS,MF_CHECKED);
     else          CheckMenuItem(D3dMenu,IDM_GLVIEW_SCROLLBARS,MF_UNCHECKED);
     PostMessage(D3dWnd,WM_UPDATE,0,0);
     break;
   case IDM_GLVIEW_TWOSIDE:
     DeleteObject(active_window);
     MakeD3dModel(active_window);
     InvalidateRect(hWnd,NULL,FALSE);
     UpdateWindow(hWnd);
     break;
   default:
     break;
 }
}

static void LoadPrefs(void){
 double R,G,B;
 char pref_id[64];
 GetPrivateProfileString("D3DPREFERENCES","FLAT","$$$",
                   pref_id,sizeof(pref_id),"OPENFX_.INI");
 if(strncmp(pref_id,"NO",2)  == 0)flat=0;
 if(strncmp(pref_id,"YES",3) == 0)flat=1;
 GetPrivateProfileString("D3DPREFERENCES","WIREB","$$$",
                   pref_id,sizeof(pref_id),"OPENFX_.INI");
 if(strncmp(pref_id,"YES",3) == 0)bounding_box=1;
 if(strncmp(pref_id,"NO",2)  == 0)bounding_box=0;
 GetPrivateProfileString("D3DPREFERENCES","COLOUR","$$$",
                   pref_id,sizeof(pref_id),"OPENFX_.INI");
 if(strncmp(pref_id,"$$$",3) != 0){
   sscanf(pref_id,"%lf %lf %lf",&R,&G,&B);
   gbRed=(float)R;  gbGreen=(float)G;  gbBlue=(float)B;
 }
 GetPrivateProfileString("D3DPREFERENCES","MAPPED","$$$",
                   pref_id,sizeof(pref_id),"OPENFX_.INI");
 if(strncmp(pref_id,"YES",3) == 0)Mapped=TRUE;
 if(strncmp(pref_id,"NO",2)  == 0)Mapped=FALSE;
 GetPrivateProfileString("D3DPREFERENCES","UPDATE","$$$",
                   pref_id,sizeof(pref_id),"OPENFX_.INI");
 if(strncmp(pref_id,"YES",3) == 0)Update=TRUE;
 if(strncmp(pref_id,"NO",2)  == 0)Update=FALSE;
 GetPrivateProfileString("D3DPREFERENCES","FASTEST","$$$",
                   pref_id,sizeof(pref_id),"OPENFX_.INI");
 if(strncmp(pref_id,"YES",3) == 0)Fastest=TRUE;
 if(strncmp(pref_id,"NO",2)  == 0)Fastest=FALSE;
 GetPrivateProfileString("D3DPREFERENCES","CLAMPED","$$$",
                   pref_id,sizeof(pref_id),"OPENFX_.INI");
 if(strncmp(pref_id,"YES",3) == 0)Clamped=TRUE;
 if(strncmp(pref_id,"NO",2)  == 0)Clamped=FALSE;
 GetPrivateProfileString("D3DPREFERENCES","DEPTHCUE","$$$",
                   pref_id,sizeof(pref_id),"OPENFX_.INI");
 if(strncmp(pref_id,"YES",3) == 0)AttenuateLight=TRUE;
 if(strncmp(pref_id,"NO",2)  == 0)AttenuateLight=FALSE;
 GetPrivateProfileString("D3DPREFERENCES","SCROLLBARS","$$$",
                   pref_id,sizeof(pref_id),"OPENFX_.INI");
 if(strncmp(pref_id,"YES",3) == 0)ScrollBars=TRUE;
 if(strncmp(pref_id,"NO",2)  == 0)ScrollBars=FALSE;
}

static BOOL CALLBACK PrefsDlgProc(HWND hdlg,UINT msg,
                           WPARAM wparam,LPARAM lparam){
 BOOL state;
 static double R,G,B;
 char *w, yesyes[]="YES", nono[]="NO",str[64];
 unsigned char uColour[3];
 switch( msg ) {
   case WM_INITDIALOG:
     CentreDlgOnC(hdlg);
     if(flat)state=TRUE; else state=FALSE;
     SendDlgItemMessage(hdlg,DLG_PREFS_FLAT,BM_SETCHECK,state,0);
     if(0)state=TRUE; else state=FALSE;
     SendDlgItemMessage(hdlg,DLG_PREFS_WIRE,BM_SETCHECK,state,0);
     if(bounding_box == 1)state=TRUE; else state=FALSE;
     SendDlgItemMessage(hdlg,DLG_PREFS_WIREB,BM_SETCHECK,state,0);
     if(Mapped == TRUE)state=TRUE; else state=FALSE;
     SendDlgItemMessage(hdlg,DLG_PREFS_MAPS,BM_SETCHECK,state,0);
     if(Update == TRUE)state=TRUE; else state=FALSE;
     SendDlgItemMessage(hdlg,DLG_PREFS_UPDATE,BM_SETCHECK,state,0);
     if(Fastest == TRUE)state=TRUE; else state=FALSE;
     SendDlgItemMessage(hdlg,DLG_PREFS_FASTEST,BM_SETCHECK,state,0);
     if(Clamped == TRUE)state=TRUE; else state=FALSE;
     SendDlgItemMessage(hdlg,DLG_PREFS_CLAMPED,BM_SETCHECK,state,0);
     if(AttenuateLight == TRUE)state=TRUE; else state=FALSE;
     SendDlgItemMessage(hdlg,DLG_PREFS_DEPTHC,BM_SETCHECK,state,0);
     R=(double)gbRed; G=(double)gbGreen; B=(double)gbBlue;
     return (TRUE);
   case WM_COMMAND:
      switch(LOWORD(wparam)){
        case DLG_PREFS_COLOUR:
          uColour[0]=(unsigned char)(R*255.0);
          uColour[1]=(unsigned char)(G*255.0);
          uColour[2]=(unsigned char)(B*255.0);
          ChooseColour(uColour,"Background Color",hdlg);
          R=(double)uColour[0]/255.0;
          G=(double)uColour[1]/255.0;
          B=(double)uColour[2]/255.0;
          break;
        case IDOK:
          if(SendDlgItemMessage(hdlg,DLG_PREFS_FLAT,BM_GETCHECK,0,0))
            flat=1; else flat=0;
          if(flat == 1)w=yesyes; else w=nono;
          WritePrivateProfileString("D3DPREFERENCES","FLAT",w,"OPENFX_.INI");
          if(SendDlgItemMessage(hdlg,DLG_PREFS_WIREB,BM_GETCHECK,0,0))
            bounding_box=1; else bounding_box=0;
          if(bounding_box == 1)w=yesyes; else w=nono;
          WritePrivateProfileString("D3DPREFERENCES","WIREB",w,"OPENFX_.INI");
          if(SendDlgItemMessage(hdlg,DLG_PREFS_MAPS,BM_GETCHECK,0,0))
            Mapped=TRUE; else Mapped=FALSE;
          if(Mapped == TRUE)w=yesyes; else w=nono;
          WritePrivateProfileString("D3DPREFERENCES","MAPPED",w,"OPENFX_.INI");
          if(SendDlgItemMessage(hdlg,DLG_PREFS_UPDATE,BM_GETCHECK,0,0))
            Update=TRUE; else Update=FALSE;
          if(Update == TRUE)w=yesyes; else w=nono;
          WritePrivateProfileString("D3DPREFERENCES","UPDATE",w,"OPENFX_.INI");
          if(SendDlgItemMessage(hdlg,DLG_PREFS_FASTEST,BM_GETCHECK,0,0))
            Fastest=TRUE; else Fastest=FALSE;
          if(Fastest == TRUE)w=yesyes; else w=nono;
          WritePrivateProfileString("D3DPREFERENCES","FASTEST",w,"OPENFX_.INI");
          if(SendDlgItemMessage(hdlg,DLG_PREFS_CLAMPED,BM_GETCHECK,0,0))
            Clamped=TRUE; else Clamped=FALSE;
          if(Clamped == TRUE)w=yesyes; else w=nono;
          WritePrivateProfileString("D3DPREFERENCES","CLAMPED",w,"OPENFX_.INI");
          if(SendDlgItemMessage(hdlg,DLG_PREFS_DEPTHC,BM_GETCHECK,0,0))
            AttenuateLight=TRUE; else AttenuateLight=FALSE;
          if(AttenuateLight == TRUE)w=yesyes; else w=nono;
          WritePrivateProfileString("D3DPREFERENCES","DEPTHCUE",w,"OPENFX_.INI");
          gbRed=(float)R; gbGreen=(float)G; gbBlue=(float)B;
          InvalidateRect(GetParent(hdlg),NULL,FALSE);
          sprintf(str,"%lf %lf %lf",R,G,B);
          WritePrivateProfileString("D3DPREFERENCES","COLOUR",str,"OPENFX_.INI");
          EndDialog(hdlg,TRUE);
          return(TRUE);
          break;
        case IDCANCEL:
          EndDialog(hdlg,FALSE);
          return(TRUE);
          break;
        default:  break;
      }
      break;
    default: break;
 }
 return(FALSE);
}
