/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file DESIGN.H  The main program file for the Designer  */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <setjmp.h>
#include <windows.h>
#include <commctrl.h>

#include "mstruct.h"
#include "mmenuid.h"
#include "mstrings.h"

#define WM_UPDATEPDIALOG (WM_USER+1)
#define WM_INTERROGATE   (WM_USER+2)

#ifdef MODULE_DESIGN
#define WHERE
#else
#define WHERE extern
#endif
WHERE HINSTANCE ghinst_main,ghinstDummy1;
WHERE HPALETTE ghpaletteScreen,ghpaletteDummy1;
WHERE HFONT  ghFont1,ghFont2;
WHERE HWND ghwnd_main,ghwnd_triview[3],ghwnd_current,
           ghwnd_view,ghwnd_info,ghwndDlgPrimitives,
           ghwndTools,ghwndLock,ghwndData,
           ghwndCoord1,ghwndDlgAttribs,ghwndDlgExpand,
           ghwndDlgTools,ghwndOpenGLview,ghwndTooltip,
           ghwndSkEdit,ghwndSkToolbar;
WHERE COLORREF gScreenColourRef,gGridColourRef1,gGridColourRef2;
WHERE HBRUSH ghbrushScreen,ghbrushWindow,
             ghSelectedBrush,ghDeselectedBrush,ghInvertBrush,
             ghDummyb1,ghDummyb2,ghDummyb3;
WHERE HPEN   ghSelectedPen,ghDeselectedPen,ghEditPen,ghEdgePen,
             ghInvertPen,ghWireframePen,ghCursorPen,ghSelectorPen,
             ghDeselectorPen,ghDotSelectedPen,
             ghDummyp1,ghDummyp2,ghdummyp3;
WHERE HCURSOR ghcurWait,ghcurArrow,ghcurCross,ghcurSave,ghcurPan,
              ghcurArrowD,ghcurZout,ghcurZin,ghcurSelect,ghcurDeselect,
              ghcurPlotter,ghcurPlot3d,ghcurGrabber,ghcurBuilder,
              ghcurExpander,ghcurRotator,ghcurPrims, ghcurZoom,
              ghcurShaper,ghcurMagnetTo,ghcurMagnetFr,
              ghcurMagnetTw,ghcurMagnetCu,
              ghcurSel_a,ghcurSel_s,ghcurSel_l_a,ghcurSel_l_s,
              ghcurSel_c_a,ghcurSel_c_s;
WHERE HCURSOR ghcurTools[NTOOLS];
WHERE X__STRUCTURE EviStructure;
WHERE X__MEMORY_MANAGER EviMemoryManager;
WHERE FILE *debug;
WHERE jmp_buf j_buf;
WHERE UINT update_timer;
WHERE long Xres,Yres;
WHERE long WindowBox_view;
WHERE BOOL StartedInModeler,bToolpannelLeft,bToolpannelSmall,
           bBackgroundImage;
WHERE long View,ActiveView;
WHERE int ToolbuttonSize,ToolpannelSpace,
          WindowLeftOrigin,WindowTopOrigin,
          WindowGap,
          TriviewSpaceX,TriviewSpaceY,
          Window0sizeX,Window0sizeY,
          Textheight,Textwidth,
          WindowSizeX[3],WindowSizeY[3],
          WindowCentreX[3],WindowCentreY[3],
          WindowViewXsize,WindowViewYsize,
          InfoWindowSize,
          WindowsXmin[3],WindowsYmin[3],
          WindowViewXmin,WindowViewYmin;
WHERE double WindowPixelSize;
WHERE long TVpointX,TVpointY,TVpointZ,
           TVcentreX,TVcentreY,TVcentreZ,
           TVsizeX,TVsizeY,TVsizeZ;
WHERE char gszHomeDir[MAX_DIR];
WHERE char gszSCEfile[MAX_FILE],gszSCEdir[MAX_DIR];
WHERE char gszSCFfile[MAX_FILE],gszSCFdir[MAX_DIR];
WHERE char gszSCNfile[MAX_FILE],gszSCNdir[MAX_DIR];
WHERE char gszPTHfile[MAX_FILE],gszPTHdir[MAX_DIR];
WHERE char gszIMGfile[MAX_FILE],gszIMGdir[MAX_DIR];
WHERE char gszGIFfile[MAX_FILE],gszGIFdir[MAX_DIR];
WHERE char gszDLLfile[MAX_FILE],gszDLLdir[MAX_DIR];
WHERE char gszDXFfile[MAX_FILE],gszDXFdir[MAX_DIR];
WHERE char gsz3DSfile[MAX_FILE],gsz3DSdir[MAX_DIR];
WHERE char gszTDDfile[MAX_FILE],gszTDDdir[MAX_DIR];
WHERE char gszDLMfile[MAX_FILE],gszDLMdir[MAX_DIR];
WHERE char gszFLXfile[MAX_FILE],gszFLXdir[MAX_DIR];
WHERE int gCurTool,gCurCommand,gCurSelect,gCurAction,gCurZoom,
          gCurCoord,gCurLock;
WHERE PREFERENCES Preferences;
WHERE PRIMITIVE   PrimStruct;
#undef WHERE

#ifdef MODULE_DESIGN
char IniFilename[] = "OPENFX_.INI",
     IniSection[]  = "MPREFERENCES";
char szMainClass[]   ="OFX:ModelerClass",
     szViewClass[]   ="OFX:ModelerViewClass",
     szTriViewClass[]="OFX:ModelerTriViewClass",
     szToolboxClass[]="OFX:ModelerToolboxClass",
     szToolBtnClass[]="OFX:ModelerToolBtnClass";
HDC  ghdc_triview_Bitmap[3]={NULL,NULL,NULL},ghdc_view_Bitmap=NULL;
HBITMAP ghbm_triview[3]={NULL,NULL,NULL},ghbm_view=NULL;
int   EDIT_ACTION=NO,LOADOPERATION=NO,CursorToggle=0,current_message = -1,
      UNDO_ON=YES,icon_arrow_ids=YES,type_of_view=0,do_NOT_abort=FALSE,
      axis_move_flag = -1,image_edit_flag= -1;
char   *WorkDrive;                      /* from TEMP environment */
char   ruler_name[8];
double ruler=(double)UNIT;
long   rulerx=0,rulery=0,rulerz=0,    /* relative */
       lrulerx=0,lrulery=0,lrulerz=0, /* origin of ruler */
       draw_grid_on=0,grid_on=0,grid_size=UNIT,
       coords_visible=0,data_visible=0,global_quickdraw=0,draw_joins=1;
long   NpointerX=0,NpointerY=0,NpointerZ=0;
int    tool=NOTOOL,sktool=NO,lock_visible=NO,controls_visible=YES,
       select_visible=YES,tools_visible=YES;
wireframe w_frame={0,0,NULL,NULL};
bezier_curve *Bcurves=NULL;
axis  ObjectAxis={NULL,0,0,0,0.0,0.0,
                  0L,0L,0L,
                  UNIT,0L,0L,
                  0L,UNIT,0L,
                  0L,0L,UNIT,
                  NULL,0,0,0,0.0,0.0,
                  0L,0L,0L};
vertex *MainVp=NULL;
edge   *MainEp=NULL;
face   *MainFp=NULL;
skel   *MainSp=NULL,*FirstSp=NULL,*current_skeleton=NULL;
nurbs  *MainNp=NULL;
unsigned long   Nvert=0,NvertSelect=0,NvertDeselect=0,NvertGlue=0,
                Nface=0,Nedge=0,Nskel=0,N_Bcurves=0,Nnurbs=0;
int             SelectedBrush = -1, SelectedShader = -1,MirrorFlag = -1,
                FontLoaded=NO,ShadowFlag=NO;
double   PerspTheta=0.0,
         PerspFi=0.0;
int      nImaps=0,nLockediMaps=0,nSha=0;
SHADERAXIS iSha[NAXISMAX];
IMAGEMAP   iMap[NMAPSMAX];
XSHADER  xShaders[8];
char     *AlTextList[] = {
"No Texture","Wood","Marble","Granite","Plain","Luminous","Flashing",
"Bumpy","Aztec","Wrinkled","Spotted","Agate","Cloudy","Dents","Blend",
"Wood++","Crystal","Wavelets"};
short NoAlTexts = 18;
double refractive_index=1.2;
long DefaultBrilliance=8,DefaultParameter=0,
     DefaultReflectivity=0,DefaultTransp=0,
     DefaultTexture=0,DefaultShiny=0,DefaultSmoothing=0;
unsigned char FaceColour[3]={255,255,255},
              ShaderColour[3]={128,128,128},
              LastColour[3]={255,255,255};
int  nActionsList=0;
char *ActionsList[256];
#else
extern char IniFilename[],
            IniSection[];
extern char szMainClass[],
            szTriViewClass[],
            szViewClass[],
            szToolboxClass[],
            szToolBtnClass[];
extern HDC ghdc_triview_Bitmap[],ghdc_view_Bitmap;
extern HBITMAP ghbm_triview[],ghbm_view;
extern int    EDIT_ACTION,LOADOPERATION,CursorToggle,current_message,
              UNDO_ON,icon_arrow_ids,type_of_view,do_NOT_abort,
              axis_move_flag,image_edit_flag;
extern char   *WorkDrive;
extern axis   ObjectAxis;
extern char   ruler_name[];
extern double ruler;
extern long   rulerx,rulery,rulerz,
              lrulerx,lrulery,lrulerz,
              draw_grid_on,grid_on,grid_size,
              coords_visible,data_visible,global_quickdraw,draw_joins;
extern long NpointerX,NpointerY,NpointerZ;
extern int  tool,sktool,lock_visible,controls_visible,
            select_visible,tools_visible;
extern wireframe w_frame;
extern bezier_curve *Bcurves;
extern vertex *MainVp;
extern edge   *MainEp;
extern face   *MainFp;
extern skel   *MainSp,*FirstSp,*current_skeleton;
extern nurbs  *MainNp;
extern unsigned long Nvert,NvertSelect,NvertDeselect,NvertGlue,
                     Nface,Nedge,Nskel,N_Bcurves,Nnurbs;
extern int    SelectedBrush,SelectedShader,FontLoaded,MirrorFlag,ShadowFlag;
extern double PerspTheta,
              PerspFi;
extern int    nImaps,nLockediMaps,nSha;
extern SHADERAXIS iSha[];
extern IMAGEMAP iMap[];
extern XSHADER  xShaders[];
extern char   *AlTextList[];
extern short  NoAlTexts;
extern double refractive_index;
extern long DefaultBrilliance,DefaultParameter,
            DefaultReflectivity,DefaultTransp,
            DefaultTexture,DefaultShiny,DefaultSmoothing;
extern unsigned char FaceColour[],ShaderColour[],LastColour[];
extern int  nActionsList;
extern char *ActionsList[];
#endif


#include "mprotos.h"

