/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file DIALOGS.H  */

#define DLG_CHOOSE                5000
#define DLG_CHOOSE_LIST           5001
#define DLG_CHOOSE_OK             5002
#define DLG_CHOOSE_CANCEL         5003
#define DLG_STRING                5004
#define DLG_STRING_EDIT           5005
#define DLG_STRING_OK             5006
#define DLG_NUMENTRY              5007
#define DLG_NUMENTRY_EDIT         5008
#define DLG_NUMENTRY_OK           5009
#define DLG_NUMENTRY_CANCEL       5010
#define DLG_NUMENTRY_TEXT         5011
#define DLG_NUMENTRY_SPIN         5012
#define DLG_GRIDSIZE              5022
#define DLG_GRIDSIZE_ON           5023
#define DLG_GRIDSIZE_OFF          5024
#define DLG_GRIDSIZE_EDIT         5025
#define DLG_GRIDSIZE_OK           5026
#define DLG_GRIDSIZE_CANCEL       5027
#define DLG_COORD                 5028
#define DLG_COORD_NAME            5029
#define DLG_COORD_CAL             5030
#define DLG_COORD_OK              5031
#define DLG_COORD_CANCEL          5032
#define DLG_3REALS                5033
#define DLG_3REALS_NAME1          5034
#define DLG_3REALS_NAME2          5035
#define DLG_3REALS_NAME3          5036
#define DLG_3REALS_CAL1           5037
#define DLG_3REALS_CAL2           5038
#define DLG_3REALS_CAL3           5039
#define DLG_3REALS_OK             5040
#define DLG_3REALS_CANCEL         5041

#define DLG_ATTRIBS               5100
#define DLG_ATTRIBS_FC_GET        5101
#define DLG_ATTRIBS_FC_SET        5102
#define DLG_ATTRIBS_FC_EDIT       5103
#define DLG_ATTRIBS_SC_GET        5104
#define DLG_ATTRIBS_SC_SET        5105
#define DLG_ATTRIBS_SC_EDIT       5106
#define DLG_ATTRIBS_GLS_SCROLL    5107
#define DLG_ATTRIBS_GLS_EDIT      5108
#define DLG_ATTRIBS_GLS_OFF       5109
#define DLG_ATTRIBS_GLS_ON        5110
#define DLG_ATTRIBS_GLS_GET       5111
#define DLG_ATTRIBS_GLS_SET       5112
#define DLG_ATTRIBS_TRN_SCROLL    5113
#define DLG_ATTRIBS_TRN_EDIT      5114
#define DLG_ATTRIBS_TRN_GET       5115
#define DLG_ATTRIBS_TRN_SET       5116
#define DLG_ATTRIBS_TRN_TYPE0     5117
#define DLG_ATTRIBS_TRN_TYPE1     5118
#define DLG_ATTRIBS_PRM_SCROLL    5119
#define DLG_ATTRIBS_PRM_EDIT      5120
#define DLG_ATTRIBS_PRM_GET       5121
#define DLG_ATTRIBS_PRM_SET       5122
#define DLG_ATTRIBS_REF_SCROLL    5123
#define DLG_ATTRIBS_REF_EDIT      5124
#define DLG_ATTRIBS_REF_GET       5125
#define DLG_ATTRIBS_REF_SET       5126
#define DLG_ATTRIBS_SHA_SET       5127
#define DLG_ATTRIBS_SHA_INT       5128
#define DLG_ATTRIBS_SHA_EXT       5129
#define DLG_ATTRIBS_SHA_NAME      5130
#define DLG_ATTRIBS_SHA_XCHOOSE   5131
#define DLG_ATTRIBS_SHA_XMOVE     5132
#define DLG_ATTRIBS_SHA_XNAME     5133
#define DLG_ATTRIBS_MAP_SET       5134
#define DLG_ATTRIBS_MAP_DROP      5135
#define DLG_ATTRIBS_MAP_MOVE      5136
#define DLG_ATTRIBS_MAP_EDIT      5137
#define DLG_ATTRIBS_MAP_DELETE    5138
#define DLG_ATTRIBS_MAP_NAME      5139
#define DLG_ATTRIBS_MAP_TYPE      5140
#define DLG_ATTRIBS_MAP_SINGLE    5141
#define DLG_ATTRIBS_MAP_TILE      5142
#define DLG_ATTRIBS_MAP_SHADED    5143
#define DLG_ATTRIBS_MAP_UNSHADED  5144
#define DLG_ATTRIBS_MAP_OPAQUE    5145
#define DLG_ATTRIBS_MAP_CLEAR     5146
#define DLG_ATTRIBS_SMOOTH_OFF    5147
#define DLG_ATTRIBS_SMOOTH_ON     5148
#define DLG_ATTRIBS_CLOSE         5149
#define DLG_ATTRIBS_PREVIEW       5150
#define DLG_ATTRIBS_WARN_FC       5151
#define DLG_ATTRIBS_WARN_SC       5152
#define DLG_ATTRIBS_WARN_GLS      5153
#define DLG_ATTRIBS_WARN_SPEC     5154  // toggle highlights
#define DLG_ATTRIBS_WARN_TRN      5155
#define DLG_ATTRIBS_WARN_TRNE     5156
#define DLG_ATTRIBS_WARN_PRM      5157
#define DLG_ATTRIBS_WARN_REF      5158
#define DLG_ATTRIBS_WARN_SHA      5159
#define DLG_ATTRIBS_WARN_MAP      5160
#define DLG_ATTRIBS_WARN_MAP1     5161
#define DLG_ATTRIBS_WARN_MAP2     5162
#define DLG_ATTRIBS_WARN_MAP3     5163
#define DLG_ATTRIBS_WARN_MAP4     5164
#define DLG_ATTRIBS_WARN_MAP5     5165
#define DLG_ATTRIBS_WARN_SMOOTH   5166

#define DLG_MAPS                  5200
#define DLG_MAPS_DONE             5201
#define DLG_MAPS_LIST             5202
#define DLG_MAPS_MOVE             5203
#define DLG_MAPS_NEW              5204
#define DLG_MAPS_DELETE           5205
#define DLG_MAPS_PM               5206
#define DLG_MAPS_P                5207
#define DLG_MAPS_C                5208
#define DLG_MAPS_CM               5209
#define DLG_MAPS_G                5210
#define DLG_MAPS_S                5211
#define DLG_MAPS_C_SCROLL         5212
#define DLG_MAPS_C_EDIT           5214
#define DLG_MAPS_S_NAME           5215
#define DLG_MAPS_S_SET            5216
#define DLG_MAPS_S_PRESET         5217
#define DLG_MAPS_S_DROP           5218
#define DLG_MAPS_S_VIEW           5219
#define DLG_MAPS_S_STILL          5220
#define DLG_MAPS_S_ANIMATED       5221
#define DLG_MAPS_S_SCROLL         5222
#define DLG_MAPS_S_EDIT           5223
#define DLG_MAPS_R_NAME           5224
#define DLG_MAPS_R_SET            5225
#define DLG_MAPS_R_DROP           5226
#define DLG_MAPS_R_VIEW           5227
#define DLG_MAPS_R_SCROLL         5228
#define DLG_MAPS_R_EDIT           5229
#define DLG_MAPS_B_NAME           5230
#define DLG_MAPS_B_SET            5231
#define DLG_MAPS_B_DROP           5232
#define DLG_MAPS_B_VIEW           5233
#define DLG_MAPS_B_SCROLL         5234
#define DLG_MAPS_B_EDIT           5235
#define DLG_MAPS_T_NAME           5236
#define DLG_MAPS_T_SET            5237
#define DLG_MAPS_T_DROP           5238
#define DLG_MAPS_T_VIEW           5239
#define DLG_MAPS_T_SCROLL         5240
#define DLG_MAPS_T_EDIT           5241
#define DLG_MAPS_KEY_INDEX        5242
#define DLG_MAPS_KEY_CHOSEN       5243
#define DLG_MAPS_KEY_COLOUR       5244
#define DLG_MAPS_R_STILL          5245
#define DLG_MAPS_R_ANIMATED       5246
#define DLG_MAPS_B_STILL          5247
#define DLG_MAPS_B_ANIMATED       5248
#define DLG_MAPS_T_STILL          5249
#define DLG_MAPS_T_ANIMATED       5250
#define DLG_MAPS_PREVIEW          5251
#define DLG_MAPS_S_ACTIVE         5252
#define DLG_MAPS_R_ACTIVE         5253
#define DLG_MAPS_B_ACTIVE         5254
#define DLG_MAPS_T_ACTIVE         5255
#define DLG_MAPS_S_MODIFY         5256
#define DLG_MAPS_R_MODIFY         5257
#define DLG_MAPS_B_MODIFY         5258
#define DLG_MAPS_T_MODIFY         5259
#define DLG_MAPS_ORDERN           5260
#define DLG_MAPS_ORDERM           5261
#define DLG_MAPS_TILE             5262

#define DLG_3INTS                 5332
#define DLG_3INTS_OK              5333
#define DLG_3INTS_CANCEL          5334
#define DLG_3INTS_TEXT1           5335
#define DLG_3INTS_TEXT2           5336
#define DLG_3INTS_TEXT3           5337
#define DLG_3INTS_EDIT1           5338
#define DLG_3INTS_SPIN1           5339
#define DLG_3INTS_EDIT2           5340
#define DLG_3INTS_SPIN2           5341
#define DLG_3INTS_EDIT3           5342
#define DLG_3INTS_SPIN3           5343

#define DLG_2INTS                 5344
#define DLG_2INTS_OK              5345
#define DLG_2INTS_CANCEL          5346
#define DLG_2INTS_TEXT1           5347
#define DLG_2INTS_TEXT2           5348
#define DLG_2INTS_EDIT1           5349
#define DLG_2INTS_SPIN1           5350
#define DLG_2INTS_EDIT2           5351
#define DLG_2INTS_SPIN2           5352

#define DLG_1I1R                  5353
#define DLG_1I1R_OK               5354
#define DLG_1I1R_CANCEL           5355
#define DLG_1I1R_TEXTI            5356
#define DLG_1I1R_TEXTR            5357
#define DLG_1I1R_EDITI            5358
#define DLG_1I1R_SPINI            5359
#define DLG_1I1R_EDITR            5360

#define DLG_FPLOT                 5400
#define DLG_FPLOT_OK              5401
#define DLG_FPLOT_CANCEL          5402
#define DLG_FPLOT_LIST            5403
#define DLG_FPLOT_EDITX           5404
#define DLG_FPLOT_SPINX           5405
#define DLG_FPLOT_EDITY           5406
#define DLG_FPLOT_SPINY           5407

#define DLG_SPIRAL                5408
#define DLG_SPIRAL_OK             5409
#define DLG_SPIRAL_CANCEL         5410
#define DLG_SPIRAL_ARC            5411
#define DLG_SPIRAL_LOG            5412
#define DLG_SPIRAL_EDITN          5413
#define DLG_SPIRAL_SPINN          5414
#define DLG_SPIRAL_EDITR          5415
#define DLG_SPIRAL_SPINR          5416

#define DLG_EXTRUDEALONG          5417
#define DLG_EXTRUDEALONG_OK       5418
#define DLG_EXTRUDEALONG_EXPAND   5419
#define DLG_EXTRUDEALONG_CANCEL   5420
#define DLG_EXTRUDEALONG_EXP      5421
#define DLG_EXTRUDEALONG_MAP      5422

#define DLG_FLIP                  5423
#define DLG_FLIP_PLANEH           5424
#define DLG_FLIP_PLANEV           5425
#define DLG_FLIP_WELDOFF          5426
#define DLG_FLIP_WELDON           5427
#define DLG_FLIP_CANCEL           5428
#define DLG_FLIP_OK               5429

#define DLG_EXPAND                5430
#define DLG_EXPAND_EXPAND         5431
#define DLG_EXPAND_DONE           5432
#define DLG_EXPAND_UD             5433
#define DLG_EXPAND_EDITUD         5434
#define DLG_EXPAND_LR             5435
#define DLG_EXPAND_EDITLR         5436
#define DLG_EXPAND_FB             5437
#define DLG_EXPAND_EDITFB         5438
#define DLG_EXPAND_13             5439
#define DLG_EXPAND_12             5440
#define DLG_EXPAND_14             5441
#define DLG_EXPAND_3              5442
#define DLG_EXPAND_4              5443
#define DLG_EXPAND_2              5444
#define DLG_EXPAND_VERT           5445
#define DLG_EXPAND_FACE           5446
#define DLG_EXPAND_CURSOR         5447
#define DLG_EXPAND_CENTRE         5448
#define DLG_EXPAND_SLIDER         5449

#define DLG_SKEL                  5500
#define DLG_SKEL_DIR              5501
#define DLG_SKEL_CHILD            5502
#define DLG_SKEL_PARENT           5503
#define DLG_SKEL_ROOT             5504
#define DLG_SKEL_RENAME           5505
#define DLG_SKEL_DELETE           5506
#define DLG_SKEL_ADD              5507
#define DLG_SKEL_SELECT           5508
#define DLG_SKEL_DESELECT         5509
#define DLG_SKEL_HIDE             5510
#define DLG_SKEL_ATTACH           5511
#define DLG_SKEL_DETACH           5512
#define DLG_SKEL_FAMILY           5513
#define DLG_SKEL_DONE             5514

#define DLG_PR_CONE               5515
#define DLG_PR_CONE_OK            5516
#define DLG_PR_CONE_CANCEL        5517
#define DLG_PR_CONE_COLOUR        5518
#define DLG_PR_CONE_RADIUS        5519
#define DLG_PR_CONE_LENGTH        5520
#define DLG_PR_CONE_SIDES         5521
#define DLG_PR_CONE_SIDESS        5522
#define DLG_PR_CONE_LR            5523
#define DLG_PR_CONE_FB            5524
#define DLG_PR_CONE_UD            5525

#define DLG_PR_CUBE               5526
#define DLG_PR_CUBE_OK            5527
#define DLG_PR_CUBE_CANCEL        5528
#define DLG_PR_CUBE_COLOUR        5529
#define DLG_PR_CUBE_LENGTH        5530
#define DLG_PR_CUBE_WIDTH         5531
#define DLG_PR_CUBE_HEIGHT        5532
#define DLG_PR_CUBE_LR            5533
#define DLG_PR_CUBE_FB            5534
#define DLG_PR_CUBE_UD            5535

#define DLG_PR_CYL                5536
#define DLG_PR_CYL_OK             5537
#define DLG_PR_CYL_CANCEL         5538
#define DLG_PR_CYL_COLOUR         5539
#define DLG_PR_CYL_LENGTH         5540
#define DLG_PR_CYL_RADIUS         5541
#define DLG_PR_CYL_SIDES          5542
#define DLG_PR_CYL_SIDESS         5543
#define DLG_PR_CYL_LR             5544
#define DLG_PR_CYL_FB             5545
#define DLG_PR_CYL_UD             5546
#define DLG_PR_CYL_NSTEPS         5547
#define DLG_PR_CYL_NSTEPSS        5548

#define DLG_PR_DISK               5549
#define DLG_PR_DISK_OK            5550
#define DLG_PR_DISK_CANCEL        5551
#define DLG_PR_DISK_COLOUR        5552
#define DLG_PR_DISK_RADIUS        5553
#define DLG_PR_DISK_SIDES         5554
#define DLG_PR_DISK_SIDESS        5555
#define DLG_PR_DISK_LR            5556
#define DLG_PR_DISK_FB            5557
#define DLG_PR_DISK_UD            5558

#define DLG_PR_PLANE              5559
#define DLG_PR_PLANE_OK           5560
#define DLG_PR_PLANE_CANCEL       5561
#define DLG_PR_PLANE_COLOUR       5562
#define DLG_PR_PLANE_LENGTH       5563
#define DLG_PR_PLANE_WIDTH        5564
#define DLG_PR_PLANE_LR           5565
#define DLG_PR_PLANE_FB           5566
#define DLG_PR_PLANE_UD           5567

#define DLG_PR_POLY               5600
#define DLG_PR_POLY_OK            5601
#define DLG_PR_POLY_CANCEL        5602
#define DLG_PR_POLY_COLOUR        5603
#define DLG_PR_POLY_RADIUS        5604
#define DLG_PR_POLY_SIDES         5605
#define DLG_PR_POLY_SIDESS        5606
#define DLG_PR_POLY_LR            5607
#define DLG_PR_POLY_FB            5608
#define DLG_PR_POLY_UD            5609

#define DLG_PR_SPH                5610
#define DLG_PR_SPH_OK             5611
#define DLG_PR_SPH_CANCEL         5612
#define DLG_PR_SPH_COLOUR         5613
#define DLG_PR_SPH_RADIUS         5614
#define DLG_PR_SPH_ON             5615
#define DLG_PR_SPH_OFF            5616
#define DLG_PR_SPH_20             5617
#define DLG_PR_SPH_80             5618
#define DLG_PR_SPH_320            5619
#define DLG_PR_SPH_1280           5620
#define DLG_PR_SPH_LR             5621
#define DLG_PR_SPH_FB             5622
#define DLG_PR_SPH_UD             5623

#define DLG_PR_TUBE               5624
#define DLG_PR_TUBE_OK            5625
#define DLG_PR_TUBE_CANCEL        5626
#define DLG_PR_TUBE_COLOUR        5627
#define DLG_PR_TUBE_LENGTH        5628
#define DLG_PR_TUBE_RADIUS        5629
#define DLG_PR_TUBE_SIDES         5630
#define DLG_PR_TUBE_SIDESS        5631
#define DLG_PR_TUBE_LR            5632
#define DLG_PR_TUBE_FB            5633
#define DLG_PR_TUBE_UD            5634
#define DLG_PR_TUBE_NSTEPS        5635
#define DLG_PR_TUBE_NSTEPSS       5636

#define DLG_PR_SPH1               5637
#define DLG_PR_SPH1_OK            5638
#define DLG_PR_SPH1_CANCEL        5639
#define DLG_PR_SPH1_COLOUR        5640
#define DLG_PR_SPH1_RADIUS        5641
#define DLG_PR_SPH1_ON            5642
#define DLG_PR_SPH1_OFF           5643
#define DLG_PR_SPH1_VERT          5644
#define DLG_PR_SPH1_VERTS         5645
#define DLG_PR_SPH1_HORZ          5646
#define DLG_PR_SPH1_HORZS         5647
#define DLG_PR_SPH1_LR            5648
#define DLG_PR_SPH1_FB            5649
#define DLG_PR_SPH1_UD            5650

#define DLG_PR_TORUS              5651
#define DLG_PR_TORUS_OK           5652
#define DLG_PR_TORUS_CANCEL       5653
#define DLG_PR_TORUS_COLOUR       5654
#define DLG_PR_TORUS_RADIUS       5655
#define DLG_PR_TORUS_ON           5656
#define DLG_PR_TORUS_OFF          5657
#define DLG_PR_TORUS_VERT         5658
#define DLG_PR_TORUS_VERTS        5659
#define DLG_PR_TORUS_HORZ         5660
#define DLG_PR_TORUS_HORZS        5661
#define DLG_PR_TORUS_RATIO        5662
#define DLG_PR_TORUS_LR           5663
#define DLG_PR_TORUS_FB           5664
#define DLG_PR_TORUS_UD           5665

#define DLG_BUILD                 5700
#define DLG_BUILD_AX              5701
#define DLG_BUILD_AY              5702
#define DLG_BUILD_AZ              5703
#define DLG_BUILD_RX              5704
#define DLG_BUILD_RY              5705
#define DLG_BUILD_RZ              5706
#define DLG_BUILD_START           5707
#define DLG_BUILD_MAKE            5708
#define DLG_BUILD_DONE            5709

#define DLG_ATTRIBS_UPDATE        5725

#define DLG_MAPCURVE              5726
#define DLG_MAPCURVE_LIN          5728
#define DLG_MAPCURVE_ONE          5729
#define DLG_MAPCURVE_N            5730
#define DLG_MAPCURVE_NS           5731
#define DLG_MAPCOORD              5732
#define DLG_MAPCOORD_H            5733
#define DLG_MAPCOORD_V            5734
#define DLG_MAPCOORD_VALUE        5735
#define DLG_MAPMAP                5736
#define DLG_MAPMAP_P              5737
#define DLG_MAPMAP_C              5738
#define DLG_MAPMAP_LIST           5739

#define DLG_COLSELECT             5740
#define DLG_COLSELECT_NEAR        5741
#define DLG_COLSELECT_COLOUR      5742

#define DLG_SQUEEZE               5743
#define DLG_SQUEEZE_CUR           5744
#define DLG_SQUEEZE_CENT          5745
#define DLG_SQUEEZE_WELD          5746
#define DLG_SQUEEZE_WELDVALUE     5747

#define DLG_EXPLODE               5748
#define DLG_EXPLODE_SPHERE        5749
#define DLG_EXPLODE_H             5750
#define DLG_EXPLODE_VFB           5751
#define DLG_EXPLODE_VLR           5752
#define DLG_EXPLODE_FACES         5753
#define DLG_EXPLODE_GRID          5754
#define DLG_EXPLODE_FO_UNIFORM    5755
#define DLG_EXPLODE_FO_RANDOM     5756
#define DLG_EXPLODE_FO_PROP       5757
#define DLG_EXPLODE_FO_PROPX      5758
#define DLG_EXPLODE_FO_PROPY      5759
#define DLG_EXPLODE_FO_PROPZ      5760

#define DLG_DEFAULT_OK            5761
#define DLG_DEFAULT_CANCEL        5762
#define DLG_DEFAULT_FC_EDIT       5763
#define DLG_DEFAULT_SC_EDIT       5764
#define DLG_DEFAULT_SMOOTH_OFF    5765
#define DLG_DEFAULT_SMOOTH_ON     5766
#define DLG_DEFAULT_GLS_OFF       5767
#define DLG_DEFAULT_GLS_ON        5768
#define DLG_DEFAULT_GLS_SCROLL    5769
#define DLG_DEFAULT_BMP_SCROLL    5770
#define DLG_DEFAULT_REF_SCROLL    5771
#define DLG_DEFAULT_TRN_SCROLL    5772
#define DLG_DEFAULT_GLS_EDIT      5773
#define DLG_DEFAULT_BMP_EDIT      5774
#define DLG_DEFAULT_REF_EDIT      5775
#define DLG_DEFAULT_TRN_EDIT      5776
#define DLG_DEFAULT               5777

#define DLG_PRIMES                5800
#define DLG_PRIMES_RECT           5801
#define DLG_PRIMES_CUBE           5802
#define DLG_PRIMES_POLY           5803
#define DLG_PRIMES_TUBE           5804
#define DLG_PRIMES_DISK           5805
#define DLG_PRIMES_CYLINDER       5806
#define DLG_PRIMES_CONE           5807
#define DLG_PRIMES_SPHERE         5808
#define DLG_PRIMES_SPHERE1        5809
#define DLG_PRIMES_TORUS          5810

#define DLG_COORDS                5812
#define DLG_COORDS_X              5813
#define DLG_COORDS_Y              5814
#define DLG_COORDS_Z              5815
#define DLG_COORDS_DX             5816
#define DLG_COORDS_DY             5817
#define DLG_COORD_DZ              5818
#define DLG_COORD_SETREL          5819
#define DLG_COORD_SETCENTRE       5820
#define DLG_COORD_DEFINE          5821
#define DLG_COORD_GOTO            5822
#define DLG_COORDS_DZ             5823
#define DLG_COORDS_GOTO           5824
#define DLG_COORDS_CANCEL         5825
#define DLG_COORDS_SETCENTRE      5826
#define DLG_COORDS_DEFINE         5827

#define DLG_TAB_PRIMES              5830
#define DLG_TAB_PRIMES_AUTO         5831

#define DLG_ABOUT                   5832
#define DLG_ABOUT_ANIMATE           5833
#define DLG_ABOUT_VERSION           5834

#define DLG_LOCK                    5835
#define DLG_LOCK_SQ                 5836
#define DLG_LOCK_CI                 5837
#define DLG_LOCK_TR                 5838
#define DLG_LOCK_LK                 5839
#define DLG_LOCK_XX                 5840

#define DLG_PREFERENCES             5900
#define DLG_PREFERENCES_GENERAL     5901
#define DLG_PREFERENCES_START       5903

#define DLG_PREFERENCES_BUTTONS     5910
#define DLG_PREFERENCES_QUICKTRICK  5911
#define DLG_PREFERENCES_UNDO        5912
#define DLG_PREFERENCES_OPENGL      5913
#define DLG_PREFERENCES_VCOLOUR     5914
#define DLG_PREFERENCES_TOOLTIPS    5915
#define DLG_PREFERENCES_BIGV        5916
#define DLG_PREFERENCES_POSITIONS   5917
#define DLG_PREFERENCES_TOOLLEFT    5918
#define DLG_PREFERENCES_TOOLSMALL   5919
#define DLG_PREFERENCES_BACKGROUND  5920

#define DLG_ROTATE                  6000
#define DLG_ROTATE_CLOCK            6001
#define DLG_ROTATE_ANTICLOCK        6002
#define DLG_ROTATE_ANGLE            6003
#define DLG_ROTATE_ANGLESPIN        6004

#define DLG_MOVE                    6005
#define DLG_MOVE_X                  6006
#define DLG_MOVE_Y                  6007
#define DLG_MOVE_Z                  6008

#define DLG_SKELETON                6050
#define DLG_SKELETON_TREEVIEW       6051

#define DLG_SHADERSET             6100
#define DLG_SHADERSET_DONE        6101
#define DLG_SHADERSET_NAME1       6102
#define DLG_SHADERSET_OFF1        6103
#define DLG_SHADERSET_ON1         6104
#define DLG_SHADERSET_NAME2       6105
#define DLG_SHADERSET_OFF2        6106
#define DLG_SHADERSET_ON2         6107
#define DLG_SHADERSET_NAME3       6108
#define DLG_SHADERSET_OFF3        6109
#define DLG_SHADERSET_ON3         6110
#define DLG_SHADERSET_NAME4       6111
#define DLG_SHADERSET_OFF4        6112
#define DLG_SHADERSET_ON4         6113
#define DLG_SHADERSET_NAME5       6114
#define DLG_SHADERSET_OFF5        6115
#define DLG_SHADERSET_ON5         6116
#define DLG_SHADERSET_NAME6       6117
#define DLG_SHADERSET_OFF6        6118
#define DLG_SHADERSET_ON6         6119
#define DLG_SHADERSET_NAME7       6120
#define DLG_SHADERSET_OFF7        6121
#define DLG_SHADERSET_ON7         6122
#define DLG_SHADERSET_NAME8       6123
#define DLG_SHADERSET_OFF8        6124
#define DLG_SHADERSET_ON8         6125
#define DLG_SHADERSET_EDIT1       6126
#define DLG_SHADERSET_EDIT2       6127
#define DLG_SHADERSET_EDIT3       6128
#define DLG_SHADERSET_EDIT4       6129
#define DLG_SHADERSET_EDIT5       6130
#define DLG_SHADERSET_EDIT6       6131
#define DLG_SHADERSET_EDIT7       6132
#define DLG_SHADERSET_EDIT8       6133
#define DLG_SHADERSET_LOAD1       6134
#define DLG_SHADERSET_LOAD2       6135
#define DLG_SHADERSET_LOAD3       6136
#define DLG_SHADERSET_LOAD4       6137
#define DLG_SHADERSET_LOAD5       6138
#define DLG_SHADERSET_LOAD6       6139
#define DLG_SHADERSET_LOAD7       6140
#define DLG_SHADERSET_LOAD8       6141


#define DLG_SHADERLOAD            6150
#define DLG_SHADERLOAD_DONE       6151
#define DLG_SHADERLOAD_NAME1      6152
#define DLG_SHADERLOAD_LOAD1      6153
#define DLG_SHADERLOAD_EDIT1      6154
#define DLG_SHADERLOAD_DROP1      6155
#define DLG_SHADERLOAD_NAME2      6156
#define DLG_SHADERLOAD_LOAD2      6157
#define DLG_SHADERLOAD_EDIT2      6158
#define DLG_SHADERLOAD_DROP2      6159
#define DLG_SHADERLOAD_NAME3      6160
#define DLG_SHADERLOAD_LOAD3      6161
#define DLG_SHADERLOAD_EDIT3      6162
#define DLG_SHADERLOAD_DROP3      6163
#define DLG_SHADERLOAD_NAME4      6164
#define DLG_SHADERLOAD_LOAD4      6165
#define DLG_SHADERLOAD_EDIT4      6166
#define DLG_SHADERLOAD_DROP4      6167
#define DLG_SHADERLOAD_NAME5      6168
#define DLG_SHADERLOAD_LOAD5      6169
#define DLG_SHADERLOAD_EDIT5      6170
#define DLG_SHADERLOAD_DROP5      6171
#define DLG_SHADERLOAD_NAME6      6172
#define DLG_SHADERLOAD_LOAD6      6173
#define DLG_SHADERLOAD_EDIT6      6174
#define DLG_SHADERLOAD_DROP6      6175
#define DLG_SHADERLOAD_NAME7      6176
#define DLG_SHADERLOAD_LOAD7      6177
#define DLG_SHADERLOAD_EDIT7      6178
#define DLG_SHADERLOAD_DROP7      6179
#define DLG_SHADERLOAD_NAME8      6180
#define DLG_SHADERLOAD_LOAD8      6181
#define DLG_SHADERLOAD_EDIT8      6182
#define DLG_SHADERLOAD_DROP8      6183
#define DLG_SHADERLOAD_PREVIEW    6184

#define DLG_ADDNURBS              6200
#define DLG_ADDNURBS_NUMU         6201
#define DLG_ADDNURBS_NUMU_S       6202
#define DLG_ADDNURBS_ORDERU       6203
#define DLG_ADDNURBS_ORDERU_S     6204
#define DLG_ADDNURBS_SCALEU       6205
#define DLG_ADDNURBS_NUMV         6206
#define DLG_ADDNURBS_NUMV_S       6207
#define DLG_ADDNURBS_ORDERV       6208
#define DLG_ADDNURBS_ORDERV_S     6209
#define DLG_ADDNURBS_SCALEV       6210
#define DLG_ADDNURBS_NAME         6211
#define DLG_ADDNURBS_GRANMAX      6212
#define DLG_ADDNURBS_GRANMAX_S    6213
#define DLG_ADDNURBS_GRANMIN      6214
#define DLG_ADDNURBS_GRANMIN_S    6215
#define DLG_ADDNURBS_COLOUR       6216
#define DLG_ADDNURBS_MAP          6217
#define DLG_ADDNURBS_SHADER       6218

#define DLG_MESHNURBS             6250
#define DLG_MESHNURBS_U           6251
#define DLG_MESHNURBS_U_S         6252
#define DLG_MESHNURBS_V           6253
#define DLG_MESHNURBS_V_S         6254

#define DLG_NURBSWEIGHTS          6270
#define DLG_NURBSWEIGHTS_VALUE    6271
#define DLG_NURBSWEIGHTS_SET      6272

#define DLG_NURBSSPLIT            6273
#define DLG_NURBSSPLIT_U          6274
#define DLG_NURBSSPLIT_V          6275

#define DLG_NURBSIKNOT            6276
#define DLG_NURBSIKNOT_U          6277
#define DLG_NURBSIKNOT_V          6278
#define DLG_NURBSIKNOT_VALUE      6279
#define DLG_NURBSIKNOT_CORNER     6280

#define DLG_SKTOOLBAR             6500
#define DLG_SKTOOLBAR_BUILD       6501
#define DLG_SKTOOLBAR_REPOSITION  6502
#define DLG_SKTOOLBAR_ROTATION    6503
#define DLG_SKTOOLBAR_REMOVE      6504
#define DLG_SKTOOLBAR_INSERT      6505
#define DLG_SKTOOLBAR_ATTACH      6506
#define DLG_SKTOOLBAR_SELECT      6507
#define DLG_SKTOOLBAR_APPLYMAP    6508









