/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file DSTRUCT.H     include with defines for external functions */

#ifdef __X__NT__
#define X__Malloc(s)    LocalAlloc(LMEM_FIXED,s)
#define X__Free(p)      LocalFree((HLOCAL)p)
#define X__Realloc(p,s) LocalReAlloc((HLOCAL)p,s,LMEM_MOVEABLE)
#else
#define X__Malloc(s)    GlobalAlloc(GMEM_FIXED,s)
#define X__Free(p)      GlobalFree((HGLOBAL)p)
#define X__Realloc(p,s) GlobalReAlloc((HGLOBAL)p,s,GMEM_MOVEABLE)
//#define X__Malloc(s)    malloc(s)
//#define X__Free(s)      free(s)
//#define X__Realloc(p,s) realloc(p,s)
#endif
#define  MainVp              (*(lpEVI->MainVp))
#define  MainEp              (*(lpEVI->MainEp))
#define  MainFp              (*(lpEVI->MainFp))
#define  MainSp              (*(lpEVI->MainSp))
#define  FirstSp             (*(lpEVI->FirstSp))
#define  MainNp              (*(lpEVI->MainNp))
#define  Nvert               (*(lpEVI->Nvert))
#define  NvertSelect         (*(lpEVI->NvertSelect))
#define  NvertDeselect       (*(lpEVI->NvertDeselect))
#define  NvertGlue           (*(lpEVI->NvertGlue))
#define  Nedge               (*(lpEVI->Nedge))
#define  Nface               (*(lpEVI->Nface))
#define  Nskel               (*(lpEVI->Nskel))
#define  nImaps              (*(lpEVI->nImaps))
#define  Nnurbs              (*(lpEVI->Nnurbs))
#define  nSha                (*(lpEVI->nSha))
#define  iMap                (lpEVI->iMap)
#define  iSha                (lpEVI->iSha)
#define  xShaders            (lpEVI->xShaders)
#define  NpointerX           (*(lpEVI->NpointerX))
#define  NpointerY           (*(lpEVI->NpointerY))
#define  NpointerZ           (*(lpEVI->NpointerZ))
#define  TVsizeX             (*(lpEVI->TVsizeX))
#define  TVsizeY             (*(lpEVI->TVsizeY))
#define  TVsizeZ             (*(lpEVI->TVsizeZ))
#define  TVpointX            (*(lpEVI->TVpointX))
#define  TVpointY            (*(lpEVI->TVpointY))
#define  TVpointZ            (*(lpEVI->TVpointZ))
#define  RulerScale          (*(lpEVI->ruler))
#define  ActiveView          (*(lpEVI->ActiveView))
#define  WireFrame           (lpEVI->w_frame)
#define  EraseAll(w)         (lpEVI->fpDA(w))
#define  CreateVertex()      (lpEVI->fpCV())
#define  CreateEdge(n,m)     (lpEVI->fpCE(n,m))
#define  CreateFace(l,m,n)   (lpEVI->fpCF(l,m,n))
#define  CreateSkeleton(s)   (lpEVI->fpCS(s))
#define  UpdateVertexHeap(n) (lpEVI->fpUVH(n))
#define  UpdateEdgeHeap(n)   (lpEVI->fpUEH(n))
#define  UpdateFaceHeap(n)   (lpEVI->fpUFH(n))
#define  UpdateCounters()    (lpEVI->fpTool_UP())
#define  DrawModel()         (lpEVI->fpTool_RD())
#define  AddCopy(n)          (lpEVI->fpTool_CP(n))
#define  AutoFacetCurveWithHoles(n,m,o,p,q) \
                             (lpEVI->fpTool_FC(n,m,o,p,q))
#define  CreateAttachedCopy(n) \
                             (lpEVI->fpTool_AC(n))
#define  ChooseColour(a,b,c) (lpEVI->fpChooseColour(a,b,c))
#define  ChooseFile(a,b,c,d,e,f) \
                             (lpEVI->fpChooseFile(a,b,c,d,e,f))
#define  CentreDlgOnC(a)     (lpEVI->fpCentreDlgOnC(a))
#define  CentreDlgOnS(a)     (lpEVI->fpCentreDlgOnS(a))

#define  CopyFaceProp(a,b)   (lpEVI->fpCopyFaceProp(a,b))
#define  ZeroSkeletonBoundingBox(a) \
                             (lpEVI->fpZeroSkeletonBoundingBox(a))
#define  GetSkeletonBoundBox(a,b) \
                             (lpEVI->fpGetSkeletonBoundBox(a,b))
#define  EraseVertex(a)      (lpEVI->fpEraseVertex(a))
#define  EraseVertexMapping() \
                             (lpEVI->fpEraseVertexMapping())
#define  EraseSkeleton(a)    (lpEVI->fpEraseSkeleton(a))
#define  get_closest_vertex() \
                             (lpEVI->fpGetClosestVertex())
#define  Connected(n,m)      (lpEVI->fpConnected(n,m))
#define  oNormalize(v)       (lpEVI->fpNormalize(v))
#define  ArbitraryRotate(a,p,q,m) \
                             (lpEVI->fpArbitraryRotate(a,p,q,m))
#define  OrientateFaceNormals(a,b,c)\
                             (lpEVI->fpOrientateFaceNormals(a,b,c))
#define  ReverseFaceOrientation(a,b)\
                             (lpEVI->fpReverseFaceOrientation(a,b))
#define  IsFOSame(a,b,c,d,e,f)\
                             (lpEVI->fpIsFOSame(a,b,c,d,e,f))
#define  OrientateSelectedFaces()\
                             (lpEVI->fpOrientateSelectedFaces())
#define  AppendFileExtension(a,b)\
                             (lpEVI->fpAppendFileExtension(a,b))
#define  EraseAllNurbs()     (lpEVI->fpEraseAllNurbs())
#define  EraseNurbs(a)       (lpEVI->fpEraseNurbs(a))
#define  CreateNurbs()       (lpEVI->fpCreateNurbs())
#define  ClearNurbsSkeleton(a) \
                             (lpEVI->fpClearNurbsSkeleton(a))
#define  AllocNurbs(a,b,c)   (lpEVI->fpAllocNurbs(a,b,c))
#define  CloneNurbs(a,b)     (lpEVI->fpCloneNurbs(a,b))
#define  ReleaseNurbs(a)     (lpEVI->fpReleaseNurbs(a))

static X__STRUCTURE *lpEVI;

