#  makefile for GLDESIGN.MAK

PROJ = GLDESIGN
RC = rc

!IF "$(CPU)" == "mips"
CC = cl -c -nologo  -DWIN32 -D__X__NT__=1
CFLAGS =
LIBS0 =
#LIBS0 = crtdll.lib
#CFLAGS = -align:0x1000 /INCREMENTAL:NO /PDB:NONE /NODEFAULTLIB /MACHINE:$(SYS)
SYS=MIPS

!ELSEIF "$(CPU)" == "alpha"
CC = cl -c -nologo  -DWIN32 -D__X__NT__=1
CFLAGS =
LIBS0 =
SYS=ALPHA
!ELSE
! ifdef cc
CC = cl -c -nologo -G5 -DWIN32 -D__X__NT__=1
LIBS0 = crtdll.lib
CFLAGS = -align:0x1000 /INCREMENTAL:NO /PDB:NONE /NODEFAULTLIB /MACHINE:$(SYS)
SYS=IX86
! elseifdef wc
CC = wcc386  -Zp8 -5s -j -fpi87 -s -oimr -bd -bt=nt $(NTX) $(DEMO)
LINK = wlink
RC = WRC
! else
CC = cl -c -nologo  -DWIN32 $(NTX)
CFLAGS =
LIBS0=
! endif
!ENDIF

LFLAGS = $(CFLAGS) /NOLOGO /SUBSYSTEM:windows
LIBS1 = $(LIBS0) kernel32.lib user32.lib gdi32.lib shell32.lib
LIBS2 = GLU32.LIB OPENGL32.LIB comdlg32.lib
INC = gldesign.h

C0=gldesign.obj gif.obj gldesign.res

! ifdef wc

gldesign.exe: $(C0)
       echo >NUL @<<$(PROJ).CRF
system nt_dll initinstance terminstance
export _AttachViewOpenGL.1
export _DetachViewOpenGL.2
file gldesign.obj
file gif.obj
name $(PROJ).exe
option CASEEXACT
option MAP
library opengl32.lib
library glu32.lib
<<
 $(LINK) @$(PROJ).CRF
 $(RC) -bt=nt gldesign.rc
 copy $(PROJ).exe ..\gldesign.dll
 del $(PROJ).exe

!else

gldesign.dll: $(C0)
       echo >NUL @<<$(PROJ).DEF
LIBRARY gldesign
EXPORTS
_AttachViewOpenGL @1
_DetachViewOpenGL @2
<<
       echo >NUL @<<$(PROJ).CRF
gldesign.obj
gif.obj
gldesign.res
$(LIBS1)
$(LIBS2)
-DEF:$(PROJ).DEF
-DLL
-OUT:..\gldesign.dll
<<
 link $(LFLAGS) @$(PROJ).CRF

! endif

gldesign.obj: gldesign.c $(INC)
  $(CC) gldesign.c

gif.obj: ..\animate\gif.c
  $(CC) ..\animate\gif.c

gldesign.res: gldesign.rc $(INC)
  $(RC) -r gldesign.rc
