/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file menuhelp.c */

// This file contains the table that maps the menu commands to their
// help strings, it contains the function that loads the table of data
// with the strings so that they are stored in RAM - this is probably
// not the best way to do it as reading from the resources file is very
// fast now - but in the old days Win 3.0 it was the best !!!!

#define MODULE_MENUHELP 1

#include "design.h"

typedef struct tagMENUHELPDATA{
  int iCode,sCode;
  char *str;
} MENUHELPDATA;

static MENUHELPDATA MenuHelpData[NMENUHELPDATA]={
  0xFFFF,                            0xFFFF,                            NULL,
  IDM_FILE_NEW,                      IDH_FILE_NEW,                      NULL,
  IDM_FILE_LOAD_MODEL,               IDH_FILE_LOAD_MODEL,               NULL,
  IDM_FILE_LOAD_ABSOLUTE,            IDH_FILE_LOAD_ABSOLUTE,            NULL,
  IDM_FILE_LOAD_RELATIVE,            IDH_FILE_LOAD_RELATIVE,            NULL,
  IDM_FILE_LOAD_PATH,                IDH_FILE_LOAD_PATH,                NULL,
  IDM_FILE_SAVE,                     IDH_FILE_SAVE,                     NULL,
  IDM_FILE_SAVE_ALL,                 IDH_FILE_SAVE_ALL,                 NULL,
  IDM_FILE_SAVE_OBJECT,              IDH_FILE_SAVE_OBJECT,              NULL,
  IDM_FILE_SAVE_NAMED,               IDH_FILE_SAVE_NAMED,               NULL,
  IDM_FILE_SAVE_LETTERS,             IDH_FILE_SAVE_LETTERS,             NULL,
  IDM_FILE_SAVE_PATH,                IDH_FILE_SAVE_PATH,                NULL,
  IDM_FILE_IMPORT_DXF,               IDH_FILE_IMPORT_DXF,               NULL,
  IDM_FILE_IMPORT_3DS,               IDH_FILE_IMPORT_3DS,               NULL,
  IDM_FILE_IMPORT_POLYGON,           IDH_FILE_IMPORT_POLYGON,           NULL,
  IDM_FILE_IMPORT_ATM,               IDH_FILE_IMPORT_ATM,               NULL,
  IDM_FILE_IMPORT_FONT,              IDH_FILE_IMPORT_FONT,              NULL,
  IDM_FILE_IMPORT_TDD,               IDH_FILE_IMPORT_TDD,               NULL,
  IDM_FILE_IMPORT_SCN,               IDH_FILE_IMPORT_SCN,               NULL,
  IDM_FILE_EXPORT_DXF,               IDH_FILE_EXPORT_DXF,               NULL,
  IDM_FILE_EXPORT_3DS,               IDH_FILE_EXPORT_3DS,               NULL,
  IDM_FILE_IMPORT_STL,               IDH_FILE_IMPORT_STL,               NULL,
  IDM_FILE_EXPORT_STL,               IDH_FILE_EXPORT_STL,               NULL,
  IDM_FILE_EXPORT_VRML,              IDH_FILE_EXPORT_VRML,              NULL,
  IDM_FILE_BOUNDINGBOX_AUTO,         IDH_FILE_BOUNDINGBOX_AUTO,         NULL,
  IDM_FILE_BOUNDINGBOX_CLEAR,        IDH_FILE_BOUNDINGBOX_CLEAR,        NULL,
  IDM_FILE_BOUNDINGBOX_MAKE,         IDH_FILE_BOUNDINGBOX_MAKE,         NULL,
  IDM_FILE_BOUNDINGBOX_UNMAKE,       IDH_FILE_BOUNDINGBOX_UNMAKE,       NULL,
  IDM_FILE_BOUNDINGBOX_TOSK,         IDH_FILE_BOUNDINGBOX_TOSK,         NULL,
  IDM_FILE_TRACEOUTLINE,             IDH_FILE_TRACEOUTLINE,             NULL,
  IDM_FILE_VIEWER,                   IDH_FILE_VIEWER,                   NULL,
  IDM_FILE_HEIGHT,                   IDH_FILE_HEIGHT,                   NULL,
  IDM_FILE_EXTERNAL,                 IDH_FILE_EXTERNAL,                 NULL,
  IDM_FILE_ANIMATOR,                 IDH_FILE_ANIMATOR,                 NULL,
  IDM_FILE_UPDATE_ANIMATOR,          IDH_FILE_UPDATEANIMATOR,           NULL,
  IDM_FILE_BEZIER,                   IDH_FILE_BEZIER,                   NULL,
  IDM_FILE_PRINT,                    IDH_FILE_PRINT,                    NULL,
  IDM_FILE_PREFERENCES,              IDH_FILE_PREFERENCES,              NULL,
  IDM_VIEW_RENDERNOW,                IDH_VIEW_RENDERNOW,                NULL,
  IDM_FILE_EXIT,                     IDH_FILE_EXIT,                     NULL,
  IDM_EDIT_UNDO,                     IDH_EDIT_UNDO,                     NULL,
  IDM_EDIT_ERASE_VERTICES,           IDH_EDIT_ERASE_VERTICES,           NULL,
  IDM_EDIT_ERASE_EDGES,              IDH_EDIT_ERASE_EDGES,              NULL,
  IDM_EDIT_ERASE_INDICATEDEDGE,      IDH_EDIT_ERASE_INDICATEDEDGE,      NULL,
  IDM_EDIT_ERASE_INDICATEDVERTEX,    IDH_EDIT_ERASE_INDICATEDVERTEX,    NULL,
  IDM_EDIT_ERASE_MAP,                IDH_EDIT_ERASE_MAP,                NULL,
  IDM_EDIT_ERASE_HIERARCHY,          IDH_EDIT_ERASE_HIERARCHY,          NULL,
  IDM_EDIT_ERASE_VERTEXMAPPING,      IDH_EDIT_ERASE_VERTEXMAPPING,      NULL,
  IDM_EDIT_ERASE_ALL,                IDH_EDIT_ERASE_ALL,                NULL,
  IDM_EDIT_SELECTALL,                IDH_EDIT_SELECTALL,                NULL,
  IDM_EDIT_DESELECTALL,              IDH_EDIT_DESELECTALL,              NULL,
  IDM_EDIT_SWAPSELECT,               IDH_EDIT_SWAPSELECT,               NULL,
  IDM_EDIT_SELECTCONNECT,            IDH_EDIT_SELECTCONNECT,            NULL,
  IDM_EDIT_DESELECTCONNECT,          IDH_EDIT_DESELECTCONNECT,          NULL,
  IDM_EDIT_SELECTMAPPED,             IDH_EDIT_SELECTMAPPED,             NULL,
  IDM_EDIT_DESELECTMAPPED,           IDH_EDIT_DESELECTMAPPED,           NULL,
  IDM_EDIT_SELECTBY_BEZIER,          IDH_EDIT_SELECTBY_BEZIER,          NULL,
  IDM_EDIT_SELECTBY_INVIEW,          IDH_EDIT_SELECTBY_INVIEW,          NULL,
  IDM_EDIT_SELECTBY_OUTVIEW,         IDH_EDIT_SELECTBY_OUTVIEW,         NULL,
  IDM_EDIT_SELECTBY_MAP,             IDH_EDIT_SELECTBY_MAP,             NULL,
  IDM_EDIT_SELECTBY_COLOUR,          IDH_EDIT_SELECTBY_COLOUR,          NULL,
  IDM_EDIT_SELECTBY_SHADER,          IDH_EDIT_SELECTBY_SHADER,          NULL,
  IDM_EDIT_DESELECT_EVERY,           IDH_EDIT_DESELECT_EVERY,           NULL,
  IDM_TOOLS_SELECTOR,                IDH_TOOLS_SELECTOR,                NULL,
  IDM_TOOLS_DESELECTOR,              IDH_TOOLS_DESELECTOR,              NULL,
  IDM_TOOLS_PLOTTER,                 IDH_TOOLS_PLOTTER,                 NULL,
  IDM_TOOLS_PLOT3D,                  IDH_TOOLS_PLOT3D,                  NULL,
  IDM_TOOLS_BUILDER,                 IDH_TOOLS_BUILDER,                 NULL,
  IDM_TOOLS_GRABBER,                 IDH_TOOLS_GRABBER,                 NULL,
  IDM_TOOLS_EXPANDER,                IDH_TOOLS_EXPANDER,                NULL,
  IDM_TOOLS_ROTATOR,                 IDH_TOOLS_ROTATOR,                 NULL,
  IDM_TOOLS_MAGNET_ATTRACT,          IDH_TOOLS_MAGNET_ATTRACT,          NULL,
  IDM_TOOLS_MAGNET_REPEL,            IDH_TOOLS_MAGNET_REPEL,            NULL,
  IDM_TOOLS_PRIMITIVES,              IDH_TOOLS_PRIMITIVES,              NULL,
  IDM_TOOLS_SHAPER,                  IDH_TOOLS_SHAPER,                  NULL,
  IDM_SNAP_CLOSEST,                  IDH_SNAP_CLOSEST,                  NULL,
  IDM_SNAP_CLOSESELECT,              IDH_SNAP_CLOSESELECT,              NULL,
  IDM_SNAP_MIDPOINT,                 IDH_SNAP_MIDPOINT,                 NULL,
  IDM_SNAP_MIDSELECT,                IDH_SNAP_MIDSELECT,                NULL,
  IDM_SNAP_CENTROID,                 IDH_SNAP_CENTROID,                 NULL,
  IDM_SNAP_HPLANE,                   IDH_SNAP_HPLANE,                   NULL,
  IDM_SNAP_VPLANERL,                 IDH_SNAP_VPLANERL,                 NULL,
  IDM_SNAP_VPLANEFB,                 IDH_SNAP_VPLANEFB,                 NULL,
  IDM_SNAP_STORE,                    IDH_SNAP_STORE,                    NULL,
  IDM_SNAP_TOSTORED,                 IDH_SNAP_TOSTORED,                 NULL,
  IDM_SNAP_TOCOORD,                  IDH_SNAP_TOCOORD,                  NULL,
  IDM_SNAP_INCREMENT,                IDH_SNAP_INCREMENT,                NULL,
  IDM_ACTIONS_ROTATE_CLOCKWISE,      IDH_ACTIONS_ROTATE_CLOCKWISE,      NULL,
  IDM_ACTIONS_ROTATE_ANTICLOCKWISE,  IDH_ACTIONS_ROTATE_ANTICLOCKWISE,  NULL,
  IDM_ACTIONS_WELD,                  IDH_ACTIONS_WELD,                  NULL,
  IDM_ACTIONS_FILL,                  IDH_ACTIONS_FILL,                  NULL,
  IDM_ACTIONS_FACET,                 IDH_ACTIONS_FACET,                 NULL,
  IDM_ACTIONS_SPIN,                  IDH_ACTIONS_SPIN,                  NULL,
  IDM_ACTIONS_EXPAND,                IDH_ACTIONS_EXPAND,                NULL,
  IDM_ACTIONS_EFFECTS_PLAN,          IDH_ACTIONS_EFFECTS_PLAN,          NULL,
  IDM_ACTIONS_EFFECTS_EXPLODE,       IDH_ACTIONS_EFFECTS_EXPLODE,       NULL,
  IDM_ACTIONS_EFFECTS_SHATTER,       IDH_ACTIONS_EFFECTS_SHATTER,       NULL,
  IDM_ACTIONS_EFFECTS_FULLINTERSECT, IDH_ACTIONS_EFFECTS_FULLINTERSECT, NULL,
  IDM_ACTIONS_EFFECTS_PARTINTERSECT, IDH_ACTIONS_EFFECTS_PARTINTERSECT, NULL,
  IDM_TOOLS_EXTRUDE,                 IDH_TOOLS_EXTRUDE,                 NULL,
  IDM_ACTIONS_EXTRUDE_ALONG,         IDH_ACTIONS_EXTRUDE_ALONG,         NULL,
  IDM_ACTIONS_EXTRUDE_BEVEL,         IDH_ACTIONS_EXTRUDE_BEVEL,         NULL,
  IDM_ACTIONS_EXTRUDE_ROUND,         IDH_ACTIONS_EXTRUDE_ROUND,         NULL,
  IDM_ACTIONS_DUPLICATE_MAKE,        IDH_ACTIONS_DUPLICATE_MAKE,        NULL,
  IDM_ACTIONS_DUPLICATE_CONNECT,     IDH_ACTIONS_DUPLICATE_CONNECT,     NULL,
  IDM_ACTIONS_DUPLICATE_MULTI,       IDH_ACTIONS_DUPLICATE_MULTI,       NULL,
  IDM_ACTIONS_SUBDIVIDE,             IDH_ACTIONS_SUBDIVIDE,             NULL,
  IDM_ACTIONS_SMOOTH,                IDH_ACTIONS_SMOOTH,                NULL,
  IDM_ACTIONS_FLIP,                  IDH_ACTIONS_FLIP,                  NULL,
  IDM_ACTIONS_JOIN,                  IDH_ACTIONS_JOIN,                  NULL,
  IDM_ACTIONS_BEZIER,                IDH_ACTIONS_BEZIER,                NULL,
  IDM_ACTIONS_BOOLEAN,               IDH_ACTIONS_BOOLEAN,               NULL,
  IDM_ACTIONS_TWIST,                 IDH_ACTIONS_TWIST,                 NULL,
  IDM_ACTIONS_ORIENTATE,             IDH_ACTIONS_ORIENTATE,             NULL,
  IDM_ACTIONS_REVERSE,               IDH_ACTIONS_REVERSE,               NULL,
  IDM_ACTIONS_JOINS,                 IDH_ACTIONS_JOINS,                 NULL,
  IDM_TOOLS_ADDVERTEX,               IDH_TOOLS_ADDVERTEX,               NULL,
  IDM_TOOLS_BUILDFACET,              IDH_TOOLS_BUILDFACET,              NULL,
  IDM_ACTIONS_SPECIAL_3DPLOT,        IDH_ACTIONS_SPECIAL_3DPLOT,        NULL,
  IDM_ACTIONS_SPECIAL_HELIX,         IDH_ACTIONS_SPECIAL_HELIX,         NULL,
  IDM_ACTIONS_SPECIAL_SPIRAL,        IDH_ACTIONS_SPECIAL_SPIRAL,        NULL,
  IDM_ACTIONS_SPECIAL_3DSPIRAL,      IDH_ACTIONS_SPECIAL_3DSPIRAL,      NULL,
  IDM_ACTIONS_SPECIAL_LINE,          IDH_ACTIONS_SPECIAL_LINE,          NULL,
  IDM_ACTIONS_SPECIAL_BUTTERFLY,     IDH_ACTIONS_SPECIAL_BUTTERFLY,     NULL,
  IDM_ACTIONS_BUILD,                 IDH_ACTIONS_BUILD,                 NULL,
  IDM_ACTIONS_MOVE,                  IDH_ACTIONS_MOVE,                  NULL,
  IDM_ATTRIBUTES_FACE,               IDH_ATTRIBUTES_FACE,               NULL,
  IDM_ATTRIBUTES_DEFAULT,            IDH_ATTRIBUTES_DEFAULT,            NULL,
  IDM_ATTRIBUTES_MAP,                IDH_ATTRIBUTES_MAP,                NULL,
  IDM_ATTRIBUTES_NEWMAP,             IDH_ATTRIBUTES_NEWMAP,             NULL,
  IDM_ATTRIBUTES_PURGE,              IDH_ATTRIBUTES_PURGE,              NULL,
  IDM_ATTRIBUTES_VECTOR,             IDH_ATTRIBUTES_VECTOR,             NULL,
  IDM_ATTRIBUTES_MAPAXES,            IDH_ATTRIBUTES_MAPAXES,            NULL,
  IDM_ATTRIBUTES_SHADER_MOVE,        IDH_ATTRIBUTES_SHADER_MOVE,        NULL,
  IDM_ATTRIBUTES_SHADER_NEW,         IDH_ATTRIBUTES_SHADER_NEW,         NULL,
  IDM_ATTRIBUTES_SHADER_DELETE,      IDH_ATTRIBUTES_SHADER_DELETE,      NULL,
  IDM_ATTRIBUTES_EXTERNALSHADER,     IDH_ATTRIBUTES_EXTERNALSHADER,     NULL,
  IDM_ATTRIBUTES_SHADER_PREVIEW,     IDH_ATTRIBUTES_SHADER_PREVIEW,     NULL,
  IDM_ATTRIBUTES_SHADER_PURGE,       IDH_ATTRIBUTES_SHADER_PURGE,       NULL,
  IDM_ATTRIBUTES_CENTREPOINT,        IDH_ATTRIBUTES_CENTREPOINT,        NULL,
  IDM_ATTRIBUTES_FOLLOWPOINT,        IDH_ATTRIBUTES_FOLLOWPOINT,        NULL,
  IDM_ATTRIBUTES_SHADOW,             IDH_ATTRIBUTES_SHADOW,             NULL,
  IDM_ATTRIBUTES_MAPFROMMAP,         IDH_ATTRIBUTES_MAPFROMMAP,         NULL,
  IDM_ATTRIBUTES_MAPONPATH,          IDH_ATTRIBUTES_MAPONPATH,          NULL,
  IDM_ATTRIBUTES_SETVERTEXMAPPING,   IDH_ATTRIBUTES_SETVERTEXMAPPING,   NULL,
  IDM_ATTRIBUTES_MIRROR,             IDH_ATTRIBUTES_MIRROR,             NULL,
  IDM_ATTRIBUTES_REFINDEX,           IDH_ATTRIBUTES_REFINDEX,           NULL,
  IDM_HIERARCHY_NAME,                IDH_HIERARCHY_NAME,                NULL,
  IDM_HIERARCHY_POSE,                IDH_HIERARCHY_POSE,                NULL,
  IDM_HIERARCHY_BUILD,               IDH_HIERARCHY_BUILD,               NULL,
  IDM_HIERARCHY_STRETCH,             IDH_HIERARCHY_STRETCH,             NULL,
  IDM_HIERARCHY_TWIST,               IDH_HIERARCHY_TWIST,               NULL,
  IDM_HIERARCHY_REMOVE,              IDH_HIERARCHY_REMOVE,              NULL,
  IDM_HIERARCHY_INSERT,              IDH_HIERARCHY_INSERT,              NULL,
  IDM_HIERARCHY_ATTACH,              IDH_HIERARCHY_ATTACH,              NULL,
  IDM_HIERARCHY_SELECT,              IDH_HIERARCHY_SELECT,              NULL,
  IDM_HIERARCHY_MAP,                 IDH_HIERARCHY_MAP,                 NULL,
  IDM_VIEW_HIDE,                     IDH_VIEW_HIDE,                     NULL,
  IDM_VIEW_REVEAL,                   IDH_VIEW_REVEAL,                   NULL,
  IDM_VIEW_DRAWING_HIDEEDGES,        IDH_VIEW_DRAWING_HIDEEDGES,        NULL,
  IDM_VIEW_DRAWING_HIDEJOINS,        IDH_VIEW_DRAWING_HIDEJOINS,        NULL,
  IDM_VIEW_RENDER,                   IDH_VIEW_RENDER,                   NULL,
  IDM_VIEW_SHOW,                     IDH_VIEW_SHOW,                     NULL,
  IDM_VIEW_WIREFRAME,                IDH_VIEW_WIREFRAME,                NULL,
  IDM_VIEW_HIDDENLINE,               IDH_VIEW_HIDDENLINE,               NULL,
  IDM_VIEW_GRID,                     IDH_VIEW_GRID,                     NULL,
  IDM_VIEW_DRAW_GRID,                IDH_VIEW_DRAW_GRID,                NULL,
  IDM_VIEW_DEFINEGRID,               IDH_VIEW_DEFINEGRID,               NULL,
  IDM_ZOOM_IN,                       IDH_ZOOM_IN,                       NULL,
  IDM_ZOOM_OUT,                      IDH_ZOOM_OUT,                      NULL,
  IDM_ZOOM_CENTRE,                   IDH_ZOOM_CENTRE,                   NULL,
  IDM_VIEW_RESTORE,                  IDH_VIEW_RESTORE,                  NULL,
  IDM_VIEW_FULL,                     IDH_VIEW_FULL,                     NULL,
  IDM_VIEW_SCREENCOLOURS,            IDH_VIEW_SCREENCOLOURS,            NULL,
  IDM_VIEW_FEEDBACK_CURSOR,          IDH_VIEW_FEEDBACK_CURSOR,          NULL,
  IDM_WINDOW_SWITCHWINDOWS,          IDH_WINDOW_SWITCHWINDOWS,          NULL,
  IDM_VIEW_SWAPVIEWPOINT,            IDH_VIEW_SWAPVIEWPOINT,            NULL,
  IDM_WINDOW_RESET,                  IDH_WINDOW_RESET,                  NULL,
  IDM_WINDOW_TOOLLEFT,               IDH_WINDOW_TOOLLEFT,               NULL,
  IDM_WINDOW_COORDS,                 IDH_WINDOW_COORDS,                 NULL,
  IDM_WINDOW_DATA,                   IDH_WINDOW_DATA,                   NULL,
  IDM_WINDOW_UNDOACTIVE,             IDH_WINDOW_UNDOACTIVE,             NULL,
  IDM_WINDOW_COORD_DEF,              IDH_WINDOW_COORD_DEF,              NULL,
  IDM_WINDOW_COORD_LAST,             IDH_WINDOW_COORD_LAST,             NULL,
  IDM_WINDOW_SELECT,                 IDH_WINDOW_SELECT,                 NULL,
  IDM_WINDOW_HIDETOOLS,              IDH_WINDOW_HIDETOOLS,              NULL,
  IDM_WINDOW_SHOWOPENGL,             IDH_WINDOW_SHOWOPENGL,             NULL,
  IDM_WINDOW_VIEWOPENGL,             IDH_WINDOW_VIEWOPENGL,             NULL,
  IDM_WINDOW_QUICKRENDER,            IDH_WINDOW_QUICKRENDER,            NULL,
  IDM_STOP,                          IDH_STOP,                          NULL,
  IDM_NURBS_CREATE,                  IDH_NURBS_CREATE,                  NULL,
  IDM_NURBS_DELETE,                  IDH_NURBS_DELETE,                  NULL,
  IDM_NURBS_EDIT,                    IDH_NURBS_EDIT,                    NULL,
  IDM_NURBS_SPLIT,                   IDH_NURBS_SPLIT,                   NULL,
  IDM_NURBS_SETWEIGHTS,              IDH_NURBS_SETWEIGHTS,              NULL,
  IDM_NURBS_TRIANGULATE1,            IDH_NURBS_TRIANGULATE1,            NULL,
  IDM_NURBS_TRIANGULATE2,            IDH_NURBS_TRIANGULATE2,            NULL,
  IDM_NURBS_SELECT,                  IDH_NURBS_SELECT,                  NULL,
  IDM_NURBS_DESELECT,                IDH_NURBS_DESELECT,                NULL,
  IDM_NURBS_SWAP,                    IDH_NURBS_SWAP,                    NULL,
  IDM_NURBS_HIDE,                    IDH_NURBS_HIDE,                    NULL,
  IDM_NURBS_REVEAL,                  IDH_NURBS_REVEAL,                  NULL,
  IDM_NURBS_PRIM1,                   IDH_NURBS_PRIM1,                   NULL,
  IDM_NURBS_PRIM2,                   IDH_NURBS_PRIM2,                   NULL,
  IDM_NURBS_PRIM3,                   IDH_NURBS_PRIM3,                   NULL,
  IDM_NURBS_PRIM4,                   IDH_NURBS_PRIM4,                   NULL,
  IDM_HELP,                          IDH_HELP_H,                        NULL,
  IDM_HELP_HOME,                     IDH_HELP_HOME,                     NULL,
  IDM_HELP_SUPPORT,                  IDH_HELP_SUPPORT,                  NULL,
  IDM_HELP_GENERAL,                  IDH_HELP_GENERAL,                  NULL,
  IDM_HELP_HELP,                     IDH_HELP_HELP,                     NULL,
  IDM_HELP_ABOUT,                    IDH_HELP_ABOUT,                    NULL
};

void LoadMenuHelpTable(HWND hwnd){
 char *p;
 int i,cch;
 MenuHelpData[0].str=(char *)X__Malloc(32);
 strcpy(MenuHelpData[0].str,"      ");
 for(i=1;i<NMENUHELPDATA;i++){
   if((p = (char *)X__Malloc(CCHTEXTMAX)) == NULL)return;
   if((cch = LoadString(ghinst_main,MenuHelpData[i].sCode,p,CCHTEXTMAX)) == 0){
     X__Free(p);
     return;
   }
   p = (char *)X__Realloc(p,cch+1);
   if(p == NULL)return;
   MenuHelpData[i].str=p;
 }
}



UINT CheckMenuHelpData(UINT uItem){
 UINT i,id=0;       
 for(i=0;i<NMENUHELPDATA;i++){
   if(uItem == MenuHelpData[i].iCode){id=i; break;}
 }
 return id;
}

void DisplayMenuHelpData(HWND hwnd,UINT id){
 SendMessage(hwnd,SB_SETTEXT,(WPARAM)0,
             (LPARAM)MenuHelpData[id].str);
 return;
}

void FreeMenuHelpData(void){
 long i;
 for(i=0;i<NMENUHELPDATA;i++)
   if(MenuHelpData[i].str != NULL)X__Free(MenuHelpData[i].str);
 return;
}
