/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file mmenuid.h   included in design */

#define MODELER_MENU                        10
#define MODELER_ACCEL                       11

#define IDC_COORD_UPDATE                   102      /* internal commands */

#define IDM_FILE_NEW                     10010
#define IDM_FILE_LOAD_MODEL              10011
#define IDM_FILE_LOAD_ABSOLUTE           10012
#define IDM_FILE_LOAD_RELATIVE           10013
#define IDM_FILE_LOAD_PATH               10014
#define IDM_FILE_LOAD_DIRECT             10015
#define IDM_FILE_SAVE                    10020
#define IDM_FILE_SAVE_ALL                10021
#define IDM_FILE_SAVE_OBJECT             10022
#define IDM_FILE_SAVE_NAMED              10023
#define IDM_FILE_SAVE_LETTERS            10024
#define IDM_FILE_SAVE_PATH               10025
#define IDM_FILE_IMPORT_DXF              10031
#define IDM_FILE_IMPORT_3DS              10032
#define IDM_FILE_IMPORT_POLYGON          10033
#define IDM_FILE_IMPORT_ATM              10034
#define IDM_FILE_IMPORT_FONT             10035
#define IDM_FILE_IMPORT_TDD              10036
#define IDM_FILE_IMPORT_SCN              10037
#define IDM_FILE_IMPORT_STL              10038

#define IDM_FILE_EXPORT_DXF              10041
#define IDM_FILE_EXPORT_3DS              10042
#define IDM_FILE_EXPORT_STL              10043
#define IDM_FILE_EXPORT_VRML             10044

#define IDM_FILE_BOUNDINGBOX_MAKE        10051
#define IDM_FILE_BOUNDINGBOX_UNMAKE      10052
#define IDM_FILE_BOUNDINGBOX_CLEAR       10053
#define IDM_FILE_BOUNDINGBOX_AUTO        10054
#define IDM_FILE_BOUNDINGBOX_TOSK        10055
#define IDM_FILE_TRACEOUTLINE            10060
#define IDM_FILE_VIEWER                  10070
#define IDM_FILE_HEIGHT                  10080
#define IDM_FILE_EXTERNAL                10090
#define IDM_FILE_ANIMATOR                10100
#define IDM_FILE_UPDATE_ANIMATOR         10110
#define IDM_FILE_BEZIER                  10120
#define IDM_FILE_PRINT                   10130
#define IDM_FILE_PREFERENCES             10140
#define IDM_VIEW_RENDERNOW               10150
#define IDM_VIEW_RENDERINWINDOW          10151
#define IDM_FILE_EXIT                    10160

#define IDM_EDIT_UNDO                    11000
#define IDM_EDIT_ERASE_VERTICES          11021
#define IDM_EDIT_ERASE_EDGES             11022
#define IDM_EDIT_ERASE_INDICATEDEDGE     11023
#define IDM_EDIT_ERASE_INDICATEDVERTEX   11024
#define IDM_EDIT_ERASE_MAP               11025
#define IDM_EDIT_ERASE_HIERARCHY         11026
#define IDM_EDIT_ERASE_VERTEXMAPPING     11027
#define IDM_EDIT_ERASE_ALL               11028
#define IDM_EDIT_SELECTALL               11030
#define IDM_EDIT_DESELECTALL             11040
#define IDM_EDIT_SWAPSELECT              11050
#define IDM_EDIT_SELECTCONNECT           11060
#define IDM_EDIT_DESELECTCONNECT         11070
#define IDM_EDIT_SELECTBY_BEZIER         11081
#define IDM_EDIT_SELECTBY_INVIEW         11082
#define IDM_EDIT_SELECTBY_OUTVIEW        11083
#define IDM_EDIT_SELECTBY_MAP            11084
#define IDM_EDIT_SELECTBY_COLOUR         11085
#define IDM_EDIT_SELECTBY_SHADER         11086
#define IDM_EDIT_SELECTMAPPED            11090
#define IDM_EDIT_DESELECTMAPPED          11100
#define IDM_EDIT_DESELECT_EVERY          11110

#define IDM_TOOLS_SELECTOR               12010
#define IDM_TOOLS_DESELECTOR             12020
#define IDM_TOOLS_PLOTTER                12030
#define IDM_TOOLS_PLOT3D                 12040
#define IDM_TOOLS_BUILDER                12050
#define IDM_TOOLS_GRABBER                12060
#define IDM_TOOLS_EXPANDER               12070
#define IDM_TOOLS_ROTATOR                12080
#define IDM_TOOLS_MAGNET_ATTRACT         12091
#define IDM_TOOLS_MAGNET_REPEL           12092
#define IDM_TOOLS_PRIMITIVES             12100
#define IDM_TOOLS_EXTRUDE                12110
#define IDM_TOOLS_SHAPER                 12120
#define IDM_TOOLS_BUILDFACET             12130
#define IDM_TOOLS_ADDVERTEX              12140
#define IDM_TOOLS_PAN                    12150
#define IDM_TOOLS_ZOOMIN                 12160
#define IDM_TOOLS_NODE                   12170

#define IDM_ACTIONS_ROTATE_CLOCKWISE     13010
#define IDM_ACTIONS_ROTATE_ANTICLOCKWISE 13020
#define IDM_ACTIONS_WELD                 13030
#define IDM_ACTIONS_FILL                 13040
#define IDM_ACTIONS_FACET                13050
#define IDM_ACTIONS_SPIN                 13060
#define IDM_ACTIONS_EXPAND               13070
#define IDM_ACTIONS_EFFECTS_PLAN         13081
#define IDM_ACTIONS_EFFECTS_EXPLODE      13082
#define IDM_ACTIONS_EFFECTS_SHATTER      13083
#define IDM_ACTIONS_EFFECTS_FULLINTERSECT 13084
#define IDM_ACTIONS_EFFECTS_PARTINTERSECT 13085
#define IDM_ACTIONS_EXTRUDE_ALONG        13091
#define IDM_ACTIONS_EXTRUDE_BEVEL        13092
#define IDM_ACTIONS_EXTRUDE_ROUND        13093
#define IDM_ACTIONS_DUPLICATE_MAKE       13101
#define IDM_ACTIONS_DUPLICATE_CONNECT    13102
#define IDM_ACTIONS_DUPLICATE_MULTI      13103
#define IDM_ACTIONS_SUBDIVIDE            13110
#define IDM_ACTIONS_SMOOTH               13120
#define IDM_ACTIONS_FLIP                 13130
#define IDM_ACTIONS_JOIN                 13140
#define IDM_ACTIONS_BEZIER               13150
#define IDM_ACTIONS_SPECIAL              13160
#define IDM_ACTIONS_SPECIAL_3DPLOT       13161
#define IDM_ACTIONS_SPECIAL_HELIX        13162
#define IDM_ACTIONS_SPECIAL_SPIRAL       13163
#define IDM_ACTIONS_SPECIAL_3DSPIRAL     13164
#define IDM_ACTIONS_SPECIAL_LINE         13165
#define IDM_ACTIONS_SPECIAL_BUTTERFLY    13166
#define IDM_ACTIONS_BUILD                13200
#define IDM_ACTIONS_MOVE                 13201
#define IDM_ACTIONS_BOOLEAN              13210
#define IDM_ACTIONS_TWIST                13212
#define IDM_ACTIONS_ORIENTATE            13213
#define IDM_ACTIONS_REVERSE              13214
#define IDM_ACTIONS_JOINS                13215

#define IDM_ATTRIBUTES_FACE              14010
#define IDM_ATTRIBUTES_DEFAULT           14020
#define IDM_ATTRIBUTES_MAP               14030
#define IDM_ATTRIBUTES_PURGE             14031
#define IDM_ATTRIBUTES_VECTOR            14032
#define IDM_ATTRIBUTES_NEWMAP            14033
#define IDM_ATTRIBUTES_MAPAXES           14040
#define IDM_ATTRIBUTES_SHADER_MOVE       14051
#define IDM_ATTRIBUTES_SHADER_NEW        14052
#define IDM_ATTRIBUTES_SHADER_DELETE     14053
#define IDM_ATTRIBUTES_SHADER_PREVIEW    14054
#define IDM_ATTRIBUTES_SHADER_PURGE      14055
#define IDM_ATTRIBUTES_CENTREPOINT       14060
#define IDM_ATTRIBUTES_FOLLOWPOINT       14070
#define IDM_ATTRIBUTES_SHADOW            14080
#define IDM_ATTRIBUTES_MAPFROMMAP        14090
#define IDM_ATTRIBUTES_MAPONPATH         14100
#define IDM_ATTRIBUTES_SETVERTEXMAPPING  14110
#define IDM_ATTRIBUTES_EXTERNALSHADER    14120
#define IDM_ATTRIBUTES_MIRROR            14130
#define IDM_ATTRIBUTES_REFINDEX          14140

#define IDM_HIERARCHY_SELECT             15010
#define IDM_HIERARCHY_NAME               15020
#define IDM_HIERARCHY_POSE               15030
#define IDM_HIERARCHY_STRETCH            15040
#define IDM_HIERARCHY_BUILD              15050
#define IDM_HIERARCHY_REMOVE             15060
#define IDM_HIERARCHY_INSERT             15070
#define IDM_HIERARCHY_ATTACH             15080
#define IDM_HIERARCHY_MAP                15090
#define IDM_HIERARCHY_TWIST              15100

#define IDM_VIEW_HIDE                    16010
#define IDM_VIEW_REVEAL                  16020
#define IDM_VIEW_DRAWING_HIDEEDGES       16031
#define IDM_VIEW_DRAWING_HIDEJOINS       16032
#define IDM_VIEW_RENDER                  16040
#define IDM_VIEW_SHOW                    16050
#define IDM_VIEW_WIREFRAME               16060
#define IDM_VIEW_HIDDENLINE              16070
#define IDM_VIEW_GRID                    16080
#define IDM_VIEW_DRAW_GRID               16090
#define IDM_VIEW_DEFINEGRID              16100
#define IDM_VIEW_RESTORE                 16110
#define IDM_VIEW_FULL                    16120
#define IDM_VIEW_SCREENCOLOURS           16130
#define IDM_VIEW_FEEDBACK_CURSOR         16140

#define IDM_WINDOW_COORDS                17010
#define IDM_WINDOW_COORD_DEF             17021
#define IDM_WINDOW_COORD_LAST            17022
#define IDM_WINDOW_SWITCHWINDOWS         17030
#define IDM_VIEW_SWAPVIEWPOINT           17040
#define IDM_WINDOW_SWITCHWINDOW0         17050
#define IDM_WINDOW_SWITCHWINDOW1         17060
#define IDM_WINDOW_DATA                  17070
#define IDM_WINDOW_UNDOACTIVE            17080
#define IDM_WINDOW_ACTIVATE              17090
#define IDM_WINDOW_SHOWALL               17100
#define IDM_WINDOW_SELECT                17110
#define IDM_WINDOW_HIDETOOLS             17120
#define IDM_WINDOW_SHOWOPENGL            17130  // MUST MATCH IN GLVIEW (cmd)
#define IDM_WINDOW_VIEWOPENGL            17131
#define IDM_WINDOW_TOOLLEFT              17140
#define IDM_WINDOW_RESET                 17150
#define IDM_WINDOW_QUICKRENDER           17160

#define IDM_SNAP_CLOSEST                 18000
#define IDM_SNAP_CLOSESELECT             18001
#define IDM_SNAP_MIDPOINT                18002
#define IDM_SNAP_MIDSELECT               18003
#define IDM_SNAP_CENTROID                18004
#define IDM_SNAP_HPLANE                  18005
#define IDM_SNAP_VPLANERL                18006
#define IDM_SNAP_VPLANEFB                18007
#define IDM_SNAP_STORE                   18008
#define IDM_SNAP_TOSTORED                18009
#define IDM_SNAP_TOCOORD                 18010
#define IDM_SNAP_INCREMENT               18011

#define IDM_STOP                         19000

#define IDM_HELP                         19001
#define IDM_HELP_HELP                    19002
#define IDM_HELP_GENERAL                 19003
#define IDM_HELP_ABOUT                   19004
#define IDM_HELP_HOME                    19005
#define IDM_HELP_SUPPORT                 19006

#define IDM_ZOOM_IN                      20021
#define IDM_ZOOM_OUT                     20022
#define IDM_ZOOM_CENTRE                  20023
#define IDM_ZOOM_WORLD                   20024
#define IDM_PAN_UP                       20025
#define IDM_PAN_DOWN                     20026
#define IDM_PAN_LEFT                     20027
#define IDM_PAN_RIGHT                    20028
#define IDM_PAN_UP1                      20029
#define IDM_PAN_DOWN1                    20030
#define IDM_PAN_LEFT1                    20031
#define IDM_PAN_RIGHT1                   20032
#define IDM_COORDS_DEFINE                20037
#define IDM_COORDS_ORIGIN                20038
#define IDM_COORDS_RELATIVE              20039
#define IDM_COORDS_MEASURE               20040
#define IDM_LOCK_SQUARE                  20041
#define IDM_LOCK_CIRCLE                  20042
#define IDM_LOCK_TRIANGLE                20043
#define IDM_LOCK_LOCK                    20044

#define IDM_KEY_DELETE                   20050

#define IDM_PRIMITIVE_QADD               20100
#define IDM_PRIMITIVE_QADD_1             20101
#define IDM_PRIMITIVE_QADD_2             20102
#define IDM_PRIMITIVE_QADD_3             20103
#define IDM_PRIMITIVE_QADD_4             20104
#define IDM_PRIMITIVE_QADD_5             20105
#define IDM_PRIMITIVE_QADD_6             20106
#define IDM_PRIMITIVE_QADD_7             20107
#define IDM_PRIMITIVE_QADD_8             20108
#define IDM_PRIMITIVE_QADD_9             20109

#define IDM_CONTEXT_TOOLSLEFT            20200
#define IDM_CONTEXT_TOOLSSMALL           20201

#define IDM_NURBS_CREATE                 21010
#define IDM_NURBS_DELETE                 21020
#define IDM_NURBS_EDIT                   21030
#define IDM_NURBS_TRIANGULATE1           21040
#define IDM_NURBS_TRIANGULATE2           21050
#define IDM_NURBS_SELECT                 21060
#define IDM_NURBS_DESELECT               21070
#define IDM_NURBS_SWAP                   21080
#define IDM_NURBS_SETWEIGHTS             21090
#define IDM_NURBS_HIDE                   21100
#define IDM_NURBS_REVEAL                 21110
#define IDM_NURBS_SPLIT                  21120
#define IDM_NURBS_PRIM1                  21130
#define IDM_NURBS_PRIM2                  21140
#define IDM_NURBS_PRIM3                  21150
#define IDM_NURBS_PRIM4                  21160

#define IDBM_TESTUP      2500
#define IDBM_TESTDN      2501

#define IDBM_ZOOMIUP     2502
#define IDBM_ZOOMIDN     2503
#define IDBM_ZOOMOUP     2504
#define IDBM_ZOOMODN     2505
#define IDBM_ZOOMCU      2506
#define IDBM_ZOOMCD      2507
#define IDBM_ZOOMWU      2508
#define IDBM_ZOOMWD      2509

#define IDBM_C_H_U       2510
#define IDBM_C_H_D       2511
#define IDBM_C_C_U       2512
#define IDBM_C_C_D       2513
#define IDBM_C_R_U       2514
#define IDBM_C_R_D       2515
#define IDBM_C_S_U       2516
#define IDBM_C_S_D       2517
#define IDBM_C_CC_U      2518
#define IDBM_C_CC_D      2519
#define IDBM_C_TX_U      2520
#define IDBM_C_TX_D      2521
#define IDBM_C_AT_U      2522
#define IDBM_C_AT_D      2523
#define IDBM_C_UD_U      2524
#define IDBM_C_UD_D      2526

#define IDBM_S_SR_U      2527
#define IDBM_S_SR_D      2528
#define IDBM_S_DR_U      2529
#define IDBM_S_DR_D      2530
#define IDBM_S_SA_U      2531
#define IDBM_S_SA_D      2532
#define IDBM_S_DA_U      2533
#define IDBM_S_DA_D      2534
#define IDBM_S_SW_U      2535
#define IDBM_S_SW_D      2536
#define IDBM_S_SC_U      2537
#define IDBM_S_SC_D      2538
#define IDBM_S_HS_U      2539
#define IDBM_S_HS_D      2540
#define IDBM_S_RH_U      2541
#define IDBM_S_RH_D      2542

#define IDBM_T_PT_U      2543
#define IDBM_T_PT_D      2544
#define IDBM_T_P3_U      2545
#define IDBM_T_P3_D      2546
#define IDBM_T_BU_U      2547
#define IDBM_T_BU_D      2548
#define IDBM_T_GB_U      2549
#define IDBM_T_GB_D      2550
#define IDBM_T_EX_U      2551
#define IDBM_T_EX_D      2552
#define IDBM_T_RT_U      2553
#define IDBM_T_RT_D      2554
#define IDBM_T_MA_U      2555
#define IDBM_T_MA_D      2556
#define IDBM_T_MR_U      2557
#define IDBM_T_MR_D      2558
#define IDBM_T_PR_U      2559
#define IDBM_T_PR_D      2560
#define IDBM_T_XT_U      2561
#define IDBM_T_XT_D      2562
#define IDBM_T_SH_U      2563
#define IDBM_T_SH_D      2564
#define IDBM_T_PO_U      2565
#define IDBM_T_PO_D      2566

#define IDBM_A_RA_U      2567
#define IDBM_A_RA_D      2568
#define IDBM_A_RC_U      2569
#define IDBM_A_RC_D      2570
#define IDBM_A_BZ_U      2571
#define IDBM_A_BZ_D      2572
#define IDBM_A_JN_U      2573
#define IDBM_A_JN_D      2574
#define IDBM_A_CP_U      2575
#define IDBM_A_CP_D      2576
#define IDBM_A_CC_U      2577
#define IDBM_A_CC_D      2578
#define IDBM_A_FT_U      2579
#define IDBM_A_FT_D      2580
#define IDBM_A_FO_U      2581
#define IDBM_A_FO_D      2582
#define IDBM_A_WD_U      2583
#define IDBM_A_WD_D      2584
#define IDBM_A_XL_U      2585
#define IDBM_A_XL_D      2586
#define IDBM_A_SP_U      2587
#define IDBM_A_SP_D      2588
#define IDBM_A_MS_U      2589
#define IDBM_A_MS_D      2590
#define IDBM_A_MM_U      2591
#define IDBM_A_MM_D      2592
#define IDBM_A_EX_U      2593
#define IDBM_A_EX_D      2594
#define IDBM_A_AF_U      2595
#define IDBM_A_AF_D      2596
#define IDBM_A_AV_U      2597
#define IDBM_A_AV_D      2598

#define IDBM_ARROW_Zp    2599
#define IDBM_ARROW_Zm    2600
#define IDBM_ARROW_Xp    2601
#define IDBM_ARROW_Xm    2602
#define IDBM_ARROW_Yp    2607
#define IDBM_ARROW_Ym    2608

#define IDBM_CO1         2603
#define IDBM_CO2         2604
#define IDBM_CO3         2605
#define IDBM_CO4         2606

#define IDBM_WIN_T       2611
#define IDBM_WIN_S       2612
#define IDBM_WIN_R       2613
#define IDBM_WIN_F       2614

#define IDBM_L_SQ_U      2615
#define IDBM_L_SQ_D      2616
#define IDBM_L_CI_U      2617
#define IDBM_L_CI_D      2618
#define IDBM_L_TR_U      2619
#define IDBM_L_TR_D      2620
#define IDBM_L_LK_U      2621
#define IDBM_L_ND_U      2637
#define IDBM_L_ND_D      2638
#define IDBM_L_LK_D      2622

#define IDBM_WIN_Th      2623
#define IDBM_WIN_Sh      2624
#define IDBM_WIN_Rh      2625
#define IDBM_WIN_Fh      2626

/* added icons to be re-numbered later */
#define IDBM_T_OS_U      2627
#define IDBM_T_OS_D      2628
#define IDBM_T_VS_U      2629
#define IDBM_T_VS_D      2630
#define IDBM_T_HD_U      2631
#define IDBM_T_HD_D      2632
#define IDBM_T_ZM_U      2633
#define IDBM_T_ZM_D      2634
#define IDBM_A_RH_U      2635
#define IDBM_A_RH_D      2636

#define IDBM_SKTOOLBAR   2639

#define IDBM_LOCK1       2640
#define IDBM_LOCK2       2641
#define IDBM_LOCK3       2642
#define IDBM_LOCK4       2643
#define IDBM_LOCK5       2644

#define IDBM_MAPS1       2645
#define IDBM_MAPS2       2646
#define IDBM_MAPS3       2647
#define IDBM_MAPS4       2648
#define IDBM_MAPS5       2649
#define IDBM_MAPS6       2650   /* <--------- */

#define IDBM_TOOLBAR_B   2700
#define IDBM_TOOLBAR_H   2701
#define IDBM_TOOLBAR_D   2702
#define IDBM_TOOLBAR_A   2703
#define IDBM_TOOLBAR_I   2704
#define IDBM_TOOLBAR_M   2705

#define IDBM_STOOLBAR_B  2706
#define IDBM_STOOLBAR_H  2707
#define IDBM_STOOLBAR_D  2708
#define IDBM_STOOLBAR_A  2709
#define IDBM_STOOLBAR_I  2710
#define IDBM_STOOLBAR_M  2711

#define IDBM_MENU1_1     2712
#define IDBM_MENU1_2     2713
#define IDBM_MENU1_3     2714
#define IDBM_MENU1_4     2715
#define IDBM_MENU1_5     2716
#define IDBM_MENU1_6     2717
#define IDBM_MENU1_7     2718
#define IDBM_MENU1_8     2719
#define IDBM_MENU1_9     2720

#define IDBM_MAP_FX1     2721
#define IDBM_MAP_FX2     2722
#define IDBM_MAP_FX3     2723
#define IDBM_MAP_FX4     2724
#define IDBM_MAP_FX5     2725
#define IDBM_MAP_FX6     2726

#define IDBM_SKTOOLBAR1  2750
#define IDBM_BACKGROUND  2751
#define IDBM_ABOUT       2752

#define IDC_NONE         3000   /* cursor */
#define IDC_SELECTOR     3001
#define IDC_DESELECTOR   3002
#define IDC_PLOTTER      3003
#define IDC_PLOT3D       3004
#define IDC_GRABBER      3005
#define IDC_BUILDER      3006
#define IDC_EXPANDER     3007
#define IDC_ROTATOR      3008
#define IDC_PRIMS        3009
#define IDC_SHAPER       3010
#define IDC_MAGNETTO     3011
#define IDC_MAGNETFROM   3012
#define IDC_PAN          3013
#define IDC_ZOOMIN       3014
#define IDC_ZOOMOUT      3015
#define IDC_XCROSS       3016
#define IDC_OPENARROW    3017
#define IDC_ZOOM         3018
#define IDC_SEL_A        3019   // add
#define IDC_SEL_S        3020
#define IDC_SEL_L_A      3021
#define IDC_SEL_L_S      3022
#define IDC_SEL_C_A      3023
#define IDC_SEL_C_S      3024
#define IDC_MAGNETTWIST  3025
#define IDC_MAGNETCURL   3026

#include "dialogs.h"

