/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file MPROTOS.H  prototypes for global functions in modeler*/

/* Window Class Window handlers */

LRESULT CALLBACK MainModelerWndProc(HWND hwnd, UINT msg, WPARAM wparam,
                                    LPARAM lparam);
LRESULT CALLBACK ModelerTriViewWndProc(HWND hwnd, UINT msg, WPARAM wparam,
                                    LPARAM lparam);
LRESULT CALLBACK ModelerViewWndProc(HWND hwnd, UINT msg, WPARAM wparam,
                                    LPARAM lparam);
LRESULT CALLBACK ModelerInfoWndProc(HWND hwnd, UINT msg, WPARAM wparam,
                                    LPARAM lparam);
LRESULT CALLBACK ToolboxWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK ToolBtnWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);

#ifdef MODULE_DESIGN
#define WHERE
#else
#define WHERE extern
#endif
WHERE void ExecuteKeyboardKeyCommand(int key);
WHERE void DisengageDesignerTool(void);
WHERE void DisengageSkeletonTool(void);
WHERE void InitializeLastFilesList(void);
#undef WHERE

#ifdef MODULE_TOOLBOX
#define WHERE
#else
#define WHERE extern
#endif
WHERE void ChangeToolboxBitmaps(void);
WHERE void MoveToolsWindow(void);
WHERE void ToolboxSelectTool(int);
WHERE void ToolboxShow(BOOL);
WHERE void ToolboxDestroy(void);
WHERE void ToolboxSetPosition(int);
WHERE void EnableTools(BOOL status);
WHERE void PannelSelectTool(HWND hwnd, int *oldtool, int newtool);
WHERE LRESULT CALLBACK CoordinatesDlgProc(HWND hdlg,UINT msg,
                            WPARAM wparam,LPARAM lparam);
WHERE LRESULT CALLBACK LockDlgProc(HWND hdlg,UINT msg,
                            WPARAM wparam,LPARAM lparam);
#undef WHERE

#ifdef MODULE_UTILS
#define WHERE
#else
#define WHERE extern
#endif
WHERE void EraseAll(short);
WHERE void EraseAllSkeleton(void);
WHERE void Delete_Bcurve(void);
WHERE void Delete_MapLock(void);
WHERE void RecalibrateMapLocks(void);
WHERE short WhichBezier(vertex *);
WHERE short EraseSkeleton(skel *);
WHERE int EraseEdge(int);
WHERE int EraseVertex(int);
WHERE void EraseVertexMapping(void);
WHERE int EraseIndicatedEdge(void);
WHERE int EraseIndicatedVertex(void);
WHERE short intriview(vertex  *);
WHERE void CreateVertex(void);
WHERE void CreateFace(long v1, long v2, long v3);
WHERE void CreateEdge(long v1, long v2);
BOOL UpdateVertexHeap(long n);
BOOL UpdateEdgeHeap(long n);
BOOL UpdateFaceHeap(long n);
WHERE void CreateSkeleton(skel *);
WHERE BOOL CheckFaceExists(long, long, long, long);
WHERE BOOL CheckEdgeExists(long, long, long);
WHERE void CopyFaceProp(face *fin, face *fout);
WHERE void MakeAutoWireFrame(void);
WHERE int MakeWireFrame(void);
WHERE void UnMakeWireFrame(void);
WHERE void ClearWireFrame(void);
WHERE void SpecialFunction(int item);
WHERE void AddPolygon(int ns, long radius, int axis);
WHERE void BuildPrimitive(long PrimitiveType, int view);
WHERE void UpdatePrimitiveStructure(long primitivetype, int view,
                              long xmin, long ymin, long zmin,
                              long xmax, long ymax, long zmax,
                              long xc,   long yc,   long zc);
WHERE void Nudge(int );
WHERE void ExecutePrimitivesMenu(HWND );
WHERE void AddSinglePrimitive(long );
#undef WHERE

#ifdef MODULE_LOADER
#define WHERE
#else
#define WHERE extern
#endif
WHERE int LoadObject(char *FileName, short relation);
WHERE char *short_form(char *filename);
WHERE void Save_Undo(short model);
WHERE void Restore_Undo(void);
WHERE void Empty_Undo(void);
WHERE void SaveObject(char *Filename, short status);
WHERE void SaveObjects(char *rootname, short do_all, short rotate180);
WHERE void Render_View(int light_pos, long how);
WHERE BOOL LoadHeightField(HWND hwnd);
WHERE BOOL ExecuteExternalAction(int, HWND);
WHERE BOOL ExecuteExternalModeler(HWND hwnd);
WHERE BOOL ExecuteBezierModeler(HWND hwnd);
WHERE BOOL LoadInternalAction(char *library);
WHERE long LoadXmodel(char *, char *);
WHERE long ExportModel(char *, char *);
WHERE void ConvertDXFmodel(HWND hwnd);
WHERE void Convert3DSmodel(HWND hwnd);
WHERE void ConvertTDDmodel(HWND hwnd);
WHERE void ConvertSCNmodel(HWND hwnd);
WHERE void Export3dSmodel(HWND hwnd);
WHERE void ExportDXFmodel(HWND hwnd);
WHERE BOOL TraceImageOutline(HWND hwnd);
WHERE void LoadAApoly(int aa_or_not_aa, char *filename);
WHERE void SavePath(void);
WHERE void ShaderPreview(void);
BOOL PrintImageFile(HWND hwnd);
WHERE void LoadViewer(int type);
WHERE void LoadMDIviewer(void);
WHERE void LoadExternalOpenGL(void);
#undef WHERE

#ifdef MODULE_LIBS
#define WHERE
#else
#define WHERE extern
#endif
WHERE short RequestNumEntry(short val, short minval, short maxval,
                      char *title, char *message);
WHERE int RequestCharString(int len, char *string, char *title, HWND parent);
WHERE void EnableToolPannels(int what_one, BOOL status);
WHERE void ActivateAllMenus(HWND hwnd, UINT fuFlags);
WHERE int SelectScrolledItemList(int n, char **list, char *title, HWND parent);
WHERE int SelectItemList(int n, char **list, char *title);
WHERE int SelectItems(int n, char **list, char *title, int where, BOOL lock);
WHERE PSTR FileInPath(PSTR pstrPath);
WHERE void GetTriview(BOOL reset);
WHERE void get_centre(short option, point p, point TVp, BOOL all);
WHERE void reset_mod_maxview(short option);
WHERE void ( *GetWorldCoords)(int W, long *x, long *y,
                             long *z, int hpos, int vpos);
WHERE void ( *GetWindowCoords)(int W, long x, long y,
                             long z,  int *hpos,  int *vpos);
WHERE void SetUpWindowBoxView(int view);
WHERE void DrawOne3dCursor(HDC hdc, int i);
WHERE void Draw3dCursor(void);
WHERE void Move3dCursor(int stor, int xw, int yw);
WHERE void LoadArrowIcons(void);
WHERE void DrawArrowIcons(HDC hdc, int id);
WHERE int CheckWindowIcon(int xi, int yi);
WHERE void InvertWindowIcon(int i, HWND hwnd);
WHERE void DeleteArrowIcons(void);
WHERE void SwapViewBitmaps(void);
WHERE void UpdateRuler(short m);
WHERE void SetUpGrid(void);
WHERE void DrawGridInOne(HDC hdc, int i);
WHERE BOOL SetColour(unsigned char colour[], char *Title, HWND parent);
WHERE BOOL SetSfxColour(unsigned char colour[], long ID, HWND parent);
WHERE void scal(double t[4][4], double sx, double sy, double sz);
WHERE void rotz(double tr[4][4], double ang);
WHERE void roty(double tr[4][4], double ang);
WHERE void rotx(double tr[4][4], double ang);
WHERE void tram(double t[4][4], double dx, double dy, double dz);
WHERE void mv4by1(double t4[4][4], vector v1, vector v2);
WHERE void m4by4(double t1[4][4], double t2[4][4], double tr[4][4]);
WHERE void m4by1(double t4[4][4], double x, double y, double z,
                 double *xx, double *yy, double *zz);
WHERE void null_transform(double t[4][4]);
WHERE void c4to4(double tin[4][4], double tout[4][4]);
WHERE void L_cross(point p1, point p2, point p3, point p4);
WHERE void rotate_round_vector(double angle, vector v, double t[4][4]);
WHERE void arbitrary_rotate(double angle, point p1, point p2, double t[4][4]);
WHERE void CentreDialogOnCursor(HWND);
WHERE void CentreDialogOnScreen(HWND hWnd);
WHERE void AppendFileExtension(char *, char *);
WHERE void Zoom(int command, int redraw);
WHERE void PaintDialogBackground(HWND hDlg, HINSTANCE hInst);
#undef WHERE

#ifdef MODULE_DRAW
#define WHERE
#else
#define WHERE extern
#endif
WHERE int  CheckInterrupt(void);
WHERE int  O_normalize(vector v);
WHERE void DrawModel(void);
WHERE void UpdateCounters(void);
WHERE void DrawVerticesOnly(vertex *vs);
WHERE void DrawOneEdgeOnly(vertex *v1, vertex *v2);
WHERE void Draw3dView(int smab, int skelview);
WHERE void DrawQuick3dView(int skelview);
WHERE void SelectInPerspective(int tl, int boxl, int box, int boyl, int boy);
WHERE void DrawRubberBoundBox(long xmin, long ymin, long zmin,
                              long xmax, long ymax, long zmax);
WHERE void DrawRubberLines(HWND hwnd, int av, long vtx, int x, int y);
WHERE void DrawRubber3dLine(point p1,point p2);
WHERE void DrawBrush(int brushID);
WHERE void DrawShader(int shaderID);
WHERE void DrawShaperSphere(long x,long y,long z,
             double shaper_angle_theta, double shaper_angle_phi,
             double shaper_size);
WHERE void DrawSkeleton(void);
WHERE void DrawQuickModel(void);
#undef WHERE

#ifdef MODULE_SELECT
#define WHERE
#else
#define WHERE extern
#endif
WHERE void SelectConnected(int);
WHERE void SelectConnectedTo(long id);
WHERE void ExecuteSelect(int item);
WHERE void ExecuteHide(BOOL hide);
WHERE long SelectVertex(int, int, int );
WHERE void SelectorDown(HWND, int, int x, int y);
WHERE void SelectorMove(HWND, int, int x, int y);
WHERE void SelectorUp(HWND, int, int x, int y, BOOL bFlagMoved, BOOL bFlagNoTool);
WHERE void SnapCursorTo(int item);
WHERE long PickVertex(void);
#undef WHERE

#ifdef MODULE_TOOLS1
#define WHERE
#else
#define WHERE extern
#endif
WHERE void MakeBezierCurve(void);
WHERE int AddVertex(void);
WHERE void Plot3dOn(void);
WHERE void Plot3dOff(void);
WHERE void Edge3dOn(void);
WHERE void Edge3dOff(void);
WHERE void GrabOn(void);
WHERE BOOL PrimitiveOn(void);
WHERE void PrimitiveOff(void);
WHERE void IxpandOn(void);
WHERE void IrotateOn(void);
WHERE void ToolDown(HWND, int, int x, int y);
WHERE void ToolUp(HWND, int, int x, int y);
WHERE void ToolMove(HWND,int, int x, int y);
WHERE void ToolAction(int x, int y);
WHERE void RecalibrateBezier(int id);
WHERE void RecalibrateAllBezier(void);
WHERE BOOL AddCopy(int wait);
WHERE BOOL CreateAttachedCopy(int);
WHERE BOOL Extrude(int);
WHERE BOOL PanToolDown(int , int , BOOL , BOOL, HWND);
WHERE void PanToolMove(int , int , BOOL , BOOL, HWND);
WHERE void PanToolUp(int , int , BOOL , BOOL, HWND);
#undef WHERE

#ifdef MODULE_TOOLS2
#define WHERE
#else
#define WHERE extern
#endif
WHERE int Subdivide(long down_to_f, long down_to_e, long draw);
WHERE int connected(long v1, long v2);
WHERE int AutoFillFace(long down_to);
WHERE void Replace_Faces(int how, double threshold);
WHERE void ActionRotate(int axis, double angle, int draw);
WHERE void Explode(int type);
WHERE long get_closest_vertex(void);
WHERE void ExtrudeAlong(void);
WHERE void JoinTwoCurves(void);
WHERE void Spin(int, int , BOOL, int);
WHERE void CopyConnected(void);
WHERE void Flip(void);
WHERE void SmoothCurve(void);
#undef WHERE

#ifdef MODULE_TOOLS3
#define WHERE
#else
#define WHERE extern
#endif
WHERE void ShatterEffect(void);
WHERE long *GetPathList(long *np);
WHERE int AutoFacetCurveWithHoles(int function, int visible, int atm,
                                  double ba, double bd);
WHERE void UnPlan(void);
WHERE BOOL CALLBACK BuildAccurateCurveDlgProc(HWND hwnd, UINT msg,
                                     WPARAM wparam, LPARAM lparam);
#undef WHERE

#ifdef MODULE_TOOLS4
#define WHERE
#else
#define WHERE extern
#endif
void OrientateFaceNormals(long, long, long *);
void ReverseFaceOrientation(long, long *);
BOOL IsFOSame(long, long, long, long, long, long);
void OrientateSelectedFaces(void);
#undef WHERE

#ifdef MODULE_ATTRIBS
#define WHERE
#else
#define WHERE extern
#endif
WHERE BOOL CALLBACK AttribsDlgProc(HWND hwnd,UINT msg,
                                   WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK LoadExternalShaderDlgProc(HWND hdlg,UINT msg,
                                   WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK DefaultAttribsDlgProc(HWND hdlg,UINT msg,
                             WPARAM wparam,LPARAM lparam);
WHERE BOOL IsAttribDlgMessage(HWND hWnd, LPMSG lpMsg);
#undef WHERE

#ifdef MODULE_MAPPING
#define WHERE
#else
#define WHERE extern
#endif
WHERE void EditImageMap(int id);
WHERE void DrawBrushInOne(HDC hdc,int view,int j);
WHERE void PositionBrushOnOff(int OnOff,int id);
WHERE void GrabBrushPoint(int x,int y);
WHERE void UnGrabBrushPoint(void);
WHERE void PullBrushPoint(int x,int y);
WHERE int RequestMapID(HWND parent, char *message, int new);
WHERE int RequestShaderID(HWND parent, char *message);
WHERE int RequestMirrorID(HWND parent);
WHERE int CreateModelerBrush(void);
WHERE void DumpBrush(int idd);
WHERE void PurgeMaps(void);
WHERE void PurgeShaders(void);
WHERE void VectorMaps(void);
WHERE void AddAdditionalShader(void);
WHERE void DumpShader(int idd);
WHERE void DrawShaderInOne(HDC hDC,int view,int j);
WHERE void PositionShaderOnOff(int OnOff,int id);
WHERE void GrabShaderPoint(int x,int y);
WHERE void UnGrabShaderPoint(void);
WHERE void PullShaderPoint(int x,int y);
WHERE void SetMapCoords(void);
WHERE void MapOntoPath(void);
WHERE void MapVerticesByBrush(void);
WHERE void  ExecuteLockAction(int item, int sb);
#undef WHERE

#ifdef MODULE_DIALOGS
#define WHERE
#else
#define WHERE extern
#endif
WHERE int Read3Reals(char *title, double *r1, double *r2, double *r3,
                     int list);
WHERE int Read3Ints(char *title, char *it1, char *it2, char *it3,
                    int *i1, int *i2, int *i3, HWND parent);
WHERE int Read2Ints(char *title, char *it1, char *it2,
                    int *i1, int *i2, HWND parent);
WHERE int Read1Int1Real(char *title, char *it1, char *it2,
                    int *i, int il, int ih,
                    double *r, double rl, double rh, HWND parent);
WHERE BOOL CALLBACK SpiralsDlgProc(HWND hwnd, UINT msg,
                             WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK FunctionPlotDlgProc(HWND hwnd, UINT msg,
                             WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK ExtrudeAlongDlgProc(HWND hwnd, UINT msg,
                             WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK FlipDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK ExpandDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK HierarchyDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK CubePrimitiveDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK SpherePrimitiveDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK PolygonPrimitiveDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK DiskPrimitiveDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK TubePrimitiveDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK CylinderPrimitiveDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK ConePrimitiveDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK PlanePrimitiveDlgProc(HWND hwnd, UINT msg,
                          WPARAM wparam, LPARAM lparam);
WHERE BOOL CALLBACK SqueezeDlgProc(HWND hdlg,UINT msg,
                          WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK ExplodeDlgProc(HWND hdlg,UINT msg,
                          WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK PrimitivesDlgProc(HWND hdlg,UINT msg,
                          WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK AboutDlgProc(HWND hdlg,UINT msg,
                          WPARAM wparam,LPARAM lparam);
WHERE BOOL CALLBACK RotateDlgProc(HWND, UINT, WPARAM, LPARAM);
WHERE BOOL CALLBACK MoveDlgProc(HWND, UINT, WPARAM, LPARAM);
WHERE void PreferencesPropertyDlgProc(HWND hwndOwner);
WHERE BOOL IsPrimitivesDialogMessage(MSG *msg);
#undef WHERE


#ifdef MODULE_SKELETON
#define WHERE
#else
#define WHERE extern
#endif
WHERE void GetSkeletonBoundBox(skel *sp, int ass);
WHERE void DrawTrSkeletonInOne(HDC hdc, int view);
WHERE void DrawSkeletonInOne(HDC hdc, int view);
WHERE void SkToolOn(void);
WHERE void SkToolOff(void);
WHERE void SkDelete1(skel *sp);
WHERE void ZeroSkeletonBoundingBox(skel *sp);
WHERE void SelectByHierarchy(skel *sp, int op);
WHERE int skintriview(point p);
WHERE void TidyUpOldSkeltonType(void);
WHERE void TabSkeletonAxis(void);
WHERE void SkToolDown(int x, int y);
WHERE void SkToolUp(int x, int y);
WHERE void SkToolMove(int x, int y);
WHERE void SkToolAction(int x, int y);
WHERE void SkeletonTreeView(HWND hWnd);
WHERE void UpdateSkTreeView(void);
WHERE void SetSkToolbarState(BOOL state);
WHERE void SkeletonToolBar(HWND hWndParent);
#undef WHERE

#ifdef MODULE_ATMFONT
#define WHERE
#else
#define WHERE extern
#endif
WHERE BOOL BuildATMfontString(HWND hwnd);
WHERE BOOL BuildTTFfontString(HWND hwnd);
#undef WHERE

#ifdef MODULE_NURBS
#define WHERE
#else
#define WHERE extern
#endif
WHERE void EraseAllNurbs(void);
WHERE void EraseNurbs(nurbs *);
WHERE void CreateNurbs(void);
WHERE void ClearNurbsSkeleton(skel *);
WHERE BOOL AllocNurbs(nurbs *, double *, double *);
WHERE BOOL CloneNurbs(nurbs *, nurbs *);
WHERE void ReleaseNurbs(nurbs *);
WHERE void DrawAllNurbsInOne(HDC, int, BOOL);
WHERE void MakeNewNurbsSurface(int);
WHERE BOOL DeleteSelectedNurbsSurfaces(void);
WHERE void EditSelectedNurbsSurface(void);
WHERE void SetSelectedNurbsWeights(void);
WHERE void DrawNurbsWireFrame(HDC, int,
                        double, double [4][4],
                        short (*)(vertex *, vertex *),
                        short (*)(vertex *, vertex *),
                        BOOL);
WHERE void HideNurbs(BOOL);
WHERE void SelectAllNurbs(BOOL);
WHERE void SwapNurbsSelection(void);
WHERE BOOL SelectNurbsPatch(int, int, int);
WHERE BOOL SelectNurbsControlPoint(int, int, int);
WHERE void SelectNurbsInRectangle(int, BOOL, long, long, long, long);
WHERE void SelectNurbsInCircle(int, BOOL,int, int, double);
WHERE void SelectNurbsInLasso(int, BOOL, HRGN);
WHERE void MoveNurbsControlPoint(int, int, int, int);
WHERE void TriangulateNurbsSurface(void);
WHERE void MoveNurbsSurface(int, int, int, int);
WHERE void RotateNurbsSurface(int, int, double);
WHERE void RotateNurbsAction(int, double);
WHERE void XpandNurbsSurface(int, int, double, double, double);
WHERE void ExpandNurbsAction(long, long, long, double, double, double);
WHERE void DuplicateSelectedNurbs(void);
WHERE void HiddenGetNurbsNumbers(long *, long *);
WHERE void HiddenAddNurbsVertices(long *, void *, double, double [4][4],
                                  long, long, long, long);
WHERE void HiddenAddNurbsFaces(long *, void *, long);
WHERE void MeshNurbsSurface(void);
WHERE void IncludeNurbsBoundary(short *, long *, long *, long *, long *, long *, long *);
WHERE void PutNurbsAttribute(int, void *);
WHERE void ReadNurbs(long, short, HANDLE);
WHERE void WriteNurbs(FILE *);
WHERE void SplitNurbs(void);
#undef WHERE

#ifdef MODULE_MENUHELP 
#define WHERE
#else
#define WHERE extern
#endif
WHERE void LoadMenuHelpTable(HWND hwnd);
WHERE UINT CheckMenuHelpData(UINT uItem);
WHERE void DisplayMenuHelpData(HWND hwnd,UINT id);
WHERE void FreeMenuHelpData(void);
#undef WHERE

#ifdef MODULE_FILES
#define WHERE
#else
#define WHERE extern
#endif
WHERE int SelectFileName(int save, char *szfile, char *szdir,
                   char *szTitle, char *szfilter, HWND parent);
WHERE int SelectSfxFileName(int save, char *szfile, char *szdir,
                   long ID, char *szfilter, HWND parent);
#undef WHERE

#ifdef MODULE_WINDOWS
#define WHERE
#else
#define WHERE extern
#endif
WHERE void SetWindowSize(int x, int y, int view, BOOL reset);
WHERE BOOL CreateMemoryWindows(void);
WHERE void DeleteMemoryWindows(void);
WHERE void SwitchWindow(int button);
WHERE void FormatScreen(void);
WHERE void UpdateIconPositions(void);
WHERE void FocusActiveWindow(HDC, BOOL );
WHERE BOOL CursorInTriview(void);
#undef WHERE

#ifdef MODULE_SETUP
#define WHERE
#else
#define WHERE extern
#endif
WHERE HPALETTE CreateAppPalette(int *, int *);
WHERE BOOL DesignStartup(UINT *);
WHERE void DesignShutdown(void);
WHERE BOOL SetupMainWindow(HANDLE inst, int cmdshow);
WHERE void LoadPreferences(void);
WHERE void ActivatePreferences(void);
WHERE void StartOpenGL(BOOL first_time);
WHERE void ExecuteAnimator(BOOL reload);
WHERE void SetupStructures(void);
WHERE void SendPrgmText(PSTR p);
WHERE void SendPrgmHelpMessage(int id);
WHERE void SendPrgmMessage(int idString,int where);
WHERE void SetPrgmMessage(int idString, PSTR pstr);
WHERE int  SendPrgmQuery(int idString, int response);
WHERE void SendIconHelpMessage(int idString);
WHERE void InitialiseStringVectors(void);
WHERE void FreeStringVectors(void);
#undef WHERE

