/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* strings.h     String identifiers for modeler */


#define CCHTEXTMAX                256

#define FIRST_IDS_STRING            0

#define IDS_DEFAULT                 0
#define IDS_CURRENT                 1
#define IDS_LOADING                 2
#define IDS_ZERO                    3
#define IDS_DUMMY1                  4
#define IDS_SWAPSVIEW               5
#define IDS_PAN                     6
#define IDS_SWAP3VIEW               7
#define IDS_SWAPOTHER               8
#define IDS_PANU                    9
#define IDS_PAND                   10
#define IDS_PANL                   11
#define IDS_PANR                   12
#define IDS_PANF                   13
#define IDS_PANB                   14
#define IDS_SAVING                 15
#define IDS_OK                     17
#define IDS_FILEOPENFAIL           18
#define IDS_FAILINCLUDE            19
#define IDS_PLOTTERR               20
#define IDS_SELECTOR               21
#define IDS_DESELECTOR             22
#define IDS_PLOTTER                23
#define IDS_GRABBER                24
#define IDS_PLOT3D                 25
#define IDS_BUILD                  26
#define IDS_EXPANDER               27
#define IDS_ROTATOR                28
#define IDS_PRIMS                  29
#define IDS_SHAPER                 30
#define IDS_MAGNETTO               31
#define IDS_MAGNETFROM             32
#define IDS_PERSPVIEW              33
#define IDS_MAPLOCKED              34
#define IDS_PANTOOL                35
#define IDS_OUTZOOMTOOL            36
#define IDS_INZOOMTOOL             37
#define IDS_T_NOTOOL               38
#define IDS_T_NODETOOL             39
#define IDS_T_PAN                  40
#define IDS_T_INZOOM               41
#define IDS_T_GRABBER              42
#define IDS_T_ROTATOR              43
#define IDS_T_EXPANDER             44
#define IDS_T_PLOTTER              45
#define IDS_T_SHAPER               46
#define IDS_T_MAGNETTO             47
#define IDS_T_BUILDER              48
#define IDS_T_PLOT3D               49
#define IDS_T_PRIMS                50
#define IDS_T_SKANIMATE            51
#define IDS_T_SELECTOR             52
#define IDS_T_DESELECTOR           53
#define IDS_T_SKGRAB               54
#define IDS_T_SKADD                55
#define IDS_T_SKDELETE             56
#define IDS_T_SKSUBDIV             57
#define IDS_T_SKASSIGN             58
#define IDS_T_SKSELECT             59
#define IDS_T_SKATMAP              60
#define IDS_T_SKTWIST              61
#define IDS_VIEWUPDATE             62
#define IDS_DEFAULT_LITE           64
#define IDS_CURRENT_LITE           65

#define CSTRINGS                   66   /* this must always be last+1 */

#define FIRST_IDQ_STRING         1000
#define IDQ_DUMMY1               1000  /* use again */
#define IDQ_DUMMY2               1001  /* use again */
#define IDQ_CONFIRM              1002
#define IDQ_CHANGED              1003
#define IDQ_NOMEM1               1004
#define IDQ_NOMEM2               1005
#define IDQ_NODELETEFILE         1006
#define IDQ_FILEOPENFAIL         1007
#define IDQ_TFWE                 1008
#define IDQ_SAVINGERROR          1009
#define IDQ_READERROR            1010
#define IDQ_NOHELP               1011
#define IDQ_NOZOOMOUT            1012
#define IDQ_NOZOOMIN             1013
#define IDQ_NOOPENWORKFILE       1014
#define IDQ_INVALIDDATA          1015
#define IDQ_COORDTOOBIG          1016
#define IDQ_PANTOOFAR            1017
#define IDQ_FILEEXISTS           1018
#define IDQ_OLD2                 1019
#define IDQ_NOBRUSH              1020
#define IDQ_BRUSHGLUED           1021
#define IDQ_MAPLOCKED            1022
#define IDQ_NOSHADERAXES         1023
#define IDQ_NODELETEROOTSHADER   1024
#define IDQ_WIRETOOBIG           1025
#define IDQ_NOTSUITABLECURVE     1026
#define IDQ_EDGEINCONSISTANT     1027
#define IDQ_NOPATHSTART          1028
#define IDQ_NOSHATTER            1029
#define IDQ_SCALETOOSMALL        1030
#define IDQ_BADRATIO             1031
#define IDQ_NOUNDOSPACE          1032
#define IDQ_NOUNDO               1033
#define IDQ_NOMOREMAPS           1034
#define IDQ_NOTAAPROPATH         1035
#define IDQ_NOTPATHFILE          1036
#define IDQ_BADCURVE             1037
#define IDQ_TOOFEWVERTICES       1038
#define IDQ_POINTSTOOCLOSE       1039
#define IDQ_NOLOOPBACK           1040
#define IDQ_NOCURVE1             1041
#define IDQ_NOCURVE2             1042
#define IDQ_NOJOIN               1043
#define IDQ_NONEARVERTEX         1044
#define IDQ_NOTPLANECURVE        1045
#define IDQ_ATMFILLFAIL          1046
#define IDQ_FAILED               1047
#define IDQ_NODELETESKROOT       1048
#define IDQ_WIREEXISTS           1049
#define IDQ_WIRENOEXISTS         1050
#define IDQ_TOOLNOTFINISHED      1051
#define IDQ_NOHIDDEN             1052
#define IDQ_HIDDEN1              1053
#define IDQ_HIDDEN2              1054
#define IDQ_HIDDEN3              1055
#define IDQ_HIDDEN4              1056
#define IDQ_HERROR               1057
#define IDQ_MAPNOLOCK            1058
#define IDQ_MODELERBUSY          1059
#define IDQ_MODELERACTIVATEFAIL  1060
#define IDQ_TOOFEWFACES          1061
#define IDQ_TOOFEWITEMS          1062
#define IDQ_SAVEBEFOREUPDATING   1063
#define IDQ_SET_COORD_ORIGIN     1064
#define IDQ_UNDONOTREADY         1065
#define IDQ_FILESEXIST           1066
#define IDQ_POLYTOOSMALL         1067
#define IDQ_MISC_DSHADER         1068
#define IDQ_MISC_DSCOLOUR        1069
#define IDQ_MISC_DFCOLOUR        1070
#define IDQ_FAILEDFUNCTION       1071
#define IDQ_FAILEDLIBRARY        1072
#define IDQ_NOSTART              1073
#define IDQ_NOVIEWIMAGE          1074
#define IDQ_BADPENS              1075
#define IDQ_BADNEXTFILE          1076
#define IDQ_FILEERROR            1077
#define IDQ_UNPLAN               1078
#define IDQ_COORD_BAD_RANGE      1079

#define QSTRINGS                 80 /* this is the number of Q strings(last+1) */

/* ids used for menu help */

#define IDH_FILE_NEW                        5158
#define IDH_FILE_LOAD_MODEL                 5001 /* start with 1 as 0xffff */
#define IDH_FILE_SAVE                       5156
#define IDH_FILE_LOAD_ABSOLUTE              5002
#define IDH_FILE_LOAD_RELATIVE              5003
#define IDH_FILE_LOAD_PATH                  5004
#define IDH_FILE_SAVE_ALL                   5005
#define IDH_FILE_SAVE_OBJECT                5006
#define IDH_FILE_SAVE_NAMED                 5007
#define IDH_FILE_SAVE_LETTERS               5008
#define IDH_FILE_SAVE_PATH                  5009
#define IDH_FILE_IMPORT_DXF                 5010
#define IDH_FILE_IMPORT_3DS                 5011
#define IDH_FILE_IMPORT_POLYGON             5012
#define IDH_FILE_IMPORT_ATM                 5013
#define IDH_FILE_IMPORT_FONT                5014
#define IDH_FILE_IMPORT_TDD                 5164
#define IDH_FILE_IMPORT_SCN                 5165
#define IDH_FILE_EXPORT_DXF                 5015
#define IDH_FILE_EXPORT_3DS                 5016
#define IDH_FILE_BOUNDINGBOX_MAKE           5017
#define IDH_FILE_BOUNDINGBOX_UNMAKE         5018
#define IDH_FILE_BOUNDINGBOX_CLEAR          5174
#define IDH_FILE_BOUNDINGBOX_AUTO           5178
#define IDH_FILE_TRACEOUTLINE               5019
#define IDH_FILE_BEZIER                     5157
#define IDH_FILE_VIEWER                     5020
#define IDH_FILE_HEIGHT                     5021
#define IDH_FILE_EXTERNAL                   5022
#define IDH_FILE_ANIMATOR                   5153
#define IDH_FILE_UPDATEANIMATOR             5155
#define IDH_FILE_PRINT                      5170
#define IDH_FILE_PREFERENCES                5159
#define IDH_VIEW_RENDERNOW                  5160
#define IDH_FILE_EXIT                       5023

#define IDH_EDIT_UNDO                       5024
#define IDH_EDIT_ERASE_VERTICES             5025
#define IDH_EDIT_ERASE_EDGES                5026
#define IDH_EDIT_ERASE_INDICATEDEDGE        5027
#define IDH_EDIT_ERASE_INDICATEDVERTEX      5028
#define IDH_EDIT_ERASE_MAP                  5029
#define IDH_EDIT_ERASE_HIERARCHY            5030
#define IDH_EDIT_ERASE_VERTEXMAPPING        5031
#define IDH_EDIT_ERASE_ALL                  5032
#define IDH_EDIT_SELECTALL                  5033
#define IDH_EDIT_DESELECTALL                5034
#define IDH_EDIT_SWAPSELECT                 5035
#define IDH_EDIT_SELECTCONNECT              5036
#define IDH_EDIT_DESELECTCONNECT            5037
#define IDH_EDIT_SELECTMAPPED               5038
#define IDH_EDIT_DESELECTMAPPED             5039
#define IDH_EDIT_SELECTBY_BEZIER            5040
#define IDH_EDIT_SELECTBY_INVIEW            5041
#define IDH_EDIT_SELECTBY_OUTVIEW           5042
#define IDH_EDIT_SELECTBY_MAP               5043
#define IDH_EDIT_SELECTBY_COLOUR            5044
#define IDH_EDIT_SELECTBY_SHADER            5045
#define IDH_EDIT_DESELECT_EVERY             5173

#define IDH_TOOLS_SELECTOR                  5046
#define IDH_TOOLS_DESELECTOR                5047
#define IDH_TOOLS_PLOTTER                   5048
#define IDH_TOOLS_PLOT3D                    5049
#define IDH_TOOLS_BUILDER                   5050
#define IDH_TOOLS_GRABBER                   5051
#define IDH_TOOLS_EXPANDER                  5052
#define IDH_TOOLS_ROTATOR                   5053
#define IDH_TOOLS_MAGNET_ATTRACT            5054
#define IDH_TOOLS_MAGNET_REPEL              5055
#define IDH_TOOLS_PRIMITIVES                5056
#define IDH_TOOLS_SHAPER                    5057

#define IDH_SNAP_CLOSEST                    5058
#define IDH_SNAP_CLOSESELECT                5059
#define IDH_SNAP_MIDPOINT                   5060
#define IDH_SNAP_MIDSELECT                  5061
#define IDH_SNAP_CENTROID                   5062
#define IDH_SNAP_HPLANE                     5063
#define IDH_SNAP_VPLANERL                   5064
#define IDH_SNAP_VPLANEFB                   5065
#define IDH_SNAP_STORE                      5066
#define IDH_SNAP_TOSTORED                   5067
#define IDH_SNAP_TOCOORD                    5068
#define IDH_SNAP_INCREMENT                  5069
#define IDH_ACTIONS_ROTATE_CLOCKWISE        5070
#define IDH_ACTIONS_ROTATE_ANTICLOCKWISE    5071
#define IDH_ACTIONS_WELD                    5072
#define IDH_ACTIONS_FILL                    5073
#define IDH_ACTIONS_FACET                   5074
#define IDH_ACTIONS_SPIN                    5075
#define IDH_ACTIONS_EXPAND                  5076
#define IDH_ACTIONS_EFFECTS_PLAN            5077
#define IDH_ACTIONS_EFFECTS_EXPLODE         5078
#define IDH_ACTIONS_EFFECTS_SHATTER         5079
#define IDH_ACTIONS_EFFECTS_FULLINTERSECT   5080
#define IDH_ACTIONS_EFFECTS_PARTINTERSECT   5081
#define IDH_TOOLS_EXTRUDE                   5082
#define IDH_ACTIONS_EXTRUDE_ALONG           5083
#define IDH_ACTIONS_EXTRUDE_BEVEL           5084
#define IDH_ACTIONS_EXTRUDE_ROUND           5085
#define IDH_ACTIONS_DUPLICATE_MAKE          5086
#define IDH_ACTIONS_DUPLICATE_CONNECT       5087
#define IDH_ACTIONS_DUPLICATE_MULTI         5088
#define IDH_ACTIONS_SUBDIVIDE               5089
#define IDH_ACTIONS_SMOOTH                  5090
#define IDH_ACTIONS_FLIP                    5091
#define IDH_ACTIONS_JOIN                    5092
#define IDH_ACTIONS_BEZIER                  5093
#define IDH_TOOLS_ADDVERTEX                 5094
#define IDH_TOOLS_BUILDFACET                5095
#define IDH_ACTIONS_SPECIAL_3DPLOT          5096
#define IDH_ACTIONS_SPECIAL_HELIX           5097
#define IDH_ACTIONS_SPECIAL_SPIRAL          5098
#define IDH_ACTIONS_SPECIAL_3DSPIRAL        5099
#define IDH_ACTIONS_SPECIAL_LINE            5100
#define IDH_ACTIONS_SPECIAL_BUTTERFLY       5101
#define IDH_ACTIONS_BUILD                   5154
#define IDH_ACTIONS_MOVE                    5181

#define IDH_ATTRIBUTES_FACE                 5102
#define IDH_ATTRIBUTES_DEFAULT              5103
#define IDH_ATTRIBUTES_MAP                  5104
#define IDH_ATTRIBUTES_MAPAXES              5105
#define IDH_ATTRIBUTES_SHADER_MOVE          5106
#define IDH_ATTRIBUTES_SHADER_NEW           5107
#define IDH_ATTRIBUTES_SHADER_DELETE        5108
#define IDH_ATTRIBUTES_EXTERNALSHADER       5109
#define IDH_ATTRIBUTES_SHADER_PREVIEW       5110
#define IDH_ATTRIBUTES_CENTREPOINT          5111
#define IDH_ATTRIBUTES_FOLLOWPOINT          5112
#define IDH_ATTRIBUTES_SHADOW               5113
#define IDH_ATTRIBUTES_MAPFROMMAP           5114
#define IDH_ATTRIBUTES_MAPONPATH            5115
#define IDH_ATTRIBUTES_SETVERTEXMAPPING     5116
#define IDH_ATTRIBUTES_MIRROR               5168
#define IDH_ATTRIBUTES_PURGE                5171
#define IDH_ATTRIBUTES_VECTOR               5172
#define IDH_ATTRIBUTES_REFINDEX             5177
#define IDH_ATTRIBUTES_SHADER_PURGE         5194

#define IDH_HIERARCHY_NAME                  5117
#define IDH_HIERARCHY_POSE                  5118
#define IDH_HIERARCHY_BUILD                 5119
#define IDH_HIERARCHY_STRETCH               5120
#define IDH_HIERARCHY_TWIST                 5121
#define IDH_HIERARCHY_REMOVE                5122
#define IDH_HIERARCHY_INSERT                5123
#define IDH_HIERARCHY_ATTACH                5124
#define IDH_HIERARCHY_SELECT                5125
#define IDH_HIERARCHY_MAP                   5126

#define IDH_VIEW_HIDE                       5127
#define IDH_VIEW_REVEAL                     5128
#define IDH_VIEW_DRAWING_HIDEEDGES          5129
#define IDH_VIEW_DRAWING_HIDEJOINS          5130
#define IDH_VIEW_RENDER                     5131
#define IDH_VIEW_SHOW                       5132
#define IDH_VIEW_WIREFRAME                  5133
#define IDH_VIEW_HIDDENLINE                 5134
#define IDH_VIEW_GRID                       5135
#define IDH_VIEW_DRAW_GRID                  5169
#define IDH_VIEW_DEFINEGRID                 5136
#define IDH_ZOOM_IN                         5137
#define IDH_ZOOM_OUT                        5138
#define IDH_ZOOM_CENTRE                     5139
#define IDH_VIEW_RESTORE                    5140
#define IDH_VIEW_FULL                       5141
#define IDH_VIEW_SCREENCOLOURS              5142
#define IDH_VIEW_FEEDBACK_CURSOR            5143

#define IDH_WINDOW_SWITCHWINDOWS            5144
#define IDH_VIEW_SWAPVIEWPOINT              5145
#define IDH_WINDOW_COORDS                   5146
#define IDH_WINDOW_DATA                     5147
#define IDH_WINDOW_UNDOACTIVE               5148
#define IDH_WINDOW_COORD_DEF                5149
#define IDH_WINDOW_COORD_LAST               5150
#define IDH_WINDOW_SELECT                   5161
#define IDH_WINDOW_SHOWOPENGL               5167
#define IDH_WINDOW_VIEWOPENGL               5179
#define IDH_WINDOW_HIDETOOLS                5162
#define IDH_WINDOW_TOOLLEFT                 5175
#define IDH_WINDOW_RESET                    5176
#define IDH_STOP                            5151
#define IDH_HELP_H                          5152
#define IDH_HELP_HELP                       5163
#define IDH_HELP_GENERAL                    5166
#define IDH_HELP_ABOUT                      5180
#define IDH_WINDOW_QUICKRENDER              5182
#define IDH_FILE_IMPORT_STL                 5183
#define IDH_FILE_EXPORT_STL                 5184
#define IDH_FILE_EXPORT_VRML                5185
#define IDH_FILE_BOUNDINGBOX_TOSK           5186
#define IDH_ACTIONS_BOOLEAN                 5187
#define IDH_ACTIONS_TWIST                   5188
#define IDH_ACTIONS_ORIENTATE               5189
#define IDH_ACTIONS_REVERSE                 5190
#define IDH_ACTIONS_JOINS                   5191
#define IDH_HELP_HOME                       5192
#define IDH_HELP_SUPPORT                    5193

#define IDH_NURBS_CREATE                    5195
#define IDH_NURBS_DELETE                    5196
#define IDH_NURBS_EDIT                      5197
#define IDH_NURBS_TRIANGULATE1              5198
#define IDH_NURBS_TRIANGULATE2              5199
#define IDH_NURBS_PRIM1                     5200
#define IDH_NURBS_PRIM2                     5201
#define IDH_NURBS_PRIM3                     5202
#define IDH_NURBS_PRIM4                     5203
#define IDH_NURBS_SELECT                    5204
#define IDH_NURBS_DESELECT                  5205
#define IDH_NURBS_SWAP                      5206
#define IDH_NURBS_SETWEIGHTS                5207
#define IDH_NURBS_HIDE                      5208
#define IDH_NURBS_REVEAL                    5209
#define IDH_NURBS_SPLIT                     5210

#define IDH_ATTRIBUTES_NEWMAP               5211

/* This is the number of menu help items+1  */
#define NMENUHELPDATA  212

/* These are the ICON help strings */

#define FIRST_IDI_STRING         6000

#define IDI_ZOOM                 6000
#define IDI_PAN                  6001
#define IDI_ZOOM_CENTRE          6002
#define IDI_ZOOM_WORLD           6003

#define IDI_COORD_MEASURE        6004
#define IDI_COORD_RELATIVE       6005
#define IDI_COORD_ORIGIN         6006
#define IDI_COORD_DEFINE         6007

#define IDI_SELECT_SELECTOR      6008
#define IDI_SELECT_DESELECTOR    6009
#define IDI_SELECT_SELECTALL     6010
#define IDI_SELECT_DESELECTALL   6011
#define IDI_SELECT_SWAPSELECT    6012
#define IDI_SELECT_SELECTCONNECT 6013
#define IDI_SELECT_HIDE          6014
#define IDI_SELECT_REVEAL        6015

#define IDI_TOOLS_PLOTTER        6016
#define IDI_TOOLS_PLOT32         6017
#define IDI_TOOLS_GRABBER        6018
#define IDI_TOOLS_BUILDER        6019
#define IDI_TOOLS_EXPANDER       6020
#define IDI_TOOLS_ROTATOR        6021
#define IDI_TOOLS_PRIMITIVES     6022
#define IDI_TOOLS_SHAPER         6023
#define IDI_TOOLS_MAGNET_ATTRACT 6024
#define IDI_TOOLS_MAGNET_REPEL   6025
#define IDI_TOOLS_QPRIMITIVES    6026
#define IDI_TOOLS_NOTUSED2       6027

#define IDI_ACTION_ROTATE_A      6028
#define IDI_ACTION_ROTATE_C      6029
#define IDI_ACTION_BEZIER        6030
#define IDI_ACTION_JOIN          6031
#define IDI_ACTION_DUP_MAKE      6032
#define IDI_ACTION_DUP_CONNECT   6033
#define IDI_ACTION_FILL          6034
#define IDI_ACTION_FACET         6035
#define IDI_TOOLS_EXTRUDE        6036
#define IDI_ACTION_EXTRUDEALONG  6037
#define IDI_ACTION_SPIN          6038
#define IDI_ACTION_DUP_MULTI     6039
#define IDI_ACTION_FLIP          6040
#define IDI_ACTION_WELD          6041
#define IDI_ACTION_BUILDFACET    6042
#define IDI_ACTION_ADDVERTEX     6043

#define IDI_CONTROL_HELP         6044
#define IDI_CONTROL_CURSOR       6045
#define IDI_CONTROL_RENDER       6046
#define IDI_CONTROL_SHOW         6047
#define IDI_CONTROL_CLOSEST      6048
#define IDI_CONTROL_ATMFONT      6049
#define IDI_CONTROL_ATTRIBUTES   6050
#define IDI_CONTROL_UNDO         6051

#define IDI_LOCK_SNAP1           6052
#define IDI_LOCK_SNAP2           6053
#define IDI_LOCK_SNAP3           6054
#define IDI_LOCK_LOCK            6055
#define IDI_HIDDENLINE           6056
#define IDI_OBJECT_SELECTOR      6057
#define IDI_VERTEX_SELECTOR      6058

#define ISTRINGS                   59    /* this must always be last+1 */

#define IDI_TIP_T_1              6500
#define IDI_TIP_T_2              6501
#define IDI_TIP_T_3              6502
#define IDI_TIP_T_4              6503
#define IDI_TIP_T_5              6504
#define IDI_TIP_T_6              6505
#define IDI_TIP_T_7              6506
#define IDI_TIP_T_8              6507
#define IDI_TIP_T_9              6508
#define IDI_TIP_T_A              6509
#define IDI_TIP_T_B              6510
#define IDI_TIP_T_C              6511

#define IDI_TIP_A_1              6512
#define IDI_TIP_A_2              6513
#define IDI_TIP_A_3              6514
#define IDI_TIP_A_4              6515
#define IDI_TIP_A_5              6516
#define IDI_TIP_A_6              6517
#define IDI_TIP_A_7              6518
#define IDI_TIP_A_8              6519
#define IDI_TIP_A_9              6520
#define IDI_TIP_A_A              6521
#define IDI_TIP_A_B              6522
#define IDI_TIP_A_C              6523

#define IDI_TIP_S_1              6524
#define IDI_TIP_S_2              6525
#define IDI_TIP_S_3              6526
#define IDI_TIP_S_4              6527
#define IDI_TIP_S_5              6528
#define IDI_TIP_S_6              6529
#define IDI_TIP_S_7              6530
#define IDI_TIP_S_8              6531

#define IDI_TIP_M_1              6532
#define IDI_TIP_M_2              6533
#define IDI_TIP_M_3              6534
#define IDI_TIP_M_4              6535
#define IDI_TIP_M_5              6536
#define IDI_TIP_M_6              6537

#define IDI_TIP_C_1              6538
#define IDI_TIP_C_2              6539
#define IDI_TIP_C_3              6540
#define IDI_TIP_C_4              6541

#define IDI_TIP_K_1              6542
#define IDI_TIP_K_2              6543
#define IDI_TIP_K_3              6544
#define IDI_TIP_K_4              6545
#define IDI_TIP_K_5              6546
#define IDI_TIP_K_6              6547
#define IDI_TIP_K_7              6548
#define IDI_TIP_K_8              6549
#define IDI_TIP_K_9              6550

#define IDI_TIP_KT_1             6561
#define IDI_TIP_KT_2             6562
#define IDI_TIP_KT_3             6563
#define IDI_TIP_KT_4             6564
#define IDI_TIP_KT_5             6565
#define IDI_TIP_KT_6             6566
#define IDI_TIP_KT_7             6567
#define IDI_TIP_KT_8             6568

#define IDX_MISC_TOOLS           7000
#define IDX_MISC_ACTIONS         7001
#define IDX_MISC_SELECT          7002
#define IDX_MISC_COORDS          7003
#define IDX_MISC_DATA            7004
#define IDX_MISC_AXIS            7005
#define IDX_MISC_HTOOLS          7006
#define IDX_MISC_STOOLS          7007
#define IDX_MISC_HSELECTORS      7008
#define IDX_MISC_SSELECTORS      7009
#define IDX_MISC_CROSSHAIR       7010
#define IDX_MISC_CROSSWIRE       7011
#define IDX_MISC_SINGLEVIEW      7012
#define IDX_MISC_QUADVIEW        7013
#define IDX_MISC_HEIGHTFIELD     7014
#define IDX_MISC_TRACE           7015
#define IDX_MISC_WRITEPATH       7016
#define IDX_MISC_EXPORTDXF       7017
#define IDX_MISC_EXTMODELER      7018
#define IDX_MISC_IMAGEFILE       7019
#define IDX_MISC_IMPORTDXF       7020
#define IDX_MISC_OUTPUTSCE       7021
#define IDX_MISC_IMPORT3DS       7022
#define IDX_MISC_EXPORT3DS       7023
#define IDX_MISC_IMPORTTDD       7024
#define IDX_MISC_IMPORTSCN       7025
#define IDX_MISC_IMAGEFORMAP     7026
#define IDX_MISC_FIRSTIMAGE      7027
#define IDX_MISC_SAVEMODEL       7028
#define IDX_MISC_OPENMODEL       7029
#define IDX_MISC_INCLUDEMODEL    7030
#define IDX_MISC_LOADPATH        7031
#define IDX_MISC_SAVESELECTED    7032
#define IDX_MISC_LOADXSHADER     7033
#define IDX_MISC_CONFIRM         7034
#define IDX_FLIC_SET1            7035
#define IDX_FLIC_SET2            7036
#define IDX_FLIC_SET3            7037
#define IDX_FLIC_SET4            7038
#define IDX_MISC_FACE_COLOUR     7039
#define IDX_MISC_SHADER_COLOUR   7040
#define IDX_MISC_CHOOSE_COLOUR   7041
#define IDX_MISC_BACK_COLOUR     7042
#define IDX_MISC_KEYCOLOUR       7043
#define IDX_MISC_REFINDEX        7044
#define IDX_PRIMS_RECTANGLE      7045
#define IDX_PRIMS_CUBE           7046
#define IDX_PRIMS_POLYGON        7047
#define IDX_PRIMS_TUBE           7048
#define IDX_PRIMS_DISK           7049
#define IDX_PRIMS_CYLINDER       7050
#define IDX_PRIMS_CONE           7051
#define IDX_PRIMS_SPHERE         7052
#define IDX_MISC_SHOWGL          7053
#define IDX_MISC_HIDEGL          7054
#define IDX_MISC_PREF_TITLE      7055
#define IDX_MISC_ATT_COLOUR      7056
#define IDX_MISC_ATT_SETTINGS    7057
#define IDX_MISC_ATT_SHADER      7058
#define IDX_MISC_ATT_MAPS        7059

#define IDX_MISC_LANGUAGE        7060
#define IDX_MISC_SETATTRIBS      7061
#define IDX_MISC_HELPFILENAME    7062
#define IDX_MISC_HELPFILENAME1   7063
#define IDX_MISC_PLUGINACTIONS   7064
#define IDX_MISC_HELPTITLE1      7065
#define IDX_MISC_HELPTITLE2      7066
#define IDX_MISC_HELPTITLE3      7067
#define IDX_MISC_LOADFILTER      7068
#define IDX_MISC_HOMEPAGE        7069
#define IDX_MISC_SUPPORTPAGE     7070
#define IDX_MISC_HOMEPAGEL       7071
#define IDX_MISC_SUPPORTPAGEL    7072
#define IDX_PRIMS_SPHERE1        7073
#define IDX_PRIMS_TORUS          7074

