/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/*  STLOUT.CPP  */

#include "vtk.hh"
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <windows.h>

#define UNIT         32768L
#define DESELECTED       0
#define SELECTED         1
#define INEDITOR         6

#ifdef __cplusplus
extern "C" {
#endif

#include "struct.h"
#include "dstruct.h"

#ifdef __cplusplus
}
#endif

#include "stlout.h"

#include "sfx2vtk.h"
#include "sfx2vtk.cpp"

static HINSTANCE hThisInstance;

#if __WATCOMC__
int APIENTRY LibMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#else
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#endif
  switch (dwReason) {
    case DLL_PROCESS_ATTACH: {
      hThisInstance=(HINSTANCE)hDLL;
      if(hDLL == NULL)MessageBeep(MB_OK);
      break;
    }
    case DLL_PROCESS_DETACH:
      break;
  }
  return TRUE;
}

extern "C" BOOL _Export
 (HWND parent_window, char *filename, X__STRUCTURE *lpevi){
 HCURSOR hSave;
 lpEVI=lpevi;
 char localfile[256];
 if(filename == NULL){
   strcpy(localfile,"unnamed.stl");
   ChooseFile(1,localfile,"\\","Save STL","*.stl",parent_window);
 }
 else strcpy(localfile,filename);
 AppendFileExtension(localfile,".stl");
 hSave=SetCursor(LoadCursor(NULL,IDC_WAIT));
 SfxReader sfxinput;
 vtkSTLWriter stlw;
 stlw.SetInput(sfxinput.GetOutput());
 stlw.SetFilename(localfile);
 stlw.Update();
 SetCursor(hSave);
 return 1;
}

