/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/*  TESSEL.C  */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <windows.h>

#include "struct.h"
#include "dstruct.h"

#include "tessel.h"

#define DESELECTED 0
#define SELECTED   1


static HWND      hParent;
static HINSTANCE hThisInstance;


#if __WATCOMC__
int APIENTRY LibMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#else
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#endif
  switch (dwReason) {
    case DLL_PROCESS_ATTACH: {
      hThisInstance=hDLL;
      if(hDLL == NULL)MessageBox ( GetFocus()," NULL instance",NULL, MB_OK);
      break;
    }
    case DLL_PROCESS_DETACH:
      break;
  }
  return TRUE;
}

BOOL _Xmodeler
 (HWND parent_window,HWND info_window,X__STRUCTURE *lpevi){
 char text_string[255],name_string[255];
 lpEVI=lpevi;
 hParent=parent_window;
 LoadString(hThisInstance,IDX_STRING2,text_string,256);
 LoadString(hThisInstance,IDX_STRING1,name_string,256);
 if(MessageBox(hParent,text_string,name_string,MB_OKCANCEL)
               == IDCANCEL)return FALSE;
 else{
#if 0
 {// this is the copy code //
 HCURSOR hSave;
 vertex *vp,*V0,*V1,*V2,*Vp;
 edge   *ep;
 face   *fp;
 long   i,Nvert1,Nedge1,Nface1;
 long x,y,z;
 if(NvertSelect == 0 || NvertSelect > 32000)return FALSE;
 hSave=SetCursor(LoadCursor(NULL,IDC_WAIT));
 if(!UpdateVertexHeap(Nvert+NvertSelect))return FALSE;
 for(Nedge1=0,ep=MainEp,i=0;i<Nedge;i++){
   V0=(MainVp+ep->V[0]); V1=(MainVp+ep->V[1]);
   if(V0->status == SELECTED && V1->status == SELECTED)Nedge1++;
   ep++;
 }
 if(!UpdateEdgeHeap(Nedge+Nedge1))return FALSE;
 for(Nface1=0,fp=MainFp,i=0;i<Nface;i++){
   V0=(MainVp+fp->V[0]); V1=(MainVp+fp->V[1]); V2=(MainVp+fp->V[2]);
   if(V0->status == SELECTED &&
      V1->status == SELECTED &&
      V2->status == SELECTED)Nface1++;
   fp++;
 }
 if(!UpdateFaceHeap(Nface+Nface1))return FALSE;
 Nvert1=Nvert; Nedge1=Nedge; Nface1=Nface;
 vp=MainVp; for(i=0;i<Nvert1;i++){
   if(vp->status == SELECTED){
     CreateVertex();
     Vp=(MainVp+Nvert-1);
     Vp->xyz[0]=vp->xyz[0];
     Vp->xyz[1]=vp->xyz[1];
     Vp->xyz[2]=vp->xyz[2];
     Vp->gp=vp->gp;
     if(Vp->gp == 1){
       Vp->x=vp->x;
       Vp->y=vp->y;
       NvertGlue++;
     }
     Vp->status=DESELECTED;
     vp->id=Nvert-1;
     NvertSelect--; NvertDeselect++;
   }
   else{
     vp->id = -1;  /* needed by copy+flip+weld */
   }
   vp++;
 }
 if(Nedge > 0)for(ep=MainEp,i=0;i<Nedge1;i++){
   V0=(MainVp+ep->V[0]); V1=(MainVp+ep->V[1]);
   if(V0->status == SELECTED &&
      V1->status == SELECTED){
      CreateEdge(V0->id,V1->id);
   }
   ep++;
 }
 if(Nface > 0)for(fp=MainFp,i=0;i<Nface1;i++){
   V0=(MainVp+fp->V[0]); V1=(MainVp+fp->V[1]); V2=(MainVp+fp->V[2]);
   if(V0->status == SELECTED &&
      V1->status == SELECTED &&
      V2->status == SELECTED) {
     CreateFace(V0->id,V1->id,V2->id);
     CopyFaceProp(fp,(MainFp+Nface-1));
   }
   fp++;
 }
 vp=MainVp; for(i=0;i<Nvert1;i++){
   if(vp->status == SELECTED){
    vp->status=DESELECTED;
    (MainVp+vp->id)->status=SELECTED;
   }
   vp++;
 }
 SetCursor(hSave);
 }
#endif
   HCURSOR hSave;
   vertex *vp,*V0,*V1,*V2,*Vp;
   face   *fp;
   long   i,nf;
   long x,y,z;
   if(NvertSelect == 0 || NvertSelect > 32000 || Nface == 0)return FALSE;
   hSave=SetCursor(LoadCursor(NULL,IDC_WAIT));
   for(nf=0,fp=MainFp,i=0;i<Nface;i++){
     V0=(MainVp+fp->V[0]); V1=(MainVp+fp->V[1]); V2=(MainVp+fp->V[2]);
     if(V0->status == SELECTED &&
        V1->status == SELECTED &&
        V2->status == SELECTED)nf++;
     fp++;
   }
   if(nf == 0)goto XXIT;
   if(!UpdateVertexHeap(Nvert+nf))goto XXIT;
   if(!UpdateEdgeHeap(Nedge+3*nf))goto XXIT;
   if(!UpdateFaceHeap(Nface+2*nf))goto XXIT;
   for(nf=0,fp=MainFp,i=0;i<Nface;i++){
     V0=(MainVp+fp->V[0]); V1=(MainVp+fp->V[1]); V2=(MainVp+fp->V[2]);
     if(V0->status == SELECTED &&
        V1->status == SELECTED &&
        V2->status == SELECTED){ /* this face */
       x=(long)(((double)V0->xyz[0]+(double)V1->xyz[0]+(double)V2->xyz[0])/3.0);
       y=(long)(((double)V0->xyz[1]+(double)V1->xyz[1]+(double)V2->xyz[1])/3.0);
       z=(long)(((double)V0->xyz[2]+(double)V1->xyz[2]+(double)V2->xyz[2])/3.0);
       CreateVertex();
       Vp=(MainVp+Nvert-1);
       Vp->xyz[0]=x; Vp->xyz[1]=y; Vp->xyz[2]=z;
       Vp->status=DESELECTED;
       NvertSelect--; NvertDeselect++;
       CreateEdge(Nvert-1,fp->V[0]);
       CreateEdge(Nvert-1,fp->V[1]);
       CreateEdge(Nvert-1,fp->V[2]);
       CreateFace(fp->V[0],Nvert-1,fp->V[2]);
       CreateFace(fp->V[0],fp->V[1],Nvert-1);
       fp->V[0]=Nvert-1;
     }
     fp++;
   }
   XXIT:
   SetCursor(hSave);
 }
 return TRUE;
}
