/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file PSTRUCT.H   for external animation effects                          */
/*                                                                          */
/* Defines and structure member definitions required by external effects    */


#define double float    /*      The renderer uses FLOAT real numbers        */
typedef double vector[3];

/* Must use WINDOWS own memory allocation scheme for windows NT             */

#ifdef __X__NT__
#define X__Malloc(s)    LocalAlloc(LMEM_FIXED,s)
#define X__Free(p)      LocalFree((HLOCAL)p)
#define X__Realloc(p,s) LocalReAlloc((HLOCAL)p,s,LMEM_MOVEABLE)
#else
#define X__Malloc(s)    GlobalAlloc(GMEM_FIXED,s)
#define X__Free(p)      GlobalFree((HGLOBAL)p)
#define X__Realloc(p,s) GlobalReAlloc((HGLOBAL)p,s,GMEM_MOVEABLE)
#endif

typedef float Svertex[3]; /* structure for preview vertex positions         */

typedef struct VERTEX { /* structure for each vertex                        */
 vector p;              /* real position  3D space                          */
 double x,y;            /* screen location pixel space - NOT used in effect */
} vertex;

#define UNSIGNED unsigned short

typedef struct FACE {
 UNSIGNED V[3];
 unsigned char color[3];
 unsigned char fparam,matsp,mattr,matre,texco[3];
 unsigned char fattrib,fmap,fshader,faxis;
 short    top,bottom,left,right;
} face;

#include "sfxinfo.h"    /* main SFX info structure                          */

#include "..\animate\memory.h" /* for memory definition                     */
#include "..\animate\memdef.h" /* local names                               */
