/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* Template for building EXTERNAL animation effect using PHARLAP's TNT */

#include <stdio.h>
#include <math.h>
#include <pharlap.h>
#define DLL_PROCESS_DETACH 0
#define DLL_PROCESS_ATTACH 1

#ifndef max
#define max(a,b)  ( ((a) > (b)) ? (a) : (b) )
#endif

#if __WATCOMC__
#define PI 3.1415926
#endif

/************** Structures that may be addressed externally ********/

#define double float    /* renderer uses FLOAT real numbers */
typedef double vector[3];

typedef struct VERTEX { /* structure for each vertex   */
 vector p;              /* real position  3D space     */
 double x,y;            /* screen location pixel space - NOT used in effect */
} vertex;

typedef struct TVERTEX {
 double x,y;            /* texture coordinates - for future expansion       */
} tvertex;

typedef struct {
 long nvert;            /* number of vertices that apply to the model       */
 long ltime;
 long vmin[3];
 long vmax[3];
 long origin[3];
 double time;
} sfxinfo;

/**************  Function that is called by  ****************/

long DLL_ExternalEffect(char *PrmList,sfxinfo *SFXinfo, vertex *Vlist);

/************************** DLL entry point ********************************/

ULONG __stdcall DllEntryPoint(void *hDLL, ULONG Reason, void *Reserved){
 switch (Reason) {
   case DLL_PROCESS_ATTACH:
     break;
   case DLL_PROCESS_DETACH:
     break;
 }
 return (ULONG)TRUE;
}

/*******************************************************************\
|                Code that define the effects                       |
\*******************************************************************/

long DLL_ExternalEffect(char *PrmList, sfxinfo *SFXinfo,
                                 vertex *Vlist){
 double amplitude,wavelength,displacement,distance;
 long i;
 double PRMfreq, PRMwavelength;
 char axis, *cp;
 wavelength=max((double)(SFXinfo->vmax[1]-SFXinfo->vmin[1]),1.0) / 12.0;
 amplitude=wavelength/24;
 for(i=0L; i < SFXinfo->nvert; i++){
  distance=sqrt((double)Vlist[i].p[0]*(double)Vlist[i].p[0] +
                (double)Vlist[i].p[1]*(double)Vlist[i].p[1]);
#if 0
  displacement=amplitude*cos(PI*2*(SFXinfo->time-distance/wavelength));
  Vlist[i].p[2] += (long)displacement;
#endif
 }
 return 1;
}

