/* file MAINDLL.C OpenGL Entry for DLL and MAIN   */

/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

#define MODULE_MAINDLL

#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <commctrl.h>

#include <gl\gl.h>
#include <gl\glu.h>

#include "main.h"

extern HWND      glWnd,glWndFrame,glWndParent;
extern HINSTANCE glInstance;
extern BOOL RendererStandAlone;

extern void RegisterOpenGL(HINSTANCE);
extern void UnregisterOpenGL(HINSTANCE);
extern HWND RegisterWindow(HWND, LPRECT);

extern char iniFilename[];

#if __DLL__

#include "..\animate\astruct.h"
#include "..\animate\dstruct.h"

#if __WATCOMC__
int APIENTRY LibMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#elif __BCC__
int APIENTRY DllEntryPoint(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#else
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#endif
  switch (dwReason) {
    case DLL_PROCESS_ATTACH:
      RegisterOpenGL(hDLL);
      break;
    case DLL_PROCESS_DETACH:
      UnregisterOpenGL(hDLL);
      break;
  }
  return (int)TRUE;
}

HWND _AttachViewOpenGL(
     HWND parent,
     LPRECT pr,
     ANI_STRUCTURE *lpevi
                      ){
 lpEVI=lpevi;
 return RegisterWindow(parent,pr);
}

void _DetachViewOpenGL(
     void
                       ){
 if(glWnd != NULL)DestroyWindow(glWnd);
 if(glWndFrame != NULL)DestroyWindow(glWndFrame);
}

#else


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine, int nCmdShow){
 MSG msg;
 RECT rc;
 InitCommonControls();
 if(LOBYTE(LOWORD(GetVersion())) < 4){
   if(LoadLibrary("dlg3d.dll") == NULL)
     MessageBox(NULL,"Dlg3d DLL missing",NULL,MB_OK);
 }
 //Ctl3dRegister(hInstance);
 //Ctl3dAutoSubclass(hInstance);
 if(lpCmdLine == NULL)RendererStandAlone=TRUE;
 else{
   if(strstr(lpCmdLine,"$SAL$") == NULL)RendererStandAlone=TRUE;
   else                                 RendererStandAlone=FALSE;
 }
 RegisterOpenGL(hInstance);
 rc.left=100; rc.top=100; rc.right=320; rc.bottom=240;
 if(RendererStandAlone)rc.bottom +=  GetSystemMetrics(SM_CYMENU);
 {
   char pref_id[64];
   GetPrivateProfileString("GLAPREFERENCES","GLWINDOW","$$$",
                     pref_id,sizeof(pref_id),iniFilename);
   if(strncmp(pref_id,"$$$",3) != 0){
     long x1,y1,x2,y2;
     sscanf(pref_id,"%ld %ld %ld %ld",&x1,&y1,&x2,&y2);
     rc.left=x1; rc.top=y1; rc.right=x2-x1; rc.bottom=y2-y1;
   }
 }
 RegisterWindow(NULL,&rc);
 if(RendererStandAlone)PostMessage(glWndFrame,WM_COMMAND,IDM_SCRIPT,0);
 while (GetMessage(&msg,NULL,0,0)){
   TranslateMessage(&msg);
   DispatchMessage(&msg);
 }
 DestroyWindow(glWnd);
 DestroyWindow(glWndFrame);
 UnregisterOpenGL(hInstance);
 //Ctl3dUnAutoSubclass();
 //Ctl3dUnregister(hInstance);
 return TRUE;
}

#endif

#if __DLL__

#if 0
void drawWire(HWND hWnd, int mode){
 HDC hDC;
 RECT rc;
 GetClientRect(hWnd,&rc);
 hDC=GetDC(hWnd);
 PatBlt(hDC,0,0,rc.right,rc.bottom,PATCOPY);
 DrawPerspectiveView(0,mode,hDC,hWnd,GetStockObject(BLACK_PEN));
 ReleaseDC(hWnd,hDC);
}
#endif

void drawWire(HWND hWnd, int mode){
 HDC hDC,hdc_view;
 HBITMAP hbm_view,hbmoldv;
 HBRUSH  hbrushold;
 RECT rc;
 GetClientRect(hWnd,&rc);
 hDC=GetDC(hWnd);
 hdc_view=CreateCompatibleDC(hDC);
 if(hdc_view == NULL)return;
 hbm_view=CreateCompatibleBitmap(hDC,rc.right,rc.bottom);
 if(hbm_view == NULL){
   DeleteDC(hdc_view);
   ReleaseDC(hWnd,hDC);
   return;
 }
 hbmoldv=SelectObject(hdc_view,hbm_view);
 hbrushold=SelectObject(hdc_view,GetStockObject(GRAY_BRUSH));
 PatBlt(hdc_view,0,0,rc.right,rc.bottom,PATCOPY);
 DrawPerspectiveView(0,mode,hdc_view,hWnd,GetStockObject(WHITE_PEN));
 BitBlt(hDC,0,0,rc.right,rc.bottom,hdc_view,0,0,SRCCOPY);
 SelectObject(hdc_view,hbrushold);
 SelectObject(hdc_view,hbmoldv);
 DeleteObject(hbm_view);
 DeleteDC(hdc_view);
 ReleaseDC(hWnd,hDC);
 return;
}

#endif
