/* MAKELIST.C   included in solid.c                           */
/* this file contains the code to make an OpenGL display list */

/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

void MakeFrameList(BOOL listit){
 GLfloat aspect,fov;
 int jitter,accsize;
 GLfloat p[4]={0.0,0.0,0.0,0.0};
 GLfloat zmin,zmax;
 if(fLightAttenuated){
   p[3]=1.0;
   glLightf(GL_LIGHT0,GL_LINEAR_ATTENUATION,
            0.000005/(GLfloat)LightAttenuation);
//            0.000003/(GLfloat)LightAttenuation);
 }
 else p[3]=0.0;

// This appears to cause a failure under windows 95
// glDeleteLists(2,2);  /* make the objects into a separate list */
// glNewList(2,GL_COMPILE);
// if(fflat)draw3dF();
// else     draw3dS();
// glEndList();

 if(listit){
   if(listID > 0)glDeleteLists(listID,listID);
   listID = -1;
 }
 zmin=5.0e3; zmax=5.0e7;
// GetDepthBufferRange(&zmin,&zmax);
// {char xx[256]; sprintf(xx,"%le %le",zmin,zmax);MessageBox(NULL,xx,NULL,MB_OK);}
 if(listit){
   listID=1;
   glNewList(listID,GL_COMPILE);
 }
 if(fantialiased){
   accsize=4;
   glClear(GL_ACCUM_BUFFER_BIT);
 }
 else accsize=1;
 for(jitter=0;jitter<accsize;jitter++){
   if(Nsky == 0)glClearColor(gbRed,gbGreen,gbBlue,1.0);
   else         glClearColor((GLfloat)Sky.Zenith[0]/255.0,
                             (GLfloat)Sky.Zenith[1]/255.0,
                             (GLfloat)Sky.Zenith[2]/255.0,1.0);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   if(Nsky > 0 && fmapped && Sky.type == BACKDROP)drawSky();
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   aspect = (GLfloat) oldrect.right / oldrect.bottom;
   fov=40.0/CamSx;
//   if(fantialiased)accPerspective(fov,aspect,3.0,FARAWAY,
//                   j4[jitter].x,j4[jitter].y,0.0,0.0,1.0);
//   else            gluPerspective(fov,aspect,3.0,FARAWAY);
   if(fantialiased)accPerspective(fov,aspect,zmin,zmax,
                   j4[jitter].x,j4[jitter].y,0.0,0.0,1.0);
   else            gluPerspective(fov,aspect,zmin,zmax);
   glMatrixMode( GL_MODELVIEW );
   if(fflat)glShadeModel(GL_FLAT);
   else     glShadeModel(GL_SMOOTH);
   glPushMatrix();
   glLoadIdentity();
   glRotatef(-CamTheta,0.0,0.0,1.0);
   glRotatef(-CamAlpha,1.0,0.0,0.0);
   glRotatef(-CamPhi,0.0,1.0,0.0);
   glTranslatef(-ViewPoint[0],-ViewPoint[2],ViewPoint[1]);
   glPushMatrix();
   if(Nlights > 0 && Lights != NULL){
     p[0] = Lights[0].p[0]; p[1] = Lights[0].p[2]; p[2] = -Lights[0].p[1];
   }
   else {
     p[0] = ViewPoint[0]; p[1] = ViewPoint[2]; p[2] = -ViewPoint[1];
   }
   glLightfv(GL_LIGHT0,GL_POSITION,p);
   glPopMatrix();
   glEnable(GL_LIGHTING);
   if(Nground > 0)drawGround();
//   glCallList(2);  /* play the objects list */
   if(fflat)draw3dF();
   else     draw3dS();
   glDisable(GL_LIGHTING);
   glPopMatrix();
   if(fantialiased)glAccum(GL_ACCUM,1.0/(GLfloat)accsize);
 }
 if(fantialiased)glAccum(GL_RETURN,1.0);
 if(listit)glEndList();
}

static void drawSky(void){
 int x,y;
 unsigned char *Image;
 if((Image=LoadMAP((char *)Sky.MapName,&x,&y)) == NULL)return;
 glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 glOrtho(0.0,1.0,0.0,1.0,-1.0,1.0);
 glMatrixMode( GL_MODELVIEW );
 glRasterPos2i(0,0);
 glPixelZoom((GLfloat)oldrect.right/(GLfloat)x,
             (GLfloat)oldrect.bottom/(GLfloat)y);
 glDrawPixels((GLsizei)x,(GLsizei)y,GL_RGB,GL_UNSIGNED_BYTE,(GLvoid *)Image);
 glFinish();
 glClear(GL_DEPTH_BUFFER_BIT);
 X__Free(Image);
}

#define GSCALE 100.0
#define HSCALE 100.0
//#define HSCALE 1.0

static void drawGround(void){
 GLfloat x,y,z,color[4];
 glPushMatrix();
 VECCOPY(Ground.pin,Ground.p)
 VECCOPY(Ground.xin,Ground.x)
 VECCOPY(Ground.yin,Ground.y)
 VECSUB(Ground.x,Ground.p,Ground.dx)
 VECSUB(Ground.y,Ground.p,Ground.dy)
 CROSS(Ground.dx,Ground.dy,Ground.n)
 normalise(Ground.n);
 if(fmapped &&
   (Ground.type == BRUM || Ground.type == TBRUM || Ground.type == MBRUM)){
   vector mP,mX,mY,mN,xyz;
   GLfloat alpha,beta;
   unsigned char *Image;
   int xm,ym;
   if((Image=LoadMAP(Ground.Map.filename,&xm,&ym)) != NULL)
     makeNextMap(Image,xm,ym);
   GetMapNormal(PLANE,Ground.Map.p,Ground.Map.x,Ground.Map.y,mP,mX,mY,mN);
   glScalef(HSCALE,1.0,HSCALE);
   glEnable(GL_TEXTURE_2D);
   glBegin(GL_TRIANGLE_FAN);
//   color[0]=(GLfloat)Ground.color[0]/255.0;
//   color[1]=(GLfloat)Ground.color[1]/255.0;
//   color[2]=(GLfloat)Ground.color[2]/255.0;
   color[0]=1.5; color[1]=1.5; color[2]=1.5;
   glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
   glNormal3f(Ground.n[0],Ground.n[2],-Ground.n[1]);
   x=y=0.0;
   z=(GLfloat)Ground.p[2];
   xyz[0]=x; xyz[1]=y; xyz[2]=z;
   GetMappingCoordP(mN,mX,mY,mP,xyz,&alpha,&beta);
   alpha *= HSCALE; beta *=HSCALE;
   glTexCoord2f(alpha,beta);  glVertex3f(x,z,-y);
   x =  (GLfloat)Ground.dy[0]; y =  (GLfloat)Ground.dy[1];
   xyz[0]=x; xyz[1]=y; xyz[2]=z;
   GetMappingCoordP(mN,mX,mY,mP,xyz,&alpha,&beta);
   alpha *= HSCALE; beta *=HSCALE;
   glTexCoord2f(alpha,beta);  glVertex3f(x,z,-y);
   x =  (GLfloat)Ground.dx[0]; y =  (GLfloat)Ground.dx[1];
   xyz[0]=x; xyz[1]=y; xyz[2]=z;
   GetMappingCoordP(mN,mX,mY,mP,xyz,&alpha,&beta);
   alpha *= HSCALE; beta *=HSCALE;
   glTexCoord2f(alpha,beta);  glVertex3f(x,z,-y);
   x = -(GLfloat)Ground.dy[0]; y = -(GLfloat)Ground.dy[1];
   xyz[0]=x; xyz[1]=y; xyz[2]=z;
   GetMappingCoordP(mN,mX,mY,mP,xyz,&alpha,&beta);
   alpha *= HSCALE; beta *=HSCALE;
   glTexCoord2f(alpha,beta);  glVertex3f(x,z,-y);
   x = -(GLfloat)Ground.dx[0]; y = -(GLfloat)Ground.dx[1];
   xyz[0]=x; xyz[1]=y; xyz[2]=z;
   GetMappingCoordP(mN,mX,mY,mP,xyz,&alpha,&beta);
   alpha *= HSCALE; beta *=HSCALE;
   glTexCoord2f(alpha,beta);  glVertex3f(x,z,-y);
   x =  (GLfloat)Ground.dy[0]; y =  (GLfloat)Ground.dy[1];
   xyz[0]=x; xyz[1]=y; xyz[2]=z;
   GetMappingCoordP(mN,mX,mY,mP,xyz,&alpha,&beta);
   alpha *= HSCALE; beta *=HSCALE;
   glTexCoord2f(alpha,beta);  glVertex3f(x,z,-y);
   glEnd();
   glDisable(GL_TEXTURE_2D);
 }
 else{
   glTranslatef( (GLfloat)Ground.p[0],
                 (GLfloat)Ground.p[2],
                -(GLfloat)Ground.p[1]);
   glScalef(GSCALE,1.0,GSCALE);
   glBegin(GL_TRIANGLE_FAN);
   color[0]=(GLfloat)Ground.color[0]/255.0;
   color[1]=(GLfloat)Ground.color[1]/255.0;
   color[2]=(GLfloat)Ground.color[2]/255.0;
   glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
   glNormal3f(Ground.n[0],Ground.n[2],-Ground.n[1]);
   x=y=z=0.0;
   glVertex3f(x,z,-y);
   x =  (GLfloat)Ground.dy[0]; y =  (GLfloat)Ground.dy[1];
   glVertex3f(x,z,-y);
   x =  (GLfloat)Ground.dx[0]; y =  (GLfloat)Ground.dx[1];
   glVertex3f(x,z,-y);
   x = -(GLfloat)Ground.dy[0]; y = -(GLfloat)Ground.dy[1];
   glVertex3f(x,z,-y);
   x = -(GLfloat)Ground.dx[0]; y = -(GLfloat)Ground.dx[1];
   glVertex3f(x,z,-y);
   x =  (GLfloat)Ground.dy[0]; y =  (GLfloat)Ground.dy[1];
   glVertex3f(x,z,-y);
   glEnd();
 }
 glPopMatrix();
}

static void drawOptimised(BOOL smooth,long Nvert, long Nface,
                          vertex *MainVp, face *MainFp){
 GLfloat x,y,z,n[3],color[4],*spec_color,
         glos_color[]={1.0,1.0,1.0,1.0},
         matt_color[]={0.0,0.0,0.0,0.0},
         shiny[]={100.0},dot;
 face *fp;
 vertex *v,*v1,*v2,*v0;
 normal *nv=NULL;
 int i,j,k,Vi,V[3],jf,jl,count=0;
 if(smooth){
   if((nv=(normal *)X__Malloc(sizeof(normal)*Nvert)) == NULL){
     MessageBox(NULL,"Memory Out",NULL,MB_OK); return;
   }
   for(i=0;i<Nvert;i++)nv[i][0]=nv[i][1]=nv[i][2]=0.0;
   fp=MainFp; for(i=0;i<Nface;i++){
     V[0]=fp->V[0]; V[1]=fp->V[1]; V[2]=fp->V[2];
     v0=(MainVp+V[0]); v1=(MainVp+V[1]); v2=(MainVp+V[2]);
     if(fp->texture >> 7 != 0 && Normalize(v0->p,v1->p,v2->p,n)){
       for(j=0;j<3;j++){
         dot=DOT(nv[V[j]],n);
         if(fabs(dot) < 1.e-10){
           VECCOPY(n,nv[V[j]])
         }
         else if(dot >  0.5){
           VECSUM(nv[V[j]],n,nv[V[j]])
           normalise(nv[V[j]]);
         }
         else if(dot < -0.5){
           VECSUB(nv[V[j]],n,nv[V[j]])
           normalise(nv[V[j]]);
         }
       }
     }
     fp++;
   }
 }
 color[3]=1.0;
 glBegin(GL_TRIANGLES);
 glMaterialfv(GL_FRONT_AND_BACK,GL_SHININESS,shiny);
 glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,glos_color);
 same_color(black);
 for(i=0;i<Nface;i++){ /* draw single faces */
   fp=(MainFp+i);
   if(fp->next == -1){
     v0=(MainVp+fp->V[0]);
     v1=(MainVp+fp->V[1]);
     v2=(MainVp+fp->V[2]);
     if((fp->texture & 0x1f ) !=  0x4){ /* glass */
       if(!same_color(fp->color)){
         color[0]=(GLfloat)fp->color[0]/255.0;
         color[1]=(GLfloat)fp->color[1]/255.0;
         color[2]=(GLfloat)fp->color[2]/255.0;
         if(Cmaterial)glColor4fv(color);
         else{
           glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
           if((fp->texture & 0x20) == 0x20)spec_color=glos_color;
           else                            spec_color=matt_color;
           glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec_color);
         }
       }
       if(Normalize(v0->p,v1->p,v2->p,n)){
         for(j=0;j<3;j++){
           Vi=fp->V[j]; v=(MainVp+Vi);
           x=(GLfloat)(v->p[0]);
           y=(GLfloat)(v->p[1]);
           z=(GLfloat)(v->p[2]);
           if(smooth && ((fp->texture >> 7) != 0)){ /* smoothed */
             dot=DOT(nv[Vi],n);
             if(fabs(dot) < 0.5)glNormal3f(n[0],n[2],-n[1]);
             else if(dot  < 0.0)glNormal3f(-nv[Vi][0],-nv[Vi][2], nv[Vi][1]);
             else               glNormal3f( nv[Vi][0], nv[Vi][2],-nv[Vi][1]);
           }
           else{/* not smoothed */
             glNormal3f( n[0], n[2],-n[1]);
           }
           glVertex3f(x,z,-y);    count++;
         }
       }
     }
   }
 }
 glEnd();
 glBegin(GL_QUADS);
 same_color(black);
 for(i=0;i<Nface;i++){ /* draw quads */
   fp=(MainFp+i);
   if(fp->start == 2){
     v0=(MainVp+fp->V[0]);
     v1=(MainVp+fp->V[1]);
     v2=(MainVp+fp->V[2]);
     if((fp->texture & 0x1f ) !=  0x4){ /* glass */
       if(!same_color(fp->color)){
         color[0]=(GLfloat)fp->color[0]/255.0;
         color[1]=(GLfloat)fp->color[1]/255.0;
         color[2]=(GLfloat)fp->color[2]/255.0;
         if(Cmaterial)glColor4fv(color);
         else{
           glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
           if((fp->texture & 0x20) == 0x20)spec_color=glos_color;
           else                            spec_color=matt_color;
           glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec_color);
         }
       }
       if(Normalize(v0->p,v1->p,v2->p,n)){
         int table[3]={1,0,2};
         for(j=0;j<3;j++){
           Vi=fp->V[table[j]]; v=(MainVp+Vi);
           x=(GLfloat)(v->p[0]);
           y=(GLfloat)(v->p[1]);
           z=(GLfloat)(v->p[2]);
           if(smooth && ((fp->texture >> 7) != 0)){ /* smoothed */
             dot=DOT(nv[Vi],n);
             if(fabs(dot) < 0.5)glNormal3f(-n[0],-n[2], n[1]);
             else if(dot  < 0.0)glNormal3f( nv[Vi][0], nv[Vi][2],-nv[Vi][1]);
             else               glNormal3f(-nv[Vi][0],-nv[Vi][2], nv[Vi][1]);
           }
           else{/* not smoothed */
             glNormal3f(-n[0],-n[2], n[1]);
           }
           glVertex3f(x,z,-y);       count++;
         }
         fp=(MainFp+fp->next);  /* 4th vertex */
         j=(int)(fp->vid);
         Vi=fp->V[j]; v=(MainVp+Vi);
         x=(GLfloat)(v->p[0]);
         y=(GLfloat)(v->p[1]);
         z=(GLfloat)(v->p[2]);
         glVertex3f(x,z,-y);
         count++;
       }
     }
   }
 }
 glEnd();
 same_color(black);
 for(i=0;i<Nface;i++){ /* draw strips */
   fp=(MainFp+i);
   if((fp->start == 1)){
     k=i;
     while(k >= 0){
       fp=(MainFp+k);
       v0=(MainVp+fp->V[0]);
       v1=(MainVp+fp->V[1]);
       v2=(MainVp+fp->V[2]);
       if(k == i){
         glBegin(GL_TRIANGLE_STRIP); jf=0; jl=3;
       }
       else{
         jf=(int)(fp->vid); jl=jf+1;
         if(jf < 0){MessageBeep(MB_OK); jf=jl=0;}
       }
       if(!same_color(fp->color)){
         color[0]=(GLfloat)fp->color[0]/255.0;
         color[1]=(GLfloat)fp->color[1]/255.0;
         color[2]=(GLfloat)fp->color[2]/255.0;
         if(Cmaterial)glColor4fv(color);
         else{
           glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
           if((fp->texture & 0x20) == 0x20)spec_color=glos_color;
           else                            spec_color=matt_color;
           glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec_color);
         }
       }
       if(Normalize(v0->p,v1->p,v2->p,n)){
         for(j=jf;j<jl;j++){
           Vi=fp->V[j]; v=(MainVp+Vi);
           x=(GLfloat)(v->p[0]);
           y=(GLfloat)(v->p[1]);
           z=(GLfloat)(v->p[2]);
           if(smooth && ((fp->texture >> 7) != 0)){ /* smoothed */
             dot=DOT(nv[Vi],n);
             if(fabs(dot) < 0.5)glNormal3f(n[0],n[2],-n[1]);
             else if(dot  < 0.0)glNormal3f(-nv[Vi][0],-nv[Vi][2], nv[Vi][1]);
             else               glNormal3f( nv[Vi][0], nv[Vi][2],-nv[Vi][1]);
           }
           else{/* not smoothed */
             glNormal3f( n[0], n[2],-n[1]);
           }
           glVertex3f(x,z,-y);     count++;
         }
       }
       k=fp->next;
       if(k < 0)glEnd();
     }
   }
 }
 if(nv != NULL)X__Free(nv);
 return;
}

static void draw3dF(void){
 int i,j,k,Nv,Nf,count=0;
 vertex *V,*v,*v0,*v1,*v2;
 face   *F;
 object *O;
 GLfloat x,y,z,n[3],color[4],*spec_color,
         glos_color[]={1.0,1.0,1.0,1.0},
         matt_color[]={0.0,0.0,0.0,0.0},
         shiny[]={100.0};
 color[3]=1.0;
 if(ObjectCount == 0 || (O=Object) == NULL)return;
 for(i=0;i<ObjectCount;i++){
   if((V=O[i].Vbase) != NULL && (Nv=O[i].NoVertices) > 0 &&
      (F=O[i].Fbase) != NULL && (Nf=O[i].NoFaces) > 0){
     glPushMatrix();
     glTranslatef(O[i].Offset[0],O[i].Offset[2],-O[i].Offset[1]);
     glRotatef(O[i].fi,0.0,1.0,0.0);
     glRotatef(O[i].alpha,1.0,0.0,0.0);
     glRotatef(O[i].theta,0.0,0.0,1.0);
     glScalef(O[i].sx,O[i].sz,O[i].sy);
     if(O[i].im > 0){
       if(O[i].im == 1)glRotatef((GLfloat)O[i].ima,0.0,1.0,0.0); //R_rotz
       if(O[i].im == 2)glRotatef((GLfloat)O[i].ima,1.0,0.0,0.0); //R_rotx
       if(O[i].im == 3)glRotatef((GLfloat)O[i].ima,0.0,0.0,1.0); //R_roty
     }
     glTranslatef(-(GLfloat)O[i].Origin[0],
                  -(GLfloat)O[i].Origin[2],
                   (GLfloat)O[i].Origin[1]);
     if(Cmaterial)glEnable(GL_COLOR_MATERIAL);
     if(0/*Optimised*/)drawOptimised(FALSE,Nv,Nf,V,F);
     else{
       glBegin(GL_TRIANGLES);
       same_color(black);
       glMaterialfv(GL_FRONT_AND_BACK,GL_SHININESS,shiny);
       for(j=0;j<Nf;j++,F++){
         if(!same_color(F->color)){
           color[0]=(GLfloat)F->color[0]/255.0;
           color[1]=(GLfloat)F->color[1]/255.0;
           color[2]=(GLfloat)F->color[2]/255.0;
           if(Cmaterial)glColor4fv(color);
           else{
             glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
             if((F->texture & 0x20) == 0x20)spec_color=glos_color;
             else                           spec_color=matt_color;
             glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec_color);
           }
         }
         v0=(V+(F->V[0]));
         v1=(V+(F->V[1]));
         v2=(V+(F->V[2]));
         if(Normalize(v0->p,v1->p,v2->p,n)){
           glNormal3f(n[0],n[2],-n[1]);
           for(k=0;k<3;k++){
             v=(V+F->V[k]);
             x=(GLfloat)v->p[0];
             y=(GLfloat)v->p[1];
             z=(GLfloat)v->p[2];
             glVertex3f(x,z,-y); count++;
           }
         }
       }
       glEnd();
     }
     if(Cmaterial)glDisable(GL_COLOR_MATERIAL);
     glPopMatrix();
   }
 }
}

static void GetDepthBufferRange(GLfloat *zmin, GLfloat *zmax){
 int i,j,k,Nv,Nf,count=0;
 vertex *V,*v;
 object *O;
 GLfloat x,y,z,m[16],zp,zx,zn;
 if(ObjectCount == 0 || (O=Object) == NULL)return;
 zx = -FARAWAY;
 zn = FARAWAY;
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();
 glPushMatrix();
 glRotatef(-CamTheta,0.0,0.0,1.0);
 glRotatef(-CamAlpha,1.0,0.0,0.0);
 glRotatef(-CamPhi,0.0,1.0,0.0);
 glTranslatef(-ViewPoint[0],-ViewPoint[2],ViewPoint[1]);
 for(i=0;i<ObjectCount;i++){
   if((V=O[i].Vbase) != NULL && (Nv=O[i].NoVertices) > 0){
     glPushMatrix();
     glTranslatef(O[i].Offset[0],O[i].Offset[2],-O[i].Offset[1]);
     glRotatef(O[i].fi,0.0,1.0,0.0);
     glRotatef(O[i].alpha,1.0,0.0,0.0);
     glRotatef(O[i].theta,0.0,0.0,1.0);
     glScalef(O[i].sx,O[i].sz,O[i].sy);
     if(O[i].im > 0){
       if(O[i].im == 1)glRotatef((GLfloat)O[i].ima,0.0,1.0,0.0); //R_rotz
       if(O[i].im == 2)glRotatef((GLfloat)O[i].ima,1.0,0.0,0.0); //R_rotx
       if(O[i].im == 3)glRotatef((GLfloat)O[i].ima,0.0,0.0,1.0); //R_roty
     }
     glTranslatef(-(GLfloat)O[i].Origin[0],
                  -(GLfloat)O[i].Origin[2],
                   (GLfloat)O[i].Origin[1]);
     glGetFloatv(GL_MODELVIEW_MATRIX,m);
#if 0
{
FILE *ff;
ff=fopen("f:xxx","w");
fprintf(ff,"%le %le %le %le\n",m[ 0],m[ 4],m[ 8],m[12]);
fprintf(ff,"%le %le %le %le\n",m[ 1],m[ 5],m[ 9],m[13]);
fprintf(ff,"%le %le %le %le\n",m[ 2],m[ 6],m[10],m[14]);
fprintf(ff,"%le %le %le %le\n",m[ 3],m[ 7],m[11],m[15]);
fclose(ff);
}
#endif
     for(j=0;j<Nv;j++){
       v=(V+j);
       x =  (GLfloat)v->p[0];
       z =  (GLfloat)v->p[1];
       y = -(GLfloat)v->p[2];
//       zp = (m[0]*x + m[4]*y + m[ 8]*z + m[12]);
//       zp = (m[1]*x + m[5]*y + m[ 9]*z + m[13]);
       zp = -(m[2]*x + m[6]*y + m[10]*z + m[14]);
       if(zp < zn)zn=zp;
       if(zp > zx)zx=zp;
     }
     glPopMatrix();
   }
 }
 glPopMatrix();
 zn = zn*(1.0 - 1.0/5.0);
 *zmin = max(zn,1024.0);
 zx = zx*(1.0 + 1.0/5.0);
 *zmax = max(*zmin,zx);
}

static void draw3dS(void){
 int i,j,l,Nv,Nf,Vi,Vl[3],count;
 vertex *V,*v,*v0,*v1,*v2;
 face   *F,*fp;
 object *O;
 GLfloat x,y,z,n[3],color[4],*spec_color,
         glos_color[]={1.0,1.0,1.0,1.0},
         matt_color[]={0.0,0.0,0.0,0.0},
         shiny[]={100.0},dot;
 normal *nv;
 if(ObjectCount == 0 || (O=Object) == NULL)return;
 for(i=0;i<ObjectCount;i++){
   count=0;
   if((V=O[i].Vbase) != NULL && (Nv=O[i].NoVertices) > 0 &&
      (F=O[i].Fbase) != NULL && (Nf=O[i].NoFaces) > 0){
     color[3]=1.0;
     glPushMatrix();
     glTranslatef(O[i].Offset[0],O[i].Offset[2],-O[i].Offset[1]);
     glRotatef(O[i].fi,0.0,1.0,0.0);
     glRotatef(O[i].alpha,1.0,0.0,0.0);
     glRotatef(O[i].theta,0.0,0.0,1.0);
     glScalef(O[i].sx,O[i].sz,O[i].sy);
     if(O[i].im > 0){
       if(O[i].im == 1)glRotatef((GLfloat)O[i].ima,0.0,1.0,0.0); //R_rotz
       if(O[i].im == 2)glRotatef((GLfloat)O[i].ima,1.0,0.0,0.0); //R_rotx
       if(O[i].im == 3)glRotatef((GLfloat)O[i].ima,0.0,0.0,1.0); //R_roty
     }
     glTranslatef(-(GLfloat)O[i].Origin[0],
                  -(GLfloat)O[i].Origin[2],
                   (GLfloat)O[i].Origin[1]);
     if(Cmaterial)glEnable(GL_COLOR_MATERIAL);
     if(Optimised)drawOptimised(TRUE,Nv,Nf,V,F);
     else{
       if((nv=(normal *)X__Malloc(sizeof(normal)*Nv)) == NULL){
         MessageBeep(MB_OK); return;
       }
       for(l=0;l<Nv;l++)nv[l][0]=nv[l][1]=nv[l][2]=0.0;
       fp=F; for(l=0;l<Nf;l++){
         Vl[0]=fp->V[0]; Vl[1]=fp->V[1]; Vl[2]=fp->V[2];
         v0=(V+Vl[0]); v1=(V+Vl[1]); v2=(V+Vl[2]);
         if(fp->texture >> 7 != 0 && Normalize(v0->p,v1->p,v2->p,n)){
           for(j=0;j<3;j++){
             dot=DOT(nv[Vl[j]],n);
             if(fabs(dot) < 1.e-10){
               VECCOPY(n,nv[Vl[j]])
             }
             else if(dot >  0.5){
               VECSUM(nv[Vl[j]],n,nv[Vl[j]])
               normalise(nv[Vl[j]]);
             }
             else if(dot < -0.5){
               VECSUB(nv[Vl[j]],n,nv[Vl[j]])
               normalise(nv[Vl[j]]);
             }
           }
         }
         fp++;
       }
       glBegin(GL_TRIANGLES);
       glMaterialfv(GL_FRONT_AND_BACK,GL_SHININESS,shiny);
       same_color(black);
       fp=F; for(l=0;l<Nf;l++,fp++){
         if(fmapped && ((fp->texture & 0x40) == 0x40))continue; /* mapped */
         v0=(V+fp->V[0]); v1=(V+fp->V[1]); v2=(V+fp->V[2]);
         if((fp->texture & 0x1f ) !=  0x4){ /* not glass */
           if(!same_color(fp->color)){
             color[0]=(GLfloat)fp->color[0]/255.0;
             color[1]=(GLfloat)fp->color[1]/255.0;
             color[2]=(GLfloat)fp->color[2]/255.0;
             if(Cmaterial)glColor4fv(color);
             else{
               glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
               if((fp->texture & 0x20) == 0x20)spec_color=glos_color;
               else                            spec_color=matt_color;
               glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec_color);
             }
           }
           if(Normalize(v0->p,v1->p,v2->p,n)){
             for(j=0;j<3;j++){
               Vi=fp->V[j]; v=(V+Vi);
               x=(GLfloat)v->p[0];
               y=(GLfloat)v->p[1];
               z=(GLfloat)v->p[2];
               if(fp->texture >> 7 != 0){ /* smoothed */
                 dot=DOT(nv[Vi],n);
                 if(fabs(dot) < 0.5)glNormal3f(n[0],n[2],-n[1]);
                 else if(dot  < 0.0)glNormal3f(-nv[Vi][0],-nv[Vi][2], nv[Vi][1]);
                 else               glNormal3f( nv[Vi][0], nv[Vi][2],-nv[Vi][1]);
               }   
               else{/* not smoothed */
                 glNormal3f( n[0], n[2],-n[1]);
               }
               glVertex3f(x,z,-y);          count++;
             }
           }
         }
       }
       glEnd();
       if(fmapped && Object[i].NoMaps > 0){
         BOOL refmap;
         int k,brushID;
         vector mN,mX,mY,mP;
         GLfloat alpha,beta;
         unsigned char *Image;
         int xm,ym;
         color[0]=1.5; color[1]=1.5; color[2]=1.5;
         if(Cmaterial)glColor4fv(color);
         else{
           glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
           glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,glos_color);
         }
         for(k=0;k<Object[i].NoMaps;k++){
           iMap *Map;
           Map=(Object[i].Mbase+k);
           if(Map->pp < 0 && Map->rp > 0)refmap=TRUE;
           else                          refmap=FALSE;
           if(Map->pixels == NULL){ /* no preloaded map */
             if(refmap)Image=LoadMAP(Map->frefl,&xm,&ym);
             else      Image=LoadMAP(Map->filename,&xm,&ym);
             if(Image != NULL)makeNextMap(Image,xm,ym);
           }
           else{ /* make map from preloaded and scaled image */
             MakeMapFromImage(Map->pixels,Map->ix,Map->iy);
           }
           if(refmap){
             glEnable(GL_TEXTURE_GEN_S);
             glEnable(GL_TEXTURE_GEN_T);
             color[0]=1.8; color[1]=1.8; color[2]=1.8;
             glColor4fv(color);
           }
           GetMapNormal(Map->map,Map->p,Map->x,Map->y,mP,mX,mY,mN);
           glEnable(GL_TEXTURE_2D);
           glBegin(GL_TRIANGLES);
           fp=F; for(l=0;l<Nf;l++,fp++){
             if((fp->texture & 0x40) != 0x40)continue; /* if not mapped */
             brushID=(int)(fp->MapID);
             if(brushID != k)continue;         /* skip if not this map */
             v0=(V+fp->V[0]); v1=(V+fp->V[1]); v2=(V+fp->V[2]);
             if(!same_color(fp->color)){
               color[0]=(GLfloat)fp->color[0]/255.0;
               color[1]=(GLfloat)fp->color[1]/255.0;
               color[2]=(GLfloat)fp->color[2]/255.0;
               if(Cmaterial)glColor4fv(color);
               else{
                 glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
                 if((fp->texture & 0x20) == 0x20)spec_color=glos_color;
                 else                            spec_color=matt_color;
                 glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec_color);
               }  
             }
             if(Normalize(v0->p,v1->p,v2->p,n)){
               for(j=0;j<3;j++){
                 Vi=fp->V[j]; v=(V+Vi);
                 x=(GLfloat)v->p[0];
                 y=(GLfloat)v->p[1];
                 z=(GLfloat)v->p[2];
                 if(fp->texture >> 7 != 0){ /* smoothed */
                   dot=DOT(nv[Vi],n);
                   if(fabs(dot) < 0.5)glNormal3f(n[0],n[2],-n[1]);
                   else if(dot  < 0.0)glNormal3f(-nv[Vi][0],-nv[Vi][2], nv[Vi][1]);
                   else               glNormal3f( nv[Vi][0], nv[Vi][2],-nv[Vi][1]);
                 }
                 else{/* not smoothed */
                   glNormal3f( n[0], n[2],-n[1]);
                 }
                 if(Map->map == MAP_BY_VERTEX){
                   alpha=(GLfloat)v->x;
                   beta=(GLfloat)v->y;
                 }
                 else{
                   if(Map->map == CYLINDER ||
                      Map->map == CYLINDER_MOZIAC)GetMappingCoordC
                         (mN,mX,mY,mP,Map->angle,v->p,&alpha,&beta);
                   else GetMappingCoordP(mN,mX,mY,mP,v->p,&alpha,&beta);
                 }
                 if(!refmap)glTexCoord2f(alpha,beta);
                 glVertex3f(x,z,-y);        count++;
               }
             }
           }
           glEnd();
           glDisable(GL_TEXTURE_2D);
           if(refmap){
             glDisable(GL_TEXTURE_GEN_S);
             glDisable(GL_TEXTURE_GEN_T);
           }
         }
       }
       X__Free(nv);
     }
     if(Cmaterial)glDisable(GL_COLOR_MATERIAL);
     glPopMatrix();
   }
 }
}
