# makefile

CC=

!IFDEF wc
CC = wcc386  -Zp4 -5s -j -bt=nt -DSTRICT -DWIN32 -D_WIN32 -D__WIN32__
!ELSE
CC= cl -c -D__WIN32__
!ENDIF

LIBSOURCES =  \
 ADLER32.C    COMPRESS.C   CRC32.C      DEFLATE.C    \
 GZIO.C       INFBLOCK.C   INFCODES.C   INFFAST.C    INFLATE.C \
 INFTREES.C   INFUTIL.C    TREES.C   \
 UNCOMPR.C    ZUTIL.C

SOURCES= $(LIBSOURCES)
# files included by source files
INCLUDES=
LIBOBJECTS= \
 ADLER32.obj    COMPRESS.obj   CRC32.obj      DEFLATE.obj  \
 GZIO.obj       INFBLOCK.obj   INFCODES.obj   INFFAST.obj    INFLATE.obj \
 INFTREES.obj   INFUTIL.obj    TREES.obj   \
 UNCOMPR.obj    ZUTIL.obj

!IFDEF wc
LIB = wlib
LIBFLAGS=
lib: $(LIBOBJECTS)
 $(LIB) ..\zlib_wc.lib   \
 -+ADLER32.obj    -+COMPRESS.obj   -+CRC32.obj      -+DEFLATE.obj    \
 -+GZIO.obj       -+INFBLOCK.obj   -+INFCODES.obj   -+INFFAST.obj    -+INFLATE.obj \
 -+INFTREES.obj   -+INFUTIL.obj    -+TREES.obj   \
 -+UNCOMPR.obj    -+ZUTIL.obj
!ELSE
LIB = lib
LIBFLAGS = /verbose /out:..\zlib_ms.lib
lib: $(LIBOBJECTS)
 $(LIB) $(LIBFLAGS) $(LIBOBJECTS)
!ENDIF

ADLER32.obj: adler32.c
 $(CC) ADLER32.c
COMPRESS.obj: compress.c
 $(CC) compress.c
CRC32.obj: crc32.c
 $(CC) crc32.c
DEFLATE.obj: deflate.c
 $(CC) deflate.c
GZIO.obj: gzio.c
 $(CC) gzio.c
INFBLOCK.obj: infblock.c
 $(CC) infblock.c
INFCODES.obj: infcodes.c
 $(CC) infcodes.c
INFFAST.obj: inffast.c
 $(CC) inffast.c
INFLATE.obj: inflate.c
 $(CC) inflate.c
INFTREES.obj: inftrees.c
 $(CC) inftrees.c
INFUTIL.obj: infutil.c
 $(CC) infutil.c
TREES.obj: trees.c
 $(CC) trees.c
UNCOMPR.obj: uncompr.c
 $(CC) uncompr.c
ZUTIL.obj: zutil.c
 $(CC) zutil.c


