/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

#include <stdlib.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <windows.h>
#include <time.h>
#include "struct.h"           /* general structures    */
#include "ximage.h"           /* XIMAGE structure      */
#include "local.h"

#include "snow.h"


#if __X__MIPS__
BOOL WINAPI _CRT_INIT(HINSTANCE ,DWORD , LPVOID );
#endif

static HINSTANCE hDLLinstance=NULL; /* use to pick up resources from DLL   */

/************************** Local Utility Functions ***********************/

#include "utils.h"
#include "paint.c"

/************************** DLL entry point ********************************/

#if __WATCOMC__
int APIENTRY LibMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#elif __BC__
BOOL WINAPI DllEntryPoint(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#else
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#endif
  switch (dwReason) {
    case DLL_PROCESS_ATTACH:
#if __X__MIPS__
      if(!_CRT_INIT(hDLL,dwReason,lpReserved))return(int)FALSE;
#endif
//MessageBox(NULL,"Attaching",NULL,MB_OK);
      hDLLinstance = hDLL;  /* handle to DLL file */
      break;
    case DLL_PROCESS_DETACH:
#if __X__MIPS__
      if(!_CRT_INIT(hDLL,dwReason,lpReserved))return(int)FALSE;
#endif
//MessageBox(NULL,"Detaching",NULL,MB_OK);
      break;
  }
return (int)TRUE;
}

#if __SC__
#pragma startaddress(DllMain)
#endif

/*******************************************************************\
|                Code that executes the process                     |
\*******************************************************************/

long _RenderImageProcess(char *PrmList, XIMAGE *lpXimage){

 long i,j, np, inp; 
 long direct;
 int prob, speed;
 char dummy[255];
 fullscreenbuffer *S;
 /* read the parameters from the parameter list */
 sscanf(PrmList,"%s %d %d %d",dummy, &prob, &direct, &speed);
 /* set local pointer to start of screen buffer */
 S=lpXimage->Screen;
 srand(1109);
 np=(long)(((double)prob/2000.0)*((double)(lpXimage->Xmax)*(double)(lpXimage->Ymax)));
 
  for (inp=0;inp<np/3;inp++){
    i=((lpXimage->Xmax-1)*(rand()))/RAND_MAX+1;
    j=((lpXimage->Ymax-1)*(rand()))/RAND_MAX+1;
    j=j+((lpXimage->this_frame)*speed);
    i=i+((lpXimage->this_frame)*direct);
    while (j>=lpXimage->Ymax){
      j=j-lpXimage->Ymax;
    }
    while (i>=lpXimage->Xmax){
      i=i-lpXimage->Xmax;
    }
    while (i<0){
      i=i+lpXimage->Xmax;
    }
    (S+(j*(lpXimage->Xmax))+i)->R=200;
    (S+(j*(lpXimage->Xmax))+i)->G=200;
    (S+(j*(lpXimage->Xmax))+i)->B=200;

    if (i>0 && i<lpXimage->Xmax && j>0 && j<lpXimage->Ymax-1){
      (S+(j*(lpXimage->Xmax))+i+1)->R=255;
      (S+(j*(lpXimage->Xmax))+i+1)->G=255;
      (S+(j*(lpXimage->Xmax))+i+1)->B=255;
      (S+(j*(lpXimage->Xmax))+i-1)->R=255;
      (S+(j*(lpXimage->Xmax))+i-1)->G=255;
      (S+(j*(lpXimage->Xmax))+i-1)->B=255;
      (S+((j+1)*(lpXimage->Xmax))+i)->R=255;
      (S+((j+1)*(lpXimage->Xmax))+i)->G=255;
      (S+((j+1)*(lpXimage->Xmax))+i)->B=255;
      (S+((j-1)*(lpXimage->Xmax))+i)->R=255;
      (S+((j-1)*(lpXimage->Xmax))+i)->G=255;
      (S+((j-1)*(lpXimage->Xmax))+i)->B=255;
    }

   

  }
  for (inp=0;inp<np/3;inp++){
    i=((lpXimage->Xmax-1)*(rand()))/RAND_MAX+1;
    j=((lpXimage->Ymax-1)*(rand()))/RAND_MAX+1;
    j=j+((lpXimage->this_frame)*(speed+1));
    i=i+((lpXimage->this_frame)*direct);
    while (j>=lpXimage->Ymax){
      j=j-lpXimage->Ymax;
    }
    while (i>=lpXimage->Xmax){
      i=i-lpXimage->Xmax;
    }
    while (i<0){
      i=i+lpXimage->Xmax;
    }
    (S+(j*(lpXimage->Xmax))+i)->R=255;
    (S+(j*(lpXimage->Xmax))+i)->G=255;
    (S+(j*(lpXimage->Xmax))+i)->B=255;
   }


  for (inp=0;inp<np/3;inp++){
    i=((lpXimage->Xmax-1)*(rand()))/RAND_MAX+1;
    j=((lpXimage->Ymax-1)*(rand()))/RAND_MAX+1;
    j=j+((lpXimage->this_frame)*(speed-1));
    i=i+((lpXimage->this_frame)*direct);
    while (j>=lpXimage->Ymax){
      j=j-lpXimage->Ymax;
    }
    while (i>=lpXimage->Xmax){
      i=i-lpXimage->Xmax;
    }
    while (i<0){
      i=i+lpXimage->Xmax;
    }
    (S+(j*(lpXimage->Xmax))+i)->R=255;
    (S+(j*(lpXimage->Xmax))+i)->G=255;
    (S+(j*(lpXimage->Xmax))+i)->B=255;
   }

 return 1;          /* all done OK                           */
}



/*************** Functions used for set up  ***************/


/* local variable for communication between dialog box and Setup function */
int prob=30;
long angle=0;
int speed=2;


/* Dialog box callback prototype */
BOOL CALLBACK DlgProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam);

char * _SetExternalParameters(
  char *Op,                 /* string for the parameters                  */
  HWND hWnd,                /* parent window                              */
  long ruler,               /* ruler scale value to facilitate scaling    */
  char *name,               /* name of DLL file with the effect           */
  X__MEMORY_MANAGER *lpEVI /* pointer to structure with memory functions */
                                    ){
 /* output buffer should be as long as necessary to hold full string        */
 char buffer[256];
 if(Op != NULL){  /* parameters exist so read them off the list */
   sscanf(Op,"%s %d %d %d",buffer, &prob, &angle, &speed);
 }
 /*   Do the user interface as required to set up the effect, may use a     */
 /*   dialog box etc. Return old string if effect is cancelled (no change)  */
 if(DialogBox(hDLLinstance,MAKEINTRESOURCE(DLG_SNOW1),hWnd,
              (DLGPROC)DlgProc) == FALSE)return Op;
 /* Free space occupied by old parameter string */
 if(Op != NULL)CALL_FREE(Op);  /* free the old string */
 /* print the parameters into the buffer */
 sprintf(buffer,"%s %d %d %d",name, prob, angle, speed);
 /* Prepare the output buffer to take copy of parameter list */
 if((Op=(char *)CALL_MALLOC(strlen(buffer)+1)) == NULL){
  MessageBox (GetFocus(),"External effect: Out of memory","Error",
                MB_OK|MB_TASKMODAL|MB_ICONSTOP);
   return NULL;
 }
 /* Copy the parameter string to the output buffer */
 strcpy(Op,buffer);
 return Op;
}

BOOL CALLBACK DlgProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam){
 char str[32];
 switch( msg ) {
   case WM_INITDIALOG:
     /* prime dialog box controls          */
     sprintf(str,"%d",prob);
     SetDlgItemText(hwnd,DLG_PROB,str);
     sprintf(str,"%d",angle);
     SetDlgItemText(hwnd,DLG_ANGLE,str);
     sprintf(str,"%d",speed);
     SetDlgItemText(hwnd,DLG_SPEED,str);
     CentreDialogOnScreen(hwnd);
     return TRUE;
   case WM_PAINT:
     PaintBackground(hwnd);
     break;
     return TRUE;
   case WM_COMMAND:
     switch(LOWORD(wparam)){
        case IDCANCEL:    /* user clicked cancel                            */
          EndDialog(hwnd,FALSE);
          return(TRUE);
        case IDOK:        /* OK so get numbers from the Dailog Box controls */
          if(GetDlgItemText(hwnd,DLG_PROB,str,12) != 0)
            sscanf(str,"%d",&prob);
      if(GetDlgItemText(hwnd,DLG_ANGLE,str,12) != 0)
            sscanf(str,"%d",&angle);
      if(GetDlgItemText(hwnd,DLG_SPEED,str,12) != 0)
            sscanf(str,"%d",&speed);
      if (speed<2){
        MessageBox(NULL,"The speed value must be greater than 1.",NULL,MB_OK);
      }
      else EndDialog(hwnd,TRUE);
      return(TRUE);
        default:
          break;
      }
      break;
    default: break;
 }
 return FALSE;
}

