/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file STRUCT.H */

/* always include this in any PostProcessor code                     */


#define double float    /* The Renderer uses FLOAT real numbers */

#if __ZTC__ || __SC__
#ifndef max
#define max(a,b)  ( ((a) > (b)) ? (a) : (b) )
#endif
#endif

#ifndef PI
#define PI 3.1415926
#endif

/* for Windows NT use LocalMemory else use standard C library */

#ifdef __X__NT__
#define X__Malloc(s)    LocalAlloc(LMEM_FIXED,s)
#define X__Free(p)      LocalFree((HLOCAL)p)
#define X__Realloc(p,s) LocalReAlloc((HLOCAL)p,s,LMEM_MOVEABLE)
#else
#define X__Malloc(s)    GlobalAlloc(GMEM_FIXED,s)
#define X__Free(p)      GlobalFree((HGLOBAL)p)
#define X__Realloc(p,s) GlobalReAlloc((HGLOBAL)p,s,GMEM_MOVEABLE)
#endif

typedef double vector[3];

typedef struct SCREENBUFFER {
 unsigned char A,  /* Alpha channel (not available yet) */
               R,  /* red value  range - 255            */
               G,  /* green value  range - 255          */
               B;  /* blue value  range - 255           */
} fullscreenbuffer;

typedef struct {
        vector pin;/* original light position before transform        */
        vector p,  /* p is the position of the light, it has been     */
                   /*   transformed for the camera position and       */
                   /*    direction and may be used as is!             */
               d;  /* d is normalized dirn. for spots                 */
        double dot1,                  /* not useful for image process */
               falloff,
               dPhi,
               dTheta,
               dAlpha,
               cone1,
               cone2,
               dot2,
               internal_size,
               scale;
        short type,AnimatorID;
        float *shadow_buffer;
        double shadow_transform[4][4];
        unsigned char color[3],internal_type,*object_buffer;
        unsigned short *face_buffer;
        double Ire,Igr,Ibl,Intensity; /* normalized light intensities */
        BOOL   dc;                    /* depth cue - default FALSE */
        double dc_c,da_l,dc_q;        /* depth cue - parameters    */
        float *atmospheric_shadow_buffer;
} light;

#define NORMAL    0    /* light types */
#define NOSHADOW  1
#define SHADOWS   2
#define SPOTLIGHT 3
#define DUMMYL    4
