/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* UTILS.H  utility functions for image processing external processes */

extern long GetActorsID(void *, HWND);
extern char *GetActorsName(void *, long);
extern BOOL XimageFileName(void *, char *, char *, char *, char *, HWND);
extern void CentreDialogOnScreen(HWND hwnd);

#define FARAWAY 1.0e30

void TransformIntoView(
  double t4[4][4],              /* viewing transform as passed to process */
  double x, double y, double z, /* input co-ordinates (world)             */
  double *xx,                   /* output co-ords, relative to camera     */
  double *yy,                   /* camera is located at (0,0,0)           */
  double *zz                    /* and points in (0,1,0) ie. forwards     */
){
   *xx=t4[0][0]*x+t4[0][1]*y+t4[0][2]*z+t4[0][3];
   *yy=t4[1][0]*x+t4[1][1]*y+t4[1][2]*z+t4[1][3];
   *zz=t4[2][0]*x+t4[2][1]*y+t4[2][2]*z+t4[2][3];
 return;
}

