/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file xutils.c  */

#include <windows.h>

#include "..\animate\astruct.h"
#include "..\animate\dstruct.h"

void CentreDialogOnScreen(HWND hwnd){
 RECT rcDlg;
 long Xres,Yres;
 Yres=GetSystemMetrics(SM_CYSCREEN);
 Xres=GetSystemMetrics(SM_CXSCREEN);
 GetWindowRect(hwnd,&rcDlg);
 OffsetRect(&rcDlg,-rcDlg.left,-rcDlg.top);
 OffsetRect(&rcDlg,(Xres-rcDlg.right)/2,(Yres-rcDlg.bottom)/2);
 SetWindowPos(hwnd,HWND_TOP,rcDlg.left,rcDlg.top,0,0,SWP_NOSIZE);
 return;
}

long GetActorsID(void *lpevi, HWND parent){
 if(lpevi == NULL){
   MessageBox(parent,"Cannot Assign Actor",NULL,MB_OK);
   return -1;
 }
 lpEVI=(ANI_STRUCTURE *)lpevi;
 return SelectNodeID(parent);
}

char *GetActorsName(void *lpevi, long id){
 node *Np;
 if(lpevi == NULL)return NULL;
 lpEVI=(ANI_STRUCTURE *)lpevi;
 Np=MainNp; while(Np != NULL){
   if(Np->ID == id)return Np->actorname;
   Np=Np->last;
 }
 return NULL;
}

BOOL XimageFileName(void *lpevi, char *f_name, char *direct, char *title,
                   char *filter, HWND parent){
 char f_dir[256];
 lpEVI=(ANI_STRUCTURE *)lpevi;
 strcpy(f_dir,gszHomeDir); strcat(f_dir,direct);
 return SelectFileName(0,f_name,f_dir,title,filter,parent);
}
