/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* MODEL1.C                */

#include <math.h>
#include <windows.h>

#include "example1.h"

#if __ZTC__ || __SC__
#ifndef max
#define max(a,b)  ( ((a) > (b)) ? (a) : (b) )
#endif
#endif

#if __X__MIPS__
BOOL WINAPI _CRT_INIT(HINSTANCE ,DWORD , LPVOID );
#endif

static HINSTANCE hDLLinstance=NULL; /* use to pick up resources from DLL   */

#include "..\animate\astruct.h"
#include "..\animate\dstruct.h"


#if __WATCOMC__
int APIENTRY LibMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#else
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#endif
  switch (dwReason) {
    case DLL_PROCESS_ATTACH:
#if __X__MIPS__
      if(!_CRT_INIT(hDLL,dwReason,lpReserved))return(int)FALSE;
#endif
      hDLLinstance = hDLL;  /* handle to DLL file */
      break;
    case DLL_PROCESS_DETACH:
#if __X__MIPS__
      if(!_CRT_INIT(hDLL,dwReason,lpReserved))return(int)FALSE;
#endif
      break;
  }
return (int)TRUE;
}

#if __SC__
#pragma startaddress(LibMain)
#endif


BOOL _ExternalPreset(HWND parent, ANI_STRUCTURE *lpevi){
 object   *Op;
 position *Pp;
 char f_name[255],f_dir[255];
 lpEVI=lpevi;
 MessageBox(parent,"Example1 External Script","Debug",MB_OK);
 SetNumberOfFrames(60);
 /* add Camera position channel and move the camera - Camera always present */
 if(CreatePosition(FirstNp,1,(short)Nframes) == NULL)return FALSE;
 FirstNp->fpos->finish[0]=TVpointX+TVsizeX*2;
 FirstNp->fpos->finish[1]=TVpointY+TVsizeY*2;
 FirstNp->fpos->finish[2]=TVpointZ+TVsizeZ*2;
 /* create a Target Actor and Costume default at (0,0,0) */
 if(CreateNode() == NULL)return FALSE;
 strcpy(MainNp->actorname,"Target");
 MainNp->type=TARGET;
 if((Op=CreateActor(MainNp,1,(short)Nframes)) == NULL)return FALSE;
 Op->type=MainNp->type;
 /* Now point the Camera to Look at the target */
 if(CreateAlign(FirstNp,1,(short)Nframes) == NULL)return FALSE;
 FirstNp->fali->type=TRACK; FirstNp->fali->topath=MainNp;
 /* Now load a light actor */
 if(CreateNode() == NULL)return FALSE;
 strcpy(MainNp->actorname,"Light");
 MainNp->type=LIGHT;
 if((Op=CreateActor(MainNp,1,Nframes)) == NULL)return FALSE;
 Op->type=MainNp->type;
 Op->lighttype=SPHERE; Op->colour[0]=Op->colour[1]=Op->colour[2]=255;
 /* Position Channel for Light */
 if((Pp=CreatePosition(MainNp,1,(short)Nframes)) == NULL)return FALSE;
 Pp->finish[0]=FirstNp->fpos->finish[0]+TVsizeX/2;
 Pp->finish[1]=FirstNp->fpos->finish[1]+TVsizeY;
 Pp->finish[2]=FirstNp->fpos->finish[2]+TVsizeZ*2;
 /* Add Actor with Chosen Model for Costume */
 if(CreateNode() == NULL)return FALSE;
 strcpy(MainNp->actorname,"Actor");
 MainNp->type=NORMAL;
 if((Op=CreateActor(MainNp,1,(short)Nframes)) == NULL)return FALSE;
 Op->type=MainNp->type;
 strcpy(f_dir,gszHomeDir); strcat(f_dir,"objects"); strcpy(f_name,"*.sce");
 if(SelectFileName(0,f_name,f_dir,"Choose Actor's Costume",
                   "(*.SCE)|*.sce|",parent) == TRUE){
   strcpy(Op->name,f_name);
   Op->morph=NO;
   if(StageLoadObject(f_name,Op,YES,YES,NO) == FAIL)DeleteActor(MainNp,1);
 }
 else return FALSE;

 return TRUE;
}
