/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* stereov.c                */

#include <math.h>
#include <windows.h>
#include <stdio.h>
#include "stereov.h"
#include "..\postprocess\utils.h"

#if __ZTC__ || __SC__
#ifndef max
#define max(a,b)  ( ((a) > (b)) ? (a) : (b) )
#endif
#endif

#if __X__MIPS__
BOOL WINAPI _CRT_INIT(HINSTANCE ,DWORD , LPVOID );
#endif

static HINSTANCE hDLLinstance=NULL; /* use to pick up resources from DLL   */
static BOOL CALLBACK Instr(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);

#include "..\animate\astruct.h"
#include "..\animate\dstruct.h"


#if __WATCOMC__
int APIENTRY LibMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#else
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#endif
  switch (dwReason) {
    case DLL_PROCESS_ATTACH:
#if __X__MIPS__
      if(!_CRT_INIT(hDLL,dwReason,lpReserved))return(int)FALSE;
#endif
      hDLLinstance = hDLL;  /* handle to DLL file */
      break;
    case DLL_PROCESS_DETACH:
#if __X__MIPS__
      if(!_CRT_INIT(hDLL,dwReason,lpReserved))return(int)FALSE;
#endif
      break;
  }
return (int)TRUE;
}

#if __SC__
#pragma startaddress(LibMain)
#endif


int sep=5;

static BOOL CALLBACK Instr(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam){
 
 int i;
 char str[255];
 BOOL err;
 switch( msg ) {
   case WM_INITDIALOG:
	 sprintf(str,"%d",sep);
     SetDlgItemText(hwnd,IDC_EDIT1,str);
     CentreDialogOnScreen(hwnd);
	 return TRUE;
   case WM_COMMAND:
     switch(LOWORD(wparam)){
       case IDOK:
         if(GetDlgItemText(hwnd,IDC_EDIT1,str,12) != 0)
           sscanf(str,"%d",&sep);
		 if(sep>10)
			 sep=10;
		 EndDialog(hwnd,TRUE);
       return(TRUE);
         default:
           break;
       }
           break;
   default: break;
 }
 return(FALSE);
}







BOOL _ExternalPreset(HWND parent, ANI_STRUCTURE *lpevi){
 node *TargetPointer1,*TargetPointer2,*LeftCamera,*RightCamera,*Light1,*Ground1;
 object   *Op,*Model1;
 position *Pp;
 sky      *Sp;
 int i,np,ne;
 long xmax,xmin,ymax,ymin,zmax,zmin,xsize,ysize,zsize,x,y,z,separation,alpha,maxsize,dist;
 char strsize[255],strp[255],strnp[255],strne[255],strmaxsize[255],strdist[255],strmin[255],strorig[255],strx[255]="x coords",stry[255]="y coords",strz[255]="z coords";
 point *p;
 char f_name[255],f_dir[255];
 FILE *fp1,*fp2;
 lpEVI=lpevi;
 //MessageBox(parent,"Stereov External Script","Debug",MB_OK);
 DialogBox(hDLLinstance,MAKEINTRESOURCE(IDD_DIALOG1),GetFocus(),(DLGPROC)Instr);
 SetNumberOfFrames(60);
 alpha=2.35585;
 

 /* Add Camera position channel - Camera always present */
 if(CreatePosition(FirstNp,1,(short)Nframes) == NULL)return FALSE;
 strcpy(FirstNp->actorname,"Right Camera");
 RightCamera=FirstNp;


 /* Create a Target Actor and Costume and Position Channels */
 if(CreateNode() == NULL)return FALSE;
 strcpy(MainNp->actorname,"Right Target");
 MainNp->type=TARGET;
 if((Op=CreateActor(MainNp,1,(short)Nframes)) == NULL)return FALSE;
 Op->type=MainNp->type;
 if(CreatePosition(MainNp,1,(short)Nframes) == NULL)return FALSE;
 TargetPointer2=MainNp;

 
 /* Create a Second Target Actor and Costume and Position Channels */
 if(CreateNode() == NULL)return FALSE;
 strcpy(MainNp->actorname,"Left Target");
 MainNp->type=TARGET;
 if((Op=CreateActor(MainNp,1,(short)Nframes)) == NULL)return FALSE;
 Op->type=MainNp->type;
 if(CreatePosition(MainNp,1,(short)Nframes) == NULL)return FALSE;
 TargetPointer1=MainNp;


 /* Now point the Camera to Look at the target */
 if(CreateAlign(FirstNp,1,(short)Nframes) == NULL)return FALSE;
 FirstNp->fali->type=TRACK; FirstNp->fali->topath=TargetPointer2;
 
 
 /* Adding the second camera */
 if(CreateNode() == NULL)return FALSE;
 strcpy(MainNp->actorname,"Left Camera");
 MainNp->type=CAMERA;
 (*(lpEVI->Ncameras))=2;

 if((Op=CreateActor(MainNp,1,Nframes)) == NULL)return FALSE;
 Op->type=MainNp->type;


 /* Position Channel for the Second Camera */
 if(CreatePosition(MainNp,1,(short)Nframes) == NULL)return FALSE;
 LeftCamera=MainNp;
 
 
 /* Now point the Second Camera to Look at the target */
 
 if(CreateAlign(MainNp,1,(short)Nframes) == NULL)return FALSE;
 MainNp->fali->type=TRACK; MainNp->fali->topath=TargetPointer1;
 
 
 /* Now load a light actor */
 if(CreateNode() == NULL)return FALSE;
 strcpy(MainNp->actorname,"Light");
 MainNp->type=LIGHT;
 if((Op=CreateActor(MainNp,1,Nframes)) == NULL)return FALSE;
 Op->type=MainNp->type;
 Op->lighttype=SPHERE; Op->colour[0]=Op->colour[1]=Op->colour[2]=255;
 
 
 /* Position Channel for Light */
 if((Pp=CreatePosition(MainNp,1,(short)Nframes)) == NULL)return FALSE;
 Light1=MainNp;
 
 
 /* Now load a sky for a background */
 if(CreateNode() == NULL)return FALSE;
 strcpy(MainNp->actorname,"Sky");
 MainNp->type=SKY;
 if((Sp=CreateSky(MainNp,1,Nframes)) == NULL)return FALSE;
 Sp->type=SKYCOLOURED;
 Sp->zcolour[0]=0; Sp->zcolour[1]=0; Sp->zcolour[2]=0;

 /* Now load a ground */
 if(CreateNode() == NULL)return FALSE;
 strcpy(MainNp->actorname,"Ground");
 MainNp->type=GROUND;
 (*(lpEVI->Nground))=1;
 Ground1=MainNp;
 if((Op=CreateActor(MainNp,1,Nframes)) == NULL)return FALSE;
 Op->type=MainNp->type;
 Op->groundtype=PLAIN;
 Op->colour[0]=255; Op->colour[1]=255; Op->colour[2]=255;
 Op->acolour[0]=0; Op->acolour[1]=0; Op->acolour[2]=0;
 if(CreatePosition(MainNp,1,(short)Nframes) == NULL)return FALSE;

 /* Add Actor with Chosen Model for Costume */
 if(CreateNode() == NULL)return FALSE;
 strcpy(MainNp->actorname,"Actor");
 MainNp->type=NORMAL;
 if((Op=CreateActor(MainNp,1,(short)Nframes)) == NULL)return FALSE;
 Op->type=MainNp->type;
 Model1=Op;
 strcpy(f_dir,gszHomeDir); strcat(f_dir,"objects"); strcpy(f_name,"*.mfx");
 if(SelectFileName(0,f_name,f_dir,"Choose Actor's Costume",
                   "(*.MFX)|*.mfx|",parent) == TRUE){
   strcpy(Op->name,f_name);
   Op->morph=NO;
   if(StageLoadObject(f_name,Op,YES,YES,NO) == FAIL)DeleteActor(MainNp,1);
 }
 else return FALSE;


 /*Add a position channel for the object */
 if(CreatePosition(MainNp,1,(short)Nframes) == NULL)return FALSE;
 MainNp->fpos->finish[0]=0;
 MainNp->fpos->finish[1]=0;
 MainNp->fpos->finish[2]=0;


 /*Add rotation channel to object */
 if(CreateAlign(MainNp,1,(short)Nframes) == NULL)return FALSE;
 MainNp->fali->type=TWEEN;MainNp->fali->im=1;MainNp->fali->ima=1.0;
 
 
 /* Additions to the main program to print the size of the object */
 if(Op == NULL) {MessageBox(NULL,"Bad Op","No Object Loaded",MB_OK); return FALSE;}
 p=Op->points;
 if(p == NULL) {MessageBox(NULL,"Bad p","No Points Available",MB_OK); return FALSE;}
 sprintf(strp,"%ld",p);
 //MessageBox(NULL,strp,"Points",MB_OK);
 np=Op->npoints;
 sprintf(strnp,"%ld",np);
 //MessageBox(NULL,strnp,"Number of Vertices",MB_OK);
 ne=Op->nedges;
 sprintf(strne,"%ld",ne);
 //MessageBox(NULL,strne,"Number of Edges",MB_OK);
 xmax=-MAXUNIT;
 xmin=MAXUNIT;
 ymax=-MAXUNIT;
 ymin=MAXUNIT;
 zmax=-MAXUNIT;
 zmin=MAXUNIT;


 for(i=0;i<np;i++) {
	 x=p[i][0];
	 y=p[i][1];
	 z=p[i][2];
	 if(x>xmax) xmax=x;
	 if(x<xmin) xmin=x;
	 if(y>ymax) ymax=y;
	 if(y<ymin) ymin=y;
     if(z>zmax) zmax=z;
	 if(z<zmin) zmin=z;
 }

 sprintf(strmin,"%ld %ld %ld %ld %ld %ld",xmin,xmax,ymin,ymax,zmin,zmax);
 //MessageBox(NULL,strmin,"Mins and Maxs",MB_OK);
 
 xsize=xmax-xmin;
 ysize=ymax-ymin;
 zsize=zmax-zmin;
 sprintf(strsize,"%ld %ld %ld",xsize,ysize,zsize);
 //MessageBox(NULL,strsize,"Object Size - x,y,z",MB_OK);
 

 /* Positioning the cameras relative to the object */
 if(xsize>ysize)
	 maxsize=xsize;
 else {
	 maxsize=ysize;
 }

 if(zsize>maxsize) maxsize=zsize;
 
 dist=maxsize*alpha;
 separation=dist/(125-(sep*10));

 sprintf(strmaxsize,"%ld",maxsize);
 //MessageBox(NULL,strmaxsize,"Max size",MB_OK);

 sprintf(strdist,"%ld",dist);
 //MessageBox(NULL,strdist,"Distance to Object",MB_OK);
 
 LeftCamera->fpos->finish[0]=(separation/2);
 LeftCamera->fpos->finish[1]=dist;
 LeftCamera->fpos->finish[2]=0;
 
 RightCamera->fpos->finish[0]=-(separation/2);
 RightCamera->fpos->finish[1]=dist;
 RightCamera->fpos->finish[2]=0;

 
 /* Positioning the light relative to the camera */
 Light1->fpos->finish[0]=LeftCamera->fpos->finish[0]+TVsizeX/2;
 Light1->fpos->finish[1]=LeftCamera->fpos->finish[1]+TVsizeY;
 Light1->fpos->finish[2]=LeftCamera->fpos->finish[2]+TVsizeZ*2;
 
 
 /*Debugging*/
 fp1=fopen("Debug1.txt","w");
 fprintf(fp1,"%s  %s  %s\n",strx,stry,strz);
 for(i=0;i<np;i++) {
	 fprintf(fp1,"%ld     ",p[i][0]);
     fprintf(fp1,"%ld     ",p[i][1]);
     fprintf(fp1,"%ld\n",p[i][2]);
 }
 fclose(fp1);

 /*Trying to reposition the object */
 /*for(i=0;i<np;i++) {
	 p[i][0]=p[i][0]-Model1->origin[0];
	 p[i][1]=p[i][1]-Model1->origin[1];
	 p[i][2]=p[i][2]-Model1->origin[2];
 }*/
 
 //Model1->origin[0]=0;
 //Model1->origin[1]=0;
 //Model1->origin[2]=0;

 sprintf(strorig,"%ld %ld %ld",Model1->origin[0],Model1->origin[1],Model1->origin[2]);
 MessageBox(NULL,strorig,"Values for Origin",MB_OK);

 
 /* Positioning the first target */
 TargetPointer1->fpos->finish[0]=xmin+(xsize/2)+(separation/2);
 TargetPointer1->fpos->finish[1]=ymin+(ysize/2);
 TargetPointer1->fpos->finish[2]=zmin+(zsize/2);


/* Positioning the second target */
 TargetPointer2->fpos->finish[0]=xmin+(xsize/2)-(separation/2);
 TargetPointer2->fpos->finish[1]=ymin+(ysize/2);
 TargetPointer2->fpos->finish[2]=zmin+(zsize/2);

 
 /* Positioning the ground */
 Ground1->fpos->finish[0]=TargetPointer1->fpos->finish[0];
 Ground1->fpos->finish[1]=TargetPointer1->fpos->finish[1];
 Ground1->fpos->finish[2]=TargetPointer1->fpos->finish[2]-zsize;
 
 return TRUE;
}


void CentreDialogOnScreen(HWND hwnd){
  RECT rcDlg;
  long Xres,Yres;
  Yres=GetSystemMetrics(SM_CYSCREEN);
  Xres=GetSystemMetrics(SM_CXSCREEN);
  GetWindowRect(hwnd,&rcDlg);
  OffsetRect(&rcDlg,-rcDlg.left,-rcDlg.top);
  OffsetRect(&rcDlg,(Xres-rcDlg.right)/2,(Yres-rcDlg.bottom)/2);
  SetWindowPos(hwnd,HWND_TOP,rcDlg.left,rcDlg.top,0,0,SWP_NOSIZE);
  return;
}
