/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/*  BMP_MAP.C  */

#include <windows.h>

#define BFT_BITMAP 0x4d42   /* 'BM' */
#define X__Malloc(s)    LocalAlloc(LMEM_FIXED,s)
#define X__Free(p)      LocalFree((HLOCAL)p)

int x_size, y_size;
unsigned char *R,*G,*B;

static HINSTANCE hThisInstance;

#if __WATCOMC__
int APIENTRY LibMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#else
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#endif
  switch (dwReason) {
    case DLL_PROCESS_ATTACH: {
      hThisInstance=hDLL;
      break;
    }
    case DLL_PROCESS_DETACH:
      break;
  }
  return TRUE;
}

BOOL _GetExternalImageSize
 (char *filename,
  long *x,
  long *y){
 return FALSE;
}

BOOL _GetExternalImage
 (char *filename,
  long x, long y,
  unsigned char *Red,
  unsigned char *Green,
  unsigned char *Blue){
 return FALSE;
}

typedef struct SCREENBUFFER {
 unsigned char A,R,G,B;
} fullscreenbuffer;

BOOL _PutExternalImage
 (char *szOutFileName,
  long nx, long ny,
  long quality,
  fullscreenbuffer *image){
 HANDLE hfbm;
 DWORD dwRead;
 BITMAPFILEHEADER hdr,*lphdr;
 BITMAPINFOHEADER bfi,*lpbi;
 long i,j,imagesize,mx;
 unsigned char *Screen1,*p;
 mx=((nx*24+31)/32) * 4;
 if((Screen1=(unsigned char *)X__Malloc(nx*ny*3)) == NULL){
   MessageBox(NULL,"Out of Memory","Warning",MB_OK);
   return FALSE;
 }
 p=Screen1;
 for(i=0;i<ny;i++){
   p=Screen1+(ny-i-1)*nx*3;
   for(j=0;j<nx;j++){
     *p++ = (unsigned char)image->B;
     *p++ = (unsigned char)image->G;
     *p++ = (unsigned char)image->R;
     image++;
   }
 }
 if((hfbm=CreateFile(szOutFileName,GENERIC_WRITE,FILE_SHARE_WRITE,
   NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,
   (HANDLE)NULL)) == INVALID_HANDLE_VALUE){
   X__Free(Screen1);
   MessageBox(NULL,szOutFileName,"File Open Fail",MB_OK);
   MessageBeep(MB_OK);
   return FALSE;
 }
 lpbi=&bfi;
 lpbi->biSize=sizeof(BITMAPINFOHEADER);
 lpbi->biWidth=(DWORD)nx;
 lpbi->biHeight=(DWORD)ny;
 lpbi->biPlanes=1;
 lpbi->biBitCount=24;
 lpbi->biCompression=BI_RGB;
 lpbi->biSizeImage = imagesize = (DWORD)(mx*ny);
 lpbi->biXPelsPerMeter=0;
 lpbi->biYPelsPerMeter=0;
 lpbi->biClrUsed=0;
 lpbi->biClrImportant=0;
 lphdr=&hdr;
 hdr.bfType          = BFT_BITMAP;
 hdr.bfSize          = (sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)
                        + imagesize);
 hdr.bfReserved1     = 0;
 hdr.bfReserved2     = 0;
 hdr.bfOffBits       = (DWORD)sizeof(BITMAPFILEHEADER) + lpbi->biSize;
 WriteFile(hfbm,lphdr,sizeof(BITMAPFILEHEADER),&dwRead,(LPOVERLAPPED)NULL);
 WriteFile(hfbm,lpbi,sizeof(BITMAPINFOHEADER),&dwRead,(LPOVERLAPPED)NULL);
 WriteFile(hfbm,Screen1,imagesize,&dwRead,(LPOVERLAPPED)NULL);
 if(dwRead != imagesize){
   MessageBeep(MB_OK);
   MessageBox(NULL,"Bad write",NULL,MB_OK);
 }
 if(!CloseHandle(hfbm)){
   MessageBeep(MB_OK);
   MessageBox(NULL,"Bad close",NULL,MB_OK);
 }
 X__Free(Screen1);
 return TRUE;
}
