/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* include file FLC.H   for the renderer */

#if __ZTC__
#pragma ZTC align 1
#endif


#define FLC_MAXFRAMES    4000      /* Max number of frames... */
#define FLCH_MAGIC     0xaf12      /* File header Magic */
#define FLCF_MAGIC     0xf1fa      /* Frame Magic */
#define FLC_FINISHED        1      /* finished writing flc */
#define FLC_LOOPED          2      /* flc has a loop frame */

typedef struct flc_head{
  long size;
  unsigned short type;             /* = FLCH_MAGIC */
  unsigned short frames;
  unsigned short width;
  unsigned short height;
  unsigned short depth;
  short flags;                      /* set to 0x0003 after ring frame */
  long  speed;
  short reserved1;                  /* set to zero */
  long created;
  long aapro_serial;                /* "FLIB" */
  long date_update;
  long updater;
  short aspectx;
  short aspecty;
  char reserved2[38];
  long oframe1;                     /* offset from file to first ani chunk */
  long oframe2;                     /* offset from file to second ani chunk */
  char reserved3[40];
} Flc_head;

typedef struct flc_frame{
  long size;
  unsigned short type;          /* = 0xf1fa FLCF_MAGIC */
  short chunks;
  char pad[8];
} Flc_frame;

typedef struct flc_chunk{
  long size;
  short type;
} Flc_chunk;

/* types of chunk in a flc_frame */
#define FLC_COLOR256 4
#define FLC_SS2      7
#define FLC_COLOR   11
#define FLC_LC      12
#define FLC_BLACK   13
#define FLC_BRUN    15
#define FLC_COPY    16
#define FLC_PSTAMP  18

/* old animator 1.0 cel  structure */

#define PIC_MAGIC 0x9119
struct pic_header        {
  unsigned short type;    /* Always equal to PIC_MAGIC */
  short w,h,x,y;          /* Dimensions of Cel */
  char d;                 /* Bits-per-pixel */
  char compress;          /* Zero for uncompressed */
  long csize;             /* Size of data (after color map) */
  char reserved[16];      /* All zero */
};
