/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* include file FLI.H   for the renderer */

#if __ZTC__
#pragma ZTC align 1
#endif


#define FLI_MAXFRAMES (4*1000)     /* Max number of frames... */
#define FLIH_MAGIC     0xaf11      /* File header Magic */
#define FLIF_MAGIC     0xf1fa      /* Frame Magic */
#define FLI_FINISHED        1      /* finished writing fli */
#define FLI_LOOPED          2      /* fli has a loop frame */
#define AA_COLOURS        256
#define FLI_CBUF_SIZE   65000

typedef struct fli_head
{
  long size;
  unsigned short type;             /* = FLIH_MAGIC */
  unsigned short frame_count;
  unsigned short width;
  unsigned short height;
  unsigned short bits_a_pixel;
  short flags;
  short speed;
  long next_head;
  long frames_in_table;
  short file;           /* used by players.  Contains zeros on disk. */
  long frame1_off;      /* used by players.  Contains zeros on disk. */
  long strokes;         /* how many paint strokes etc. made. */
  long session;         /* stokes since file's been loaded. */
  char reserved[88];    /* all zeroes on disk */
} Fli_head;

typedef struct fli_frame
{
  long size;
  unsigned short type;          /* = 0xf1fa FLIF_MAGIC */
  short chunks;
  char pad[8];
} Fli_frame;

typedef struct fli_ram_frame
{
 long size;
 unsigned short type;
 short chunks;
 char *frame;
} Fli_ram_frame;

typedef struct fli_chunk
{
  long size;
  short type;
} Fli_chunk;

typedef struct fli_lc
{
  unsigned short skip;
  unsigned short line;
} Fli_lc;

/* types of chunk in a fli_frame */
#define FLI_COLOR 11
#define FLI_LC    12
#define FLI_BLACK 13
#define FLI_BRUN  15
#define FLI_COPY  16
