/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/*  JPG_MAP.C  */

#include <windows.h>

int x_size, y_size;
unsigned char *R,*G,*B;

extern long ReadJPG(char *filename, short info_only);

static HINSTANCE hThisInstance;

#if __WATCOMC__
int APIENTRY LibMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#else
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved){
#endif
  switch (dwReason) {
    case DLL_PROCESS_ATTACH: {
      hThisInstance=hDLL;
      break;
    }
    case DLL_PROCESS_DETACH:
      break;
  }
  return TRUE;
}

void jpg_display_line(unsigned char *pbgr, long line){
 register long i;
 for(i=0;i<x_size;i++){
  *R++ = *(pbgr);
  *G++ = *(pbgr+1);
  *B++ = *(pbgr+2);
  pbgr+=3;
 }
}

BOOL _GetExternalImageSize
 (char *filename,
  long *x,
  long *y){
 if(ReadJPG(filename,1) == 0)return FALSE;
 *x = x_size;
 *y = y_size;
 return TRUE;
}

BOOL _GetExternalImage
 (char *filename,
  long x, long y,
  unsigned char *Red,
  unsigned char *Green,
  unsigned char *Blue){
 x_size=x;
 y_size=y;
 R=Red;
 G=Green;
 B=Blue;
 if(ReadJPG(filename,0) == 0)return FALSE;
 return TRUE;
}

typedef struct SCREENBUFFER {
 unsigned char A,R,G,B;
} fullscreenbuffer;

extern long WriteJPG(char *, long, long, long, fullscreenbuffer *);

BOOL _PutExternalImage
 (char *filename,
  long x, long y,
  long quality,
  fullscreenbuffer *image){
  if(WriteJPG(filename,x,y,quality,image) == 0)
    MessageBox(NULL,"Bad JPG",NULL,MB_OK);
 return FALSE;
}
