/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/*    FILE LOADSCPT.CPP   */
//
// The code in this file reads script files and builds the
// animation in RAM it call to the LOADMESH file to read
// mesh models


#define MODULE_READER

#include "render.h"

extern FILE *CF;
extern short End_of_animation;

#ifdef _SUNSTYLE
static void read_vec(v) vector v; {
#else
static void read_vec(vector v){
#endif
 if(fscanf(CF,GET_VEC,&v[0],&v[1],&v[2]) != 3){
   Render_Message(6,0,NULL);
 }
}

/* Read the ASCII script file .SCR and assemble the Actors */

#ifdef _SUNSTYLE
int GetCommand(firstframe,frame,nAnimStart,outfile_root)
long firstframe; long frame; long nAnimstart; char *outfile_root;  {
#else
int GetCommand(long firstframe, long frame, long nAnimStart,
                      char *outfile_root){
#endif
 long i;
 long a=0,b=0,c,d,e,f;
 double p,t,al,du,sx,sy,sz,gbtr[4][4],tr1[4][4],tr2[4][4],
        qmorph_ratio,robo_ratio,i_ratio=0.0;
 short imo,mo,robo=NO;
 char   Com[16],second_morph[256],robo_file1[256],robo_file2[256],
        morphfile[256],tempfile[256],namefile[256],*cc;
 object *temp_object;
 light  *temp_light;
 csg    *temp_csg;
 XIP    *temp_xip;
 long   flag;
 BOOL   bWfm,bHlin;
 while (fscanf(CF,"%s",Com) != EOF){
  imo=0;
  bWfm=FALSE; bHlin=FALSE;
  switch(Com[0]) {
    case 'e' :
      read_vec(ViewPoint);
      fscanf(CF,GET_VEC,&CamPhi,&CamTheta,&CamAlpha);
      fscanf(CF,GET_VEC,&CamSx,&CamSy,&CamSz);
      fscanf(CF,"%ld %ld",&a,&b); CamIm=b;  /* camera internal */
      fscanf(CF,GET_DOB,&CamIma);
      break;
    case 'i' :
      fscanf(CF,"%ld %ld %ld %ld",&imo,&a,&c,&b);
      fscanf(CF,GET_DOB,&i_ratio);
      if(ImageProcesses == NULL)temp_xip = (XIP *)X__Malloc(sizeof(XIP));
      else                      temp_xip = (XIP *)X__Realloc(ImageProcesses,
                                    (nImageProcesses+1)*sizeof(XIP));
      if(temp_xip == NULL)return -1;
      temp_xip[nImageProcesses].imo=(long)imo;
      temp_xip[nImageProcesses].first_frame=a;
      temp_xip[nImageProcesses].this_frame=c;
      temp_xip[nImageProcesses].last_frame=b;
      temp_xip[nImageProcesses].fmr=i_ratio;
      temp_xip[nImageProcesses].parameters=NULL;
      temp_xip[nImageProcesses].mparameters=NULL;
      { char itempfile[512];
        fscanf(CF," %[^\n]",itempfile); c=strlen(itempfile)+1;
        if((temp_xip[nImageProcesses].parameters=(char *)X__Malloc(c)) != NULL)
          strcpy(temp_xip[nImageProcesses].parameters,itempfile);
        if(imo == 1){
          fscanf(CF," %[^\n]",itempfile); c=strlen(itempfile)+1;
          if((temp_xip[nImageProcesses].mparameters=(char *)X__Malloc(c)) != NULL)
            strcpy(temp_xip[nImageProcesses].mparameters,itempfile);
        }
      }
      ImageProcesses=temp_xip;
      nImageProcesses++;
      break;
    case 'l' :
      if(Lights == NULL)temp_light = (light *)X__Malloc(sizeof(light));
      else              temp_light = (light *)X__Realloc(Lights,
                                        (Nlights+1)*sizeof(light));
      if(temp_light == NULL){
        Render_Message(7,0,NULL);
        if(Lights != NULL)X__Free(Lights);
        Lights=NULL;
        return -1;
      }
      Lights=temp_light;
      Lights[Nlights].dc=FALSE;
      Lights[Nlights].dc_c=1.0;
      Lights[Nlights].dc_l=0.0;
      Lights[Nlights].dc_q=0.0;
      fscanf(CF,"%ld",&a); Lights[Nlights].type=a;
      fscanf(CF,"%ld %ld %ld",&a,&b,&c);
      fscanf(CF,GET_DOB,&Lights[Nlights].Intensity);
      Lights[Nlights].Intensity=1.0;
      Lights[Nlights].color[0] = (unsigned char)a;
      Lights[Nlights].color[1] = (unsigned char)b;
      Lights[Nlights].color[2] = (unsigned char)c;
      read_vec(Lights[Nlights].p);
      VECCOPY(Lights[Nlights].p,Lights[Nlights].pin)
      fscanf(CF,GET_VEC,&Lights[Nlights].dPhi
                       ,&Lights[Nlights].dTheta
                       ,&Lights[Nlights].dAlpha);
      /* Theta axis bank  (Not used)                  */
      /* Phi is direction   Alpha is elevation angle  */
      fscanf(CF,"%ld %ld",&a,&b);  /* light internals */
      Lights[Nlights].AnimatorID=a;
      Lights[Nlights].internal_type=b;
      fscanf(CF,GET_DOB,&Lights[Nlights].internal_size);
      fscanf(CF,"%ld",&a);  /* light depth cue */
      Lights[Nlights].dc=a;
      fscanf(CF,GET_DOB,&Lights[Nlights].dc_c);
      fscanf(CF,GET_DOB,&Lights[Nlights].dc_l);
      fscanf(CF,GET_DOB,&Lights[Nlights].dc_q);
      if(Lights[Nlights].type == SPOTLIGHT){
        fscanf(CF,GET_DOB,&Lights[Nlights].cone1);    /* angle  */
        fscanf(CF,GET_DOB,&Lights[Nlights].falloff);  /* degree */
      }
      Nlights++;
      break;
     case 'g' :
       fscanf(CF,"%ld",&a); Ground.type=a;
       fscanf(CF,"%ld %ld %ld",&a,&b,&c);
       Ground.color[0] = (unsigned char)a;
       Ground.color[1] = (unsigned char)b;
       Ground.color[2] = (unsigned char)c;
       Ground.ambient_light=ambient_light*0.8;
       Ground.texture = -1; Ground.shader = -1;
       if(Ground.type == PLAIN)Ground.texture=0;
       else if(Ground.type > 127){
         fscanf(CF,"%ld %ld %ld",&a,&b,&c);
         Ground.acolor[0] = (unsigned char)a;
         Ground.acolor[1] = (unsigned char)b;
         Ground.acolor[2] = (unsigned char)c;
         Ground.texture = Ground.type-128;
         Ground.type = TEXTU;
         if(Ground.texture == 0)Ground.type=PLAIN;
         else if(Ground.texture > 15){  /* external shader   */
           fscanf(CF,"  %[^\n]",namefile); /* no parameters yet */
           if(LoadExternalTexture(namefile,"# 1") == FAIL){
             Ground.texture=0; Ground.type=PLAIN;
           }
           else Ground.shader=(Nshader-1);
         }
       }
       if(Ground.type == BRUM || Ground.type == TBRUM || Ground.type == MBRUM){
         fscanf(CF,"  %[^\n]",namefile);
         if(hidden_line == YES){ Ground.type=PLAIN; goto SKIPH1; }
         if(DROP == YES){
           strcpy(Ground.map.filename,short_form(namefile));
         }
         else  strcpy(Ground.map.filename,namefile);
         Ground.map.pp = 100; /* strength use to indicate */
         Ground.map.rp =  -1; /* brush is STATIC only     */
         Ground.map.bp =  -1;
         Ground.map.tp =  -1;
       }
       SKIPH1:
       read_vec(Ground.p);
       fscanf(CF,GET_VEC,&p,&t,&al);
       fscanf(CF,GET_VEC,&sx,&sy,&sz);
       fscanf(CF,"%ld %ld",&a,&b);  /* ground internals */
       fscanf(CF,GET_DOB,&du);
       fscanf(CF,GET_DOB,&Ground.refl); Ground.refl *= 0.01;
       Ground.height=sz;
       Ground.x[0]=Ground.p[0]+(double)UNIT*sx*4.0;  /* ground is flat */
       Ground.x[1]=Ground.p[1];
       Ground.x[2]=Ground.p[2];
       Ground.y[0]=Ground.p[0];
       Ground.y[1]=Ground.p[1]-(double)UNIT*sy*4.0;
       Ground.y[2]=Ground.p[2];       /* this may change */
       R_Nground=1;
       Ground.mapped=FALSE;
       if(Ground.type == TEXTU){
         vecsub(Ground.x,Ground.p,Ground.x);
         vecsub(Ground.y,Ground.p,Ground.y);
         if(b > 0){
           if(b == 1)R_rotz(tr1,du*PI/180.0);
           if(b == 2)R_rotx(tr1,du*PI/180.0);
           if(b == 3)R_roty(tr1,du*PI/180.0);
           R_rotz(tr2,p*PI/180.0);
           R_m4by4(tr2,tr1,gbtr);
         }
         else R_rotz(gbtr,p*PI/180.0);
         R_m4by1(gbtr, Ground.x[0], Ground.x[1],
                       Ground.x[2],&Ground.x[0],
                      &Ground.x[1],&Ground.x[2]);
         R_m4by1(gbtr, Ground.y[0], Ground.y[1],
                       Ground.y[2],&Ground.y[0],
                       &Ground.y[1],&Ground.y[2]);
         vecsum(Ground.x,Ground.p,Ground.x);
         vecsum(Ground.y,Ground.p,Ground.y);
       }
       else if(Ground.type == BRUM || Ground.type == TBRUM ||
               Ground.type == MBRUM){
         Ground.map.p[0]=0.0;
         Ground.map.p[1]=0.0;
         Ground.map.p[2]=0.0;
         Ground.map.x[0]=Ground.map.p[0]+UNIT*4*sx;
         Ground.map.x[1]=Ground.map.p[1];
         Ground.map.x[2]=Ground.map.p[2];
         Ground.map.y[0]=Ground.map.p[0];
         Ground.map.y[1]=Ground.map.p[1]-UNIT*4*sy;
         Ground.map.y[2]=Ground.map.p[2];
         if(b > 0){
           if(b == 1)R_rotz(tr1,du*PI/180.0);
           if(b == 2)R_rotx(tr1,du*PI/180.0);
           if(b == 3)R_roty(tr1,du*PI/180.0);
           R_rotz(tr2,p*PI/180.0);
           R_m4by4(tr2,tr1,gbtr);
         }
         else R_rotz(gbtr,p*PI/180.0);
         R_m4by1(gbtr, Ground.map.x[0], Ground.map.x[1],
                       Ground.map.x[2],&Ground.map.x[0],
                      &Ground.map.x[1],&Ground.map.x[2]);
         R_m4by1(gbtr, Ground.map.y[0], Ground.map.y[1],
                       Ground.map.y[2],&Ground.map.y[0],
                      &Ground.map.y[1],&Ground.map.y[2]);
         vecsum(Ground.map.p,Ground.p,Ground.map.p);
         vecsum(Ground.map.x,Ground.p,Ground.map.x);
         vecsum(Ground.map.y,Ground.p,Ground.map.y);
         VECCOPY(Ground.map.p,Ground.map.pin)
         VECCOPY(Ground.map.x,Ground.map.xin)
         VECCOPY(Ground.map.y,Ground.map.yin)
         if(SetupImageMap(&Ground.map,"dummy") == 1){
           if(Ground.type ==  BRUM)Ground.maptype=SINGLE;
           if(Ground.type == TBRUM)Ground.maptype=TILE;
           if(Ground.type == MBRUM){
             Ground.maptype=TILE;
             Ground.map.moziac=YES;
           }
           Ground.mapped=TRUE;
         }
         else Ground.type=PLAIN;  /* could not load map */
       }
       VECCOPY(Ground.p,Ground.pin)
       VECCOPY(Ground.x,Ground.xin)
       VECCOPY(Ground.y,Ground.yin)
       break;
     case 's' :
       fscanf(CF,"%ld %ld %ld %ld %ld %ld ",&a,&b,&c,&d,&e,&f);
       Sky.Horizon[0]=a; Sky.Horizon[1]=b; Sky.Horizon[2]=c;
       Sky.Zenith[0]=d; Sky.Zenith[1]=e; Sky.Zenith[2]=f;
       fscanf(CF,GET_DOB,&Sky.blendratio);
       fscanf(CF,GET_DOB,&object_ambient_light);
       fscanf(CF,GET_DOB,&ground_ambient_light);
       fscanf(CF,"%ld %ld %ld %ld %ld %ld ",&a,&b,&c,&d,&e,&f);
       Sky.Zblend[0]=a; Sky.Zblend[1]=b; Sky.Zblend[2]=c;
       Sky.Hblend[0]=d; Sky.Hblend[1]=e; Sky.Hblend[2]=f;
       fscanf(CF,"%ld",&a);
       Sky.type = (short)a;
       Sky.mapped=FALSE;
       skyYscale=2.2111; skyXscale=0.888; skyBmax=199;
       if(Sky.type > SKYGRADED){
         fscanf(CF,"  %[^\n]",namefile);
         if(hidden_line == YES){ Sky.type=SKYCOLOUR; goto SKIPH2; }
         if(DROP == YES){
           strcpy(Sky.map.filename,short_form(namefile));
         }
         else  strcpy(Sky.map.filename,namefile);
         Sky.map.pp = 100; /* strength use to indicate */
         Sky.map.rp =  -1; /* brush is STATIC only     */
         Sky.map.bp =  -1;
         Sky.map.tp =  -1;
         Sky.map.p[0]=0.0;
         Sky.map.p[1]=0.0;
         Sky.map.p[2]=UNIT*1000;
         Sky.map.x[0]=Sky.map.p[0]+UNIT*5000;
         Sky.map.x[1]=Sky.map.p[1];
         Sky.map.x[2]=Sky.map.p[2];
         Sky.map.y[0]=Sky.map.p[0];
         Sky.map.y[1]=Sky.map.p[1]+UNIT*5000;
         Sky.map.y[2]=Sky.map.p[2];
         VECCOPY(Sky.map.p,Sky.map.pin)
         VECCOPY(Sky.map.x,Sky.map.xin)
         VECCOPY(Sky.map.y,Sky.map.yin)
         if(SetupImageMap(&Sky.map,"dummy") == 1){
           Sky.mapped=TRUE;
           Sky.map.map=PLANE;
           skyYscale=(double)(Sky.map.ymax-1)/90.0;
           skyXscale=(double)(Sky.map.xmax)/360.0;
           skyBmax=Sky.map.ymax-1;
         }
       }
       SKIPH2:
       Nsky=1;
       break;
     case 'h' : bHlin=TRUE;
     case 'w' : bWfm=TRUE;
     case 'o' :
       if(Object == NULL)temp_object = (object *)X__Malloc(sizeof(object));
       else              temp_object = (object *)X__Realloc(Object,
                                       (ObjectCount+1)*sizeof(object));
       if(temp_object == NULL){
         Render_Message(7,0,NULL);
         if(Object != NULL)X__Free(Object);
         Object=NULL;
         return -1;
       }
       Object=temp_object;
       Object[ObjectCount].self_shadow=TRUE;
       Object[ObjectCount].cast_shadow=TRUE;
       Object[ObjectCount].show_shadow=TRUE;
       Object[ObjectCount].effect_param_list=NULL;
       Object[ObjectCount].NoMaps=0;
       Object[ObjectCount].Mbase=NULL;
       Object[ObjectCount].wireframe=FALSE;
       if(bWfm){
         Object[ObjectCount].wireframe=TRUE;
         bWire=TRUE;
       }
       fscanf(CF," %ld",&a); Object[ObjectCount].AnimatorID=a;
       fscanf(CF," %[^\n]",tempfile);  /* note single space in format */
       { char messages[255];
         sprintf(messages,"Loading %s",tempfile);
         Render_Message(91,0,messages);
       }
       if(DROP == YES)strcpy(namefile,short_form(tempfile));
       else           strcpy(namefile,tempfile);
       Object[ObjectCount].shadowed=NO;
       for(i=0;i<8;i++)Object[ObjectCount].shader[i] = 0;
       Object[ObjectCount].fshader = Nshader;
       Object[ObjectCount].Origin[0]=0;
       Object[ObjectCount].Origin[1]=0;
       Object[ObjectCount].Origin[2]=0;
       Object[ObjectCount].visibility=NO;
       Object[ObjectCount].morphratio=1.0;
       Object[ObjectCount].refractive_index=1.2;
       fscanf(CF,"%ld",&a); mo=a;
       robo=NO;
       if(mo == 4){ /* robot  note the special read with leading spaces */
         robo=YES;
         fscanf(CF," %[^\n]",tempfile);  /* note single space */
         if(DROP == YES)strcpy(robo_file1,short_form(tempfile));
         else           strcpy(robo_file1,tempfile);
         fscanf(CF,"  %[^\n]",tempfile);   /* note double space */
         if(DROP == YES)strcpy(robo_file2,short_form(tempfile));
         else           strcpy(robo_file2,tempfile);
         fscanf(CF,GET_DOB,&robo_ratio);
         mo=0;     /* robots can't morph */
       }
       if(mo > 0){
         long mvs,ovs,swp;
         fscanf(CF,GET_DOB,&Object[ObjectCount].morphratio);
         fscanf(CF,"  %[^\n]",tempfile);    /* note double space */
         if(DROP == YES)strcpy(morphfile,short_form(tempfile));
         else           strcpy(morphfile,tempfile);
         if(mo == 1){
           swp=0;
           FindNumberVertices(morphfile,&mvs);
           FindNumberVertices(namefile,&ovs);
//           if(mvs > 0 && ovs > 0 && mvs != ovs){
//             if(ovs > mvs && Object[ObjectCount].morphratio < 0.1)swp=1;
//             if(mvs > ovs && Object[ObjectCount].morphratio < 0.9)swp=1;
//           }
           if(mvs > ovs)swp=1;
           if(swp){
             strcpy(tempfile,namefile);
             strcpy(namefile,morphfile);
             strcpy(morphfile,tempfile);
             Object[ObjectCount].morphratio=1.0-Object[ObjectCount].morphratio;
           }
         }
       }
       if(R_LoadObject(namefile,frame+nAnimStart,robo,robo_ratio,
                       robo_file1,robo_file2) <= 0){
         Render_Message(34,1,namefile);
         return (-1);
       }
       if(mo > 0){
         strcpy(namefile,morphfile);
         if(mo > 1){/* 2 or 3 for - or + morph  quadratic morph*/
           fscanf(CF,GET_DOB,&qmorph_ratio);
           fscanf(CF,"  %[^\n]",tempfile);  /* note double space */
           if(DROP == YES)strcpy(second_morph,short_form(tempfile));
           else           strcpy(second_morph,tempfile);
         }
         if(LoadMorphObject(mo,namefile,Object[ObjectCount].morphratio,
            second_morph,qmorph_ratio) == 0)Render_Message(35,1,namefile);
       }
       read_vec(Object[ObjectCount].Offset);
       fscanf(CF,GET_VEC,&Object[ObjectCount].fi
                        ,&Object[ObjectCount].theta
                        ,&Object[ObjectCount].alpha);
       fscanf(CF,GET_VEC,&Object[ObjectCount].sx
                        ,&Object[ObjectCount].sy
                        ,&Object[ObjectCount].sz);
       fscanf(CF,"%ld %ld",&a,&b); /* a is zero for expansion */
       Object[ObjectCount].im=b;
       fscanf(CF,GET_DOB,&Object[ObjectCount].ima);
       fscanf(CF,"%ld",&a); Object[ObjectCount].effect=a;
       fscanf(CF,GET_DOB,&Object[ObjectCount].effectratio);
       fscanf(CF,"%ld %ld %ld",&Object[ObjectCount].self_shadow,
         &Object[ObjectCount].cast_shadow,&Object[ObjectCount].show_shadow);
       if(a > 20){
         c=0L;
         Object[ObjectCount].effect_param_list=NULL;
         fscanf(CF,"  %s",tempfile);  /* note 2 spaces */
         b=strlen(tempfile)+1L;
         if((Object[ObjectCount].effect_param_list=(char *)X__Malloc(b)) == NULL){
           Object[ObjectCount].effect=0;
           goto NOFX;
         }
         else strcpy(Object[ObjectCount].effect_param_list,tempfile);
         c += b;
         while(1){
           fscanf(CF,"%s",tempfile);
           if(strcmp(tempfile,"~") == 0) break;
           b=strlen(tempfile)+2L;
           c += b;
           if((Object[ObjectCount].effect_param_list=(char *)
               X__Realloc(Object[ObjectCount].effect_param_list,c)
              ) == NULL){ Object[ObjectCount].effect=0; goto NOFX; }
           else {
             strcat(Object[ObjectCount].effect_param_list," ");
             strcat(Object[ObjectCount].effect_param_list,tempfile);
           }
         }
         /* Determine if F/X is internal */
         sscanf(Object[ObjectCount].effect_param_list,"%s",tempfile);
         if(strlen(tempfile) <= 2 && tempfile[0] > 48 &&
            tempfile[0] < 58)Object[ObjectCount].effect=atoi(tempfile);
         else Object[ObjectCount].effect=50;
         NOFX:;
       }
       ObjectCount++;
       break;
     case 'c' :
       if(Csg == NULL)temp_csg = (csg *)X__Malloc(sizeof(csg));
       else           temp_csg = (csg *)X__Realloc(Csg,(Ncsg+1)*sizeof(csg));
       if(temp_csg == NULL){
         if(Csg != NULL)X__Free(Csg);
         Csg=NULL;
         Render_Message(10,0,NULL);
         return -1;
       }
       Csg=temp_csg;
       fscanf(CF,"%ld %ld",&a,&b);
       Csg[Ncsg].type=a; Csg[Ncsg].bool=b;
       fscanf(CF,"%ld %ld",&a,&b);
       Csg[Ncsg].f.fshader=(unsigned char)a;
       Csg[Ncsg].f.fmap=(unsigned char)b;
       fscanf(CF,"%ld %ld %ld",&a,&b,&c);
       Csg[Ncsg].f.color[0] = (unsigned char)a;
       Csg[Ncsg].f.color[1] = (unsigned char)b;
       Csg[Ncsg].f.color[2] = (unsigned char)c;
       fscanf(CF,"%ld %ld %ld",&a,&b,&c);
       Csg[Ncsg].f.texco[0] = (unsigned char)a;
       Csg[Ncsg].f.texco[1] = (unsigned char)b;
       Csg[Ncsg].f.texco[2] = (unsigned char)c;
       Csg[Ncsg].f.matsp=8;
       Csg[Ncsg].f.V[0]=0;
       Csg[Ncsg].f.V[1]=0;
       Csg[Ncsg].f.V[2]=0;
       read_vec(Csg[Ncsg].p0);
       VECCOPY(Csg[Ncsg].p0,Csg[Ncsg].pin)
       fscanf(CF,GET_VEC,&p,&t,&al);
       fscanf(CF,GET_VEC,&sx,&sy,&sz);
       Csg[Ncsg].fi=p; Csg[Ncsg].theta=t; Csg[Ncsg].alpha=al;
       Csg[Ncsg].sx=sx; Csg[Ncsg].sy=sy; Csg[Ncsg].sz=sz;
       fscanf(CF,"%ld",&a); Csg[Ncsg].im=a;
       fscanf(CF,GET_DOB,&Csg[Ncsg].ima);
       Ncsg++;
       break;
     case 'b' : return 1; break;  // end of integrated frame
     case 'f' : return 0; break;  // end of frame
     case 'q' :
       fclose(CF);
       CF=NULL;
       End_of_animation=1;
#if __NT__
       WindowedRenderMessage(WRM_COMPLETE);
#else
       Render_Message(36,0,NULL);
#endif
       return (-1);
     default:   break;
  }
 }
 Render_Message(37,1,NULL);
 return (-1);
}

#ifdef _SUNSTYLE
short Make_up_output(firstframe,lastframe,outfile_root,iLace)
long firstframe; long lastframe; char *outfile_root; BOOL iLace; {
#else
short Make_up_output(long firstframe, long lastframe, char *outfile_root,
                     BOOL iLace){
#endif
 if(ColourResolution == BITS16 ||
   (ColourResolution == BITS24 &&
    OUTPUT_FILE_TYPE != I24_FILE) )return(-1);
 XMAX=ResolutionX; YMAX=ResolutionY;
 Render_Message(38,0,NULL);
 if(     OUTPUT_FILE_TYPE == I24_FILE)
   Iff24Palette(firstframe,lastframe,outfile_root);
 else if(OUTPUT_FILE_TYPE == GIF_FILE)
   OneGifPalette(firstframe,lastframe,outfile_root,iLace);
 else if(OUTPUT_FILE_TYPE == IFF_FILE)
   OneIffPalette(firstframe,lastframe,outfile_root,1);
 else if(OUTPUT_FILE_TYPE == LBM_FILE)
   OneIffPalette(firstframe,lastframe,outfile_root,0);
 Render_Message(39,0,NULL);
 return -1;
}

