/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

#ifdef MODULE_RENDER
#define WHERE
#else
#define WHERE extern
#endif
WHERE short R_terminator(void);
WHERE void read_vec(vector v);
WHERE void MakeVertexNormals(void);
WHERE long RenderHide(void);
WHERE long FastAntiAliasRenderHide(void);
WHERE char *short_form(char *filename);
#if __VAX__ || __UNIX__
WHERE char *strlwr(char *string);
#endif
#undef WHERE

#ifdef MODULE_READER
#define WHERE
#else
#define WHERE extern
#endif
WHERE int GetCommand(long, long, long, char*);
WHERE short Make_up_output(long firstframe, long lastframe,
                           char *outfile_root, BOOL iLace);
#undef WHERE

#ifdef MODULE_LOADER
#define WHERE
#else
#define WHERE extern
#endif
WHERE char R_getl(long *val);
WHERE char R_getsht(short * val);
WHERE char R_getusht(unsigned short *val);
WHERE long LoadMorphObject(short mo, char *FileName, double mr,
                     char *QmorphFile, double qr);
WHERE long R_LoadObject(char *FileName, long frame, short robo,
                  double robo_ratio, char *robo_file1, char *robo_file2);
WHERE void R_getchunk(long clen);
WHERE long FindNumberVertices(char *ofile, long *nvs);
WHERE void InvertRotationMatrix(double T[4][4], double t[4][4]);
#undef WHERE

#ifdef MODULE_GEO
#define WHERE
#else
#define WHERE extern
#endif
WHERE double dot(vector v1, vector v2);
WHERE void SwapFaces(face  *f1, face  *f2,
                     eface  *e1, eface  *e2);
WHERE double FaceDepth(face  *f, vertex  *v);
WHERE void DepthSortFaces(long O);
WHERE void NewPoint(double plane, vector p1, vector p2, vector p);
WHERE short ClipObject(long O);
WHERE long IShadow(long scanline, long v1x, long v1y, long v2x, long v2y,
             long *xi);
WHERE void ShadowFillLine(long scanline, long vx[3], long vy[3],
                          long *leftedge, long *rightedge);
WHERE void ShadowGround(void);
WHERE void ShadowObject(long i);
WHERE double hitpoint(vector n, vector x, vector y, vector pb, vector pf,
                      double * a, double * b);
WHERE double hitcylinder(vector n, vector x, vector y, vector p0, vector p,
                double * a, double * b);
WHERE double hitsphere(vector n, vector x, vector y, vector p0, vector p,
                double * a, double * b);
WHERE void ( *UpdateScanBuffers)(double, double, long, long,
                  face *, eface *, double,
                  long *[], long *[], double *[],
                  long *, long *, double *, double *);
WHERE void UpdateGlassScanBuffers(double, double, long, long,
                  face *, eface *, double,
                  long *[], long *[], double *[],
                  long *, long *, double *, double *);
WHERE void UpdateNoGlassScanBuffers(double, double, long, long,
                  face *, eface *, double,
                  long *[], long *[], double *[],
                  long *, long *, double *, double *);
WHERE long Intersect(long scanline, vertex  *v1,
                     vertex  *v2, double *xi);
WHERE long Active(long scanline, vertex  *v, face  *f,
                     double *leftedge, double *rightedge);
WHERE void SetPerspectiveView(void);
WHERE void SetTrPos(double fi, double theta, double alpha,
              short im, double ima,
              double sx, double sy, double sz, ivector Offset,
              vector Position,
              double trpos[4][4],
              double pos[4][4],
              double trinv[4][4]);
WHERE void PerspObstra(double xo, double yo, double zo,
                 double xt, double yt, double zt,
                 double to[4][4]);
WHERE void R_scal(double tr[4][4], double sx, double sy, double sz);
WHERE void R_rotz(double tr[4][4], double ang);
WHERE void R_rotx(double tr[4][4], double ang);
WHERE void R_roty(double tr[4][4], double ang);
WHERE void R_tram(double t[4][4], double dx, double dy, double dz);
WHERE void R_m4by4(double t1[4][4], double t2[4][4], double tr[4][4]);
WHERE void R_c4to4(double tin[4][4], double tout[4][4]);
WHERE void R_null_transform(double t[4][4]);
WHERE void R_m4by1(double t4[4][4], double x, double y, double z,
             double *xx, double *yy, double *zz);
WHERE void R_reflect(double t4[4][4], vector p, vector n);
WHERE void veccopy(vector v1, vector r);
WHERE void vecsub(vector v1, vector v2, vector r);
WHERE void vecsum(vector v1, vector v2, vector r);
WHERE void vecscale(double s, vector v, vector r);
WHERE short normalize(vector v);
WHERE double R_length(vector v);
WHERE void cross(vector v1,vector v2, vector r);
#undef WHERE

#ifdef MODULE_FX
#define WHERE
#else
#define WHERE extern
#endif
WHERE void EffectObjectVertices(long global, long O);
WHERE short LoadExternalTexture(char *name, char *parameters);
WHERE short MorphExternalTexture(char *name, char *parameters, long obj);
WHERE void FreeExternalTextures(void);
WHERE void GetExternalTexture(long axisid, long tid, long ctype,
                        vector p, vector n,
                        double alpha, double beta, double gamma,
                        double bump_scale,
                        double *ac,
                        double *transparency,
                        unsigned char sc[3],
                        long model_id, face *fp,
                        double colour[3]);
WHERE long ExternalImageProcess(long frame);
WHERE long MotionBlurFrame(long frame, long subframe, long command_id);
#undef WHERE

#ifdef MODULE_GIF
#define WHERE
#else
#define WHERE extern
#endif
WHERE short CompressWordLine(unsigned short *input, short *buffer,
                             long xmax);
WHERE void  UnCompressWordLine(short bufsize, short *buffer,
                               unsigned short *output);
WHERE long ScreenTo16bitFile(long frame, char *rawfile, char *out_root);
WHERE void FillAlfaLine(UCHAR *, long *[], long *);
WHERE void ScanlineToZbuffer(long, double *);
WHERE void ScanlineToZobject(long, long *);
WHERE long AntiAliasLine(long, long,
                         UCHAR *, UCHAR *, UCHAR *, UCHAR *,
                         UCHAR *, UCHAR *, UCHAR *, UCHAR *,
                         UCHAR *, UCHAR *, UCHAR *, UCHAR *);
WHERE void OneGifPalette(long firstframe, long lastframe, char *file_root, BOOL iLace);
WHERE void OneIffPalette(long firstframe, long lastframe, char *file_root,
                   short ham);
WHERE void Iff24Palette(long firstframe, long lastframe, char *file_root);
WHERE long out_line (unsigned char *pixels, long linelen);
WHERE long get_byte(void);
WHERE long SetupImageMap(imap *Map, char *objectfile);
WHERE void OneTargaFrame32(long, char *, char *, short, short);
WHERE void OneAlfaSeparate(long, char *, char *);
WHERE void OneTargaFrame16(long, char *, char *, short, short);
WHERE void FreeRenderBrush(imap *);
WHERE void OneTiffFrame(long frame, char *rawfile, char *out_root);
WHERE void OneExternalFrame(long frame, char *rawfile,
                            char *out_root, long type, long quality);
#undef WHERE

#ifdef MODULE_TEXTURE
#define WHERE
#else
#define WHERE extern
#endif
WHERE void init_spec(void);
WHERE void GetSkyLocation(void);
WHERE long PutBackIntersection(long, double, UCHAR *, double *,
                               long *[], long *[], double *[],
                               long *, long *, double *, double *,
                               double *);
WHERE long FastAntiAliasShadedScanline(long, long, double, long *,
                             UCHAR *, UCHAR *, UCHAR *,
                             double *, long, double,
                             long *, long *,
                             long *[], long *[], double *[],
                             long *, long *, double *, double *);
WHERE long ShadedScanline(long, double d2, long *,
                       UCHAR *, UCHAR *, UCHAR *,
                       double *, long, double,
                       long *[], long *[], double *[],
                       long *, long *, double *, double *);
WHERE void RenderWireframeObjects(long,
                       UCHAR *, UCHAR *, UCHAR *,
                       long *[], long *[], double *[],
                       long *, long *, double *, double *);
WHERE long MapBrush(imap *, short type, short clear,
                        vector p , double *red
                                 , double *green
                                 , double *blue);
WHERE long MapByCoordinates(imap *Map, long obj, face *f,
                        short type, short clear,
                        vector p , double *red
                                 , double *green
                                 , double *blue);
WHERE long MapTransByAxis(imap *Map, short type,
                        vector p , double *trans);
WHERE long MapTransByCoords(imap *Map, long obj, face *f,
                        vector p , double *trans);
WHERE long MapExternalByCoords(long obj,face *f, vector p,
                    double *alpha, double *beta, double *gamma);
WHERE void GetMirrorValues(double *color, vector p, vector d, vector n,
                           long, long, long);
WHERE void map_bumpy(short type, long obj, imap *Map, vector p,
                       vector n);
WHERE void BumpByCoordinates(imap *, long, face *, vector, vector);
WHERE void GetGroundLight(vector p0, double *R, double *G, double *B);
WHERE void MapMirror(double *, double *, double *,
                     imap *, vector, vector);
WHERE void (*GetPixelValue)(long, long, imap *,
                              eface * ,face *, long, vector,
                              UCHAR *, UCHAR *, UCHAR *,
                              double *, UCHAR *);
WHERE void GetPhongPixelValue(long, long, imap *,
                              eface * ,face *, long, vector,
                              UCHAR *, UCHAR *, UCHAR *,
                              double *, UCHAR *);
WHERE void GetTracePixelValue(long, long, imap *,
                              eface * ,face *, long, vector,
                              UCHAR *, UCHAR *, UCHAR *,
                              double *, UCHAR *);
WHERE double DepthCueLight(long, double);
#undef WHERE

#ifdef MODULE_TEXTUR2
#define WHERE
#else
#define WHERE extern
#endif
WHERE void  FreeTextureHashTable(void);
WHERE short Initialize_noise2(void);
WHERE void waves2(vector p, vector n, vector dx, vector dy, vector p0,
   vector Vector, double Frequency, double Phase, double Bump_Amount);
WHERE void wood_grain2(double *color, long obj, vector p,
                unsigned char *txcol, double turbulence, long t);
WHERE void wood_grain(double *color, long obj, vector p,
                       unsigned char *txcol, long t);
WHERE void spotted_grain(double *color, long obj, vector p,
                   unsigned char *txcol, long t);
WHERE void bozo_grain(double *color, long obj, vector p,
                   unsigned char *txcol, double turb, double zscale, long t);
WHERE void agate_grain(double *color, long obj, vector p,
                   unsigned char *txcol, long t);
WHERE void granite_grain(double *color, long obj, vector p,
                   unsigned char *txcol, long t);
WHERE double wrinkles(long obj, vector p, vector normal, double Bump_Amount, long t);
WHERE double new_bumpy(long obj, vector p, vector normal, double Bump_Amount,long t);
WHERE double dents(long obj, vector p, vector normal, double Bump_Amount, long t);
WHERE void Dnoise2(vector result, double x, double y, double z);
WHERE void ripples2(double x, double y, double z, double Frequency,
              double phase, double Bump_Amount, vector Vector);
WHERE void init_noise(void);
WHERE double noise(double x, double y, double z);
WHERE double aztec_bumpy(long obj, vector p, vector n, double bumpyness, long t);
WHERE void marble_grain(double *color, long obj, vector p,
                  unsigned char *txcol, long t);
WHERE void blend_grain(double *color, long obj, vector p,
                unsigned char *txcol, long t);
WHERE void calcripple(vector point, vector wave_centre,
                double wave_propagate,double wave_wavelength,
                double wave_drag, double wave_amplitude,
                vector ripple);
WHERE void init_ripples(void);
WHERE void Ocean(vector p0, vector Groundn, vector gn);
#undef WHERE

#ifdef MODULE_CSG
#define WHERE
#else
#define WHERE extern
#endif
WHERE void GetCSGintersections(long, double, long *, double *,
                               long *, long *, double *);
WHERE void GetCSGvalue(long, long, double, long *,
                       UCHAR *, UCHAR *, UCHAR *,
                       double *, double *);
WHERE void TransformCSG(void);
#undef WHERE

#ifdef MODULE_DITHER
#define WHERE
#else
#define WHERE extern
#endif
WHERE void DitherLine(long scanline,long xmax, unsigned char *R,
                      unsigned char *G, unsigned char *B);
WHERE BOOL AllocateThreadStorage(THD *);
WHERE void FreeThreadStorage(THD *);
WHERE short SetUpDitherScanLines(void);
WHERE void ResetDither(void);
WHERE void FreeDitherScanLines(void);
WHERE void Render_Message(short number, short query, char *str);
WHERE int  (*X_message)(const char *,...);
WHERE int  X__local_print(const char *,...);
WHERE void setup_render_discarded_list(void);
WHERE void free_render_discarded_list(void);
WHERE char *GetRenderReplacementFilename(char *name);
WHERE FILE *GetRenderRelativeFile(char *fn, char *objectfilename, char *newname);
WHERE HANDLE GetRenderRelativeHandle(char *fn, char *objectfilename, char *newname);
#undef WHERE

#ifdef MODULE_MIRRORS
#define WHERE
#else
#define WHERE extern
#endif
WHERE void GetSurfaceValue(int, face *, pface *, vertex *, eface *,
                     vector, vector,
                     double *, double *, double *,
                     long, long, long);
WHERE int R_intersect_face(vector p, vector d,
                     vector p0, vector p1, vector p2, vector n,
                     double *depth, double tollerance);
WHERE void PointInShadow(vector p, long id, double *intensity);
WHERE void Add_Ground_Mirror(long, long, vector, unsigned char *,
                     unsigned char *,unsigned char *);
#undef WHERE

#ifdef MODULE_NURBS
#define WHERE
#else
#define WHERE extern
#endif
WHERE void FreeNurbs(long, nurbs *);
WHERE BOOL AllocNurbs(nurbs *, double *, double *);
WHERE BOOL MeshNurbsSurfaces(long);
#undef WHERE

#ifdef TRACER
#ifdef MODULE_TRACE
#define WHERE
#else
#define WHERE extern
#endif
WHERE short check_for_shadow(long obj, vector p, vector natp);
WHERE short trace_reflection_ray(vector p, vector d, double depth_max,
                          double *colour,
                          long, long, long);
WHERE void  trace_refraction_ray(vector p, vector d, vector n,
                          int obj, face *f,
                          double depth_max, double *colour,
                          long, long, long);
WHERE void trace_transmission_ray(vector p, vector d, vector n,
                          int at_o, face *at_f,
                          double depth_max, double *colour,
                          long trace_reflection_depth,
                          long trace_refraction_depth,
                          long refractive_flag);
WHERE int buildBST(void);
WHERE void freeBST(void);
#undef WHERE
#endif

extern short AddToRenderFlicFile(long scanline,
                                 unsigned char *R,
                                 unsigned char *G,
                                 unsigned char *B);
extern void AnimatorHiddenLineCallback(long scanline, long xmax,
         unsigned char *r,unsigned char *g, unsigned char *b);
extern void AddToRenderImagePreview(long index,
                                    long xmax, long ymax,
                                    fullscreenbuffer *f,
                                    unsigned char *R,
                                    unsigned char *G,
                                    unsigned char *B);

