/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* settings.h */

#define RD_CONTROL                     4000
#define RD_CONTROL_CANCEL              4001
#define RD_FILE                        3001
#define RD_RESOLUTION                  3002
#define RD_AA                          3007
#define RD_X_SIZE                      3019
#define RD_Y_SIZE                      3020
#define RD_CONTROL_RENDER              4002
#define RD_CONTROL_OPTIONS             4005
#define RD_CONTROL_HELP                4006
#define RD_X_SIZE_SPIN                 4007
#define RD_Y_SIZE_SPIN                 4008
#define RD_CONTROL_DITHER              4010
#define RD_CONTROL_STILLFILEDIR        4011
#define RD_CONTROL_STILLFILENAME       4012
#define RD_CONTROL_CDSTILL             4013
#define RD_CONTROL_CURRENTFRAME        4015
#define RD_CONTROL_CURRENTFRAME_SPIN   4016
#define RD_CONTROL_FIRSTFRAME          4018
#define RD_CONTROL_FIRSTFRAME_SPIN     4019
#define RD_CONTROL_LASTFRAME           4020
#define RD_CONTROL_LASTFRAME_SPIN      4022
#define RD_CONTROL_ANIMFILEDIR         4023
#define RD_CONTROL_ANIMFILENAME        4024
#define RD_CONTROL_CDANIM              4025
#define RD_CONTROL_SPECIFIED           5000
#define RD_CONTROL_FIRST               5001
#define RD_CONTROL_XLAB                5002
#define RD_CONTROL_YLAB                5003
#define RD_CONTROL_LAST                5004
#define RD_CONTROL_FLI                 5005
#define RD_CONTROL_AVI                 5006
#define RD_CONTROL_GIF                 5007
#define RD_CONTROL_ONEFRAME            5008
#define RD_CONTROL_MANYFRAMES          5009
#define RD_CONTROL_CONSTRAIN           5010

#define RD_UPDATE                      4026
#define RD_UPDATE_STOP                 4027
#define RD_UPDATE_FRAME                4028
#define RD_UPDATE_FRAMES               4029
#define RD_UPDATE_FF                   4030
#define RD_UPDATE_LF                   4031
#define RD_UPDATE_STATUS               4032
#define RD_UPDATE_LFT                  4033
#define RD_UPDATE_ETA                  4034
#define RD_UPDATEX                     4035
#define RD_UPDATEX_VIEW                4036
#define RD_UPDATEX_LOGGING             4037
#define RD_UPDATEX_SHOWFINAL           4038
#define RD_UPDATE_INFO                 4039

#define RD_OPTIONS                     3025
#define RD_ACCELERATED_AA              3008
#define RD_HIDDEN_LINE                 3009
#define RD_NO_SMOOTHING                3010
#define RD_NO_INTERNAL                 3011
#define RD_FULL_SCREEN                 3012
#define RD_NOISE_VALUE                 3006
#define RD_SMOOTHING                   3013
#define RD_AMBIENT                     3014
#define RD_SHADOW_DENSITY              3015
#define RD_SPOTLIGHT_SIZE              3016
#define RD_HIDDEN_ANGLE                3017
#define RD_ANIM_SPEED                  3021
#define RD_OPTIONS_HELP                3027
#define RD_OPTIONS_PATH                3028
#define RD_OPTIONS_CDPATH              3029
#define RD_ANIM_SPEED_SPIN             3030
#define RD_SMOOTHING_SPIN              3031
#define RD_AMBIENT_SPIN                3032
#define RD_SHADOW_DENSITY_SPIN         3033
#define RD_SPOTLIGHT_SIZE_SPIN         3034
#define RD_HIDDEN_ANGLE_SPIN           3035
#define RD_NOISE_VALUE_SPIN            3036
#define RD_COLOUR0_OPTIONS             3037
#define RD_ZBUFFER                     3038
#define RD_NTSC_COLOURS                3039
#define RD_MOTION_BLUR                 3040
#define RD_MOTION_BLUR_SPIN            3041
#define RD_FULL_MIRROR                 3042
#define RD_ALFA_GROUND                 3043
#define RD_OBJECTID                    3044
#define RD_ALFA_EXTRA                  3045
#define RD_CALLBACK                    3046
#define RD_EDITPRESET                  3047
#define RD_LOADOWNPREFS                3048
#define RD_SAVEOWNPREFS                3049
#define RD_JPEG                        3050
#define RD_TZEROS                      3051
#define RD_TZEROS_SPIN                 3052
#define RD_THREADS                     3053
#define RD_INTERLACEGIF                3054

#define RD_TRACE_REFLECTIONS           3071
#define RD_TRACE_REFRACTIONS           3072
#define RD_TRACE_SHADOWS               3073
#define RD_TRACE_OPT_FAST              3074
#define RD_TRACE_OPT_SLOW              3075
#define RD_TRACE_OPT_DEPTH             3076
#define RD_TRACE_OPT_THRESHOLD         3077
#define RD_TRACE_OPT_SIZE              3078
#define RD_TRACE_OPT_DEPTH_SPIN        3079
#define RD_TRACE_OPT_THRESHOLD_SPIN    3080
#define RD_TRACE_OPT_SIZE_SPIN         3081

#define DLG_PREFERENCES                3100
#define DLG_PREFERENCES_ZBUFFER        3101
#define DLG_PREFERENCES_SBUFFER        3102
#define DLG_PREFERENCES_ACCELAA        3103
#define DLG_PREFERENCES_DLG3D          3104
#define DLG_PREFERENCES_LOGFILE        3105
#define DLG_PREFERENCES_PERSONAL       3106
#define DLG_PREFERENCES_UPDATE         3107
#define DLG_PREFERENCES_PREVIEW        3108
#define DLG_PREFERENCES_TZERO_STILL    3109
#define DLG_PREFERENCES_BEEP_AFTER     3110
#define DLG_PREFERENCES_AUTOSHOW       3111
#define DLG_PREFERENCES_AUTOPLAY       3112

#define DLG_TAB                        4500
#define DLG_TAB_CONTROL                4501
#define DLG_TAB_OPTIONS                4503
#define DLG_TAB_SETTINGS               4504
#define DLG_TAB_TRACING                4505

#define IDBM_BACKGROUND                1000


