#include "stdafx.h"
#include "mydllres.h"
#include "mydll.h"
#include "myclass.h"

#include <stdio.h>


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyClass dialog


CMyClass::CMyClass(CWnd* pParent, LPLONG lpSerialNo, LPSTR lpszName)
	: CDialog(CMyClass::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMyClass)
	m_StrName = _T(lpszName);
//	m_Serial  = _T("ABCD-0123-AB01-EA10");
	m_Serial  = _T("ANYTHING WILL DO !!");
	//}}AFX_DATA_INIT
}


void CMyClass::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyClass)
	DDX_Text(pDX, RS_STR_NAME, m_StrName);
	DDV_MaxChars(pDX, m_StrName, 150);
	DDX_Text(pDX, RS_STR_SERIAL, m_Serial);
	DDV_MaxChars(pDX, m_StrName, 19);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMyClass, CDialog)
	//{{AFX_MSG_MAP(CMyClass)
	ON_BN_CLICKED(RS_PBUT_RETRY, OnPbutRetry)
	ON_EN_CHANGE(RS_STR_NAME, OnChangeStrName)
	ON_EN_CHANGE(RS_STR_SERIAL, OnChangeStrSerial)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMyClass message handlers

void CMyClass::OnPbutRetry() 
{

   EndDialog( RS_PBUT_RETRY );  
}

void CMyClass::OnChangeStrName() 
{
	ProcessChange();
	
}

void CMyClass::OnChangeStrSerial() 
{
	// TODO: Add your control notification handler code here
	
}


/*----------------------------------------------------------------------------\
 *
 * Function: ProcessChange()
 *
 *  Purpose: To check whether the user input a string with stringlength
 *           greater than zero.  Also to check if the string consisted
 *           of atleast one non-space character.
 *
 *           ProcessChange() uses a utility function IsSpaceString()
 *           which returns TRUE if all characters are spaces in a
 *           string, FALSE otherwise.
 *
 *    Input: None
 *                                                                              
 *  Returns: None
 *
\*---------------------------------------------------------------------------*/
void CMyClass::ProcessChange()
{
    // Get pointer to the Window class for 'Next >' push button.
    // If unable to get it, return back!
    
    CWnd* LocalCWnd = NULL;
    LocalCWnd       = GetDlgItem( RS_PBUT_CONTINUE );
    
    if( LocalCWnd == NULL )
    {
	MessageBox( "Unable to obtain Push button Handle!" );
	return;
    }
  
    // Retrive data from the edit fields.
    UpdateData( TRUE );

    // If 'Name:' edit field is either empty, or only spaces, disable
    // the 'Next' button.  Same goes for other strings.
    
    if( m_StrName.IsEmpty() || IsSpaceString( &m_StrName ) )
    {
	LocalCWnd -> EnableWindow( FALSE );
	return;
    }

    LocalCWnd -> EnableWindow( TRUE );
}


/*----------------------------------------------------------------------------\
 *
 * Function: IsSpaceString()
 *
 *  Purpose: Checks to see if all the characters in a string are spaces.
 *
 *    Input: CString*
 *
 *  Returns: TRUE  if all characters in string pointed by CString* are spaces.
 *           FALSE otherwise.
 *
\*---------------------------------------------------------------------------*/
BOOL CMyClass::IsSpaceString( CString* Str )
{
   BOOL bIsSpace = TRUE;
   for( int i=0; i<(Str -> GetLength()); i++ )
   {
	if( Str -> GetAt(i) != ' ' )
	{
	    bIsSpace = FALSE;
	    break;
	}
   }
   return bIsSpace;
}


/*----------------------------------------------------------------------------*\
 *
 * Function: OnInitDialog()
 *           (CMyClass class)
 *
 *  Purpose: When WM_INITDIALOG message is send, set the Information Header
 *           in static text field, and also set the Dialog Title.
 *                                                                              
 *    Input: None
 *                                                                              
 *  Returns: TRUE  - since we do not want to set focus to control
 *
\*----------------------------------------------------------------------------*/
BOOL CMyClass::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Change the title of the Dialog Window.
	SetWindowText( "OpenFX Setup" );

	// Following piece of code moves the dialog in the center of the
	// screen.

	RECT rect;
	CDialog::GetWindowRect( (LPRECT) &rect );

	// Get Dialog Window Width and Height.
	int nDialogWidth = rect.right - rect.left;
	int nDialogHeight = rect.bottom - rect.top;

	// Get Screen Width and Height.
	int nScreenWidth  = GetSystemMetrics( SM_CXSCREEN );
	int nScreenHeight = GetSystemMetrics( SM_CYSCREEN );

	// Modify the positioning of the Window.
	rect.left   = (nScreenWidth - nDialogWidth )/2;
	rect.top    = (nScreenHeight -  nDialogHeight )/2;
	rect.right  = rect.left + nDialogWidth;
	rect.bottom = rect.top + nDialogHeight;

	// Move the Dialog Window in center of the screen.
	CDialog::MoveWindow( &rect );

	return TRUE;  // return TRUE unless you set the focus to a control
		      // EXCEPTION: OCX Property Pages should return FALSE
}


/*----------------------------------------------------------------------------*\
 *
 * Function: OnPaint()
 *
 *  Purpose: Paints the BITMAP and 'CUTIN' line in the Dialog,  giving
 *           dialog the look and feel of in WIN 95 common dialogs.
 *
 *    Input: None
 *                                                                              
 *  Returns: None
 *
\*----------------------------------------------------------------------------*/
void CMyClass::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
    // Do not call CDialog::OnPaint() for painting messages
   
   // Get the pointer to the Frame (rectangle) in which the bitmap is to
   // be drawn.
   CWnd* pCWndLocal = NULL;
   pCWndLocal       = GetDlgItem( RS_BMP_FRAME );

   if( pCWndLocal == NULL )
   {
      MessageBox( "Unable to retrive the Image Frame handle!" );
      return;
   }

   // Retrive the size of the frame and convert the co-ordinated to
   // use the Dialog co-ordinates (from screen co-ordinates).
   RECT tempRect;
   pCWndLocal -> GetWindowRect( &tempRect );

   POINT pt;
   pt.x = tempRect.left;
   pt.y = tempRect.top;

   int nWidth  = tempRect.right - tempRect.left;
   int nHeight = tempRect.bottom - tempRect.top;
   ScreenToClient( &pt );

   // Store the modified co-ordinates of the rectangle.
   RECT rect;
   rect.left   = pt.x;
   rect.top    = pt.y;
   rect.right  = rect.left + nWidth;
   rect.bottom = rect.top + nHeight;

   // Load the bitmap resource
   CBitmap bmp;
   CBitmap* pOldBitmap = NULL;
   if( !bmp.LoadBitmap( RS_BMP_IMAGE )  )
   {
       MessageBox( "Unable to retrive the Image handle!" );
       return;
   }

    // Cretate a compatible DC and draw the bitmap.
    CDC dcMem;
    dcMem.CreateCompatibleDC( &dc );
    pOldBitmap = dcMem.SelectObject( &bmp );
    dc.BitBlt( rect.left, rect.top, nWidth, nHeight, &dcMem, 0, 0, SRCCOPY );
    dcMem.SelectObject( pOldBitmap );
    dcMem.DeleteDC();

    // Draw the 'cutin' line around rectangle ( bSingle = FALSE)
    // to give 3D appearence
    if( !DrawCutInLine( &dc, (LPRECT) &rect, FALSE ) )
    {
	MessageBox( "Unable to Draw CutIn Line!" );
	return;
    }

    // Draw the cutin line just above the push buttons
    pCWndLocal = GetDlgItem( RS_CUTIN_LINE );
    if( pCWndLocal == NULL )
    {
	MessageBox( "Unable to retrive the CUTIN2 line handle!" );
	return;
    }

    pCWndLocal -> GetWindowRect( &tempRect );
    pt.x = tempRect.left;
    pt.y = tempRect.top;

    nWidth  = tempRect.right - tempRect.left;
    nHeight = tempRect.bottom - tempRect.top;
    ScreenToClient( &pt );

    rect.left   = pt.x;
    rect.top    = pt.y;
    rect.right  = rect.left + nWidth;
    rect.bottom = rect.top + nHeight;

    if( !DrawCutInLine( &dc, (LPRECT) &rect, TRUE ) )
    {
	MessageBox( "Unable to Draw CutIn2 Line!" );
	return;
    }   
}

/*----------------------------------------------------------------------------*\
 *
 * Function: DrawCutInLine()
 *
 *  Purpose: Draws the 'CutIn' line.
 *
 *    Input: pPdc    -  Pointer to the CDC Class
 *           pRect   - Pointer to rectangle with point co-ordinates
 *           bSingle - TRUE if only one pixel width CutInLine is
 *                     to be drawn.
 *                                                                              
 *  Returns: TRUE if drawn properly.
 *
 * Comments: The CutIn line is drawn in light shade on one side of the
 *           rectangle, and dark shade on the other side, thus giving
 *           it the 3D appearence.
 *
 *           If bSingle is TRUE, we are drawing the CUTIN line just above
 *           the push buttons, and needs to be only 2 pixel wide - one
 *           pixel of dark pen, and another pixel of light pen.
\*----------------------------------------------------------------------------*/
BOOL CMyClass::DrawCutInLine( CDC* pPdc, LPRECT pRect, BOOL bSingle )
{
    // Use the color defined for SHADOW to create DARK pen and create a
    // pen.

    CPen DarkPen;
    if( !DarkPen.CreatePen( PS_SOLID, 1, GetSysColor( COLOR_BTNSHADOW )))
    {
	MessageBox( "Unable to create pen!" );
	return( FALSE );
    }

    // Select the New pen, storing the old one.
    CPen* pOldPen = NULL;
    pOldPen       = pPdc -> SelectObject( &DarkPen );

    // Draw the lines on the left side corner of the rectangle, if
    // bSingle != TRUE

    if( bSingle )
	pPdc -> MoveTo( pRect -> left,  pRect -> top );
    else
    {
	pPdc -> MoveTo( pRect -> left,  pRect -> bottom );
	pPdc -> LineTo( pRect -> left,  pRect -> top );
    }
    pPdc -> LineTo( pRect -> right, pRect -> top );
    
    // Create a light pen, and draw lines on the right corner of the
    // rectangle.

    CPen LightPen;
    if( GetSysColor( COLOR_BTNFACE ) == RGB( 255, 255, 255 ) )
    {
	if( !LightPen.CreatePen( PS_SOLID, 1, GetSysColor( COLOR_BTNSHADOW )))
	{
	    MessageBox( "Unable to create pen!" );
	    return( FALSE );
	}
    }
    else
    {
	if( !LightPen.CreatePen( PS_SOLID, 1, RGB( 255, 255, 255)))
	{
	    MessageBox( "Unable to create pen!" );
	    return( FALSE );
	}
    }

    // NOTE:  Do not save this intermediate return pen value.  We
    //        already have the original pen value stored.
    pPdc -> SelectObject( &LightPen );

    if( bSingle )
    {
       pPdc -> MoveTo( pRect -> left,  pRect -> top+1 );
       pPdc -> LineTo( pRect -> right, pRect -> top+1 );
    }
    else
    {
      pPdc -> MoveTo( pRect -> left+1,  pRect -> bottom );
      pPdc -> LineTo( pRect -> right-1, pRect -> bottom );
      pPdc -> LineTo( pRect -> right-1, pRect -> top );
    }
    
    // Select the original Pen value.
    pPdc -> SelectObject( pOldPen );
    return( TRUE );
}

#include "password.h"

extern "C"
LONG WINAPI DrawMFCDialog( HWND hWndParent, LPLONG lpSerialNo, LPSTR lpszName )
{
   LONG nReturn;
   TRACE0( "Inside MYDLL.DLL\n" );

   // All DLL entry points should have a top-level TRY/CATCH block.
   // Otherwise, it would be possible to throw an uncaught exception from
   //  an the DLL.  This would most likely cause a crash.

   TRY
   {
	// Call the constructor of the dialog class, to copy the default
	// values to the class members.
	CMyClass dlg( CWnd::FromHandle(hWndParent), lpSerialNo, lpszName );

	// Create and display Modal dialog box and return the ID of
	// pushbutton selected by the user without updating, if
	// user selected either 'Cancel' or '< Back' button.
	nReturn = (LONG) dlg.DoModal();

	if( (nReturn == (LONG)RS_PBUT_RETRY ) || (nReturn == (LONG)RS_PBUT_CANCEL) )
	  return( nReturn );

	// Update the strings.
	lstrcpy( lpszName, dlg.m_StrName );
	char str[256];
	memset(str,0,256);
	strcpy(str,dlg.m_Serial);
    *lpSerialNo = 2002;
	return nReturn; // Any serial number will do
	if(strcmp(str,"ofx") == 0){
	  *lpSerialNo = 2002;
	  return nReturn;
	}
	BOOL ok=TRUE;
	for(int i=0;i<19;i++){
	  if((i == id1 || i == id2 || i == id3) && str[i] != tpl[i])
	    ok=FALSE;
	}
	if(!ok)*lpSerialNo = 0;
	else   *lpSerialNo = 2002;
//if(ok)::MessageBox(hWndParent,str,"OK",NULL);
//else  ::MessageBox(hWndParent,str,tpl,MB_OK);
   }
   CATCH_ALL(e)
   {
      // A failure caused an exception!
      return FALSE;
   }
   END_CATCH_ALL

   return( nReturn );
}

static char *shader_scriptc[]={
"RS",                   //1
"1 1",
"e 0.0 0.0 0.0",
"  0.0 0.0 0.0",
"  1.597 1.916 1.597",
"  0 0 0.0",
"o 1",         //7
"$:\\OPENFX\\SCRIPTS\\TEXTURE_C.MFX                                              ",
"0",
"  321.0 194264.0 -4182.0",
"  -9.0 -56.0 51.0",
"  0.900 0.900 0.900",
"  0 0 0.0 0 1.000",                      //13
"  1 1 1",
"l 0",
"  235 235 235 1.0",
"  37052.0 6862.0 29989.0",
"  0.0 0.0 0.0",
"  0 0 0.0",
"  0 1.0 0.0 0.0",
"s 128 60 60",
"  0 128 255",
"  0.0 0.10 0.08",                        //21
"  0 0 0",
"  0 0 0",
"  0",
"l 0",
"  185 185 185 1.0",
"  -141881.0 258093.0 128666.0",
"  0.0 0.0 0.0",
"  0 0 0.0",
"  1.0 0 1.0 0.0 0.0",
"f",
"q"                                       //31
};

char *shader_scripts[]={
"RS",                       //1
"1 1",
"e 0.0 0.0 0.0",
"  0.0 0.0 0.0",
"  1.000 1.200 1.000",
"  0 0 0.0",
"o 1",            //7
"$:\\OPENFX\\SCRIPTS\\TEXTURE_S.MFX                                             ",
"0",
"  -978.0 81757.0 0.0",
"  0.0 0.0 0.0",
"  0.800 0.800 0.850",
"  0 0 0.0 0 1.000",
"  1 1 1",
"l 0",
"  255 255 255 1.0",
"  37052.0 6862.0 29989.0",
"  0.0 0.0 0.0",
"  0 0 0.0",
"  0 1.0 0.0 0.0",
"s 128 60 60",
"  0 128 255",
"  0.0 0.10 0.08",                        //21
"  0 0 0",
"  0 0 0",
"  0",
"f",
"q"                                       //26
};


static void SetupPreviewScripts(char *dest){
 int i,j;
 FILE *fo;
 char destdir[256],line[256],c[2]={'c','s'};
 strcpy(destdir,dest);
 if(dest[strlen(dest)-1] != '\\')strcat(destdir,"\\");
 sprintf(line,"%sobjects",destdir);
 WritePrivateProfileString("RPREFERENCES","MODEL-PATH1",line,"OPENFX_.INI");
 sprintf(line,"%simages",destdir);
 WritePrivateProfileString("RPREFERENCES","MAP-PATH1",line,"OPENFX_.INI");
 for(i=0;i<2;i++){
   sprintf(line,"%sSCRIPTS\\TEXTURE_%c.SCR",destdir,c[i]);
   fo=fopen(line,"w");
   if(fo != NULL){
     if(i == 0){
       sprintf(shader_scriptc[7],"%sSCRIPTS\\TEXTURE_C.MFX",destdir);
       for(j=0;j<30;j++)fprintf(fo,"%s\n",shader_scriptc[j]);
     }
     else{
       sprintf(shader_scripts[7],"%sSCRIPTS\\TEXTURE_S.MFX",destdir);
       for(j=0;j<25;j++)fprintf(fo,"%s\n",shader_scripts[j]);
     }
     fclose(fo);
   }
   else{
     ::MessageBox(NULL,"Failed to create Texture Preview Scripts","Error",MB_OK|MB_TASKMODAL);
   }
 }
}

static BOOL WriteRegistryItem(char *keyname, char *keyvalue){
 HKEY hkey;
 DWORD result;
 if(RegCreateKeyEx(HKEY_CLASSES_ROOT,keyname,0,NULL,REG_OPTION_NON_VOLATILE,
		   KEY_ALL_ACCESS,NULL,&hkey,&result) != ERROR_SUCCESS)
   return FALSE;
 if     (result == REG_CREATED_NEW_KEY    ){;}//printf("Open new %s\n",keyname);
 else if(result == REG_OPENED_EXISTING_KEY){;}//printf("Open existing %s\n",keyname);
 else                                      {;}//printf("Unknown condition");
 if(keyvalue != NULL){
   if(RegSetValueEx(hkey,NULL,0,REG_SZ,(CONST LPBYTE)keyvalue,strlen(keyvalue)+1)
     != ERROR_SUCCESS)return FALSE;
 }
 RegCloseKey(hkey);
 return TRUE;
}

static void SetupRegistry(char *destdir){
 char line[256];
 if(!WriteRegistryItem(".mfx","mfxfile"))return;
 if(!WriteRegistryItem("mfxfile","OpenFX Model"))return;
 sprintf(line,"%sdesign.exe,0",destdir);
 if(!WriteRegistryItem("mfxfile\\DefaultIcon",line))return;
 if(!WriteRegistryItem("mfxfile\\Extensions\\MFX","OpenFX Model File"))return;
 sprintf(line,"%sdesign.exe %%1",destdir);
 if(!WriteRegistryItem("mfxfile\\shell\\open\\command",line))return;
 if(!WriteRegistryItem(".ofx","ofxfile"))return;
 if(!WriteRegistryItem("ofxfile","OpenFX Animation"))return;
 sprintf(line,"%sopenfx.exe,0",destdir);
 if(!WriteRegistryItem("ofxfile\\DefaultIcon",line))return;
 if(!WriteRegistryItem("ofxfile\\Extensions\\OFX","OpenFX Animation File"))return;
 sprintf(line,"%sopenfx.exe %%1",destdir);
 if(!WriteRegistryItem("ofxfile\\shell\\open\\command",line))return;
 return;
}

extern "C"
LONG WINAPI MakeFiles( HWND hwndMain, LPLONG lplValue, LPSTR pszString )
{
   SetupPreviewScripts(pszString);
   // UNcomment the line below to set the registry to relate OFX and MFX files
   // with the ANIMATE and DESIGN exe files
   //SetupRegistry(pszString);
   //AfxMessageBox("Registry NOT setup");
   return 1;
}

extern "C"
LONG WINAPI MakeUser( HWND hwndMain, LPLONG lplValue, LPSTR pszString )
{
   WritePrivateProfileString("LOGON","USERID",pszString,"SOFT_FX.INI");
   return 1;
}


extern "C"
LONG WINAPI RegisterHelp( HWND hwndMain, LPLONG lplValue, LPSTR dest)
{
  // not called unless RUL file is altered
  int iReturn=1;
  char ocx[256];
  strcpy(ocx,dest);
  if(dest[strlen(dest)-1] != '\\')strcat(ocx,"\\");
  strcat(ocx,"\\hhctrl.ocx");
  char _szDllRegSvr[] = "DllRegisterServer";
  char _szDllUnregSvr[] = "DllUnregisterServer";
  HINSTANCE _hInstance = NULL;
  HRESULT (__stdcall * lpDllEntryPoint)(void);
  LPSTR pszDllEntryPoint = _szDllRegSvr;
  LPSTR pszDllName = NULL;    
  pszDllName=ocx;
//  ::MessageBox(NULL,pszDllName,"Registering",MB_OK);
  if (FAILED(::OleInitialize(NULL)))
	{
	   ::MessageBox(NULL,"OLE failed",NULL,MB_OK);
		return 0;
	}
  HINSTANCE hLib = LoadLibrary(pszDllName);
  if (hLib < (HINSTANCE)HINSTANCE_ERROR)
  {
	 ::MessageBox(NULL,"Load Lib Fail",NULL,MB_OK);
     iReturn = 0;
	 goto CleanupOle;
	}
	(FARPROC&)lpDllEntryPoint = GetProcAddress(hLib, pszDllEntryPoint);
	if (lpDllEntryPoint == NULL)
	{
		TCHAR szExt[_MAX_EXT];
		_tsplitpath(pszDllName, NULL, NULL, NULL, szExt);
		if ((stricmp(szExt, ".dll") != 0) && (stricmp(szExt, ".ocx") != 0))
	   ::MessageBox(NULL,"Not OCX",NULL,MB_OK);
		else
	       ::MessageBox(NULL,"No Library Entry",NULL,MB_OK);

		iReturn = 0;
		goto CleanupLibrary;
	}
	if (FAILED((*lpDllEntryPoint)()))
	{
	::MessageBox(NULL,"Call Failed",NULL,MB_OK);
		iReturn = 0;
		goto CleanupLibrary;
	}

//::MessageBox(NULL,"Registration OK","OK",MB_OK);
CleanupLibrary:
	FreeLibrary(hLib);
CleanupOle:
	::OleUninitialize();
	return iReturn;
}


