/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <int.h>
#include <dos.h>
#include "\x-32vm\include\x32.h"

#define INTNO 0x60
#define _FAR

typedef struct tfxinfo_tag{
 long tid;       /* the id of the texture starts at 16        */
 long frame;     /* the frame of the animation                */
 double alpha,   /* position of surface point relative to the */
        beta,    /* shader axes alpha/beta in plane of axes   */
        gamma;   /* gamma at right angles to plane            */
 double x,y;     /* the surface mapping coords - if available */
 double   R,G,B; /* returned RGB colours on scale if 0-255.0  */
 unsigned char fc[3], /* original colour of face              */
               sc[3]; /* secondary (shader) colour for face   */
 unsigned char pad1,pad2;
} tfxinfo;

ExternalTextureProcedure(unsigned short tid, tfxinfo _FAR *TFXinfo);

int cdecl tsr_install (void);
int cdecl tsr_remove  (void);

main(int argc, char **argv){
int i;
 i=tsr_install();
 if(i==1){
   printf("Program already loaded! - unloading\n");
   i=tsr_uninstall();
   if(i==0)printf("Program removed\n");
   else if(i==2)printf("Can not remove, Program not loaded!\n");
   else if(i==3)printf("Can not remove, Another program loaded above\n");
   exit(0);
 }
 else           printf("Failed to install, error %i\n",i);
}

int cdecl tsr_test_vect ( unsigned vno , unsigned dataseg );
int cdecl tsr_already_in ( void );
int cdecl tsr_new_interrupt ( struct INT_DATA* );

char tsr_fprint[20] = "tsrclock.v1";  /* unique string*/
volatile int cdecl tsr_running;
volatile char cdecl oldinterrupt[4];
volatile int cdecl oldpsp;
int cdecl tsr_vect_changed;
unsigned cdecl tsr_codeseg;
struct SREGS segregs;
union REGS regs;

tsr_install(void){
 unsigned code,data,stack,extra;
 if(tsr_already_in() !=0)return 1;
 oldpsp=_psp;
// peek(0x0,INTNO*4,&oldinterrupt,4);
 int_intercept(INTNO,tsr_new_interrupt,1500);
// regs.x.dx=_datapar;
// regs.x.dx=regs.x.dx+_progpar;
 regs.h.ah=0x31;
 intdos(&regs,&regs);
}

tsr_uninstall(void){
  return 0;
}

tsr_test_vect(unsigned vno, unsigned dataseg){
#if 0
unsigned lseg,loff;
 segread(&segregs);
 tsr_codeseg=dataseg-(segregs.ds-segregs.cs);
 int_getvector(vno,&loff,&lseg);
 if((lseg == tsr_codeseg) || (lseg == dataseg)) return;
 else  tsr_vect_changed+=1;
#endif
}

tsr_already_in(void){
  return 0;
}

tsr_new_interrupt(struct INT_DATA *p){
 tfxinfo *TFXinfo;
 unsigned short off,seg,tid;
 if(tsr_running)return 0;
 tsr_running=1;
 off=p->regs.x.ax;
 seg=p->regs.x.bx;
 tid=p->regs.x.cx;
printf("External procedure called for texture %ld  off=%lx seg=lx\n",tid,off,seg);
 TFXinfo=(tfxinfo *)((unsigned int)_x32_zero_base_ptr + ((long)seg << 4) + (long)off);
printf("texture %ld\n",TFXinfo->tid);
printf("frame  %ld\n",TFXinfo->frame);
printf("x-y  %lf %lf\n",TFXinfo->x,TFXinfo->y);
printf("color %ld %ld %ld\n",TFXinfo->fc[0],TFXinfo->fc[1],TFXinfo->fc[2]);
 ExternalTextureProcedure(tid,TFXinfo);
 tsr_running=0;
 return 1;
}

ExternalTextureProcedure(unsigned short tid, tfxinfo _FAR *TFXinfo){
 TFXinfo->R=0.0;
 TFXinfo->G=255.0;
 TFXinfo->B=0.0;
}
