/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file addsnd.C || */

#define MODULE_MAIN

#define  STRICT

#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <commctrl.h>
//#include <windowsx.h>
#include <mmsystem.h>
#include <vfw.h>
#include "addsnd.h"

#define AVIIF_KEYFRAME  0x00000010L // this frame is a key frame.
#define BUFSIZE 256

#define EVI_Malloc(s)    LocalAlloc(LMEM_FIXED,s)
#define EVI_Free(p)      LocalFree((HLOCAL)p)
#define EVI_Realloc(p,s) LocalReAlloc((HLOCAL)p,s,LMEM_MOVEABLE)
#define StartWait() hcurSave = SetCursor(LoadCursor(NULL,IDC_WAIT))
#define EndWait()   SetCursor(hcurSave)

#define IDM_SYS_AVI 0x10
#define IDM_SYS_DIB 0x20

static BOOL configureAVIfile(HWND, char *);
static BOOL CALLBACK AboutDlgProc(HWND,UINT,WPARAM,LPARAM);
static LONG WINAPI MainWndProc(HWND, UINT, WPARAM, LPARAM);
static BOOL CALLBACK PrefsDlgProc(HWND hdlg,UINT msg,
                           WPARAM wparam,LPARAM lparam);
static int SelectFileName(int save, char *szfile, char *szdir,
                          char *szTitle, char *szfilter, HWND parent);
static void AppendFileExtension(char *filename, char *ext);
static PSTR FileInPath(PSTR pstrPath);
static void GetFilesInSequence(void);
static void WriteAVI(void);
static void CopyAVI(BOOL audio);

static HWND      glWndFrame=NULL,hWndList=NULL,
                 hWndStatus=NULL,hWndProgress=NULL;
static HINSTANCE glInstance;
static CHAR      szAppName[]="OFX:SoundClass";
static CHAR      szFileName[256],szDirName[256];
static CHAR      szVideoFile[256],szAudioFile[256];
static CHAR      gszHomeDir[256],gszWork[256],*gszWorkDrive;
static CHAR      szOutFileName[256],szOutDirName[256],stat_m[256];
static CHAR      message[255];
static RECT      oldrect;
static DWORD     fdwStyle;
static UINT      ToolbarHeight=0,StatusbarHeight=0,ProgressbarHeight=20;
static HWND      hTBWnd=NULL;
static BOOL      bits24=TRUE,AVItype=TRUE,bConfigured=FALSE,bDone=FALSE;
static HCURSOR   hcurSave;

#define NTOOLBARBUTTONS 11
#define NOTOOLBARIMAGES 10

static TBBUTTON tbb[NTOOLBARBUTTONS] = {
          {0,0,          TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {0,IDM_OPEN,   TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {4,IDM_OPENSND,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {0,0,          TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {1,IDM_BUILD,  TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {2,IDM_COPY,   TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {0,0,          TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {6,IDM_CLEAR,  TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {8,IDM_CODEC,  TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {0,0,          TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {9,IDM_HELP,   TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 }
                                        };

void CentreDialogOnScreen(HWND hwnd){
 RECT rcDlg;
 long Xres,Yres;
 Yres=GetSystemMetrics(SM_CYSCREEN);
 Xres=GetSystemMetrics(SM_CXSCREEN);
 GetWindowRect(hwnd,&rcDlg);
 OffsetRect(&rcDlg,-rcDlg.left,-rcDlg.top);
 OffsetRect(&rcDlg,(Xres-rcDlg.right)/2,(Yres-rcDlg.bottom)/2);
 SetWindowPos(hwnd,HWND_TOP,rcDlg.left,rcDlg.top,0,0,SWP_NOSIZE);
 return;
}

void YieldTo(void){
 MSG msg;
 while (PeekMessage(&msg, NULL, 0, 0,PM_REMOVE)){
   TranslateMessage(&msg);
   DispatchMessage(&msg);
 }
}

void Query(int id){
  char mess[256];
  LoadString(glInstance,id,mess,255);
  MessageBox(glWndFrame,mess,NULL,MB_OK);
}

void SetToolbarState(BOOL state){
 int i;
 for(i=0;i<NTOOLBARBUTTONS;i++)SendMessage(hTBWnd,
   TB_ENABLEBUTTON,(WPARAM)tbb[i].idCommand,(LPARAM)MAKELONG(state,0));
}

void RegisterMainClass(HINSTANCE hInstance){
 WNDCLASS   wc;
 wc.style         = 0;
 wc.lpfnWndProc   = (WNDPROC)MainWndProc;
 wc.cbClsExtra    = 0;
 wc.cbWndExtra    = 0;
 wc.hInstance     = hInstance;
 wc.hIcon         = LoadIcon(hInstance,"SHOWICON");
 wc.hCursor       = LoadCursor (NULL,IDC_ARROW);
 wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
 wc.lpszMenuName  = NULL;
 wc.lpszClassName = szAppName;
 glInstance=hInstance;
 if (!RegisterClass (&wc) )return;
 return;
}

void UnregisterMainClass(HINSTANCE hInstance){
 UnregisterClass(szAppName,hInstance);
}

static HWND RegisterWindow(HWND parent, LPRECT pr){
 RECT rc;
 HWND hWnd;
 GetModuleFileName(glInstance,gszHomeDir,256);
 *FileInPath(gszHomeDir) = '\0';
 strcpy(szFileName,"temp");
 strcpy(szDirName,gszHomeDir); strcat(szOutDirName,"flics");
 strcpy(szOutFileName,"temp");
 strcpy(szOutDirName,gszHomeDir); strcat(szOutDirName,"flics");
 szVideoFile[0]='\0';
 szAudioFile[0]='\0';
 if(GetEnvironmentVariable((LPTSTR)"EVT",(LPTSTR)gszWork,255) == 0){
   strcpy(gszWork,gszHomeDir);
 }
 gszWorkDrive=&gszWork[0];
 fdwStyle = WS_OVERLAPPED | WS_CAPTION | WS_THICKFRAME |
            WS_SYSMENU | WS_MAXIMIZEBOX | WS_MINIMIZEBOX |
            WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
 LoadString(glInstance,IDI_TITLE,stat_m,255);
 hWnd = CreateWindow(szAppName,
             stat_m,
             fdwStyle,
             pr->left,
             pr->top,
             pr->right,
             pr->bottom,
             parent,
             NULL,
             glInstance,
             NULL);
 if(!hWnd)return NULL;
 glWndFrame=hWnd;
 CentreDialogOnScreen(hWnd);
 ShowWindow (hWnd, SW_SHOW);
 LoadString(glInstance,IDI_INFO,stat_m,255);
 SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)stat_m);
 UpdateWindow(hWnd);
 return hWnd;
}

static void Commands(WORD cmd,HWND hWnd){
 int i;
 char temp[256];
 switch (cmd){
   case IDM_OPEN:
     LoadString(glInstance,IDI_SELECTIN,stat_m,255);
     if(SelectFileName(0,szFileName,szDirName,
       stat_m,
       "Video Files|*.avi|",
       hWnd) == TRUE){
       strcpy(szVideoFile,szFileName);
       PostMessage(hWnd,WM_COMMAND,IDM_CLEAR,0);
       bDone=FALSE;
       break;
     }
     break;
   case IDM_OPENSND:
     LoadString(glInstance,IDI_SELECTINSND,stat_m,255);
     if(SelectFileName(0,szFileName,szDirName,stat_m,NULL,hWnd) == TRUE){
       strcpy(szAudioFile,szFileName);
       PostMessage(hWnd,WM_COMMAND,IDM_CLEAR,0);
       bDone=FALSE;
     }
     break;
   case IDM_BUILD:
     LoadString(glInstance,IDI_SELECTOUT,stat_m,255);
     if(SelectFileName(1,szOutFileName,szOutDirName,stat_m,
                      "Video Files|*.avi|",hWnd) != TRUE)break;
     AppendFileExtension(szOutFileName,".avi");
     LoadString(glInstance,IDI_OUTPUT,stat_m,255);
     sprintf(message,stat_m,szOutFileName);
     SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)message);
     SetToolbarState(FALSE);
     StartWait();
     WriteAVI();
     EndWait();
     SetToolbarState(TRUE);
     LoadString(glInstance,IDI_DONEAVI,stat_m,255);
     SendMessage(hWndStatus,SB_SETTEXT,(WPARAM)0,(LPARAM)stat_m);
     bDone=TRUE;
     break;
   case IDM_COPY:
     LoadString(glInstance,IDI_SELECTOUT,stat_m,255);
     if(SelectFileName(1,szOutFileName,szOutDirName,stat_m,
                      "Video Files|*.avi|",hWnd) != TRUE)break;
     AppendFileExtension(szOutFileName,".avi");
     LoadString(glInstance,IDI_OUTPUT,stat_m,255);
     sprintf(message,stat_m,szOutFileName);
     SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)message);
     SetToolbarState(FALSE);
     StartWait();
     CopyAVI(FALSE);
     EndWait();
     SetToolbarState(TRUE);
     LoadString(glInstance,IDI_DONEAVI,stat_m,255);
     SendMessage(hWndStatus,SB_SETTEXT,(WPARAM)0,(LPARAM)stat_m);
     bDone=TRUE;
     break;
   case IDM_CODEC:
     bConfigured=TRUE;
     configureAVIfile(hWnd,NULL);
     break;
   case IDM_CLEAR:
     SendMessage(hWndList,LB_RESETCONTENT,0,0);
     LoadString(glInstance,IDI_FILESLIST,stat_m,255);
     SendMessage(hWndStatus,SB_SETTEXT,(WPARAM)0,(LPARAM)stat_m);
     SendMessage(hWndProgress,PBM_SETPOS,(WPARAM)0,0);
     LoadString(glInstance,IDI_INFO,stat_m,255);
     SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)stat_m);
     if(szVideoFile[0] != '\0'){
       LoadString(glInstance,IDI_VIDEO,stat_m,255);
       sprintf(message,stat_m,szVideoFile);
       SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)message);
     }
     if(szAudioFile[0] != '\0'){
       LoadString(glInstance,IDI_AUDIO,stat_m,255);
       sprintf(message,stat_m,szAudioFile);
       SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)message);
     }
     break;
   case IDM_HELP:
     DialogBox(glInstance,MAKEINTRESOURCE(IDD_ABOUT),hWnd,AboutDlgProc);
     break;
   case IDM_EXIT:
     PostQuitMessage(0);
     break;
   default:
     break;
 }
}

static LONG WINAPI MainWndProc(HWND hWnd,UINT uMsg,
                                 WPARAM wParam,LPARAM lParam){
 RECT rc;
 LONG lRet = 1;
 switch (uMsg){
   case WM_CREATE:{
       HMENU hmenu = GetSystemMenu(hWnd, FALSE);
       hTBWnd = CreateToolbarEx(
         hWnd,
         WS_CHILD | WS_VISIBLE | !WS_BORDER | TBSTYLE_TOOLTIPS,
         0,
         NOTOOLBARIMAGES,
         glInstance,
         TOOLBAR_IDBM,
         tbb,
         NTOOLBARBUTTONS,
         16,15, // button sizes
         16,15, // bitmap image sizes
         sizeof(TBBUTTON)
       );
       GetClientRect(hTBWnd,&rc); ToolbarHeight=rc.bottom-rc.top;
       hWndStatus=CreateWindowEx(0L,STATUSCLASSNAME,"",
         WS_CHILD | !WS_BORDER | WS_VISIBLE,
         0,0,0,0,
         hWnd,
         (HMENU)102,
         glInstance,
         NULL);
       GetClientRect(hWndStatus,&rc); StatusbarHeight=rc.bottom-rc.top;
       GetClientRect(hWnd,&rc);
       rc.top = rc.bottom-StatusbarHeight-ProgressbarHeight+2;
       hWndProgress=CreateWindowEx(0L,PROGRESS_CLASS,"",
         WS_CHILD | !WS_BORDER | WS_VISIBLE,
         2,rc.top+4,
         rc.right-4,ProgressbarHeight-4,
         hWnd,
         (HMENU)103,
         glInstance,
         NULL);
       GetClientRect(hWnd,&rc);
       hWndList=CreateWindow("listbox",
         " ",
         WS_VISIBLE | WS_CHILD | WS_VSCROLL | WS_BORDER
         | LBS_NOINTEGRALHEIGHT | LBS_EXTENDEDSEL,
         rc.left+2,
         rc.top+ToolbarHeight+2,
         rc.right-4,
         rc.bottom-ToolbarHeight-StatusbarHeight-ProgressbarHeight-2,
         hWnd,
         (HMENU)101,
         glInstance,
         NULL);
       LoadString(glInstance,IDI_FILESLIST,stat_m,255);
       SendMessage(hWndStatus,SB_SETTEXT,(WPARAM)0,(LPARAM)stat_m);
     }
     break;
   case WM_SYSCOMMAND:
     switch(LOWORD(wParam & 0xfff0)){
       case IDM_SYS_AVI:
         break;
       case IDM_SYS_DIB:
         break;
       default:
         return( DefWindowProc(hWnd,uMsg,wParam,lParam));
      }
      break;
   case WM_SIZE:
     if(hTBWnd != NULL)SendMessage(hTBWnd,uMsg,wParam,lParam);
     if(hWndStatus != NULL)SendMessage(hWndStatus,uMsg,wParam,lParam);
     SetWindowPos(hWndList,NULL,
                  0+2,ToolbarHeight+2,
                  LOWORD(lParam)-4,
                  HIWORD(lParam)-ToolbarHeight-StatusbarHeight
                                -ProgressbarHeight-2,
                  SWP_NOZORDER);
     GetClientRect(hWndList,&rc);
     if(hWndProgress != NULL)SetWindowPos(hWndProgress,NULL,
                  2,ToolbarHeight+6+rc.bottom,
                  LOWORD(lParam)-4,
                  ProgressbarHeight-4,
                  SWP_NOZORDER);
     break;
   case WM_NOTIFY:
     switch (((LPNMHDR)lParam)->code){
       case TTN_NEEDTEXT:{
           int idButton;
           LPTOOLTIPTEXT lpttt;
           lpttt=(LPTOOLTIPTEXT)lParam;
           lpttt->hinst=glInstance;
           idButton=lpttt->hdr.idFrom;
           switch(idButton){
             case IDM_OPEN:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_1);
               LoadString(glInstance,IDI_TIP_1,stat_m,255);
//               SendMessage(hWndStatus,SB_SETTEXT,(WPARAM)0,(LPARAM)stat_m);
               break;
             case IDM_OPENSND:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_2); break;
             case IDM_BUILD:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_3); break;
             case IDM_COPY:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_4); break;
             case IDM_CLEAR:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_7); break;
             case IDM_CODEC:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_9); break;
             case IDM_HELP:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_A); break;
           }
         }
         break;
       default: break;
     }
     return (DefWindowProc(hWnd,uMsg,wParam,lParam));
   case WM_COMMAND:
     if((HWND)lParam == hWndList)break;
     Commands(LOWORD(wParam),hWnd);
     break;
   case WM_CLOSE:
     PostQuitMessage(0);
     break;
   default:
     lRet = DefWindowProc (hWnd, uMsg, wParam, lParam);
   break;
 }
 return lRet;
}

static void AppendFileExtension(char *filename, char *ext){
 if(strrchr(filename,'.') == NULL){
   strcat(filename,ext);
 }
}

static PSTR FileInPath(PSTR pstrPath){
 PSTR pstr;
 pstr = pstrPath + strlen(pstrPath);
 while (pstr > pstrPath) {
     pstr = (AnsiPrev(pstrPath, pstr));
     if (*pstr == '\\' || *pstr == ':' || *pstr == '/') {
         pstr = (AnsiNext(pstr));
         break;
     }
 }
 return pstr;
}

static int SelectFileName(int save, char *szfile, char *szdir,
                          char *szTitle, char *szfilter, HWND parent){
 int i;
 OPENFILENAME ofn;
 char szFilter[256],szdummy[256];
 szdummy[0]='\0';
 if(szfilter == NULL)AVIBuildFilter(szFilter,255,FALSE);
 else{
   strcpy(szFilter,szfilter);
   i=0; while(szFilter[i] != '\0'){
     if(szFilter[i] == '|')szFilter[i]='\0'; i++;
   }
 }
 memset(&ofn,0,sizeof(OPENFILENAME));
 ofn.lStructSize=sizeof(OPENFILENAME);
 ofn.hwndOwner=parent;
 ofn.lpstrFilter=szFilter;
 ofn.nFilterIndex=1;
 ofn.lpstrFile=szfile;              /* will contain file + path */
 ofn.nMaxFile=256;
 ofn.lpstrFileTitle=szdummy;         /* file name only */
 ofn.nMaxFileTitle=256;
 ofn.lpstrInitialDir=szdir;
 ofn.lpstrTitle=szTitle;
 if(save){
  ofn.Flags=OFN_HIDEREADONLY|OFN_PATHMUSTEXIST;
   i=(int)(GetSaveFileName(&ofn));
 }
 else{
  ofn.Flags=OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST;
   i=(int)(GetOpenFileNamePreview(&ofn));
 }
 if(i){
   strcpy(szdummy,szfile);
   *AnsiPrev(szdummy,FileInPath(szdummy)) = '\0';
   strcpy(szdir,szdummy);
 }
 return i;
}

static BOOL CALLBACK AboutDlgProc(HWND hwnd,UINT msg,
                                  WPARAM wparam,LPARAM lparam){
 switch( msg ) {
   case WM_INITDIALOG:
     CentreDialogOnScreen(hwnd);
     return( TRUE );
   case WM_COMMAND:
      if( wparam == IDOK ) {
        EndDialog( hwnd, TRUE );
        return( TRUE );
      }
      break;
 }
 return( FALSE );
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine, int nCmdShow){
 MSG msg;
 RECT rc;
 InitCommonControls();
 RegisterMainClass(hInstance);
 rc.left=100; rc.top=100;
 rc.right=rc.left+185; rc.bottom=rc.top+250;
 rc.bottom +=  GetSystemMetrics(SM_CYMENU);
 RegisterWindow(NULL,&rc);
 while (GetMessage(&msg,NULL,0,0)){
   TranslateMessage(&msg);
   DispatchMessage(&msg);
 }
 DestroyWindow(glWndFrame);
 UnregisterMainClass(hInstance);
 return TRUE;
}

BOOL configureAVIfile(HWND hWnd, char *preview){
 char filename[256];
 BOOL options=FALSE;
 AVICOMPRESSOPTIONS aviopt;
 PAVIFILE poutfile = NULL;
 PAVISTREAM ps = NULL;
 LPAVICOMPRESSOPTIONS lpaviopt;
 HRESULT hr;
 if(preview != NULL)strcpy(filename,preview);
 else{
   GetModuleFileName(NULL,filename,256);
   strcpy(FileInPath(filename),"logon.avi");
 }
 AVIFileInit();
 hr = AVIFileOpen(&poutfile,filename,OF_READ,NULL);
 if(hr == AVIERR_OK){
   int i;
   AVISTREAMINFO avis;
   for(i=0;i<10;i++){
     if(AVIFileGetStream(poutfile,&ps,0,i) == AVIERR_OK){
       AVIStreamInfo(ps,&avis,sizeof(avis));
       if(avis.fccType == streamtypeVIDEO){
         lpaviopt=&aviopt;
         if(AVISaveOptions(hWnd,
               ICMF_CHOOSE_KEYFRAME|ICMF_CHOOSE_DATARATE|ICMF_CHOOSE_PREVIEW,
               1,&ps,&lpaviopt) == TRUE)options=TRUE;
         AVISaveOptionsFree(1,&lpaviopt);
         AVIStreamRelease(ps);
         break;
       }
     }
   }
   if(poutfile != NULL)AVIFileRelease(poutfile);
 }
 AVIFileExit();
 return options;
}

static void CopyAVI(BOOL audio){
 LPBITMAPINFOHEADER lpBmi;
 LPWAVEFORMATEX  lpWavx;
 LPSTR pformat,pbuffer,sbuffer;
 char buffer[256];
 AVICOMPRESSOPTIONS opts;
 HRESULT hr,hr1,hr2;
 PAVIFILE pvideofile,poutfile;
 PAVISTREAM psin[10],psout[10];
 PGETFRAME  pget;
 AVISTREAMINFO avis;
 long size,nsamples,key,nstreams,vstream,astream,lBytes,lSamples;
 long TRST,TRET,TRSS,TRES;
 int i,j,k;
 if(szVideoFile[0] == '\0'){
   MessageBox(NULL,"Must specify Video input file",NULL,MB_OK);
   return;
 }
 nstreams=0; vstream = -1,astream = -1;
 AVIFileInit();
 poutfile=NULL;
 hr1 = AVIFileOpen(&poutfile,szOutFileName,OF_WRITE | OF_CREATE,NULL);
 if(hr1 != AVIERR_OK)poutfile=NULL;
 hr2 = AVIFileOpen(&pvideofile,szVideoFile,OF_READ,NULL);
 if(hr2 != AVIERR_OK)pvideofile=NULL;
 if(hr1 == AVIERR_OK && hr2 == AVIERR_OK){
   for(i=0;i<10;i++){
     psin[i]=psout[i]=NULL;
     if(AVIFileGetStream(pvideofile,&psin[i],0,i) == AVIERR_OK){
       AVIStreamInfo(psin[i],&avis,sizeof(avis));
       if(avis.fccType == streamtypeVIDEO){
         SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)"Video Stream");
         vstream=i;
         AVIStreamFormatSize(psin[i],0,&size);
         if((pformat = (LPSTR)EVI_Malloc(size)) != NULL){
           if(AVIStreamReadFormat(psin[i],0,pformat,&size) == AVIERR_OK){
             lpBmi=(LPBITMAPINFOHEADER)pformat;
             sprintf(buffer,"Size (%ld %ld) Bits %ld",lpBmi->biWidth,lpBmi->biHeight,
                   (long)(lpBmi->biBitCount));
             SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buffer);
             if(lpBmi->biCompression == BI_RGB)strcpy(buffer,"BI_RGB uncomressed");
             else if(lpBmi->biCompression == BI_RLE8)strcpy(buffer,"BI_RLE8");
             else if(lpBmi->biCompression == BI_RLE4)strcpy(buffer,"BI_RLE4");
             else if(lpBmi->biCompression == BI_BITFIELDS)strcpy(buffer,"BI_BITFIELDS");
             else strcpy(buffer,"Unknown Commpression");
             SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buffer);
             nsamples=AVIStreamEnd(psin[i]);
             sprintf(buffer,"%ld Frames (%0.3lfs)",nsamples,
               (double)AVIStreamSampleToTime(psin[i],nsamples)*0.001);
             SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buffer);
             hr = AVIFileCreateStream(poutfile,&psout[i],&avis);
             if(hr != AVIERR_OK){
               MessageBox(NULL,"Error in output stream",NULL,MB_OK);
             }
             hr = AVIStreamSetFormat(psout[i],0,pformat,size);
             if(hr != AVIERR_OK){
               MessageBox(NULL,"Bad output format",NULL,MB_OK);
             }
           }
           EVI_Free(pformat);
         }
       }
       else if(audio && avis.fccType == streamtypeAUDIO){
         SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)"Audio Stream");
         astream=i;
         AVIStreamFormatSize(psin[i],0,&size);
         if((pformat = (LPSTR)EVI_Malloc(size)) != NULL){
           if(AVIStreamReadFormat(psin[i],0,pformat,&size) == AVIERR_OK){
             lpWavx=(LPWAVEFORMATEX)pformat;
             sprintf(buffer,"Channels=%ld Samples/sec=%ld",
                   (WORD)lpWavx->nChannels,(DWORD)lpWavx->nSamplesPerSec);
             SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buffer);
             hr = AVIFileCreateStream(poutfile,&psout[i],&avis);
             if(hr != AVIERR_OK){
               MessageBox(NULL,"Error in output stream",NULL,MB_OK);
             }
             hr = AVIStreamSetFormat(psout[i],0,pformat,size);
             if(hr != AVIERR_OK){
               MessageBox(NULL,"Bad output format",NULL,MB_OK);
             }
           }
           EVI_Free(pformat);
         }
       }
       else if(avis.fccType == streamtypeAUDIO){
         SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)"Audio Stream");
       }
       else {
         SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)"Other Stream");
       }
       nstreams++;
     }
     else {
        break;
     }
   }
   if(nstreams > 0 && vstream >= 0){
     SendMessage(hWndProgress,PBM_SETRANGE,0,MAKELPARAM(0,nsamples));
     SendMessage(hWndProgress,PBM_SETSTEP,(WPARAM)1,0);
     for(j=0;j<nsamples;j++){
       LoadString(glInstance,IDI_TESTING,stat_m,255);
       sprintf(message,stat_m,j+1,nsamples);
       SendMessage(hWndStatus,SB_SETTEXT,(WPARAM)0,(LPARAM)message);
       SendMessage(hWndProgress,PBM_SETPOS,(WPARAM)(j+1),0);
       YieldTo();
       hr = AVIStreamRead(psin[vstream],j,1,NULL,0,&lBytes,&lSamples);
       if((pbuffer = (LPSTR)EVI_Malloc(lBytes)) != NULL){
         hr = AVIStreamRead(psin[vstream],j,1,pbuffer,lBytes,NULL,NULL);
         hr = AVIStreamWrite(psout[vstream],j,1,pbuffer,lBytes,
                             j == 0 ? AVIIF_KEYFRAME : 0, NULL,NULL);
         EVI_Free(pbuffer);
         TRST=AVIStreamSampleToTime(psin[vstream],j);
         TRET=AVIStreamSampleToTime(psin[vstream],j+1);
         if(astream >= 0){
           long lBy;
           TRSS=min(AVIStreamTimeToSample(psin[astream],TRST),
                    AVIStreamEnd(psin[astream]));
           TRES=min(AVIStreamTimeToSample(psin[astream],TRET),
                    AVIStreamEnd(psin[astream]));
           hr = AVIStreamRead(psin[astream],TRSS,TRES-TRSS,NULL,0,&lBy,NULL);
           if((sbuffer = (LPSTR)EVI_Malloc(lBy)) != NULL){
             hr = AVIStreamRead(psin[astream],TRSS,TRES-TRSS,sbuffer,lBy,NULL,NULL);
             hr = AVIStreamWrite(psout[astream],TRSS,TRES-TRSS,sbuffer,lBy,0,NULL,NULL);
             EVI_Free(sbuffer);
           }
         }
       }
     }
   }
   if(nstreams > 0)for(i=0;i<nstreams;i++){
     if(i == vstream || i == astream){
       AVIStreamRelease(psin[i]); AVIStreamRelease(psout[i]);
     }
   }
 }
 if(pvideofile != NULL)AVIFileRelease(pvideofile);
 if(poutfile != NULL)AVIFileRelease(poutfile);
 AVIFileExit();
}

static void WriteAVI(void){
 LPBITMAPINFOHEADER lpBmi;
 LPWAVEFORMATEX  lpWavx;
 LPSTR pformat,pbuffer,sbuffer;
 char buffer[256];
 AVICOMPRESSOPTIONS opts;
 HRESULT hr,hr1,hr2,hr3;
 PAVIFILE pvideofile,paudiofile,poutfile;
 PAVISTREAM psin_v=NULL,psin_a=NULL,psout_v=NULL,psout_a=NULL;
 PGETFRAME  pget;
 AVISTREAMINFO avis;
 long size,nsamples,nsa,key,vstream,astream,lBytes,lSamples;
 long TRST,TRET,TRSS,TRES;
 int i,j,k;
 if(szVideoFile[0] == '\0'|| szAudioFile[0] == '\0'){
   MessageBox(NULL,"Must specify Video and Audio input files",NULL,MB_OK);
   return;
 }
 vstream = -1,astream = -1;
 AVIFileInit();
 poutfile=NULL;
 hr1 = AVIFileOpen(&poutfile,szOutFileName,OF_WRITE | OF_CREATE,NULL);
 if(hr1 != AVIERR_OK)poutfile=NULL;
 hr2 = AVIFileOpen(&pvideofile,szVideoFile,OF_READ,NULL);
 if(hr2 != AVIERR_OK)pvideofile=NULL;
 hr3 = AVIFileOpen(&paudiofile,szAudioFile,OF_READ,NULL);
 if(hr3 != AVIERR_OK)paudiofile=NULL;
 if(hr1 == AVIERR_OK && hr2 == AVIERR_OK && hr3 == AVIERR_OK){
   for(i=0;i<10;i++){
     if(AVIFileGetStream(pvideofile,&psin_v,0,i) == AVIERR_OK){
       AVIStreamInfo(psin_v,&avis,sizeof(avis));
       if(avis.fccType == streamtypeVIDEO){
         SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)"Video Stream");
         vstream=i;
         AVIStreamFormatSize(psin_v,0,&size);
         if((pformat = (LPSTR)EVI_Malloc(size)) != NULL){
           if(AVIStreamReadFormat(psin_v,0,pformat,&size) == AVIERR_OK){
             lpBmi=(LPBITMAPINFOHEADER)pformat;
             sprintf(buffer,"Size (%ld %ld) Bits %ld",lpBmi->biWidth,lpBmi->biHeight,
                   (long)(lpBmi->biBitCount));
             SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buffer);
             if(lpBmi->biCompression == BI_RGB)strcpy(buffer,"BI_RGB uncomressed");
             else if(lpBmi->biCompression == BI_RLE8)strcpy(buffer,"BI_RLE8");
             else if(lpBmi->biCompression == BI_RLE4)strcpy(buffer,"BI_RLE4");
             else if(lpBmi->biCompression == BI_BITFIELDS)strcpy(buffer,"BI_BITFIELDS");
             else strcpy(buffer,"Unknown Commpression");
             SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buffer);
             nsamples=AVIStreamEnd(psin_v);
             sprintf(buffer,"%ld Frames (%0.3lfs) %0.1lf fps",nsamples,
               (double)AVIStreamSampleToTime(psin_v,nsamples)*0.001,
               (double)nsamples*1000.0/
               (double)AVIStreamSampleToTime(psin_v,nsamples));
             SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buffer);
             hr = AVIFileCreateStream(poutfile,&psout_v,&avis);
             if(hr != AVIERR_OK){
               MessageBox(NULL,"Error in output stream",NULL,MB_OK);
             }
             hr = AVIStreamSetFormat(psout_v,0,pformat,size);
             if(hr != AVIERR_OK){
               MessageBox(NULL,"Bad output format",NULL,MB_OK);
             }
           }
           EVI_Free(pformat);
         }
         break;
       }
     }
   }
   for(i=0;i<10;i++){
     if(AVIFileGetStream(paudiofile,&psin_a,0,i) == AVIERR_OK){
       AVIStreamInfo(psin_a,&avis,sizeof(avis));
       if(avis.fccType == streamtypeAUDIO){
         SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)"Audio Stream");
         astream=i;
         AVIStreamFormatSize(psin_a,0,&size);
         if((pformat = (LPSTR)EVI_Malloc(size)) != NULL){
           if(AVIStreamReadFormat(psin_a,0,pformat,&size) == AVIERR_OK){
             lpWavx=(LPWAVEFORMATEX)pformat;
             sprintf(buffer,"Channels=%ld Samples/sec=%ld",
                   (WORD)lpWavx->nChannels,(DWORD)lpWavx->nSamplesPerSec);
             SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buffer);
             nsa=AVIStreamEnd(psin_a);
             sprintf(buffer,"%ld Samples (%0.3lfs)",nsa,
               (double)AVIStreamSampleToTime(psin_a,nsa)*0.001);
             SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buffer);
             hr = AVIFileCreateStream(poutfile,&psout_a,&avis);
             if(hr != AVIERR_OK){
               MessageBox(NULL,"Error in output stream",NULL,MB_OK);
             }
             hr = AVIStreamSetFormat(psout_a,0,pformat,size);
             if(hr != AVIERR_OK){
               MessageBox(NULL,"Bad output format",NULL,MB_OK);
             }
           }
           EVI_Free(pformat);
         }
         break;
       }
     }
   }
   SendMessage(hWndProgress,PBM_SETRANGE,0,MAKELPARAM(0,nsamples));
   SendMessage(hWndProgress,PBM_SETSTEP,(WPARAM)1,0);
   if(vstream >= 0){
     for(j=0;j<nsamples;j++){
       LoadString(glInstance,IDI_TESTING,stat_m,255);
       sprintf(message,stat_m,j+1,nsamples);
       SendMessage(hWndStatus,SB_SETTEXT,(WPARAM)0,(LPARAM)message);
       SendMessage(hWndProgress,PBM_SETPOS,(WPARAM)(j+1),0);
       YieldTo();
       hr = AVIStreamRead(psin_v,j,1,NULL,0,&lBytes,&lSamples);
       if((pbuffer = (LPSTR)EVI_Malloc(lBytes)) != NULL){
         hr = AVIStreamRead(psin_v,j,1,pbuffer,lBytes,NULL,NULL);
         hr = AVIStreamWrite(psout_v,j,1,pbuffer,lBytes,
                             j == 0 ? AVIIF_KEYFRAME : 0, NULL,NULL);
         EVI_Free(pbuffer);
         TRST=AVIStreamSampleToTime(psin_v,j);
         TRET=AVIStreamSampleToTime(psin_v,j+1);
         if(astream >= 0){
           long lBy;
           TRSS=min(AVIStreamTimeToSample(psin_a,TRST),
                    AVIStreamEnd(psin_a));
           TRES=min(AVIStreamTimeToSample(psin_a,TRET),
                    AVIStreamEnd(psin_a));
           hr = AVIStreamRead(psin_a,TRSS,TRES-TRSS,NULL,0,&lBy,NULL);
           if((sbuffer = (LPSTR)EVI_Malloc(lBy)) != NULL){
             hr = AVIStreamRead(psin_a,TRSS,TRES-TRSS,sbuffer,lBy,NULL,NULL);
             hr = AVIStreamWrite(psout_a,TRSS,TRES-TRSS,sbuffer,lBy,0,NULL,NULL);
             EVI_Free(sbuffer);
           }
         }
//         AVIFileEndRecord(poutfile);  // bad bad bad
       }
     }
   }
   if(vstream >= 0){
     AVIStreamRelease(psin_v); AVIStreamRelease(psout_v);
   }
   if(astream >= 0){
     AVIStreamRelease(psin_a); AVIStreamRelease(psout_a);
   }
 }
 if(pvideofile != NULL)AVIFileRelease(pvideofile);
 if(paudiofile != NULL)AVIFileRelease(paudiofile);
 if(poutfile != NULL)AVIFileRelease(poutfile);
 AVIFileExit();
}
