/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

#if !defined(AFX_ACTIVEMOVIE_H__C48639EE_BEA4_11D1_B2A5_00608CF21E5D__INCLUDED_)
#define AFX_ACTIVEMOVIE_H__C48639EE_BEA4_11D1_B2A5_00608CF21E5D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// Machine generated IDispatch wrapper class(es) created by Microsoft Visual C++

// NOTE: Do not modify the contents of this file.  If this class is regenerated by
//  Microsoft Visual C++, your modifications will be overwritten.

/////////////////////////////////////////////////////////////////////////////
// CActiveMovie wrapper class

class CActiveMovie : public CWnd
{
protected:
	DECLARE_DYNCREATE(CActiveMovie)
public:
	CLSID const& GetClsid()
	{
		static CLSID const clsid
			= { 0x5589fa1, 0xc356, 0x11ce, { 0xbf, 0x1, 0x0, 0xaa, 0x0, 0x55, 0x59, 0x5a } };
		return clsid;
	}
	virtual BOOL Create(LPCTSTR lpszClassName,
		LPCTSTR lpszWindowName, DWORD dwStyle,
		const RECT& rect,
		CWnd* pParentWnd, UINT nID,
		CCreateContext* pContext = NULL)
	{ return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID); }

    BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle,
		const RECT& rect, CWnd* pParentWnd, UINT nID,
		CFile* pPersist = NULL, BOOL bStorage = FALSE,
		BSTR bstrLicKey = NULL)
	{ return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID,
		pPersist, bStorage, bstrLicKey); }

// Attributes
public:

// Operations
public:
	void AboutBox();
	void Run();
	void Pause();
	void Stop();
	long GetImageSourceWidth();
	long GetImageSourceHeight();
	CString GetAuthor();
	CString GetTitle();
	CString GetCopyright();
	CString GetDescription();
	CString GetRating();
	CString GetFileName();
	void SetFileName(LPCTSTR lpszNewValue);
	double GetDuration();
	double GetCurrentPosition();
	void SetCurrentPosition(double newValue);
	long GetPlayCount();
	void SetPlayCount(long nNewValue);
	double GetSelectionStart();
	void SetSelectionStart(double newValue);
	double GetSelectionEnd();
	void SetSelectionEnd(double newValue);
	long GetCurrentState();
	double GetRate();
	void SetRate(double newValue);
	long GetVolume();
	void SetVolume(long nNewValue);
	long GetBalance();
	void SetBalance(long nNewValue);
	BOOL GetEnableContextMenu();
	void SetEnableContextMenu(BOOL bNewValue);
	BOOL GetShowDisplay();
	void SetShowDisplay(BOOL bNewValue);
	BOOL GetShowControls();
	void SetShowControls(BOOL bNewValue);
	BOOL GetShowPositionControls();
	void SetShowPositionControls(BOOL bNewValue);
	BOOL GetShowSelectionControls();
	void SetShowSelectionControls(BOOL bNewValue);
	BOOL GetShowTracker();
	void SetShowTracker(BOOL bNewValue);
	BOOL GetEnablePositionControls();
	void SetEnablePositionControls(BOOL bNewValue);
	BOOL GetEnableSelectionControls();
	void SetEnableSelectionControls(BOOL bNewValue);
	BOOL GetEnableTracker();
	void SetEnableTracker(BOOL bNewValue);
	BOOL GetAllowHideDisplay();
	void SetAllowHideDisplay(BOOL bNewValue);
	BOOL GetAllowHideControls();
	void SetAllowHideControls(BOOL bNewValue);
	long GetDisplayMode();
	void SetDisplayMode(long nNewValue);
	BOOL GetAllowChangeDisplayMode();
	void SetAllowChangeDisplayMode(BOOL bNewValue);
	LPUNKNOWN GetFilterGraph();
	void SetFilterGraph(LPUNKNOWN newValue);
	LPDISPATCH GetFilterGraphDispatch();
	unsigned long GetDisplayForeColor();
	void SetDisplayForeColor(unsigned long newValue);
	unsigned long GetDisplayBackColor();
	void SetDisplayBackColor(unsigned long newValue);
	long GetMovieWindowSize();
	void SetMovieWindowSize(long nNewValue);
	BOOL GetFullScreenMode();
	void SetFullScreenMode(BOOL bNewValue);
	BOOL GetAutoStart();
	void SetAutoStart(BOOL bNewValue);
	BOOL GetAutoRewind();
	void SetAutoRewind(BOOL bNewValue);
	long GetHWnd();
	long GetAppearance();
	void SetAppearance(long nNewValue);
	long GetBorderStyle();
	void SetBorderStyle(long nNewValue);
	BOOL GetEnabled();
	void SetEnabled(BOOL bNewValue);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ACTIVEMOVIE_H__C48639EE_BEA4_11D1_B2A5_00608CF21E5D__INCLUDED_)
