#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <windows.h>
#include <vfw.h>
#include "resource.h"

#define BUFSIZE 256

HWND hWndProgressF=NULL,hWndProgressM=NULL,
     hWndTextF=NULL,hWndTextM=NULL;

extern int mymain(int, char **);

static HINSTANCE ghInstApp=NULL;
static HWND hWndLog=NULL;
static char avi_name[256],mpg_name[256];

static PSTR FileInPath(PSTR pstrPath){
 PSTR pstr;
 pstr = pstrPath + strlen(pstrPath);
 while (pstr > pstrPath) {
     pstr = (AnsiPrev(pstrPath, pstr));
     if (*pstr == '\\' || *pstr == ':' || *pstr == '/') {
         pstr = (AnsiNext(pstr));
         break;
     }
 }
 return pstr;
}

static BOOL FormatFilterString(
UINT uID,
LPSTR lpszString )
{
    int nLength, nCtr = 0;
    char chWildCard;
    *lpszString = 0;
    nLength = LoadString( ghInstApp, uID, lpszString, BUFSIZE );
    chWildCard = lpszString[nLength-1];
    while( lpszString[nCtr] ) {
        if( lpszString[nCtr] == chWildCard )
            lpszString[nCtr] = 0;
        nCtr++;
    }
    return TRUE;
}

void MyYield(void){
 MSG msg;
 while (PeekMessage(&msg, NULL, 0, 0,PM_REMOVE)){
   TranslateMessage(&msg);
   DispatchMessage(&msg);
 }
}


int RSFfprf(FILE *f, const char *format,...){
 int i;
 char line[512];
 va_list arg_ptr;
 if(hWndLog == NULL)return 0;
 va_start(arg_ptr,format);
 vsprintf(line,format,arg_ptr);
 va_end(arg_ptr);
 i=SendMessage(hWndLog,LB_ADDSTRING,0,(LPARAM)(LPCTSTR)line);
 SendMessage(hWndLog,LB_SETTOPINDEX,(WPARAM)i,0);
 MyYield();
 return 0;
}

void CentreDialogOnScreen(HWND hWnd){
 RECT rc;
 GetWindowRect(hWnd, &rc);
 SetWindowPos(hWnd, NULL,
    (GetSystemMetrics(SM_CXSCREEN) - (rc.right - rc.left)) / 2,
    (GetSystemMetrics(SM_CYSCREEN) - (rc.bottom - rc.top)) / 2,
    0, 0, SWP_NOSIZE | SWP_NOZORDER);
}

static void ChooseMovieFile(HWND hwnd,char *type, int IDS, BOOL op){
 OPENFILENAME ofn;
 char szFileName[BUFSIZE];
 char szFileDir[BUFSIZE];
 char szFilter[BUFSIZE];
 FormatFilterString( IDS, szFilter );
 ofn.lStructSize = sizeof(OPENFILENAME);
 ofn.hwndOwner = hwnd;
 ofn.hInstance = NULL;
 ofn.lpstrFilter = szFilter;
 ofn.lpstrCustomFilter = NULL;
 ofn.nMaxCustFilter = 0;
 ofn.nFilterIndex = 0;
 GetModuleFileName(ghInstApp,szFileName,BUFSIZE);
 *FileInPath(szFileName) = '\0';
 strcat(szFileName,"movies\\");
 strcpy(szFileDir,szFileName);
 strcat(szFileName,type);
 ofn.lpstrFile = szFileName;
 ofn.nMaxFile = BUFSIZE;
 ofn.lpstrFileTitle = NULL;
 ofn.nMaxFileTitle = 0;
 ofn.lpstrInitialDir = szFileDir;
 ofn.lpstrTitle = "Open";
 ofn.Flags = OFN_PATHMUSTEXIST |
             OFN_HIDEREADONLY | 
             OFN_EXPLORER;
 if(op)ofn.Flags |= OFN_FILEMUSTEXIST;
 ofn.nFileOffset = 0;
 ofn.nFileExtension = 0;
 ofn.lpstrDefExt = NULL;
 ofn.lCustData = 0;
 ofn.lpfnHook = NULL;
 ofn.lpTemplateName = NULL;
 if(op){
   if(GetOpenFileNamePreview(&ofn)){
     strcpy(avi_name,szFileName);
     SetDlgItemText(hwnd,IDC_FILENAME1,avi_name);
   }
 }
 else{
   if(GetOpenFileName(&ofn)){
     strcpy(mpg_name,szFileName);
     SetDlgItemText(hwnd,IDC_FILENAME2,mpg_name);
   }
 }
 return;
}

static BOOL CALLBACK DlgProc(HWND hwnd,UINT msg,
                             WPARAM wparam,LPARAM lparam){
 static BOOL inuse=FALSE;
 switch( msg ) {
   case WM_INITDIALOG:
     hWndProgressF=GetDlgItem(hwnd,IDC_PROGRESS_F);
     hWndProgressM=GetDlgItem(hwnd,IDC_PROGRESS_M);
     hWndTextF=GetDlgItem(hwnd,IDC_TEXTF);
     hWndTextM=GetDlgItem(hwnd,IDC_TEXTM);
     hWndLog=GetDlgItem(hwnd,IDC_LOG);
     CentreDialogOnScreen(hwnd);
     return TRUE;
   case WM_COMMAND:
      switch(LOWORD(wparam)){
        case IDC_CHOOSE:
          ChooseMovieFile(hwnd,"*.avi",IDS_FILTERSTRING1,TRUE);
          break;
        case IDC_CHOOSE_MPG:
          ChooseMovieFile(hwnd,"*.mpg",IDS_FILTERSTRING2,FALSE);
          break;
        case IDOK:{
          int argc=4;
          char arg0[256]="name",
               arg1[256]="-z",
               arg2[256],arg3[256],*args[4];
          if(inuse)break;
          inuse=TRUE;
          GetDlgItemText(hwnd,IDC_FILENAME1,avi_name,255);
          strcpy(arg2,avi_name);
          if(GetDlgItemText(hwnd,IDC_FILENAME2,mpg_name,255) < 2)
                argc=3;
          else  strcpy(arg3,mpg_name);
          args[0]=&arg0[0];
          args[1]=&arg1[0];
          args[2]=&arg2[0];
          args[3]=&arg3[0];
          if(hWndLog != NULL){
            SendMessage(hWndLog,LB_RESETCONTENT,0,0);
            SendMessage(hWndLog,LB_SETHORIZONTALEXTENT,(WPARAM)640,0);  

          }
          mymain(argc,args);
          inuse=FALSE;
          break;
        }
        case IDCANCEL:
          PostQuitMessage(0);
          EndDialog(hwnd,FALSE);
          return FALSE;
        default:
          break;
      }
     break;
   default:
     break;
 }
 return FALSE;
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine, int nCmdShow){
 MSG msg;
 DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),NULL,(DLGPROC)DlgProc);
 while (GetMessage(&msg,NULL,0,0)){
   TranslateMessage(&msg);
   DispatchMessage(&msg);
 }
 return 0;
}
