// interact.c

/*************************************************************************
*  mplex - MPEG/SYSTEMS multiplexer           *
*************************************************************************/

#include <windows.h>
#include <vfw.h>

#include <stdio.h>
#include <stdlib.h>

#include "global.h"
#include "mplex.h"
/*************************************************************************
    File vorhanden?

    File found?
*************************************************************************/

int open_file(name, bytes)      
char *name;
unsigned int *bytes;        
{
    FILE* datei;

    datei=fopen (name, "rwb");
    if (datei==NULL)
    {  
  return (TRUE);
    }
    fseek (datei, 0, 2);
    *bytes = ftell(datei);
    fclose(datei);
    return (FALSE);
}


/*************************************************************************
  ask_continue
  Nach Anzeige der Streaminformationen Abfrage, ob weiter
  gearbeitet werden soll.

  After displaying Stream informations there is a check, wether
  we should continue computing or not.
*************************************************************************/

void ask_continue ()
{
    char input[20];

    do gets (input);
    while (input[0]!='N'&&input[0]!='n'&&input[0]!='y'&&input[0]!='Y');

    if (input[0]=='N' || input[0]=='n')
    {
  exit (0);

    }

}

/*************************************************************************
  ask_verbose
  Soll die letzte, MPEG/SYSTEM Tabelle vollstaendig ausgegeben
  werden?

  Should we print the MPEG/SYSTEM table very verbose or not?
*************************************************************************/

unsigned char ask_verbose ()
{
    char input[20];

    do gets (input);
    while (input[0]!='N'&&input[0]!='n'&&input[0]!='y'&&input[0]!='Y');

    if (input[0]=='N' || input[0]=='n') return (FALSE); else return (TRUE);
}

/******************************************************************
  Status_Info
  druckt eine Statuszeile waehrend des Multiplexens aus.

  prints a status line during multiplexing
******************************************************************/

void status_info (nsectors_a, nsectors_v, nsectors_p, nbytes, 
      buf_v, buf_a,verbose)
unsigned int nsectors_a;
unsigned int nsectors_v;
unsigned int nsectors_p;
unsigned int nbytes;
unsigned int buf_v;
unsigned int buf_a;
unsigned char verbose;
{
}

void status_header ()
{
    status_footer();
    status_footer();
}


void status_message (what)
unsigned char what;
{
  switch (what)
  {
  case STATUS_AUDIO_END:
    audio_end_early++;
  break;
  case STATUS_AUDIO_TIME_OUT:
    audio_time_out++;
  break;
  case STATUS_VIDEO_END:
    video_end_early++;
  break;
  case STATUS_VIDEO_TIME_OUT:
    video_time_out++;
  break;
  default:
    RSFfprf(stderr, " Invalid mplex status message ");
  }
}

void status_footer ()
{
}
