/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file editsnd.C || */

#define MODULE_MAIN

#define  STRICT

#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <commctrl.h>
//#include <windowsx.h>
#include <mmsystem.h>
#include <vfw.h>
#include "editsnd.h"

#define imod(a,b)  ((a) - ((a)/(b))*(b))
#define AVIIF_KEYFRAME  0x00000010L // this frame is a key frame.
#define BUFSIZE 256

#define X__Malloc(s)    LocalAlloc(LMEM_FIXED,s)
#define X__Free(p)      LocalFree((HLOCAL)p)
#define X__Realloc(p,s) LocalReAlloc((HLOCAL)p,s,LMEM_MOVEABLE)
#define StartWait() hcurSave = SetCursor(LoadCursor(NULL,IDC_WAIT))
#define EndWait()   SetCursor(hcurSave)

#define IDM_SYS_BLANK 0x10
#define IDM_SYS_AUDIO 0x20
#define IDM_SYS_DEBUG 0x30
#define IDM_SYS_CHOP  0x40
#define IDM_SYS_DUB   0x50

static LONG WINAPI MainWndProc(HWND, UINT, WPARAM, LPARAM);
static BOOL CALLBACK InfoDlgProc(HWND,UINT, WPARAM, LPARAM);
static BOOL CALLBACK AboutDlgProc(HWND,UINT,WPARAM,LPARAM);
static BOOL CALLBACK StreamDlgProc(HWND,UINT,WPARAM,LPARAM);
static int SelectFileName(int save, char *szfile, char *szdir,
                          char *szTitle, char *szfilter, HWND parent);
static void AppendFileExtension(char *, char *);
static PSTR FileInPath(PSTR);
static void UpdateTextInfo(void);
static void GetInfo(BOOL, char *);
static void UpdateInfo(void);
static void InsertSound(void);
static void MixSound(void);
static void ChopSound(void);
static void OpenInputStreams(char *);
static void CloseInputStreams(void);
static void MakeBlankSoundFile(long, long, long, long);
static void WriteAudioTrack(void);
static PAVISTREAM CreateInsertStream(char *, long, long , long);
static void CreateBlankSoundStream(void);
static void OpenPreview(int, char *);
static void ClosePreview(void);
static BOOL CheckSound(void);
static void InitialiseEdit(void);
static BOOL CopyAVIfile(char *, char *);
static void StripAudioAVI(char *, char *);
static void DubSoundtrack(char *, char *, char *);

static BOOL       debug=FALSE;
static AVICOMPRESSOPTIONS   aviopt[2];
static LPAVICOMPRESSOPTIONS lpaviopt[2];
static HWND       glWndFrame=NULL,
                  hWndList=NULL,hWndHidList=NULL,
                  hWndVideo=NULL,hWndText=NULL,
                  hWndStatus=NULL,hWndProgress=NULL;
static PAVIFILE   ptempfile=NULL,pf_video=NULL;
static PAVISTREAM ps_video[2];
static HINSTANCE  glInstance;
static CHAR       szAppName[]="OFX:EditSoundClass";
static CHAR       szVideoDirName[256],szAudioDirName[256];
static CHAR       szVideoFile[256],szAudioFile[256];
static CHAR       szAudioTrackFile[256],szWorkFile[256];
static CHAR       gszHomeDir[256],gszWork[256],*gszWorkDrive;
static CHAR       szOutFile[256],szOutDirName[256];
static CHAR       szVideoInfo[256],szAudioInfo[256],szSoundInfo[256];
static CHAR       message[256],stat_m[256];
static RECT       oldrect;
static DWORD      fdwStyle;
static UINT       ToolbarHeight=0,StatusbarHeight=0,ProgressbarHeight=20;
static HWND       hTBWnd=NULL;
static HCURSOR    hcurSave;
static int        TotalFrames=0,CurrentFrame=0;
static long       sAVIc=1,sAVIf=11025,sAVIb=1,sWAVc=1,sWAVf=11025,sWAVb=1;

#define NTOOLBARBUTTONS 24
#define NOTOOLBARIMAGES 18
#define NINFO 26

static TBBUTTON tbb[NTOOLBARBUTTONS] = {
          { 0,0,           TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          { 1,IDM_OPEN,    TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 2,IDM_OPENSND, TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 0,0,           TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          { 0,IDM_BUILD,   TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 0,0,           TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          { 3,IDM_ADDSND,  TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {11,IDM_MIXSND,  TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {13,IDM_SILENT,  TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 0,0,           TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          { 4,IDM_CLEAR,   TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {12,IDM_INFO,    TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 5,IDM_PLAYSND, TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 0,0,           TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          { 6,IDM_FIRST,   TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 7,IDM_PREVIOUS,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {14,IDM_PLAY,    TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 8,IDM_NEXT,    TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 9,IDM_LAST,    TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 0,0,           TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {16,IDM_CHOP,    TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {17,IDM_DUB,     TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          { 0,0,           TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {10,IDM_HELP,    TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 }
                                        };

void CentreDialogOnScreen(HWND hwnd){
 RECT rcDlg;
 long Xres,Yres;
 Yres=GetSystemMetrics(SM_CYSCREEN);
 Xres=GetSystemMetrics(SM_CXSCREEN);
 GetWindowRect(hwnd,&rcDlg);
 OffsetRect(&rcDlg,-rcDlg.left,-rcDlg.top);
 OffsetRect(&rcDlg,(Xres-rcDlg.right)/2,(Yres-rcDlg.bottom)/2);
 SetWindowPos(hwnd,HWND_TOP,rcDlg.left,rcDlg.top,0,0,SWP_NOSIZE);
 return;
}

void YieldTo(void){
 MSG msg;
 while (PeekMessage(&msg, NULL, 0, 0,PM_REMOVE)){
   TranslateMessage(&msg);
   DispatchMessage(&msg);
 }
}

void Query(int id){
  char mess[256];
  LoadString(glInstance,id,mess,255);
  MessageBox(glWndFrame,mess,NULL,MB_OK);
}

void SetToolbarState(BOOL state){
 int i;
 for(i=0;i<NTOOLBARBUTTONS;i++)SendMessage(hTBWnd,
   TB_ENABLEBUTTON,(WPARAM)tbb[i].idCommand,(LPARAM)MAKELONG(state,0));
 YieldTo();
}

static LONG CALLBACK my_save_callback(int n_percent){
 SendMessage(hWndProgress,PBM_SETPOS,(WPARAM)n_percent,0);
 YieldTo();
 return AVIERR_OK;
}

void RegisterMainClass(HINSTANCE hInstance){
 WNDCLASS   wc;
 wc.style         = 0;
 wc.lpfnWndProc   = (WNDPROC)MainWndProc;
 wc.cbClsExtra    = 0;
 wc.cbWndExtra    = 0;
 wc.hInstance     = hInstance;
 wc.hIcon         = LoadIcon(hInstance,"SHOWICON");
 wc.hCursor       = LoadCursor (NULL,IDC_ARROW);
 wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
 wc.lpszMenuName  = NULL;
 wc.lpszClassName = szAppName;
 glInstance=hInstance;
 if (!RegisterClass (&wc) )return;
 return;
}

void UnregisterMainClass(HINSTANCE hInstance){
 UnregisterClass(szAppName,hInstance);
}

static HWND RegisterWindow(HWND parent, LPRECT pr){
 RECT rc;
 HWND hWnd;
 GetModuleFileName(glInstance,gszHomeDir,256);
 *FileInPath(gszHomeDir) = '\0';

 strcpy(szVideoDirName,gszHomeDir); strcat(szVideoDirName,"flics");
 strcpy(szAudioDirName,gszHomeDir); strcat(szAudioDirName,"sounds");

 strcpy(szOutFile,"temp");
 strcpy(szOutDirName,gszHomeDir); strcat(szOutDirName,"flics");

 szVideoFile[0]='\0'; szAudioFile[0]='\0'; szAudioTrackFile[0]='\0';

 szVideoInfo[0]='\0'; szSoundInfo[0]='\0'; szAudioInfo[0]='\0';
 if(GetEnvironmentVariable((LPTSTR)"TEMP",(LPTSTR)gszWork,255) == 0){
   strcpy(gszWork,gszHomeDir);
 }
 strcpy(szWorkFile,gszWork);
 if(*(szWorkFile+strlen(szWorkFile)-1) != '\\')strcat(szWorkFile,"\\");
 strcat(szWorkFile,"$_RSF_$.AVI");
 gszWorkDrive=&gszWork[0];
 DeleteFile(szWorkFile);
 fdwStyle = WS_OVERLAPPED | WS_CAPTION | WS_THICKFRAME |
            WS_SYSMENU | WS_MAXIMIZEBOX | WS_MINIMIZEBOX |
            WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
 LoadString(glInstance,IDI_TITLE,stat_m,255);
 hWnd = CreateWindow(szAppName,
             stat_m,
             fdwStyle,
             pr->left,
             pr->top,
             pr->right,
             pr->bottom,
             parent,
             NULL,
             glInstance,
             NULL);
 if(!hWnd)return NULL;
 glWndFrame=hWnd;
 CentreDialogOnScreen(hWnd);
 ShowWindow (hWnd,SW_SHOW);
 UpdateWindow(hWnd);
 return hWnd;
}

static void OpenPreview(int frame, char *file){
 RECT rc;
 MCIWndOpen(hWndVideo,file,0);
 GetClientRect(glWndFrame,&rc); rc.right += 5;
 SendMessage(glWndFrame,WM_SIZE,0,MAKELPARAM(rc.right,rc.bottom));
 rc.right -= 5;
 SendMessage(glWndFrame,WM_SIZE,0,MAKELPARAM(rc.right,rc.bottom));
 TotalFrames=MCIWndGetLength(hWndVideo);
}

static void ClosePreview(void){
 MCIWndClose(hWndVideo);
}

static BOOL CheckSound(void){
 long i;
 if((i=SendMessage(hWndList,LB_GETCURSEL,0,0)) == LB_ERR){
   MessageBox(NULL,"No Sound Selected",NULL,MB_OK);
   return FALSE;
 }
 if((SendMessage(hWndHidList,LB_GETTEXT,(WPARAM)i,
     (LPARAM)(LPCTSTR)szAudioFile)) == LB_ERR){
   MessageBox(NULL,"Bad Sound File",NULL,MB_OK);
   return FALSE;
 }
 if(sAVIc != sWAVc){
   MessageBox(NULL,"Sound and AVI - Incompatible Channels",NULL,MB_OK);
   return FALSE;
 }
 if(sAVIf != sWAVf){
   MessageBox(NULL,"Sound and AVI - Incompatible Sampling Rates",NULL,MB_OK);
   return FALSE;
 }
 if(sAVIb != sWAVb){
//   MessageBox(NULL,"Sound and AVI - Incompatible Sample Size",NULL,MB_OK);
   sprintf(message,"Sound and AVI - Incompatible Sample Size [%ld and %ld]",
           sAVIb,sWAVb);
   MessageBox(NULL,message,NULL,MB_OK);
   return FALSE;
 }
 return TRUE;
}

static void Commands(WORD cmd,HWND hWnd){
 int i;
 RECT rc;
 char temp[256],temp1[256];
 switch (cmd){
   case IDM_OPEN:
     LoadString(glInstance,IDI_SELECTIN,stat_m,255);
     if(SelectFileName(0,szVideoFile,szVideoDirName,
        stat_m,
        "Video Files|*.avi|",
        hWnd) == TRUE){
       LoadString(glInstance,IDI_VIDEO,stat_m,255);
       sprintf(message,stat_m,szVideoFile);
       SendMessage(hWnd,WM_SETTEXT,0,(LPARAM)message);
       ClosePreview();
       InitialiseEdit();
       OpenPreview(0,szWorkFile);
//       OpenPreview(0,szVideoFile);
       UpdateTextInfo();
       GetInfo(TRUE,szWorkFile);
//       GetInfo(TRUE,szVideoFile);
       break;
     }
     break;
   case IDM_OPENSND:
     LoadString(glInstance,IDI_SELECTINSND,stat_m,255);
     if(SelectFileName(0,szAudioFile,szAudioDirName,stat_m,NULL,hWnd) == TRUE){
       SendMessage(hWndList,LB_ADDSTRING,0,
                  (LPARAM)(LPCTSTR)FileInPath(szAudioFile));
       SendMessage(hWndHidList,LB_ADDSTRING,0,(LPARAM)(LPCTSTR)szAudioFile);
     }
     break;
   case IDM_ADDSND:
     if(!CheckSound())break;
     InsertSound();
     break;
   case IDM_MIXSND:
     if(!CheckSound())break;
     MixSound();
     break;
   case IDM_SILENT:
     if(ps_video[1] == NULL)break;
     ChopSound();
     break;
   case IDM_CHOP:
     if(szVideoFile[0] == '\0'){
       temp1[0]='\0';
       if(SelectFileName(1,temp1,szVideoDirName,
          "File To Copy From",
          "Video Files|*.avi|",
          hWnd) != TRUE)break;
     }
     else strcpy(temp1,szVideoFile);
     temp[0]='\0';
     if(SelectFileName(1,temp,szVideoDirName,
        "File To Copy To",
        "Video Files|*.avi|",
        hWnd) == TRUE){
       StripAudioAVI(temp1,temp);
     }
     break;
   case IDM_DUB:
     if(szAudioFile[0] == '\0')break;
     if(szVideoFile[0] == '\0'){
       if(SelectFileName(0,temp1,szVideoDirName,
          "File To Copy From",
          "Video Files|*.avi|",
          hWnd) != TRUE)break;
     }
     else strcpy(temp1,szVideoFile);
     temp[0]='\0';
     if(SelectFileName(0,temp,szVideoDirName,
        "File To Dub Into",
        "Video Files|*.avi|",
        hWnd) == TRUE){
       DubSoundtrack(temp1,szAudioFile,temp);
     }
     break;
   case IDM_BUILD:
     if(ps_video[0] == NULL || ps_video[1] == NULL){
       MessageBeep(MB_OK);
       break;
     }
     LoadString(glInstance,IDI_SELECTOUT,stat_m,255);
     if(SelectFileName(1,szOutFile,szOutDirName,stat_m,
                      "Video Files|*.avi|",hWnd) != TRUE)break;
     AppendFileExtension(szOutFile,".avi");
     lpaviopt[0]=&aviopt[0];
     lpaviopt[1]=&aviopt[1];
     memset(lpaviopt[0],0,sizeof(AVICOMPRESSOPTIONS));
     memset(lpaviopt[1],0,sizeof(AVICOMPRESSOPTIONS));
     if(AVISaveOptions(hWnd,
        ICMF_CHOOSE_KEYFRAME|ICMF_CHOOSE_DATARATE|ICMF_CHOOSE_PREVIEW,
        2,ps_video,lpaviopt)){
       SendMessage(hWndProgress,PBM_SETRANGE,0,MAKELPARAM(0,100));
       SendMessage(hWndProgress,PBM_SETPOS,(WPARAM)0,0);
       SetToolbarState(FALSE);
       ClosePreview();
       DeleteFile(szOutFile);
       if(AVISaveV(szOutFile,NULL,
             (AVISAVECALLBACK)my_save_callback,
             2,
             ps_video,lpaviopt) != AVIERR_OK){
         MessageBox(NULL,"File Save Failed",NULL,MB_OK);
       }
//       OpenPreview(0,szWorkFile);
       OpenPreview(0,szOutFile);
       SetToolbarState(TRUE);
       SendMessage(hWndProgress,PBM_SETPOS,(WPARAM)0,0);
     }
     AVISaveOptionsFree(2,lpaviopt);
     break;
   case IDM_CLEAR:
     SendMessage(hWndList,LB_RESETCONTENT,0,0);
     SendMessage(hWndHidList,LB_RESETCONTENT,0,0);
     SendMessage(hWndProgress,PBM_SETPOS,(WPARAM)0,0);
     szSoundInfo[0]='\0';
     UpdateInfo();
     break;
   case IDM_PLAYSND:
     PlaySound(szAudioFile,NULL,SND_FILENAME|SND_SYNC);
     break;
   case IDM_FIRST:
     if(hWndVideo != NULL)MCIWndSeek(hWndVideo,0);
     CurrentFrame=0;
     UpdateTextInfo();
     break;
   case IDM_PREVIOUS:
     if(CurrentFrame > 0 && hWndVideo != NULL){
       CurrentFrame--;
       MCIWndSeek(hWndVideo,CurrentFrame);
       UpdateTextInfo();
     }
     break;
   case IDM_NEXT:
     if(CurrentFrame < TotalFrames && hWndVideo != NULL){
       CurrentFrame++;
       MCIWndSeek(hWndVideo,CurrentFrame);
       UpdateTextInfo();
     }
     break;
   case IDM_LAST:
     if(hWndVideo != NULL)MCIWndSeek(hWndVideo,TotalFrames);
     CurrentFrame=TotalFrames;
     UpdateTextInfo();
     break;
   case IDM_PLAY:
     if(hWndVideo != NULL)MCIWndPlay(hWndVideo);
     break;
   case IDM_HELP:
     DialogBox(glInstance,MAKEINTRESOURCE(IDD_ABOUT),hWnd,AboutDlgProc);
     break;
   case IDM_INFO:
     DialogBox(glInstance,MAKEINTRESOURCE(DLG_AUDIO_INFO),hWnd,InfoDlgProc);
     break;
   case IDM_EXIT:
     PostQuitMessage(0);
     break;
   default:
     break;
 }
}

static LONG WINAPI MainWndProc(HWND hWnd,UINT uMsg,
                                 WPARAM wParam,LPARAM lParam){
 RECT rc;
 LONG lRet = 1;
 switch (uMsg){
   case WM_CREATE:{
       HMENU hmenu = GetSystemMenu(hWnd, FALSE);
       ps_video[0]=ps_video[1]=NULL;
       AVIFileInit();
       hTBWnd = CreateToolbarEx(
         hWnd,
         WS_CHILD | WS_VISIBLE | !WS_BORDER | TBSTYLE_TOOLTIPS,
         0,
         NOTOOLBARIMAGES,
         glInstance,
         TOOLBAR_IDBM,
         tbb,
         NTOOLBARBUTTONS,
         16,15, // button sizes
         16,15, // bitmap image sizes
         sizeof(TBBUTTON)
       );
       GetClientRect(hTBWnd,&rc); ToolbarHeight=rc.bottom-rc.top;
       hWndStatus=CreateWindowEx(0L,STATUSCLASSNAME,"",
         WS_CHILD | !WS_BORDER | WS_VISIBLE,
         0,0,0,0,
         hWnd,
         (HMENU)102,
         glInstance,
         NULL);
       GetClientRect(hWndStatus,&rc); StatusbarHeight=rc.bottom-rc.top;
       GetClientRect(hWnd,&rc);
       rc.top = rc.bottom-StatusbarHeight-ProgressbarHeight+2;
       hWndProgress=CreateWindowEx(0L,PROGRESS_CLASS,"",
         WS_CHILD | !WS_BORDER | WS_VISIBLE,
         2,rc.top+4,
         rc.right-4,ProgressbarHeight-4,
         hWnd,
         (HMENU)103,
         glInstance,
         NULL);
       GetClientRect(hWnd,&rc);
       hWndList=CreateWindow("listbox",
         " ",
         WS_VISIBLE | WS_CHILD | WS_VSCROLL | WS_BORDER
         | LBS_NOINTEGRALHEIGHT | LBS_NOTIFY | 0,
         rc.left+2,
         rc.top+ToolbarHeight+2,
         rc.right/3-4,
         rc.bottom-ToolbarHeight
                  -StatusbarHeight
                  -ProgressbarHeight
                  -NINFO
                  -2,
         hWnd,
         (HMENU)101,
         glInstance,
         NULL);
       hWndText=CreateWindow("static","  ",
         WS_VISIBLE | WS_CHILD | 0,
         rc.left+2,
//         rc.top+ToolbarHeight+2+ 4+
         rc.top+ToolbarHeight+2+ 10+
         rc.bottom-ToolbarHeight
                  -StatusbarHeight
                  -ProgressbarHeight
                  -NINFO
                  -2,
         rc.right/3-4,
         NINFO-2 -4,
         hWnd,(HMENU)106, glInstance, NULL);
       hWndHidList=CreateWindow("listbox"," ",
         !WS_VISIBLE | WS_CHILD | 0, 0,0,0,0,
         hWnd,(HMENU)105, glInstance, NULL);
       hWndVideo = CreateWindow(
                     MCIWND_WINDOW_CLASS,
                     " ",
                     WS_CHILD | WS_VISIBLE | WS_BORDER |
                     MCIWNDF_NOTIFYMODE |
                     MCIWNDF_NOMENU |
                     MCIWNDF_NOAUTOSIZEWINDOW |
                     0,
                     rc.right/3,
                     rc.top+ToolbarHeight+2,
                     (rc.right*2)/3-2,
                     rc.bottom-ToolbarHeight
                               -StatusbarHeight
                               -ProgressbarHeight-2,
                     hWnd,
                     (HMENU)104,
                     glInstance,
                     NULL);
       SendMessage(hWndText,WM_SETFONT, /* for text in tab */
                  (WPARAM)GetStockObject(ANSI_VAR_FONT),0);
//       SendMessage(hWndList,WM_SETFONT, /* for text in tab */
//                  (WPARAM)GetStockObject(ANSI_VAR_FONT),0);
       LoadString(glInstance,IDI_FILESLIST,stat_m,255);
       SendMessage(hWndStatus,SB_SETTEXT,(WPARAM)0,(LPARAM)stat_m);
       AppendMenu(hmenu,MF_SEPARATOR,0,0);
       AppendMenu(hmenu,MF_STRING,IDM_SYS_BLANK,"Make Blank WAV");
       AppendMenu(hmenu,MF_STRING,IDM_SYS_AUDIO,"Write Audio");
       AppendMenu(hmenu,MF_STRING,IDM_SYS_DEBUG,"Debug On/Off");
       AppendMenu(hmenu,MF_SEPARATOR,0,0);
       AppendMenu(hmenu,MF_STRING,IDM_SYS_CHOP,"Remove Audio Track");
       AppendMenu(hmenu,MF_STRING,IDM_SYS_DUB,"Dub On Audio Track");
     }
     break;
   case WM_DESTROY:
     CloseInputStreams();
     AVIFileExit();
     break;
   case MCIWNDM_NOTIFYMODE:
     if((HWND)wParam == hWndVideo){
       if(lParam == MCI_MODE_STOP){
         int i;
         CurrentFrame=MCIWndGetPosition(hWndVideo);
         UpdateTextInfo();
       }
       else if(lParam == MCI_MODE_SEEK){
       }
       else if(lParam == MCI_MODE_PAUSE){
       }
     }
     break;
   case WM_SYSCOMMAND:
     switch(LOWORD(wParam & 0xfff0)){
       case IDM_SYS_DEBUG:
         debug ^= 1;
         break;
       case IDM_SYS_BLANK:
         if(!SelectFileName(1,szAudioTrackFile,szAudioDirName,
            "Make Blank Track", "Audio Files|*.wav|",hWnd))break;
         AppendFileExtension(szAudioTrackFile,".wav");
         MakeBlankSoundFile(5,1,11025,8);
         break;
       case IDM_SYS_AUDIO:
         if(ps_video[1] == NULL){
           MessageBox(NULL,"No Soundtrack",NULL,MB_OK);
           break;
         }
         if(!SelectFileName(1,szAudioTrackFile,szAudioDirName,
            "Write Audio Track", "Audio Files|*.wav|",hWnd))break;
         AppendFileExtension(szAudioTrackFile,".wav");
         WriteAudioTrack();
         break;
       case IDM_SYS_CHOP:
         SendMessage(hWnd,WM_COMMAND,IDM_CHOP,0);
         break;
       case IDM_SYS_DUB:
         SendMessage(hWnd,WM_COMMAND,IDM_DUB,0);
         break;
       default:
         return( DefWindowProc(hWnd,uMsg,wParam,lParam));
      }
      break;
   case WM_SIZE:
     if(hTBWnd != NULL)SendMessage(hTBWnd,uMsg,wParam,lParam);
     if(hWndStatus != NULL)SendMessage(hWndStatus,uMsg,wParam,lParam);
     SetWindowPos(hWndList,NULL,
                  0+2,ToolbarHeight+2,
                  LOWORD(lParam)/3-4,
                  HIWORD(lParam)-ToolbarHeight
                                -StatusbarHeight
                                -ProgressbarHeight
                                -NINFO
                                -2,
                  SWP_NOZORDER);
     SetWindowPos(hWndText,NULL,
                  0+2,
                  ToolbarHeight+2+ 4+
                  HIWORD(lParam)-ToolbarHeight
                                -StatusbarHeight
                                -ProgressbarHeight
                                -NINFO
                                -2,
                  LOWORD(lParam)/3-4,
                  NINFO-2 -4,
                  SWP_NOZORDER);
     if(hWndVideo != NULL)SetWindowPos(hWndVideo,NULL,
                  LOWORD(lParam)/3,ToolbarHeight+2,
                  (LOWORD(lParam)*2)/3-2,
                  HIWORD(lParam)-ToolbarHeight-StatusbarHeight
                                -ProgressbarHeight-2,
                  SWP_NOZORDER);
     else MessageBeep(MB_OK);
     GetClientRect(hWndList,&rc); rc.bottom += NINFO;
     if(hWndProgress != NULL)SetWindowPos(hWndProgress,NULL,
                  2,ToolbarHeight+6+rc.bottom,
                  LOWORD(lParam)-4,
                  ProgressbarHeight-4,
                  SWP_NOZORDER);
     break;
   case WM_NOTIFY:
     switch (((LPNMHDR)lParam)->code){
       case TTN_NEEDTEXT:{
           int idButton;
           LPTOOLTIPTEXT lpttt;
           lpttt=(LPTOOLTIPTEXT)lParam;
           lpttt->hinst=glInstance;
           idButton=lpttt->hdr.idFrom;
           switch(idButton){
             case IDM_OPEN:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_1); break;
             case IDM_OPENSND:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_2); break;
             case IDM_BUILD:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_3); break;
             case IDM_ADDSND:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_4); break;
             case IDM_PLAYSND:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_5); break;
             case IDM_FIRST:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_6); break;
             case IDM_CLEAR:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_7); break;
             case IDM_LAST:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_8); break;
             case IDM_PREVIOUS:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_9); break;
             case IDM_HELP:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_A); break;
             case IDM_NEXT:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_B); break;
             case IDM_MIXSND:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_C); break;
             case IDM_SILENT:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_D); break;
             case IDM_INFO:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_E); break;
             case IDM_PLAY:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_F); break;
             case IDM_CHOP:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_G); break;
             case IDM_DUB:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_H); break;
           }
         }
         break;
       default: break;
     }
     return (DefWindowProc(hWnd,uMsg,wParam,lParam));
   case WM_COMMAND:
     if((HWND)lParam == hWndList){
       if(HIWORD(wParam) == LBN_SELCHANGE){
         int i;
         if((i=SendMessage(hWndList,LB_GETCURSEL,0,0)) != LB_ERR &&
               SendMessage(hWndHidList,LB_GETTEXT,(WPARAM)i,
                         (LPARAM)(LPCTSTR)szAudioFile) != LB_ERR){
           GetInfo(FALSE,szAudioFile);
         }
       }
       break;
     }
     if((HWND)lParam == hWndHidList)break;
     Commands(LOWORD(wParam),hWnd);
     break;
   case WM_CLOSE:
     PostQuitMessage(0);
     break;
   default:
     lRet = DefWindowProc (hWnd, uMsg, wParam, lParam);
   break;
 }
 return lRet;
}

static PAVISTREAM CreateInsertStream(char *name, long ch, long fq, long bps){
 WAVEFORMATEX af;
 AVISTREAMINFO strhdr;
 PAVISTREAM ps;
 HRESULT hr;
 memset(&strhdr,0,sizeof(strhdr));
 strhdr.fccType       = streamtypeAUDIO;
 strhdr.dwScale       = 1;
 strhdr.dwRate        = fq;
 strhdr.dwSampleSize  = 1;
 strhdr.dwQuality    = -1;
 strcpy(strhdr.szName,name);
 hr=AVIFileCreateStream(pf_video,&ps,&strhdr);
 if(hr != AVIERR_OK){
   MessageBox(NULL,"BAD Stream",NULL,MB_OK);
   return NULL;
 }
 memset(&af,0,sizeof(af));
 af.wFormatTag=WAVE_FORMAT_PCM;
 af.nChannels=ch;
 af.nSamplesPerSec=fq;
 af.wBitsPerSample=bps*8;
 af.nBlockAlign=ch*bps;
 af.nAvgBytesPerSec=af.nSamplesPerSec*af.nBlockAlign;
 hr=AVIStreamSetFormat(ps,0,&af,sizeof(af)-2); // size PCMWAVEFO..
 if (hr != AVIERR_OK){
   MessageBox(NULL,"BAD SetFormat",NULL,MB_OK);
   return NULL;
 }
 return ps;
}

static void CreateBlankSoundStream(void){
 unsigned long ch=1,fq=11025,bps=1;
 unsigned char *buffer;
 unsigned long i,time;
 long samps,bytes;
 PAVISTREAM ps;
 DialogBox(glInstance,MAKEINTRESOURCE(DLG_AUDIO_SET),glWndFrame,StreamDlgProc);
 if((ps=CreateInsertStream("Audio Track",sAVIc,sAVIf,sAVIb)) == NULL)return;
 ch=sAVIc; fq=sAVIf; bps=sAVIb;
 time=AVIStreamSampleToTime(ps_video[0],AVIStreamEnd(ps_video[0]));
 i=time;
 time=(fq*time)/1000L;
//{
//char xxx[256]; sprintf(xxx,"i=%ld sAVIf=%ld time=%ld ch=%ld bps=%ld",
//i,sAVIf,time,ch,bps);
//MessageBox(NULL,xxx,NULL,MB_OK);
//}
 buffer=(unsigned char *)X__Malloc(time*ch*bps*sizeof(unsigned char));
 if(buffer != NULL){
   if(bps == 1)memset(buffer,127,time*ch*bps);
   else        memset(buffer,0,time*ch*bps);
   if(AVIStreamWrite(ps,0,time,buffer,ch*bps*time,
      AVIIF_KEYFRAME,&samps,&bytes) != 0){
     MessageBox(NULL,"BAD Write",NULL,MB_OK);
   }
   X__Free(buffer);
 }
 else MessageBox(NULL,"BAD Memory",NULL,MB_OK);
 if(CreateEditableStream(&ps_video[1],ps) != AVIERR_OK){
   MessageBox(NULL,"BAD Sound Edit Stream",NULL,MB_OK);
 }
 AVIStreamRelease(ps);
}

static void OpenInputStreams(char *name){
 HRESULT hr;
 PAVIFILE pfile;
 PAVISTREAM psin=NULL;
 AVISTREAMINFO avis;
 long i;
 BOOL bBadAudio=FALSE,bBadVideo=FALSE;
 hr = AVIFileOpen(&pfile,
                  name,
                  OF_READWRITE | OF_SHARE_DENY_NONE,
                  NULL);
 if(hr != AVIERR_OK)pfile=NULL;
 if(hr == AVIERR_OK){
   for(i=0;i<10;i++){
     if(AVIFileGetStream(pfile,&psin,0,i) == AVIERR_OK){
       AVIStreamInfo(psin,&avis,sizeof(avis));
       if(avis.fccType == streamtypeVIDEO){
         if(ps_video[0] == NULL){
           if(CreateEditableStream(&ps_video[0],psin) != AVIERR_OK){
             MessageBox(NULL,"Cannot create video edit stream",NULL,MB_OK);
             bBadVideo=TRUE;
           }
         }
       }
       else if(avis.fccType == streamtypeAUDIO){
         if(ps_video[1] == NULL){
           if(CreateEditableStream(&ps_video[1],psin) != AVIERR_OK){
             MessageBox(NULL,"Cannot create audio edit stream",NULL,MB_OK);
             bBadAudio=TRUE;
           }
         }
       }
       AVIStreamRelease(psin);
     }
   }
 }
// AVIMakeFileFromStreams(&pf_video,2,ps_video);
// AVIFileRelease(pfile);
 pf_video=pfile;
 if(pf_video != NULL && ps_video[1] == NULL && !bBadAudio)
   CreateBlankSoundStream();
 return;
}

static void CloseInputStreams(void){
 if(ps_video[0] != NULL)AVIStreamRelease(ps_video[0]); ps_video[0]=NULL;
 if(ps_video[1] != NULL)AVIStreamRelease(ps_video[1]); ps_video[1]=NULL;
 if(pf_video != NULL)AVIFileRelease(pf_video); pf_video=NULL;
 return;
}

static void InitialiseEdit(void){
 CloseInputStreams();
 DeleteFile(szWorkFile);
 LoadString(glInstance,IDI_COPYING,stat_m,255);
 SendMessage(hWndStatus,SB_SETTEXT,(WPARAM)0,(LPARAM)stat_m);
 SetToolbarState(FALSE);
 StartWait();
 YieldTo();
 CopyAVIfile(szVideoFile,szWorkFile);
 SetFileAttributes(szWorkFile,FILE_ATTRIBUTE_TEMPORARY);
 OpenInputStreams(szWorkFile);
 EndWait();
 SetToolbarState(TRUE);
}

static void InsertSound(void){
 unsigned char *buffer;
 HRESULT hr;
 PAVIFILE pfile;
 PAVISTREAM psin=NULL,ptemp,ptemp1;
 AVISTREAMINFO avis;
 long i,k,tstart,sstart,space,ns,samps,bytes;
 hr = AVIFileOpen(&pfile,szAudioFile,OF_READ,NULL);
 if(hr != AVIERR_OK)pfile=NULL;
 if(hr == AVIERR_OK){
   for(i=0;i<10;i++){
     if(AVIFileGetStream(pfile,&psin,0,i) == AVIERR_OK){
       AVIStreamInfo(psin,&avis,sizeof(avis));
       if(avis.fccType == streamtypeAUDIO){
         tstart=AVIStreamSampleToTime(ps_video[0],CurrentFrame);
         sstart=AVIStreamTimeToSample(ps_video[1],tstart);
         space=AVIStreamEnd(ps_video[1])-sstart;
         ns=min(space,AVIStreamEnd(psin));
if(debug){
sprintf(message,"Original End = %ld Input End = %ld  Samples to paste = %ld",
AVIStreamEnd(ps_video[1]),AVIStreamEnd(psin),ns);
MessageBox(NULL,message,"insert",MB_OK);
}
         if(ns > 0){
           if(EditStreamCut(ps_video[1],&sstart,&ns,&ptemp) != 0)
             MessageBox(NULL,"Bad CUT",NULL,MB_OK);
if(debug){
sprintf(message,"ps_video[1] End = %ld ptemp End = %ld Cut out",
AVIStreamEnd(ps_video[1]),AVIStreamEnd(ptemp));
MessageBox(NULL,message,"insert",MB_OK);
}
           if(AVIStreamEnd(ps_video[1]) == 0){ // need full replace
             AVIStreamRelease(ps_video[1]); ps_video[1]=NULL;
             AVIStreamRelease(ptemp);
             if(CreateEditableStream(&ps_video[1],psin) != AVIERR_OK)
               MessageBox(NULL,"Bad Temp Edit Stream",NULL,MB_OK);
             k=AVIStreamEnd(ps_video[1])-ns;
             if(EditStreamCut(ps_video[1],&ns,&k,&ptemp) != 0)
               MessageBox(NULL,"Bad Temp Edit CUT",NULL,MB_OK);
if(debug){
sprintf(message,"Full Cut ps_video[1] End = %ld ptemp End = %ld Sound Cut",
AVIStreamEnd(ps_video[1]),AVIStreamEnd(ptemp));
MessageBox(NULL,message,"insert",MB_OK);
}
           }
           else{
if(debug){
sprintf(message,"pasting back %ld samples at %ld\n"
"into stream length %ld from stream of length %ld",
ns,sstart,AVIStreamEnd(ps_video[1]),AVIStreamEnd(psin));
MessageBox(NULL,message,"insert",MB_OK);
}
             buffer=(unsigned char *)X__Malloc(ns*sAVIc*sAVIb*sizeof(char));
             if(buffer != NULL){
               if((ptemp1=CreateInsertStream("TempTk",sAVIc,sAVIf,sAVIb))
                   == NULL){
                 MessageBox(NULL,"Bad temp stream",NULL,MB_OK);
               }
               else{
                 hr=AVIStreamRead(psin,0,ns,buffer,ns*sAVIc*sAVIb,NULL,NULL);
                 if(hr != 0)MessageBox(NULL,"Bad Sound Read",NULL,MB_OK);
                 hr = AVIStreamWrite(ptemp1,0,ns,buffer,ns*sAVIc*sAVIb,
                                     AVIIF_KEYFRAME,NULL,NULL);
                 if(hr != 0)MessageBox(NULL,"Bad Video Write",NULL,MB_OK);
               }
               X__Free(buffer);
             }
             if(ptemp1 != NULL){
               if(EditStreamPaste(ps_video[1],&sstart,&ns,ptemp1,0,ns) != 0){
                 MessageBox(NULL,"BAD paste - Re-pasting",NULL,MB_OK);
                 if(EditStreamPaste(ps_video[1],&sstart,&ns,ptemp,0,ns) != 0)
                   MessageBox(NULL,"Bad re-PASTE",NULL,MB_OK);
               }
             }
           }
           if(ptemp1 != NULL)AVIStreamRelease(ptemp1);
           AVIStreamRelease(ptemp);
if(debug){
sprintf(message,"Pasting done stream end = %ld",AVIStreamEnd(ps_video[1]));
MessageBox(NULL,message,"insert",MB_OK);
}
         }
         AVIStreamRelease(psin);
         break;
       }
     }
   }
 }
 else MessageBox(NULL,"Bad Audio Open",NULL,MB_OK);
 if(pfile != NULL)AVIFileRelease(pfile);
 MessageBeep(MB_OK);
}

static void  MixSample(long i, unsigned char *buffer1,
                               unsigned char *buffer2){
 long j,id,value,value1,value2;
 if(sAVIc == 1 && sAVIb == 1){
   value1 = (long)buffer1[i] - 128;
   value2 = (long)buffer2[i] - 128;
   value  = value1 + value2 + 128;
   value = max(  0,value);
   value = min(255,value);
   buffer1[i] = (unsigned char)value;
 }
 else if(sAVIc == 2 && sAVIb == 1){
   id=i*2;
   for(j=0;j<2;j++){
     value1 = (long)buffer1[id] - 128;
     value2 = (long)buffer2[id] - 128;
     value  = value1 + value2 + 128;
     value = max(  0,value);
     value = min(255,value);
     buffer1[id] = (unsigned char)value;
     id++;
   }
 }
 else if(sAVIc == 1 && sAVIb == 2){
   id=i*2;
   value1 = (long)buffer1[id] + ((long)buffer1[id+1] << 8);
   value2 = (long)buffer2[id] + ((long)buffer2[id+1] << 8);
   value  = value1 + value2;
   value = max(-32768,value);
   value = min( 32767,value);
   buffer1[id]   = (unsigned char)(value & 0xff);
   buffer1[id+1] = (unsigned char)(value >> 8);
 }
 else if(sAVIc == 2 && sAVIb == 2){
   id=i*4;
   for(j=0;j<2;j++){
     value1 = (long)buffer1[id] + ((long)buffer1[id+1] << 8);
     value2 = (long)buffer2[id] + ((long)buffer2[id+1] << 8);
     value  = value1 + value2;
     value = max(-32768,value);
     value = min( 32767,value);
     buffer1[id]   = (unsigned char)(value & 0xff);
     buffer1[id+1] = (unsigned char)(value >> 8);
     id+=2;
   }
 }
}

static void MixSound(void){ /* this assumes streams are the same */
 unsigned char *buffer1,*buffer2;
 HRESULT hr;
 PAVIFILE pfile;
 PAVISTREAM psin=NULL,ptemp,pmix;
 AVISTREAMINFO avis;
 long i,tstart,sstart,space,ns,samps,bytes;
 hr = AVIFileOpen(&pfile,szAudioFile,OF_READ,NULL);
 if(hr != AVIERR_OK)pfile=NULL;
 if(hr == AVIERR_OK){
   for(i=0;i<10;i++){
     if(AVIFileGetStream(pfile,&psin,0,i) == AVIERR_OK){
       AVIStreamInfo(psin,&avis,sizeof(avis));
       if(avis.fccType == streamtypeAUDIO){
         tstart=AVIStreamSampleToTime(ps_video[0],CurrentFrame);
         sstart=AVIStreamTimeToSample(ps_video[1],tstart);
         space=AVIStreamEnd(ps_video[1])-sstart;
         ns=min(space,AVIStreamEnd(psin));
if(debug){
sprintf(message,"Original End = %ld Input End = %ld  Samples to paste = %ld",
AVIStreamEnd(ps_video[1]),AVIStreamEnd(psin),ns);
MessageBox(NULL,message,"insert",MB_OK);
}
         if(ns > 0){
           buffer1=(unsigned char *)X__Malloc(ns*sAVIc*sAVIb*sizeof(char));
           buffer2=(unsigned char *)X__Malloc(ns*sAVIc*sAVIb*sizeof(char));
           if(buffer1 != NULL && buffer2 != NULL){
             if(EditStreamCut(ps_video[1],&sstart,&ns,&ptemp) != 0)
               MessageBox(NULL,"Bad CUT",NULL,MB_OK);
             if((pmix=CreateInsertStream("TempTk",sAVIc,sAVIf,sAVIb)) == NULL)break;
             hr=AVIStreamRead(psin,0,ns,buffer1,ns*sAVIc*sAVIb,NULL,NULL);
             if(hr != 0)MessageBox(NULL,"Bad Sound Read",NULL,MB_OK);
             hr=AVIStreamRead(ptemp,0,ns,buffer2,ns*sAVIc*sAVIb,NULL,NULL);
             if(hr != 0)MessageBox(NULL,"Bad Video Read",NULL,MB_OK);
if(debug){
sprintf(message,"ps_video[1] End = %ld ptemp End = %ld after cut",
AVIStreamEnd(ps_video[1]),AVIStreamEnd(ptemp));
MessageBox(NULL,message,"insert",MB_OK);
}
             for(i=0;i<ns;i++)MixSample(i,buffer1,buffer2);
             hr = AVIStreamWrite(pmix,0,ns,buffer1,ns*sAVIc*sAVIb,
                                 AVIIF_KEYFRAME,NULL,NULL);
             if(hr != 0)MessageBox(NULL,"Bad Video Write",NULL,MB_OK);
             AVIStreamRelease(ptemp);
             if(CreateEditableStream(&ptemp,pmix) != AVIERR_OK)
               MessageBox(NULL,"Bad Edit Stream",NULL,MB_OK);
             AVIStreamRelease(pmix);
if(debug){
sprintf(message,"ps_video[1] End = %ld ptemp End = %ld Paste back",
AVIStreamEnd(ps_video[1]),AVIStreamEnd(ptemp));
MessageBox(NULL,message,"insert",MB_OK);
}
             if(AVIStreamEnd(ps_video[1]) == 0){
               AVIStreamRelease(ps_video[1]);
               ps_video[1]=ptemp;
             }
             else{
               if(EditStreamPaste(ps_video[1],&sstart,&ns,ptemp,0,ns) != 0){
                 MessageBox(NULL,"Bad Paste",NULL,MB_OK);
               }
               AVIStreamRelease(ptemp);
             }
if(debug){
sprintf(message,"Pasting done stream end = %ld",AVIStreamEnd(ps_video[1]));
MessageBox(NULL,message,"insert",MB_OK);
}
           }
           if(buffer1 != NULL)X__Free(buffer1);
           if(buffer2 != NULL)X__Free(buffer2);
         }
         AVIStreamRelease(psin);
         break;
       }
     }
   }
 }
 else MessageBox(NULL,"Bad Audio Open",NULL,MB_OK);
 if(pfile != NULL)AVIFileRelease(pfile);
 MessageBeep(MB_OK);
}

static void ChopSound(void){
 if(ps_video[1] != NULL)AVIStreamRelease(ps_video[1]);
 ps_video[1]=NULL;
 CreateBlankSoundStream();
}

#include "utils.c"

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine, int nCmdShow){
 MSG msg;
 RECT rc;
 InitCommonControls();
// Ctl3dRegister(hInstance);
// Ctl3dAutoSubclass(hInstance);
 if(!MCIWndRegisterClass())return FALSE;
 RegisterMainClass(hInstance);
 rc.left=100; rc.top=100;
 rc.right=rc.left+400; rc.bottom=rc.top+220;
 rc.bottom +=  GetSystemMetrics(SM_CYMENU);
 RegisterWindow(NULL,&rc);
 while (GetMessage(&msg,NULL,0,0)){
   TranslateMessage(&msg);
   DispatchMessage(&msg);
 }
 DestroyWindow(glWndFrame);
 UnregisterMainClass(hInstance);
 DeleteFile(szWorkFile);
// Ctl3dUnAutoSubclass();
// Ctl3dUnregister(hInstance);
 return TRUE;
}
