/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

#include <stdio.h>
#include <windows.h>
#include <windowsx.h>

#include "gif2avi.h"
#include "..\..\animate\about.h"

typedef LPBITMAPINFOHEADER PDIB;

#define MDIVIEW_APP_CLASS "OFX:Gif2Avi"
#define MDIVIEW_DOC_CLASS "OFX:Gif2Avi:Window"

#define CBWNDEXTRA            (12)
#define GWL_PALETTE            (0)
#define GWL_BITMAP_HEADER      (4)
#define GWL_BITMAP_BITS        (8)

#define FI_GIF 0

#define ISCHECKED(hwnd,id) (BOOL)(GetMenuState(GetMenu(hwnd), id, 0) & MF_CHECKED)
#define ALIGNULONG(i)   (((i+3)/4)*4)
#define BOUND(x,min,max) ((x) < (min) ? (min) : ((x) > (max) ? (max) : (x)))
#define EVI_Malloc(s)    LocalAlloc(LMEM_FIXED,s)
#define EVI_Free(p)      LocalFree((HLOCAL)p)

HINSTANCE ghInstApp;    /* Instance handle */
HACCEL ghAccelApp;
HWND ghwndApp;          /* Handle to parent window */
HWND ghwndMdi;          /* Handle to MCI client window */
HWND ghwndAct=NULL;
char szFileName[256],szDirName[256];
char szAviFileName[256],szAviDirName[256];
POINT ptSize;
BOOL configured=FALSE;
long frame_rate=1;

extern int AVI_frame_rate;
extern void configureAVIfile(HWND, char *);
extern void openAVIfile(char *, LPBITMAPINFOHEADER, int);
extern void appendAVIfile(LPBITMAPINFOHEADER);
extern void closeAVIfile(void);

LRESULT CALLBACK AppWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DocWndProc(HWND, UINT, WPARAM, LPARAM);

static BOOL AppInit(HINSTANCE, HINSTANCE, LPSTR, int);
static HWND mdiCreateDoc(LPSTR, LPSTR, LPARAM);
static HWND mdiCreateClient(HWND, HMENU);
static LRESULT mdiSendMessage(HWND, HWND, UINT, WPARAM, LPARAM);
static void mdiFilterSendMessage(HWND, UINT, WPARAM, LPARAM);
static void MCI_OnCommand(HWND, int, HWND, UINT);
static void MCI_OnInitMenuPopup(HWND, HMENU, int, BOOL);
static void MCI_OnSize(HWND, UINT, int, int);
static int SelectFileName(int, char *, char *, char *, char *, HWND);
static PSTR FileInPath(PSTR);
static int identify_file_format(char *);
static char *short_form(char *);
static void LoadGif(char *, char *, HWND);
static HBITMAP BitmapFromDib(LPSTR, LPSTR, HPALETTE);
static void AppPaint(HWND, HDC ,int, int);
static void SizeWindow(HWND);
static void SetScrollRanges(HWND);
static void GetRealClientRect(HWND, PRECT);
static BOOL CALLBACK FpsDlgProc(HWND, UINT, WPARAM, LPARAM);

static BOOL AppInit(HINSTANCE hInst,HINSTANCE hPrev,LPSTR szCmd,int sw){
 char gszHomeDir[256];
 WNDCLASS cls;
 WORD wVer;
 HWND hDesktopWnd;
 HDC hDCcaps;
 int DisplayBits;
 ghInstApp = hInst;
 ghAccelApp = LoadAccelerators(ghInstApp, "AppAccel");
 if (!hPrev) {
     cls.hCursor        = LoadCursor(NULL,IDC_ARROW);
     cls.hIcon          = LoadIcon(hInst,"AppIcon");
     cls.lpszMenuName   = "AppMenu";
     cls.lpszClassName  = MDIVIEW_APP_CLASS;
     cls.hbrBackground  = (HBRUSH)(COLOR_APPWORKSPACE+1);
     cls.hInstance      = hInst;
     cls.style          = 0;
     cls.lpfnWndProc    = (WNDPROC)AppWndProc;
     cls.cbClsExtra     = 0;
     cls.cbWndExtra     = 0;
     if (!RegisterClass(&cls))
         return FALSE;
     cls.hCursor        = LoadCursor(NULL,IDC_ARROW);
     cls.hIcon          = NULL; //LoadIcon(hInst,"AppIcon");
     cls.lpszMenuName   = NULL;
     cls.lpszClassName  = MDIVIEW_DOC_CLASS;
     cls.hbrBackground  = (HBRUSH)(COLOR_APPWORKSPACE+1);
     cls.hInstance      = hInst;
     cls.style          = 0;
     cls.lpfnWndProc    = (WNDPROC)DocWndProc;
     cls.cbClsExtra     = 0;
     cls.cbWndExtra     = CBWNDEXTRA;
     if (!RegisterClass(&cls))
         return FALSE;
 }
 ghwndApp = CreateWindow(
     MDIVIEW_APP_CLASS,
     "GIF 2 AVI File Converter",
     WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
     0,
     0,
     CW_USEDEFAULT,
     CW_USEDEFAULT,
     (HWND)NULL,        /* no parent */
     (HMENU)NULL,       /* use class menu */
     (HANDLE)hInst,     /* handle to window instance */
     (LPSTR)NULL);      /* no params to pass on */
 ShowWindow(ghwndApp,sw);
 GetModuleFileName(hInst,gszHomeDir,256);
 *FileInPath(gszHomeDir) = '\0'; szFileName[0]='\0';
 szAviFileName[0]='\0';
 strcpy(szDirName,gszHomeDir);
 strcpy(szAviDirName,gszHomeDir);
 hDesktopWnd = GetDesktopWindow();
 hDCcaps     = GetDC(hDesktopWnd);
 DisplayBits=GetDeviceCaps(hDCcaps,BITSPIXEL);
 ReleaseDC(hDesktopWnd,hDCcaps);
 return TRUE;
}

int PASCAL WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
                   LPSTR szCmdLine,int sw){
 MSG msg;
 if (!AppInit(hInstance,hPrevInstance,szCmdLine,sw))return FALSE;
 for (;;) {
    if (PeekMessage(&msg, NULL, 0, 0,PM_REMOVE)) {
      if (msg.message == WM_QUIT)break;
      if (ghAccelApp && ghwndApp && TranslateAccelerator(ghwndApp, ghAccelApp, &msg))
                continue;
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
    else {
      WaitMessage();
    }
 }
 return msg.wParam;
}

static HWND mdiCreateDoc(LPSTR szClass,LPSTR szTitle,LPARAM l){
 static int x0=0,y0=0;
 MDICREATESTRUCT mdics;
 mdics.szClass   = szClass;
 mdics.szTitle   = szTitle;
 mdics.hOwner    = ghInstApp;
 mdics.x         = x0; x0 += 8;
 mdics.y         = y0; y0 += 8;
 mdics.cx        = 320;
 mdics.cy        = 240;
 mdics.style     = WS_CLIPCHILDREN | WS_CLIPSIBLINGS | WS_HSCROLL | WS_VSCROLL;
 mdics.lParam    = l;
 return FORWARD_WM_MDICREATE(ghwndMdi,(LPMDICREATESTRUCT)&mdics,SendMessage);
}

static HWND mdiCreateClient(HWND hwndP,HMENU hmenuWindow){
 CLIENTCREATESTRUCT ccs;
 ccs.hWindowMenu = hmenuWindow;
 ccs.idFirstChild = 100;
 return CreateWindow("MDICLIENT",
            NULL,
            WS_CHILD | WS_CLIPCHILDREN | WS_VISIBLE,
            0,
            0,
            0,
            0,
            hwndP,
            0,
            ghInstApp,
            (LPVOID)&ccs);
}

static LRESULT mdiSendMessage(HWND hwndMdi,HWND hwnd,UINT msg,
                              WPARAM wParam,LPARAM lParam){
 if (hwnd == (HWND)-1) {
   for(hwnd = GetWindow(hwndMdi,GW_CHILD);
       hwnd;
       hwnd=GetWindow(hwnd,GW_HWNDNEXT))
     SendMessage(hwnd, msg, wParam, lParam);
   return 0L;
 }
 else {
   if (hwnd == NULL)hwnd = FORWARD_WM_MDIGETACTIVE(hwndMdi, SendMessage);
   if (hwnd)return SendMessage(hwnd, msg, wParam, lParam);
 }
 return 0L;
}

static void MCI_OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify){
 HWND hwndNew;
 HWND hwndMovie = FORWARD_WM_MDIGETACTIVE(ghwndMdi,SendMessage);
 switch(id) {
   case MENU_EXIT:
     PostMessage(hwnd,WM_CLOSE,0,0L);
     break;
   case MENU_CLOSE:
     PostMessage(hwndMovie, WM_CLOSE, 0, 0L);
     break;
   case MENU_FPS:
     DialogBox(ghInstApp,MAKEINTRESOURCE(DLG_FPS),hwnd,(DLGPROC)FpsDlgProc);
     if(frame_rate < 1)frame_rate=1;
     AVI_frame_rate=frame_rate;
     break;
   case MENU_CONFIGURE:
     configureAVIfile(hwnd,NULL);
     configured=TRUE;
     break;
   case MENU_ABOUT:
     MessageBox(hwnd,"     "
                     ABOUT_VERSION
                     "        ",
                     "About OpenFX Animated Gif to AVI Converter",MB_OK);
     break;
   case MENU_OPEN:{
       HBITMAP  hBitmap=NULL;
       HPALETTE hPalette=NULL;
       LPSTR    pBitmap=NULL;
       if(SelectFileName(0,szFileName,szDirName,"open GIF",
               "Compuserve GIFs|*.gif|"
                        ,hwnd) == TRUE){
         if(configured)SelectFileName(1,szAviFileName,szAviDirName,"",
                 "AVI Output File AVIs|*.avi|",hwnd);
         if (hwndNew = mdiCreateDoc(MDIVIEW_DOC_CLASS,
                       (LPSTR)short_form(szFileName),(LPARAM)0)){
           ghwndAct=hwndNew;
           if(configured){
             LoadGif(szFileName,szAviFileName,hwndNew);
             closeAVIfile();
             configured=FALSE;
           }
           else{
             LoadGif(szFileName,NULL,hwndNew);
           }
           SetFocus(hwndNew);
           SizeWindow(hwndNew);
         }
       }
     }
     break;
   case WM_MDITILE:
   case WM_MDICASCADE:
   case WM_MDIICONARRANGE:
     SendMessage(ghwndMdi, id, 0, 0);
     break;
   default:
     FORWARD_WM_COMMAND(NULL,id,hwndCtl,codeNotify,mdiFilterSendMessage);
     break;
 }
 return;
}

static void mdiFilterSendMessage(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam){
 mdiSendMessage(ghwndMdi, hwnd, msg, wParam, lParam);
}

static void MCI_OnInitMenuPopup(HWND hwnd,HMENU hMenu,
                                int item,BOOL fSystemMenu){
    HMENU hStylesMenu = GetSubMenu(GetSubMenu(GetMenu(hwnd), 1), 10);
    HMENU hFileMenu = GetSubMenu(GetMenu(hwnd), 0);
    HMENU hMovieMenu = GetSubMenu(GetMenu(hwnd), 1);
    HMENU hWindowMenu = GetSubMenu(GetMenu(hwnd), 2);
    HWND  hwndMovie = FORWARD_WM_MDIGETACTIVE(ghwndMdi, SendMessage);
    UINT f;
    if (fSystemMenu)return;
    else if (hMenu == hMovieMenu) {
    }
    else if (hMenu == hWindowMenu) {
    }
    else if (hMenu == hFileMenu) {
    }
    FORWARD_WM_INITMENUPOPUP(NULL, hMenu, item,
                             fSystemMenu, mdiFilterSendMessage);
    return;
}

static void MCI_OnSize(HWND hwnd,UINT state,int cx,int cy){
  MoveWindow(ghwndMdi,0,0,cx,cy,TRUE);
  return;
}

LRESULT CALLBACK AppWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam){
 static BOOL busy1=FALSE;
 switch (msg) {
   case WM_CREATE:
     ghwndMdi = mdiCreateClient(hwnd, GetSubMenu(GetMenu(hwnd), GetMenuItemCount(GetMenu(hwnd))-1));
     break;
   case WM_COMMAND:
     HANDLE_WM_COMMAND(hwnd, wParam, lParam, MCI_OnCommand);
     break;
   case WM_PALETTECHANGED:
     mdiSendMessage(ghwndMdi, (HWND)-1, msg, wParam, lParam);
     break;
   case WM_QUERYNEWPALETTE:
     return mdiSendMessage(ghwndMdi, NULL, msg, wParam, lParam);
     break;
   case WM_INITMENUPOPUP:
     HANDLE_WM_INITMENUPOPUP(hwnd, wParam, lParam, MCI_OnInitMenuPopup);
     break;
   case WM_SIZE:
     HANDLE_WM_SIZE(hwnd, wParam, lParam, MCI_OnSize);
     break;
   case WM_DESTROY:
     PostQuitMessage(0);
     return (0);
 }
 return DefFrameProc(hwnd,ghwndMdi,msg,wParam,lParam);
}

LRESULT CALLBACK DocWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam){
 int i,iPos,iMax,iMin,dn;
 RECT rc;
 HDC hDC;
 switch (msg) {
   case  WM_PAINT:{
       PAINTSTRUCT ps;
       hDC=BeginPaint(hwnd, &ps);
       AppPaint(hwnd,hDC,GetScrollPos(hwnd,SB_HORZ),GetScrollPos(hwnd,SB_VERT));
       EndPaint(hwnd,&ps);
     }
     break;
   case WM_VSCROLL:
     GetScrollRange (hwnd,SB_VERT, &iMin, &iMax);
     iPos = GetScrollPos (hwnd, SB_VERT);
     GetClientRect (hwnd, &rc);
     switch (LOWORD(wParam)) {
       case SB_LINEDOWN:      dn =  rc.bottom / 16 + 1;    break;
       case SB_LINEUP:        dn = -rc.bottom / 16 + 1;    break;
       case SB_PAGEDOWN:      dn =  rc.bottom / 2  + 1;    break;
       case SB_PAGEUP:        dn = -rc.bottom / 2  + 1;    break;
       case SB_THUMBTRACK:
       case SB_THUMBPOSITION: dn = HIWORD(wParam)-iPos;    break;
        default:               dn = 0;
     }
     if ((dn = BOUND (iPos + dn, iMin, iMax) - iPos) != 0) {
       ScrollWindow(hwnd, 0, -dn, NULL, NULL);
       SetScrollPos(hwnd, SB_VERT, iPos + dn, TRUE);
     }
     break;
   case WM_HSCROLL:
     GetScrollRange(hwnd, SB_HORZ, &iMin, &iMax);
     iPos = GetScrollPos(hwnd, SB_HORZ);
     GetClientRect (hwnd, &rc);
      switch (LOWORD(wParam)) {
       case SB_LINEDOWN:      dn =  rc.right / 16 + 1;     break;
       case SB_LINEUP:        dn = -rc.right / 16 + 1;     break;
       case SB_PAGEDOWN:      dn =  rc.right / 2  + 1;     break;
       case SB_PAGEUP:        dn = -rc.right / 2  + 1;     break;
       case SB_THUMBTRACK:
       case SB_THUMBPOSITION: dn = HIWORD(wParam) - iPos; break;
      default:               dn = 0;
     }
     if ((dn = BOUND (iPos + dn, iMin, iMax) - iPos) != 0) {
       ScrollWindow (hwnd, -dn, 0, NULL, NULL);
       SetScrollPos (hwnd, SB_HORZ, iPos + dn, TRUE);
     }
     break;
   case WM_SIZE:
     SetScrollRanges(hwnd);
     return DefMDIChildProc(hwnd,msg,wParam,lParam);
   case WM_DESTROY:{
       HPALETTE hPalette;
       LPSTR    pBitmap;
       hPalette=(HPALETTE)GetWindowLong(hwnd,GWL_PALETTE);
       pBitmap=(LPSTR)GetWindowLong(hwnd,GWL_BITMAP_HEADER);
       if(hPalette != NULL)DeleteObject(hPalette); hPalette=NULL;
       if(pBitmap != NULL)EVI_Free(pBitmap); pBitmap=NULL;
       SetWindowLong(hwnd,GWL_BITMAP_HEADER,(LONG)pBitmap);
       SetWindowLong(hwnd,GWL_BITMAP_BITS,(LONG)pBitmap);
       SetWindowLong(hwnd,GWL_PALETTE,(LONG)hPalette);
     }
     break;
   case WM_MDIACTIVATE:
     ghwndAct=(HWND)lParam;
     if(ghwndAct == hwnd)InvalidateRect(hwnd,(LPRECT)(NULL),1);
     break;
   default:
     return DefMDIChildProc(hwnd,msg,wParam,lParam);
 }
 return 0;
}

static void GetRealClientRect(HWND hwnd, PRECT lprc){
 DWORD dwStyle;
 dwStyle = GetWindowLong (hwnd, GWL_STYLE);
 GetClientRect (hwnd,lprc);
 if (dwStyle & WS_HSCROLL)lprc->bottom += GetSystemMetrics(SM_CYHSCROLL);
 if (dwStyle & WS_VSCROLL)lprc->right  += GetSystemMetrics(SM_CXVSCROLL);
}

static void SizeWindow(HWND hWnd){
 DWORD dwStyle = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU |
                 WS_MAXIMIZEBOX | WS_MINIMIZEBOX | WS_THICKFRAME;
 RECT  Rectangle;
 int   dx=0,dy=0;
 POINT pt;
 LPBITMAPINFOHEADER bi;
 if (IsZoomed(hWnd))SetScrollRanges(hWnd);
 else {
   bi=(LPBITMAPINFOHEADER)GetWindowLong(hWnd,GWL_BITMAP_HEADER);
   if(bi != NULL){
     dx=bi->biWidth;
     dy=bi->biHeight;
     ptSize.x = (WORD)dx;
     ptSize.y = (WORD)dy;
   }
   Rectangle.left   = 0;
   Rectangle.top    = 0;
   Rectangle.right  = (WORD)dx;
   Rectangle.bottom = (WORD)dy;
   AdjustWindowRect(&Rectangle,dwStyle,TRUE);
   Rectangle.bottom -= GetSystemMetrics(SM_CYMENU);
   SetWindowPos (hWnd,(HWND)NULL,0,0,
                 Rectangle.right  - Rectangle.left,
                 Rectangle.bottom - Rectangle.top,
                 SWP_NOMOVE | SWP_NOZORDER);
 }
 InvalidateRect(hWnd,NULL,TRUE);
}

static void SetScrollRanges(HWND hwnd){
 RECT rc;
 int iRangeH,iRangeV,i;
 static int iSem = 0;
 if(!iSem){
   iSem++;
   GetRealClientRect(hwnd,&rc);
   for(i = 0; i < 2; i++){
     iRangeV = ptSize.y - rc.bottom;
     iRangeH = ptSize.x - rc.right;
     if(iRangeH < 0)iRangeH = 0;
     if(iRangeV < 0)iRangeV = 0;
     if (GetScrollPos(hwnd,SB_VERT)  > iRangeV ||
         GetScrollPos(hwnd, SB_HORZ) > iRangeH)
       InvalidateRect (hwnd, NULL, TRUE);
     SetScrollRange(hwnd, SB_VERT, 0, iRangeV, TRUE);
     SetScrollRange(hwnd, SB_HORZ, 0, iRangeH, TRUE);
     GetClientRect(hwnd, &rc);
   }
   iSem--;
 }
}

static void AppPaint(HWND hWnd,HDC hDC,int x,int y){
 HPALETTE hpalT,hpal;
 POINT Origin;
 HDC hDCbits;
 HBITMAP hbm;
 BITMAP bm;
 LPSTR lpBitmapHeader,lpBitmapBits;
 if(!IsIconic(hWnd)){
   SetWindowOrgEx(hDC,x,y,&Origin);
   hpal=(HPALETTE)GetWindowLong(hWnd,GWL_PALETTE);
   lpBitmapHeader=(LPSTR)GetWindowLong(hWnd,GWL_BITMAP_HEADER);
   lpBitmapBits=(LPSTR)GetWindowLong(hWnd,GWL_BITMAP_BITS);
   if(hpal == NULL || lpBitmapHeader == NULL || lpBitmapBits == NULL)return;
   hbm=BitmapFromDib(lpBitmapHeader,lpBitmapBits,hpal);
 }
 else return;
 SetBkMode(hDC,TRANSPARENT);
 if(hpal != NULL){
   if(hWnd == ghwndAct){
     hpalT = SelectPalette(hDC,hpal,FALSE);
     RealizePalette(hDC);
   }
   if(hbm != NULL){
     hDCbits = CreateCompatibleDC(hDC);
     GetObject(hbm,sizeof(BITMAP),(LPSTR)&bm);
     SelectObject(hDCbits,hbm);
     BitBlt(hDC,0,0,bm.bmWidth,bm.bmHeight,hDCbits,0,0,SRCCOPY);
     DeleteDC(hDCbits);
     DeleteObject(hbm);
   }
   if(hWnd == ghwndAct)SelectPalette(hDC,hpalT,FALSE);
 }
}

static int identify_file_format(char *filename){
 char CurrentFile[256];
 int ff=FI_GIF;
 strcpy(CurrentFile,filename);
 if     (strstr(CurrentFile,".GIF") || strstr(CurrentFile,".gif"))ff=FI_GIF;
 return ff;
}

static char *short_form(char *filename){
 char *sps,*spc;
 sps=spc=filename;
 while((spc=strchr(spc,'\\')) != NULL){spc++; sps=spc;}
 return sps;
}

static PSTR FileInPath(PSTR pstrPath){
 PSTR pstr;
 pstr = pstrPath + strlen(pstrPath);
 while (pstr > pstrPath) {
     pstr = (AnsiPrev(pstrPath, pstr));
     if (*pstr == '\\' || *pstr == ':' || *pstr == '/') {
         pstr = (AnsiNext(pstr));
         break;
     }
 }
 return pstr;
}

static int SelectFileName(int save, char *szfile, char *szdir,
                          char *szTitle, char *szfilter, HWND parent){
 int i;
 OPENFILENAME ofn;
 char szFilter[256],szdummy[256];
 szdummy[0]='\0';
 strcpy(szFilter,szfilter);
 i=0; while(szFilter[i] != '\0'){
   if(szFilter[i] == '|')szFilter[i]='\0'; i++;
 }
 memset(&ofn,0,sizeof(OPENFILENAME));
 ofn.lStructSize=sizeof(OPENFILENAME);
 ofn.hwndOwner=parent;
 ofn.lpstrFilter=szFilter;
 ofn.nFilterIndex=1;
 ofn.lpstrFile=szfile;              /* will contain file + path */
 ofn.nMaxFile=256;
 ofn.lpstrFileTitle=szdummy;         /* file name only */
 ofn.nMaxFileTitle=256;
 ofn.lpstrInitialDir=szdir;
 ofn.lpstrTitle=szTitle;
 if(save){
  ofn.Flags=OFN_HIDEREADONLY|OFN_PATHMUSTEXIST;
   i=(int)(GetSaveFileName(&ofn));
 }
 else{
  ofn.Flags=OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST;
   i=(int)(GetOpenFileName(&ofn));
 }
 if(i){
   strcpy(szdummy,szfile);
   *AnsiPrev(szdummy,FileInPath(szdummy)) = '\0';
   strcpy(szdir,szdummy);
 }
 return i;
}

#define PALVERSION  0x300
#define MAXPALETTE  256
#define DibNumColors(bmih) (bmih.biClrUsed == 0 && bmih.biBitCount <= 8 \
                            ? (int)(1 << (int)bmih.biBitCount)          \
                            : (int)bmih.biClrUsed)

static WORD NumColours(LPBITMAPINFOHEADER lpbi){
 WORD bits;
 if (lpbi->biClrUsed != 0)return (WORD)lpbi->biClrUsed;
 bits = lpbi->biBitCount;
 switch (bits){
  case 1:    return 2;
  case 4:    return 16;
  case 8:    return 256;
  default:   return 0; /* A 24 bitcount DIB has no color table */
 }
}

static HPALETTE CreateImagePalette(LPBITMAPINFOHEADER lpbi){
 LOGPALETTE *pPal;
 HPALETTE   hpal = NULL;
 WORD       nNumColors;
 BYTE       red;
 BYTE       green;
 BYTE       blue;
 int        i;
 RGBQUAD    *pRgb;
 if(lpbi == NULL)return NULL;
 if(lpbi->biSize != sizeof(BITMAPINFOHEADER))return NULL;
 pRgb = (RGBQUAD *)((LPSTR)lpbi + (WORD)lpbi->biSize);
 nNumColors = NumColours(lpbi);
 if(nNumColors){
   pPal = (LOGPALETTE*)LocalAlloc(LPTR,sizeof(LOGPALETTE) + nNumColors * sizeof(PALETTEENTRY));
   if(pPal == NULL)return NULL;
   pPal->palNumEntries = nNumColors;
   pPal->palVersion    = PALVERSION;
   for (i = 0; i < nNumColors; i++){
       pPal->palPalEntry[i].peRed   = pRgb[i].rgbRed;
       pPal->palPalEntry[i].peGreen = pRgb[i].rgbGreen;
       pPal->palPalEntry[i].peBlue  = pRgb[i].rgbBlue;
       pPal->palPalEntry[i].peFlags = (BYTE)0;
   }
   hpal = CreatePalette(pPal);
   LocalFree((HANDLE)pPal);
 }
 else if (lpbi->biBitCount == 24){
   nNumColors = MAXPALETTE;
   pPal=(LOGPALETTE*)LocalAlloc(LPTR,sizeof(LOGPALETTE) + nNumColors * sizeof(PALETTEENTRY));
   if(pPal == NULL)return NULL;
   pPal->palNumEntries = nNumColors;
   pPal->palVersion    = PALVERSION;
   red = green = blue = 0;
   for (i = 0; i < pPal->palNumEntries; i++){
       pPal->palPalEntry[i].peRed   = red;
       pPal->palPalEntry[i].peGreen = green;
       pPal->palPalEntry[i].peBlue  = blue;
       pPal->palPalEntry[i].peFlags = (BYTE)0;
       if (!(red += 32))if (!(green += 32)) blue += 64;
   }
   hpal = CreatePalette(pPal);
   LocalFree((HANDLE)pPal);
 }
 return hpal;
}

static HBITMAP BitmapFromDib(LPSTR lpHeader,
                             LPSTR lpBits,
                             HPALETTE hpal){
 HDC       hdc;
 HBITMAP   hbm;
 HPALETTE  hpalT;
 if (lpHeader == NULL || lpBits == NULL)return NULL;
 hdc = GetDC(NULL);
 if(hpal != NULL){
   hpalT = SelectPalette(hdc,hpal,FALSE);
   RealizePalette(hdc);
 }
 hbm = CreateDIBitmap(hdc,
                (LPBITMAPINFOHEADER)lpHeader,
                (LONG)CBM_INIT,
                lpBits,
                (LPBITMAPINFO)lpHeader,
                DIB_RGB_COLORS );
 if(hpal != NULL)SelectPalette(hdc,hpalT,FALSE);
 ReleaseDC(NULL,hdc);
 return hbm;
}

extern short read_gif_image(char *, short);
extern unsigned char p_red[],p_green[],p_blue[];
extern int colourmap_size,x_size,y_size,x_origin,y_origin,gif_iLace;

static int x4_size,y4_size,rowcount,rowinc,framecount;
static LPSTR image_pixels;
static HWND  current_window;

void reset_row_count(void){
 MSG msg;
 LPSTR lpBi;
 framecount++;
 if(framecount == 1)SizeWindow(current_window);
 else{
   InvalidateRect(current_window,NULL,TRUE);
   UpdateWindow(current_window);
 }
 if(configured){
   lpBi=(LPSTR)GetWindowLong(current_window,GWL_BITMAP_HEADER);
   appendAVIfile((LPBITMAPINFOHEADER)lpBi);
 }
//{char xxx[256]; sprintf(xxx,"Image control Frame %ld W=%ld H=%ld (Y4=%ld) X=%ld Y=%ld",
//framecount,x_size,y_size,y4_size,x_origin,y_origin);
//MessageBox(NULL,xxx,NULL,MB_OK);}
 while (PeekMessage(&msg, NULL, 0, 0,PM_REMOVE)){
   TranslateMessage(&msg);
   DispatchMessage(&msg);
 }
 Sleep(50);
 rowcount=0;
}

int out_line(unsigned char *linepixels, int linelen){
 register long l;
 l = x_origin+(long)(y4_size - 1 - (rowcount+y_origin))*(long)(x4_size);
 memcpy(image_pixels + l, linepixels, linelen);
 rowcount+=abs(rowinc);
 if(rowcount >= y_size){
  if     (rowinc == -8){rowinc=8; rowcount=4;}
  else if(rowinc ==  8){rowinc=4; rowcount=2;}
  else if(rowinc ==  4){rowinc=2; rowcount=1;}
 }
 return 0;
}

static void LoadGif(char *temp, char *AVIfile, HWND hwndNew){
 long i,imagesize;
 LPSTR lpBitmapHeader;
 LPSTR lpBitmapBits;
 LPBITMAPINFOHEADER lpbi;
 RGBQUAD *pRgb;
 HPALETTE hPalette;
 rowcount=0;
 framecount=0;
 rowinc=1;
 current_window=hwndNew;
 if(read_gif_image(temp,1) < 0)return;
 if(gif_iLace)rowinc = -8;
 x4_size = ALIGNULONG(x_size);
 y4_size = y_size;
 imagesize = (DWORD)x4_size*(DWORD)y_size;
 lpBitmapHeader = (LPSTR)EVI_Malloc((long)sizeof(BITMAPINFOHEADER)
                       +256L*sizeof(RGBQUAD)+imagesize);
 if(lpBitmapHeader == NULL)return;
 SetWindowLong(hwndNew,GWL_BITMAP_HEADER,(LONG)lpBitmapHeader);
 lpbi=(LPBITMAPINFOHEADER)lpBitmapHeader;
 lpbi->biSize=sizeof(BITMAPINFOHEADER);
 lpbi->biWidth=(DWORD)x_size;
 lpbi->biHeight=(DWORD)y_size;
 lpbi->biPlanes=1;
 lpbi->biBitCount=8;
 lpbi->biCompression=BI_RGB;
 lpbi->biSizeImage = (DWORD)imagesize;
 lpbi->biXPelsPerMeter=0;
 lpbi->biYPelsPerMeter=0;
 lpbi->biClrUsed=256;
 lpbi->biClrImportant=256;
 pRgb=(RGBQUAD *)((LPSTR)lpbi + lpbi->biSize);
 for(i=0;i<256;i++){
   pRgb[i].rgbRed = p_red[i] << 2;
   pRgb[i].rgbGreen = p_green[i] << 2;
   pRgb[i].rgbBlue = p_blue[i] << 2;
 }
 hPalette=CreateImagePalette(lpbi);
 SetWindowLong(hwndNew,GWL_PALETTE,(LONG)hPalette);
 lpBitmapBits = ((LPSTR)lpBitmapHeader)
              + (long)sizeof(BITMAPINFOHEADER)+256*sizeof(RGBQUAD);
 SetWindowLong(hwndNew,GWL_BITMAP_BITS,(LONG)lpBitmapBits);
 memset(lpBitmapBits,0,imagesize);
 image_pixels=lpBitmapBits;
 rowcount=0;
 if(AVIfile != NULL)
   openAVIfile(AVIfile,(LPBITMAPINFOHEADER)lpBitmapHeader,0);
 if(read_gif_image(temp,0) < 0)return;
 return;
}

static BOOL CALLBACK FpsDlgProc(HWND hwnd,UINT msg,
                                WPARAM wparam,LPARAM lparam){
 BOOL err;
 int i;
 switch(msg){
   case WM_INITDIALOG:
     SetDlgItemInt(hwnd,DLG_FPS_RATE,frame_rate,FALSE);
     return TRUE;
   case WM_COMMAND:
     switch(LOWORD(wparam)){
       case IDCANCEL:
         EndDialog(hwnd,0);
         return(TRUE);
       case IDOK:
         frame_rate=GetDlgItemInt(hwnd,DLG_FPS_RATE,&err,FALSE);
         EndDialog(hwnd,1);
         return(TRUE);
       default:
         break;
     }
     break;
   default: break;
 }
 return(FALSE);
}
