/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file TIFF.C */

#include "tiffio.h"

void ErrorsH(const char *module, const char *fmt, va_list ap){
 return;
}

void WarningsH(const char *module,  const char *fmt, va_list ap){
 return;
}

extern int x_size,y_size;

extern void tif_display_line(unsigned char *, long );

long ReadTIF(char *filename, short info_only){
 long i;
 long rstate=1;
 TIFF* tif;
 TIFFSetWarningHandler(ErrorsH);
 TIFFSetErrorHandler(WarningsH);
 tif = TIFFOpen(filename, "rb");
 if (tif) {
   uint32 w,h;
   size_t npixels;
   uint32* raster;
   TIFFSetWarningHandler(ErrorsH);
   TIFFSetErrorHandler(WarningsH);
   TIFFGetField(tif,TIFFTAG_IMAGEWIDTH,&w);
   TIFFGetField(tif,TIFFTAG_IMAGELENGTH,&h);
   npixels = w * h;
   if(info_only){
     x_size=w;
     y_size=h;
     TIFFClose(tif);
     return 1;
   }
   raster = (uint32*) _TIFFmalloc(npixels * sizeof (uint32));
   if (raster != NULL) {
     if(TIFFReadRGBAImage(tif,w,h,raster,0)) {
       for(i=0;i<h;i++){
         tif_display_line((unsigned char *)(raster+i*w),h-i-1);
       }
     }
     _TIFFfree(raster);
   }
   else rstate=0;
   TIFFClose(tif);
 }
 return rstate;
}

