/* --
OpenFX version 1.0 - Modelling, Animation and Rendering Package
Copyright (C) 2000 OpenFX Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You may contact the OpenFX development team via elecronic mail
at core@openfx.org, or visit our website at http://openfx.org for
further information and support details.
-- */

/* file UTILS.C  */

#include <windows.h>

typedef LPBITMAPINFOHEADER PDIB;

#define DibPtr(lpbi)            ((lpbi)->biCompression == BI_BITFIELDS \
                                       ? (LPVOID)(DibColors(lpbi) + 3) \
                      : (LPVOID)(DibColors(lpbi) + (UINT)(DibNumColors(lpbi))))
//                      : (LPVOID)(DibColors(lpbi) + (UINT)(lpbi)->biClrUsed))
#define WIDTHBYTES(i)           ((unsigned)((i+31)&(~31))/8)
#define DibWidth(lpbi)          (UINT)(((LPBITMAPINFOHEADER)(lpbi))->biWidth)
#define DibHeight(lpbi)         (UINT)(((LPBITMAPINFOHEADER)(lpbi))->biHeight)
#define DibBitCount(lpbi)       (UINT)(((LPBITMAPINFOHEADER)(lpbi))->biBitCount)
#define DibCompression(lpbi)    (DWORD)(((LPBITMAPINFOHEADER)(lpbi))->biCompression)
#define DibWidthBytesN(lpbi, n) (UINT)WIDTHBYTES((UINT)(lpbi)->biWidth * (UINT)(n))
#define DibWidthBytes(lpbi)     DibWidthBytesN(lpbi, (lpbi)->biBitCount)
#define DibColors(lpbi)         ((RGBQUAD FAR *)((LPBYTE)(lpbi) + (int)(lpbi)->biSize))
#define DibNumColors(lpbi) \
     ((lpbi)->biClrUsed == 0 && (lpbi)->biBitCount <= 8 \
         ? (int)(1 << (int)(lpbi)->biBitCount)          \
         : (int)(lpbi)->biClrUsed)
#define DibXYN(lpbi,pb,x,y,n)  \
         (LPVOID)(                                  \
         (BYTE *)(pb) +                             \
         (UINT)((UINT)(x) * (UINT)(n) / 8u) +       \
         ((DWORD)DibWidthBytesN(lpbi,n) * (DWORD)(UINT)(y)))
#define DibXY(lpbi,x,y) \
        DibXYN(lpbi,DibPtr(lpbi),x,y,(lpbi)->biBitCount)

long const PALETTERGBFlag = 0x02000000;
long const PALETTEINDEXFlag = 0x01000000;

char unsigned const aDividedBy51Rounded[256] =
{
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
};

char unsigned const aDividedBy51[256] =
{
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 
};

char unsigned const aModulo51[256] =
{
 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37,
 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 0, 1, 2, 3, 4, 5, 6,
 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25,
 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43,
 44, 45, 46, 47, 48, 49, 50, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12,
 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30,
 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,
 49, 50, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17,
 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35,
 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 0, 1, 2, 3,
 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22,
 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 0, 
};

char unsigned const aTimes6[6] =
{
 0, 6, 12, 18, 24, 30
};

char unsigned const aTimes36[6] =
{
 0, 36, 72, 108, 144, 180
};

char unsigned const aHalftone16x16[256] =
{
 0, 44, 9, 41, 3, 46, 12, 43, 1, 44, 10, 41, 3, 46, 12, 43,
 34, 16, 25, 19, 37, 18, 28, 21, 35, 16, 26, 19, 37, 18, 28, 21,
 38, 6, 47, 3, 40, 9, 50, 6, 38, 7, 47, 4, 40, 9, 49, 6,
 22, 28, 13, 31, 25, 31, 15, 34, 22, 29, 13, 32, 24, 31, 15, 34,
 2, 46, 12, 43, 1, 45, 10, 42, 2, 45, 11, 42, 1, 45, 11, 42,
 37, 18, 27, 21, 35, 17, 26, 20, 36, 17, 27, 20, 36, 17, 26, 20,
 40, 8, 49, 5, 38, 7, 48, 4, 39, 8, 48, 5, 39, 7, 48, 4,
 24, 30, 15, 33, 23, 29, 13, 32, 23, 30, 14, 33, 23, 29, 14, 32,
 2, 46, 12, 43, 0, 44, 10, 41, 3, 47, 12, 44, 0, 44, 10, 41,
 37, 18, 27, 21, 35, 16, 25, 19, 37, 19, 28, 22, 35, 16, 25, 19,
 40, 9, 49, 5, 38, 7, 47, 4, 40, 9, 50, 6, 38, 6, 47, 3,
 24, 30, 15, 34, 22, 29, 13, 32, 25, 31, 15, 34, 22, 28, 13, 31,
 1, 45, 11, 42, 2, 46, 11, 42, 1, 45, 10, 41, 2, 46, 11, 43,
 36, 17, 26, 20, 36, 17, 27, 21, 35, 16, 26, 20, 36, 18, 27, 21,
 39, 8, 48, 4, 39, 8, 49, 5, 38, 7, 48, 4, 39, 8, 49, 5,
 23, 29, 14, 33, 24, 30, 14, 33, 23, 29, 13, 32, 24, 30, 14, 33,
};

char unsigned const aHalftone8x8[64] =
{
  0, 38,  9, 47,  2, 40, 11, 50,
 25, 12, 35, 22, 27, 15, 37, 24,
  6, 44,  3, 41,  8, 47,  5, 43,
 31, 19, 28, 15, 34, 21, 31, 18,
  1, 39, 11, 49,  0, 39, 10, 48,
 27, 14, 36, 23, 26, 13, 35, 23,
  7, 46,  4, 43,  7, 45,  3, 42,
 33, 20, 30, 17, 32, 19, 29, 16,
};

char unsigned const aHalftone4x4_1[16] =
{
 0, 25, 6, 31,
 38, 12, 44, 19,
 9, 35, 3, 28,
 47, 22, 41, 15
};

char unsigned const aHalftone4x4_2[16] =
{
 41, 3, 9, 28,
 35, 15, 22, 47,
 6, 25, 38, 0,
 19, 44, 31, 12
};

char unsigned const aWinGHalftoneTranslation[216] =
{
 0,
 29,
 30,
 31,
 32,
 249,
 33,
 34,
 35,
 36,
 37,
 38,
 39,
 40,
 41,
 42,
 43,
 44,
 45,
 46,
 47,
 48,
 49,
 50,
 51,
 52,
 53,
 54,
 55,
 56,
 250,
 250,
 57,
 58,
 59,
 251,
 60,
 61,
 62,
 63,
 64,
 65,
 66,
 67,
 68,
 69,
 70,
 71,
 72,
 73,
 74,
 75,
 76,
 77,
 78,
 79,
 80,
 81,
 82,
 83,
 84,
 85,
 86,
 87,
 88,
 89,
 250,
 90,
 91,
 92,
 93,
 94,
 95,
 96,
 97,
 98,
 99,
 100,
 101,
 102,
 103,
 104,
 105,
 106,
 107,
 108,
 109,
 110,
 111,
 227,
 112,
 113,
 114,
 115,
 116,
 117,
 118,
 119,
 151,
 120,
 121,
 122,
 123,
 124,
 228,
 125,
 126,
 229,
 133,
 162,
 135,
 131,
 132,
 137,
 166,
 134,
 140,
 130,
 136,
 143,
 138,
 139,
 174,
 141,
 142,
 177,
 129,
 144,
 145,
 146,
 147,
 148,
 149,
 150,
 157,
 152,
 153,
 154,
 155,
 156,
 192,
 158,
 159,
 160,
 161,
 196,
 163,
 164,
 165,
 127,
 199,
 167,
 168,
 169,
 170,
 171,
 172,
 173,
 207,
 175,
 176,
 210,
 178,
 179,
 180,
 181,
 182,
 183,
 184,
 185,
 186,
 187,
 188,
 189,
 190,
 191,
 224,
 193,
 194,
 195,
 252,
 252,
 197,
 198,
 128,
 253,
 252,
 200,
 201,
 202,
 203,
 204,
 205,
 206,
 230,
 208,
 209,
 231,
 211,
 212,
 213,
 214,
 215,
 216,
 217,
 218,
 219,
 220,
 221,
 222,
 254,
 223,
 232,
 225,
 226,
 255,
};

static RGBQUAD rgb[256]={
   0,0,0,0,
   191,0,0,0,
   0,191,0,0,
   191,191,0,0,
   0,0,191,0,
   191,0,191,0,
   0,191,191,0,
   192,192,192,0,
   192,220,192,0,
   164,200,240,0,
   4,4,4,0,
   8,8,8,0,
   12,12,12,0,
   17,17,17,0,
   22,22,22,0,
   28,28,28,0,
   34,34,34,0,
   41,41,41,0,
   85,85,85,0,
   77,77,77,0,
   66,66,66,0,
   57,57,57,0,
   129,129,129,0,
   129,0,0,0,
   0,129,0,0,
   129,129,0,0,
   0,0,129,0,
   129,0,129,0,
   0,129,129,0,
   51,0,0,0,
   102,0,0,0,
   153,0,0,0,
   204,0,0,0,
   0,51,0,0,
   51,51,0,0,
   102,51,0,0,
   153,51,0,0,
   204,51,0,0,
   255,51,0,0,
   0,102,0,0,
   51,102,0,0,
   102,102,0,0,
   153,102,0,0,
   204,102,0,0,
   255,102,0,0,
   0,153,0,0,
   51,153,0,0,
   102,153,0,0,
   153,153,0,0,
   204,153,0,0,
   255,153,0,0,
   0,204,0,0,
   51,204,0,0,
   102,204,0,0,
   153,204,0,0,
   204,204,0,0,
   255,204,0,0,
   102,255,0,0,
   153,255,0,0,
   204,255,0,0,
   0,0,51,0,
   51,0,51,0,
   102,0,51,0,
   153,0,51,0,
   204,0,51,0,
   255,0,51,0,
   0,51,51,0,
   51,51,51,0,
   102,51,51,0,
   153,51,51,0,
   204,51,51,0,
   255,51,51,0,
   0,102,51,0,
   51,102,51,0,
   102,102,51,0,
   153,102,51,0,
   204,102,51,0,
   255,102,51,0,
   0,153,51,0,
   51,153,51,0,
   102,153,51,0,
   153,153,51,0,
   204,153,51,0,
   255,153,51,0,
   0,204,51,0,
   51,204,51,0,
   102,204,51,0,
   153,204,51,0,
   204,204,51,0,
   255,204,51,0,
   51,255,51,0,
   102,255,51,0,
   153,255,51,0,
   204,255,51,0,
   255,255,51,0,
   0,0,102,0,
   51,0,102,0,
   102,0,102,0,
   153,0,102,0,
   204,0,102,0,
   255,0,102,0,
   0,51,102,0,
   51,51,102,0,
   102,51,102,0,
   153,51,102,0,
   204,51,102,0,
   255,51,102,0,
   0,102,102,0,
   51,102,102,0,
   102,102,102,0,
   153,102,102,0,
   204,102,102,0,
   0,153,102,0,
   51,153,102,0,
   102,153,102,0,
   153,153,102,0,
   204,153,102,0,
   255,153,102,0,
   0,204,102,0,
   51,204,102,0,
   153,204,102,0,
   204,204,102,0,
   255,204,102,0,
   0,255,102,0,
   51,255,102,0,
   153,255,102,0,
   204,255,102,0,
   255,0,204,0,
   204,0,255,0,
   0,153,153,0,
   153,51,153,0,
   153,0,153,0,
   204,0,153,0,
   0,0,153,0,
   51,51,153,0,
   102,0,153,0,
   204,51,153,0,
   255,0,153,0,
   0,102,153,0,
   51,102,153,0,
   102,51,153,0,
   153,102,153,0,
   204,102,153,0,
   255,51,153,0,
   51,153,153,0,
   102,153,153,0,
   153,153,153,0,
   204,153,153,0,
   255,153,153,0,
   0,204,153,0,
   51,204,153,0,
   102,204,102,0,
   153,204,153,0,
   204,204,153,0,
   255,204,153,0,
   0,255,153,0,
   51,255,153,0,
   102,204,153,0,
   153,255,153,0,
   204,255,153,0,
   255,255,153,0,
   0,0,204,0,
   51,0,153,0,
   102,0,204,0,
   153,0,204,0,
   204,0,204,0,
   0,51,153,0,
   51,51,204,0,
   102,51,204,0,
   153,51,204,0,
   204,51,204,0,
   255,51,204,0,
   0,102,204,0,
   51,102,204,0,
   102,102,153,0,
   153,102,204,0,
   204,102,204,0,
   255,102,153,0,
   0,153,204,0,
   51,153,204,0,
   102,153,204,0,
   153,153,204,0,
   204,153,204,0,
   255,153,204,0,
   0,204,204,0,
   51,204,204,0,
   102,204,204,0,
   153,204,204,0,
   204,204,204,0,
   255,204,204,0,
   0,255,204,0,
   51,255,204,0,
   102,255,153,0,
   153,255,204,0,
   204,255,204,0,
   255,255,204,0,
   51,0,204,0,
   102,0,255,0,
   153,0,255,0,
   0,51,204,0,
   51,51,255,0,
   102,51,255,0,
   153,51,255,0,
   204,51,255,0,
   255,51,255,0,
   0,102,255,0,
   51,102,255,0,
   102,102,204,0,
   153,102,255,0,
   204,102,255,0,
   255,102,204,0,
   0,153,255,0,
   51,153,255,0,
   102,153,255,0,
   153,153,255,0,
   204,153,255,0,
   255,153,255,0,
   0,204,255,0,
   51,204,255,0,
   102,204,255,0,
   153,204,255,0,
   204,204,255,0,
   255,204,255,0,
   51,255,255,0,
   102,255,204,0,
   153,255,255,0,
   204,255,255,0,
   255,102,102,0,
   102,255,102,0,
   255,255,102,0,
   102,102,255,0,
   255,102,255,0,
   102,255,255,0,
   193,193,193,0,
   95,95,95,0,
   119,119,119,0,
   134,134,134,0,
   150,150,150,0,
   203,203,203,0,
   178,178,178,0,
   215,215,215,0,
   221,221,221,0,
   227,227,227,0,
   234,234,234,0,
   241,241,241,0,
   248,248,248,0,
   255,251,240,0,
   160,160,164,0,
   128,128,128,0,
   255,0,0,0,
   0,255,0,0,
   255,255,0,0,
   0,0,255,0,
   255,0,255,0,
   0,255,255,0,
   255,255,255,0
};

static BOOL DibSetUsage(PDIB pdib, HPALETTE hpal,UINT wUsage){
 PALETTEENTRY       ape[256];
 RGBQUAD           *pRgb;
 WORD              *pw;
 int                nColors;
 int                n;
 if (hpal == NULL)hpal = (HPALETTE)GetStockObject(DEFAULT_PALETTE);
 if (!pdib)return FALSE;
 nColors = DibNumColors(pdib);
 if (nColors == 3 && DibCompression(pdib) == BI_BITFIELDS)nColors = 0;
 if (nColors > 0){
   pRgb = DibColors(pdib);
   switch (wUsage){
            case DIB_PAL_COLORS:
                for (pw = (WORD FAR*)pRgb,n=0; n<nColors; n++,pw++)
                    *pw = n;
                break;
            default:
            case DIB_RGB_COLORS:
                nColors = min(nColors,256);
                GetPaletteEntries(hpal,0,nColors,ape);
                for (n=0; n<nColors; n++){
                    pRgb[n].rgbRed      = ape[n].peRed;
                    pRgb[n].rgbGreen    = ape[n].peGreen;
                    pRgb[n].rgbBlue     = ape[n].peBlue;
                    pRgb[n].rgbReserved = 0;
                }
                break;
   }
 }
 return TRUE;
}

static PDIB DibCreate(int bits, int dx, int dy){
 LPBITMAPINFOHEADER lpbi ;
 DWORD       dwSizeImage;
 int         i;
 DWORD FAR  *pdw;
 RGBQUAD    *pRgb;
 dwSizeImage = dy*(DWORD)((dx*bits/8+3)&~3);
 lpbi = (PDIB)LocalAlloc(LMEM_FIXED,sizeof(BITMAPINFOHEADER)+dwSizeImage + 1024);
 if (lpbi == NULL)return NULL;
 lpbi->biSize            = sizeof(BITMAPINFOHEADER) ;
 lpbi->biWidth           = dx;
 lpbi->biHeight          = dy;
 lpbi->biPlanes          = 1;
 lpbi->biBitCount        = bits ;
 lpbi->biCompression     = BI_RGB ;
 lpbi->biSizeImage       = dwSizeImage;
 lpbi->biXPelsPerMeter   = 0 ;
 lpbi->biYPelsPerMeter   = 0 ;
 lpbi->biClrUsed         = 0 ;
 lpbi->biClrImportant    = 0 ;
 if (bits == 4)     lpbi->biClrUsed = 16;
 else if (bits == 8)lpbi->biClrUsed = 256;
 pdw = (DWORD FAR *)((LPBYTE)lpbi+(int)lpbi->biSize);
 for (i=0; i<(int)lpbi->biClrUsed/16; i++) {
        *pdw++ = 0x00000000;    // 0000  black
        *pdw++ = 0x00800000;    // 0001  dark red
        *pdw++ = 0x00008000;    // 0010  dark green
        *pdw++ = 0x00808000;    // 0011  mustard
        *pdw++ = 0x00000080;    // 0100  dark blue
        *pdw++ = 0x00800080;    // 0101  purple
        *pdw++ = 0x00008080;    // 0110  dark turquoise
        *pdw++ = 0x00C0C0C0;    // 1000  gray
        *pdw++ = 0x00808080;    // 0111  dark gray
        *pdw++ = 0x00FF0000;    // 1001  red
        *pdw++ = 0x0000FF00;    // 1010  green
        *pdw++ = 0x00FFFF00;    // 1011  yellow
        *pdw++ = 0x000000FF;    // 1100  blue
        *pdw++ = 0x00FF00FF;    // 1101  pink (magenta)
        *pdw++ = 0x0000FFFF;    // 1110  cyan
        *pdw++ = 0x00FFFFFF;    // 1111  white
 }
 return (PDIB)lpbi;
}

HPALETTE CreateMyHalftonePalette(void){
 int i;
 LOGPALETTE *pPal;
 HPALETTE   hpal = NULL;
 pPal = (LOGPALETTE*)LocalAlloc(LPTR,sizeof(LOGPALETTE) + 256 * sizeof(PALETTEENTRY));
 if(pPal == NULL)return NULL;
 pPal->palNumEntries = 256;
 pPal->palVersion    = 0x300;
 for (i = 0; i < 256; i++){
   pPal->palPalEntry[i].peRed   = rgb[i].rgbBlue;
   pPal->palPalEntry[i].peGreen = rgb[i].rgbGreen;
   pPal->palPalEntry[i].peBlue  = rgb[i].rgbRed;
   pPal->palPalEntry[i].peFlags = (BYTE)0;
 }
 hpal = CreatePalette(pPal);
 LocalFree((HANDLE)pPal);
 return hpal;
}

PDIB DibHalftoneDIB(PDIB pSource, HPALETTE hpalApp){
 int i;
 RGBQUAD *pRgb;
 char unsigned RedTemp,GreenTemp,BlueTemp,PaletteIndex;
 int Red,Green,Blue;
 PDIB pDestination = DibCreate(8,DibWidth(pSource),DibHeight(pSource));
 if(DibNumColors(pSource) > 0)pRgb = DibColors(pSource);
//{char temp[255];
//sprintf(temp,"%ld %ld nc=%ld bc=%ld wb=%ld",DibWidth(pSource),DibHeight(pSource),
//DibNumColors(pSource),DibBitCount(pSource),DibWidthBytes(pSource));
//MessageBox(NULL,temp,"Debug",MB_OK);}
 if(pDestination != NULL && hpalApp != NULL){
   long PixelsPerScanline = DibWidth(pSource);
   int Scanline;
   DibSetUsage(pDestination, hpalApp, DIB_RGB_COLORS);
   for(Scanline = 0;Scanline < (int)DibHeight(pSource);Scanline++){
     char unsigned *pSourceScanline =
           (char unsigned  *)DibXY(pSource,0,Scanline);
     char unsigned  *pDestinationScanline =
           (char unsigned  *)DibXY(pDestination,0,Scanline);
     int Pixel;
     for(Pixel = 0;Pixel < (int)DibWidth(pSource);Pixel++){
       if(DibBitCount(pSource) == 24){
         Red = pSourceScanline[Pixel*3 + 2];
         Green = pSourceScanline[Pixel*3 + 1];
         Blue = pSourceScanline[Pixel*3];
       }
       else{
         i = pSourceScanline[Pixel];
         Red   = pRgb[i].rgbRed;
         Green = pRgb[i].rgbGreen;
         Blue  = pRgb[i].rgbBlue;
       }
       RedTemp = aDividedBy51[(char unsigned)Red]
               + (aModulo51[Red] > aHalftone8x8[(Pixel%8)*8
               + Scanline%8]);
       GreenTemp = aDividedBy51[(char unsigned)Green]
               + (aModulo51[Green] > aHalftone8x8[
               (Pixel%8)*8 + Scanline%8]);
       BlueTemp = aDividedBy51[(char unsigned)Blue]
               + (aModulo51[Blue] > aHalftone8x8[
               (Pixel%8)*8 +Scanline%8]);
       PaletteIndex =
               RedTemp + aTimes6[GreenTemp] + aTimes36[BlueTemp];
       pDestinationScanline[Pixel] = aWinGHalftoneTranslation[PaletteIndex];
     }
   }
 }
 return pDestination;
}
