/* file 3DSLOAD.C  || */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <windows.h>
#include <gl\gl.h>
#include <gl\glu.h>

#include "sim.h"
#include "resource.h"

extern VERTEX *MainVp;
extern FACE   *MainFp;
extern MAP    *MapsFp;
extern WFRAME w_frame;
extern long   Nvert,Nface,NvertGlue,Nmap;


#define PLANE            0              /* brush map types */
#define CYLINDER         1
#define PLANE_MOZIAC     2
#define CYLINDER_MOZIAC  3
#define MAP_BY_VERTEX    4
#define STATICBRUSH      0
#define ANIMBRUSH        1
#define BUMPBRUSH        2
#define REFLBRUSH        3
#define PSETBRUSH        4

#define BRUSHBIT   0x40
#define SMOOTHBIT  0x80
#define TILEBIT    0x20;

typedef struct tagMAP3DS {
  char    N[32];
  short   shiny,transp,evi;
  unsigned char d_colour[3];
} MAP3DS;

static float scale_3ds,gmax[3],gmin[3];
static long posn,nJmaps=0,LastVert=0,LastFace=0;
static FILE *fi;
static MAP3DS *jMap=NULL;

static void mes3ds(char *text){
//  MessageBox(NULL,text,"debug",MB_OK);
}

static long GetLong(FILE *fp){
 long val;
 fread(&val,sizeof(long),1,fp);
 return val;
}

static short GetShort(FILE *fp){
 short val;
 fread(&val,sizeof(short),1,fp);
 return val;
}

static char GetByte(FILE *fp){
 char val;
 val  = ((char)getc(fp));
 return val;
}

static void get_material(long count, FILE *fi){
  MAP *temp_map;
  char c,mapname[128],imagename[32],str[128];
  unsigned char r,g,b;
  unsigned short id,sv,id1,first_time;
  long cc,p,i,l,j;
  while(1){
    p=ftell(fi);  id=GetShort(fi); cc=GetLong(fi);
    if(id < 0xa000 || id >= 0xafff)break;
    if(id == 0xa000){
      j=0; while((c=GetByte(fi)) != 0)mapname[j++]=c;
      mapname[j]=0;
      sprintf(str,"Material [%s]\n",mapname);
      mes3ds(str);
      first_time=1; nJmaps++;
      if(nJmaps == 1){
        if((jMap=(MAP3DS *)EVI_Malloc(nJmaps*sizeof(MAP3DS))) == NULL){
          mes3ds("Out of memory\n"); return;
        }
      }
      else {
        if((jMap=(MAP3DS *)EVI_Realloc(jMap,nJmaps*sizeof(MAP3DS))) == NULL){
          mes3ds("Out of memory\n"); return;
        }
      }
      jMap[nJmaps-1].evi = -1;
      strcpy(jMap[nJmaps-1].N,mapname);
    }
    else if(id == 0xa010){
      id=GetShort(fi); l=GetLong(fi);
      if(id != 0x11){mes3ds("Error in material\n"); break;}
      r=GetByte(fi); g=GetByte(fi); b=GetByte(fi);
    }
    else if(id == 0xa020){
      id=GetShort(fi); l=GetLong(fi);
      if(id != 0x11){mes3ds("Error in material\n"); break;}
      r=GetByte(fi); g=GetByte(fi); b=GetByte(fi);
      jMap[nJmaps-1].d_colour[0]=r;
      jMap[nJmaps-1].d_colour[1]=g;
      jMap[nJmaps-1].d_colour[2]=b;
    }
    else if(id == 0xa030){
      id=GetShort(fi); l=GetLong(fi);
      if(id != 0x11){mes3ds("Error in material\n"); break;}
      r=GetByte(fi); g=GetByte(fi); b=GetByte(fi);
    }
    else if(id == 0xa200 || id == 0xa210 || id == 0xa220 || id == 0xa230){
      if(first_time){
        if(MapsFp == NULL)
          temp_map = (MAP *)EVI_Malloc(sizeof(MAP));
        else
          temp_map = (MAP *)EVI_Realloc(MapsFp,(Nmap+1)*sizeof(MAP));
        if(temp_map == NULL){
           MessageBox(NULL,"Out of Memory",NULL,MB_OK);
           return;
        }
        MapsFp=temp_map;
        memset((MapsFp+Nmap),0,sizeof(MAP));
        Nmap++;
        jMap[nJmaps-1].evi=Nmap-1;
        first_time=0;
      }
      if(id == 0xa200){mes3ds("Texture map "); id1=1;}
      if(id == 0xa210){mes3ds("Opacity map "); id1=2;}
      if(id == 0xa220){mes3ds("Reflect map "); id1=3;}
      if(id == 0xa230){mes3ds("Bump    map "); id1=4;}
      id=GetShort(fi); l=GetLong(fi);
      if(id != 0x30){mes3ds("Error in material\n"); break;}
      sv=GetShort(fi);
      sprintf(str,"Map value %d ",sv);
      mes3ds(str);
      id=GetShort(fi); l=GetLong(fi);
      if(id != 0xa300){mes3ds("Error in material\n"); break;}
      j=0; while((c=GetByte(fi)) != 0)imagename[j++]=c;
      imagename[j]=0;
      sprintf(str,"Map [%s]\n",imagename);
      mes3ds(str);
      MapsFp[Nmap-1].rp = -1;
      MapsFp[Nmap-1].bp = -1;
      if(id1 == 1){
        MapsFp[Nmap-1].p[0]=0.0; MapsFp[Nmap-1].p[1]=0.0; MapsFp[Nmap-1].p[2]=0.0;
        MapsFp[Nmap-1].x[0]=1.0; MapsFp[Nmap-1].x[1]=0.0; MapsFp[Nmap-1].x[2]=0.0;
        MapsFp[Nmap-1].y[0]=0.0; MapsFp[Nmap-1].y[1]=1.0; MapsFp[Nmap-1].y[2]=0.0;
        MapsFp[Nmap-1].pp=100;
        MapsFp[Nmap-1].method=STATICBRUSH;
        MapsFp[Nmap-1].map=MAP_BY_VERTEX;
        strcpy(MapsFp[Nmap-1].filename,imagename);
//        iMap[nImaps-1].sp=sv;
//        iMap[nImaps-1].S=(char *)EVI_Malloc(256);
//        sprintf(iMap[nImaps-1].S,"%c:\\3ds2\\maps\\",drive+'@');
//        strcat(iMap[nImaps-1].S,imagename);
      }
      if(id1 == 3){
//        iMap[nImaps-1].r=1;
//        iMap[nImaps-1].rp=sv;
//        iMap[nImaps-1].R=(char *)EVI_Malloc(256);
//        sprintf(iMap[nImaps-1].R,"%c:\\3ds2\\maps\\",drive+'@');
//        strcat(iMap[nImaps-1].R,imagename);
      }
      if(id1 == 4){
//        iMap[nImaps-1].b=1;
//        iMap[nImaps-1].bp=sv;
//        iMap[nImaps-1].B=(char *)EVI_Malloc(256);
//        sprintf(iMap[nImaps-1].B,"%c:\\3ds2\\maps\\",drive+'@');
//        strcat(iMap[nImaps-1].B,imagename);
      }
    }
    fseek(fi,p,SEEK_SET); for(i=0;i<cc;i++)GetByte(fi);
  }
}

static void get_vertices(FILE *fi){
 VERTEX *temp;
 float f1,f2,f3,fmin[3],fmax[3];
 unsigned short n,i;
 long l;
 LastVert=Nvert;
 n=GetShort(fi);
 for(i=0;i<3;i++){
   fmin[i] =   1.e30;
   fmax[i] = - 1.e30;
 }
 if(MainVp == NULL){
  if((temp=(VERTEX *)EVI_Malloc(sizeof(VERTEX)*(long)n)) == NULL){
    MessageBox(NULL,"Out of Memory",NULL,MB_OK);
    return;
  }
 }
 else{
  if((temp=(VERTEX *)EVI_Realloc(MainVp,sizeof(VERTEX)*((long)n+Nvert))) == NULL){
    MessageBox(NULL,"Out of Memory",NULL,MB_OK);
    return;
  }
 }
 MainVp=temp;
 Nvert += n;
 for(i=0;i<n;i++){
   (MainVp+LastVert+i)->gp=0;
   (MainVp+LastVert+i)->nf=0;
   (MainVp+LastVert+i)->flist=NULL;
   fread(&f1,sizeof(float),1,fi);
   fread(&f2,sizeof(float),1,fi);
   fread(&f3,sizeof(float),1,fi);
   (MainVp+LastVert+i)->p[0]=(long)(f1*1024.0*512.0);
   (MainVp+LastVert+i)->p[1]=(long)(f2*1024.0*512.0);
   (MainVp+LastVert+i)->p[2]=(long)(f3*1024.0*512.0);
 }
 n=GetShort(fi); l=GetShort(fi);
}

static void get_mapping_coords(FILE *fi){
 float f1,f2;
 unsigned short n,i;
 long l;
 n=GetShort(fi);
 for(i=0;i<n;i++){
   fread(&f1,sizeof(float),1,fi);
   fread(&f2,sizeof(float),1,fi);
   NvertGlue++;
   (MainVp+LastVert+i)->x=f1;
   (MainVp+LastVert+i)->y=f2;
 }
 n=GetShort(fi); l=GetShort(fi);
}

static long GetMap(char *mapname){
  long i;
  if(nJmaps > 0){
    for(i=0;i<nJmaps;i++){
      if(strcmp(jMap[i].N,mapname) == 0)return i;
    }
  }
  return -1; /* no map found */
}

static void get_faces(FILE *fi){
 FACE *temp,*Fp;
 char cc,matname[128],str[128];
 unsigned short i,n,nf;
 unsigned short a,b,c,f;
 long j,l,mn;
 nf=n=GetShort(fi);
 if(MainFp == NULL){
  if((temp=(FACE *)EVI_Malloc(sizeof(FACE)*(long)n)) == NULL){
    MessageBox(NULL,"Out of Memory",NULL,MB_OK);
    return;
  }
 }
 else{
  if((temp=(FACE *)EVI_Realloc(MainFp,sizeof(FACE)*((long)n+Nface))) == NULL){
    MessageBox(NULL,"Out of Memory",NULL,MB_OK);
    return;
  }
 }
 MainFp=temp;
 LastFace=Nface;
 Nface += n;
 for(i=0;i<n;i++){
   a=GetShort(fi);  b=GetShort(fi);  c=GetShort(fi);  f=GetShort(fi);
   Fp=(MainFp+LastFace+i);
   Fp->A[0] = Fp->A[1] = Fp->A[2] = -1; Fp->next = -1;
   Fp->vid = -1; Fp->start=0;
   Fp->V[0]=(long)(a+LastVert);
   Fp->V[1]=(long)(b+LastVert);
   Fp->V[2]=(long)(c+LastVert);
   Fp->color[0]=Fp->color[1]=Fp->color[2]=255;
   Fp->matcol[0]=Fp->matcol[1]=Fp->matcol[2]=255;
   Fp->texture=0; Fp->brush=0; Fp->axis=0;
 }
 loop:
 n=GetShort(fi); l=GetLong(fi);
 if(n == 0x4130){
   j=0; while((cc=GetByte(fi)) != 0)matname[j++]=cc;
   matname[j]=0;
   sprintf(str,"Material [%s] on surfaces\n",matname);
   mes3ds(str);
   mn=GetMap(matname);
   n=GetShort(fi);
   for(i=0;i<n;i++){
     f=GetShort(fi);
     if(f >= nf)MessageBox(NULL,"Bad f ",NULL,MB_OK);
     if(mn >= 0){
       for(j=0;j<3;j++){
         (MainFp+LastFace+f)->color[j]=jMap[mn].d_colour[j];
       }
       (MainFp+LastFace+f)->texture |= 0x20;  /* brilliance bit */
       if(jMap[mn].evi >= 0){                   /* brush is on */
         (MainFp+LastFace+f)->texture |= 0x40;            /* image map on       */
         (MainFp+LastFace+f)->brush = jMap[mn].evi;       /* image map          */
         (MainFp+LastFace+f)->brush |= 0x80;              /* tiled by default   */
       }
     }
   }
   goto loop;
 }
 else if(n == 0x4150){ /* smothing group */
   if((l-6)/4 != nf){
     mes3ds("Error in face data\n"); return;
   }
   for(i=0;i<nf;i++){
     l=GetLong(fi);
     (MainFp+LastFace+i)->texture |= 0x80;  /* smoothing */
   }
   goto loop;
 }
}

static void get_object(long count, FILE *fi){
  char c,objectname[256],str[256];
  unsigned short id;
  long cc,j,i,l;
  j=0; while((c=GetByte(fi)) != 0){
    objectname[j++]=c;
  }
  objectname[j]=0;
  sprintf(str,"Object [%s]\n",objectname);
  mes3ds(str);
  id=GetShort(fi); l=GetLong(fi);
  if(id == 0x4100){  /* mesh object */
    while(1){
      j=ftell(fi);  id=GetShort(fi); cc=GetLong(fi);
      if(id < 0x4001 || id > 0x5000)break;
      if(id == 0x4110)get_vertices(fi);
      if(id == 0x4140)get_mapping_coords(fi);
      if(id == 0x4120)get_faces(fi);
      fseek(fi,j,SEEK_SET); for(i=0;i<cc;i++)GetByte(fi);
   }
 }
 else if(id == 0x4600){
   mes3ds("Light\n");
 }
 else if(id == 0x4700){
   mes3ds("Camera\n");
 }
}

int Load3dsObject(char *FileName){
 int fail=1;
 unsigned short i,id;
 long count,fze;
 posn=0; LastVert=0; LastFace=0; nJmaps=0;
 if((fi=fopen(FileName,"rb")) == NULL)return 0;
 id=GetShort(fi); posn += 2;
 if(id != 0x4d4d){
  mes3ds("Not 3DS file\n"); goto EXIT;
 }
 fze=count=GetLong(fi); posn += 4;
 while(1){
   id=GetShort(fi); if(posn >= fze)goto EXIT;
   count=GetLong(fi);
   if(id == 0x3d3d){
     posn += 6;
     while(1){
       id=GetShort(fi); if(posn >= fze)goto EXIT;
       count=GetLong(fi);
       if(id == 0x4000){
         get_object(count,fi);
         fseek(fi,posn,SEEK_SET);
       }
       if(id == 0xafff){
         get_material(count,fi);
         fseek(fi,posn,SEEK_SET);
       }
       posn += count;
       fseek(fi,posn,SEEK_SET);
     }
   }
   else{
     posn += count;
     fseek(fi,posn,SEEK_SET);
   }
 }
 EXIT:
 if(jMap != NULL)EVI_Free(jMap); jMap=NULL; nJmaps=0;
 fclose(fi);
 return fail;
}
