//#define INITGUID

#include <windows.h>

#include <commctrl.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <math.h>

//#define _OLEAUTO_H_
#include <shlguid.h>
#include <shlobj.h>
#include <objbase.h>

#include "sim.h"
#include "resource.h"

#define MAX_FILE       255
#define MAX_DIR        255
#define FI_3DS           0
#define FI_SFX           1

extern int LoadSfxObject(char *);
extern void FreeObject();
extern void ListAdjFaces(void);
extern void FixUpOrientation(void);
extern void Make3dListS(void);
extern void DrawWireFrame(void);

VERTEX  *MainVp=NULL;
FACE    *MainFp=NULL;
MAP     *MapsFp=NULL;
WFRAME  w_frame={0,0,NULL,NULL};
long    Nvert=0,Nface=0,NvertGlue=0,Nmap=0;
int     listID=0;
BOOL    Mapped=FALSE,Cmaterial=TRUE,smooth_shading=TRUE,
        ffastmapping=TRUE,LightBackground=TRUE,
        ffog=FALSE;
GLfloat ObjScale=1.0;
GLubyte checkImage[checkImageWidth][checkImageHeight][3];

void makeCheckeredImageMap(void);

static void Register(HINSTANCE);
static BOOL RegisterOpenGL(HINSTANCE);
static void UnregisterOpenGL(HINSTANCE);
static HWND AttachViewOpenGL(void);
static GLvoid initialize(HWND);
static GLvoid drawScene(HWND,BOOL);
static GLvoid resize(HWND);
static BOOL bSetupPixelFormat(HDC);
static LONG WINAPI OpenGLWndProc(HWND, UINT, WPARAM, LPARAM);
static LONG WINAPI OpenGLMainWndProc(HWND, UINT, WPARAM, LPARAM);
static void GluCommands(WORD, HWND);
static PSTR FileInPath(PSTR pstrPath);

static HWND      glWnd=NULL,hTBWnd=NULL;
static HINSTANCE glInstance;
static CHAR      szAppName[]="OFX:SfxView";
static CHAR      szCldName[]="OFX:SfxView:Child";
static HGLRC     hRC=NULL;
static HCURSOR   hcurSave=NULL;
static HPALETTE  ghpalOld, ghPalette = NULL;
static RECT      oldrect;
static UINT      AnimationTimer=0;
static double    draw_scale=1.0;
static BOOL      bZoomMode=FALSE;

static DWORD fdwStyle = WS_OVERLAPPED | WS_CAPTION | WS_THICKFRAME |
                        WS_SYSMENU | WS_MAXIMIZEBOX |
                        WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
static DWORD gdwStyle = WS_CHILD | WS_VISIBLE | !WS_BORDER |
                        WS_VSCROLL | WS_HSCROLL |
                        WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

static BOOL wireframe=FALSE,scrolling=FALSE,bCaptured=FALSE;
static GLfloat up_angle=0.0,round_angle=0.0;
static GLfloat gbRed=0.40,gbGreen=0.40,gbBlue=0.40;
static GLfloat DgbRed=0.15,DgbGreen=0.15,DgbBlue=0.15;
static GLfloat LgbRed=0.40,LgbGreen=0.40,LgbBlue=0.40;
static char    CurrentDirFile[256],CurrentDirectory[256],CurrentFile[256];
static GLfloat near_plane = 1.5,far_plane = 8.5;
static int ToolbarHeight;

#define NTOOLBARBUTTONS 16
#define NOTOOLBARIMAGES 11

static TBBUTTON tbb[NTOOLBARBUTTONS] = {
          {0,0,              TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {0,IDM_OPEN,       TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {0,0,              TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {1,IDM_ZOOM_IN,    TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {2,IDM_RESET_VIEW, TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {3,IDM_ZOOM_OUT,   TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 },
          {0,0,              TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {7,IDM_PLAY,       TBSTATE_ENABLED,TBSTYLE_BUTTON|TBSTYLE_CHECK,0,0 },
          {0,0,              TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {10,IDM_FOG,       TBSTATE_ENABLED,TBSTYLE_BUTTON|TBSTYLE_CHECK,0,0 },
          {9,IDM_BACKGROUND, TBSTATE_ENABLED,TBSTYLE_BUTTON|TBSTYLE_CHECK,0,0 },
          {4,IDM_WIREFRAME,  TBSTATE_ENABLED,TBSTYLE_BUTTON|TBSTYLE_CHECK,0,0 },
          {6,IDM_MAPS,       TBSTATE_ENABLED,TBSTYLE_BUTTON|TBSTYLE_CHECK,0,0 },
          {8,IDM_ACCELERATE, TBSTATE_ENABLED,TBSTYLE_BUTTON|TBSTYLE_CHECK,0,0 },
          {0,0,              TBSTATE_ENABLED,TBSTYLE_SEP,   0,0 },
          {5,IDM_ABOUT,      TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0 }
                                        };

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine, int nCmdShow){
  InitCommonControls();
  Register(hInstance);
  if (RegisterOpenGL(hInstance)) {
    AttachViewOpenGL();
    if (glWnd != NULL)DestroyWindow(glWnd);
    UnregisterOpenGL(hInstance);
  }
  else MessageBox(NULL,"Register Failed",NULL,MB_OK);
  return 0;
}

static void UnregisterOpenGL(HINSTANCE hInstance){
  UnregisterClass(szAppName,hInstance);
}

static BOOL RegisterOpenGL(HINSTANCE hInstance){
  WNDCLASS   wc;
  wc.style         = 0;
  wc.lpfnWndProc   = (WNDPROC)OpenGLMainWndProc;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;
  wc.hInstance     = hInstance;
  wc.hIcon         = LoadIcon(hInstance,"SFXVIEW_ICON");
  wc.hCursor       = LoadCursor (NULL,IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
  wc.lpszMenuName  = NULL; //"SFXVIEW_MENU";
  wc.lpszClassName = szAppName;
  if (!RegisterClass (&wc) )return FALSE;
  wc.style         = 0;
  wc.lpfnWndProc   = (WNDPROC)OpenGLWndProc;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;
  wc.hInstance     = hInstance;
  wc.hIcon         = NULL;
  wc.hCursor       = LoadCursor(hInstance,"HAND_CURSOR"); //(NULL,IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
  wc.lpszMenuName  = NULL;
  wc.lpszClassName = szCldName;
  glInstance=hInstance;
  if (!RegisterClass (&wc) )return FALSE;
  return TRUE;
}

static HWND AttachViewOpenGL(void){
  RECT rc;
  LPRECT pr;
  HWND hWnd;
  MSG msg;
  pr=&rc;
  rc.left=100; rc.top=50; rc.right=400; rc.bottom=400;
  hWnd = CreateWindow(
      szAppName,
      "3D Model Viewer",
      fdwStyle,
      pr->left,
      pr->top,
      pr->right,
      pr->bottom,
      NULL,
      NULL,
      glInstance,
      NULL);
  if (!hWnd)return NULL;
  ShowWindow(hWnd, SW_SHOW);
  UpdateWindow(hWnd);
  if(GetCommandLine() != NULL){
    long l,EVI_argc=2;
    char *cp,*cp1,cmdl[256];
    strcpy(cmdl,GetCommandLine());
    AnsiLower(cmdl);
    if((cp=strstr(cmdl,".exe")) != NULL){
      if((cp=strchr(cp,' ')) != NULL){
        cp++;
        if((cp1=strchr(cp,'"')) != NULL)cp=cp1+1;
        if((cp1=strchr(cp,'"')) != NULL)*cp1=0;
        l=strlen(cp);
        if(l < 2)EVI_argc=0;
      }
      else EVI_argc=0;
    }
    else EVI_argc=0;
    if(EVI_argc > 1){
      strcpy(CurrentDirFile,cp);
      strcpy(CurrentFile,FileInPath(cp));
      PostMessage(hWnd,WM_COMMAND,IDM_OPEN_NOW,0);
    }
    else PostMessage(hWnd,WM_COMMAND,IDM_OPEN,0);
  }
  while(GetMessage(&msg,NULL,0,0)) {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return hWnd;
}

static LONG WINAPI OpenGLMainWndProc(HWND hWnd,UINT uMsg,
                                 WPARAM wParam,LPARAM lParam){
 long lRet=1;
 RECT rc;
 switch (uMsg) {
 case WM_CREATE:
     hTBWnd = CreateToolbarEx(
        hWnd,
        WS_CHILD | WS_VISIBLE | !WS_BORDER | TBSTYLE_TOOLTIPS,
        0,
        NOTOOLBARIMAGES,
        glInstance,
        SFXVIEW_IDBM,
        tbb,
        NTOOLBARBUTTONS,
        16,15,
        16,15,
        sizeof(TBBUTTON)
       );
   GetClientRect(hTBWnd,&rc); ToolbarHeight=rc.bottom;
   GetClientRect(hWnd,&rc);
   glWnd = CreateWindow(
      szCldName,
      NULL,
      gdwStyle,
      rc.left,
      rc.top+ToolbarHeight,
      rc.right,
      rc.bottom,
      hWnd,
      (HMENU)1,
      glInstance,
      NULL);
   SendMessage(hTBWnd,TB_CHECKBUTTON,IDM_MAPS,
               (LPARAM)MAKELONG(Mapped,0));
   SendMessage(hTBWnd,TB_CHECKBUTTON,IDM_ACCELERATE,
               (LPARAM)MAKELONG(FALSE,0));
   break;
 case WM_SIZE:
   if(hTBWnd != NULL)SendMessage(hTBWnd,uMsg,wParam,lParam);
   SetWindowPos(glWnd,NULL,
                0,ToolbarHeight,
                LOWORD(lParam),HIWORD(lParam)-ToolbarHeight,
                SWP_NOZORDER);
   break;
   case WM_NOTIFY:
     switch (((LPNMHDR)lParam)->code){
       case TTN_NEEDTEXT:{
           int idButton;
           LPTOOLTIPTEXT lpttt;
           lpttt=(LPTOOLTIPTEXT)lParam;
           lpttt->hinst=glInstance;
           idButton=lpttt->hdr.idFrom;
           switch(idButton){
             case IDM_OPEN:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_1); break;
             case IDM_ZOOM_IN:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_2); break;
             case IDM_RESET_VIEW:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_3); break;
             case IDM_ZOOM_OUT:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_4); break;
             case IDM_ABOUT:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_5); break;
             case IDM_WIREFRAME:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_6); break;
             case IDM_MAPS:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_7); break;
             case IDM_PLAY:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_8); break;
             case IDM_ACCELERATE:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_9); break;
             case IDM_BACKGROUND:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_A); break;
             case IDM_FOG:
               lpttt->lpszText=MAKEINTRESOURCE(IDI_TIP_B); break;
           }
         }
         break;
       default: break;
     }
     return (DefWindowProc(hWnd,uMsg,wParam,lParam));
 case WM_SYSCOMMAND:
   switch(LOWORD(wParam & 0xfff0)) {
   case SC_CLOSE:
     PostMessage(hWnd,WM_COMMAND,IDM_EXIT,0);
     break;
   default:
     return( DefWindowProc(hWnd,uMsg,wParam,lParam));
     break;
   }
   break;
 case WM_TIMER:
   if(AnimationTimer == 1){
     round_angle += 2.0;
     if(round_angle > 180.0)round_angle -= 360;
     SetScrollPos(glWnd,SB_HORZ,(int)round_angle,TRUE);
     InvalidateRect(glWnd, NULL, FALSE);
   }
   break;
 case WM_COMMAND:
   GluCommands(LOWORD(wParam),hWnd);
   break;
 default:
   lRet = DefWindowProc (hWnd, uMsg, wParam, lParam);
   break;
 }
 return lRet;
}

static LONG WINAPI OpenGLWndProc(HWND hWnd,UINT uMsg,
                                 WPARAM wParam,LPARAM lParam){
  GLfloat old;
  int i,iPos,iMax,iMin,dn,dx,dy;
  LONG    lRet = 1;
  static BOOL flag=FALSE;
  static int mx,my;
  static RECT rc;
  switch (uMsg) {
  case WM_CREATE:{
      HDC hDC;
      hDC = GetDC(hWnd);
      bSetupPixelFormat(hDC);
      hRC = wglCreateContext( hDC );
      wglMakeCurrent( hDC, hRC );
      SetScrollRange(hWnd, SB_VERT, -89,89,TRUE);
      SetScrollRange(hWnd, SB_HORZ, -180,180,TRUE);
      SetScrollPos(hWnd,SB_HORZ,0,TRUE);
      SetScrollPos(hWnd,SB_VERT,0,TRUE);
      up_angle=0.0; round_angle=0.0;
      initialize(hWnd);
    }
    break;
  case WM_DESTROY:{
      HGLRC  hRC;
      HDC    hDC;
      hRC = wglGetCurrentContext();
      hDC = wglGetCurrentDC();
      wglMakeCurrent(NULL, NULL);
      if (hRC != NULL)wglDeleteContext(hRC);
      if (hDC != NULL)ReleaseDC(hWnd, hDC);
      glWnd=NULL;
      FreeObject();
    }
    break;
  case WM_PAINT:{
      HDC hDC;
      PAINTSTRUCT  ps;
      hDC = BeginPaint(hWnd, &ps);
      drawScene(hWnd,TRUE);
      EndPaint(hWnd, &ps);
    }
    break;
  case WM_SIZE:
    resize(hWnd);
    break;
   case WM_VSCROLL:
    GetScrollRange(hWnd, SB_VERT, &iMin, &iMax);
    iPos = GetScrollPos(hWnd, SB_VERT);
    switch (LOWORD(wParam)) {
    case SB_ENDSCROLL:
      dn=0; scrolling=FALSE;
      InvalidateRect(hWnd, NULL, FALSE);
      flag=FALSE;
      break;
    case SB_LINEDOWN:      dn =  1;    break;
    case SB_LINEUP:        dn = -1;    break;
    case SB_PAGEDOWN:      dn =  5;    break;
    case SB_PAGEUP:        dn = -5;    break;
    case SB_THUMBTRACK:    scrolling=TRUE;
    case SB_THUMBPOSITION: dn = (int)(short)HIWORD(wParam)-iPos;    break;
    default:               dn = 0;
    }
    if ((dn = BOUND (iPos + dn, iMin, iMax) - iPos) != 0) {
      SetScrollPos(hWnd, SB_VERT, iPos + dn, TRUE);
      old=up_angle;
      up_angle=(GLfloat)(iPos+dn);
      if (old != up_angle) {
        if (!flag)InvalidateRect(hWnd, NULL, FALSE);
      }
    }
    break;
  case WM_HSCROLL:
    GetScrollRange(hWnd, SB_HORZ, &iMin, &iMax);
    iPos = GetScrollPos(hWnd, SB_HORZ);
    switch (LOWORD(wParam)) {
    case SB_ENDSCROLL:
      dn=0; scrolling=FALSE;
      InvalidateRect(hWnd, NULL, FALSE);
      flag=FALSE;
      break;
    case SB_LINEDOWN:      dn =  1;     break;
    case SB_LINEUP:        dn = -1;     break;
    case SB_PAGEDOWN:      dn =  5;     break;
    case SB_PAGEUP:        dn = -5;     break;
    case SB_THUMBTRACK:    scrolling=TRUE;
    case SB_THUMBPOSITION: dn = (int)(short)HIWORD(wParam) - iPos; break;
    default:               dn = 0;
    }
    if ((dn = BOUND (iPos + dn, iMin, iMax) - iPos) != 0) {
      SetScrollPos(hWnd, SB_HORZ, iPos + dn, TRUE);
      old=round_angle;
      round_angle=(GLfloat)(iPos+dn);
      if (old != round_angle) {
        if (!flag)InvalidateRect(hWnd, NULL, FALSE);
      }
    }
    break;
 case WM_LBUTTONDOWN:
   SetCapture(hWnd);
   mx=(int)LOWORD(lParam);
   my=(int)HIWORD(lParam);
   if((GetAsyncKeyState(VK_SHIFT) & 0x8000) == 0x8000)bZoomMode=TRUE;
   GetWindowRect(hWnd,&rc);
//   ClipCursor(&rc);
   bCaptured=TRUE;
   break;
 case WM_MOUSEMOVE:{
     double dx,dy;
     if(!bCaptured)break;
     if(AnimationTimer > 0)break;
     mx=(short)LOWORD(lParam)-mx;
     my=(short)HIWORD(lParam)-my;
     if(bZoomMode){
       double s;
       if(mx > 0){
//         s=max(1,min(50,mx));
//         draw_scale=draw_scale+(double)s/95.0;
         ObjScale *= 1.05;
         if (ObjScale > 1024.0)ObjScale = 1024.0;
       }
       else{
//         s=max(1,min(50,abs(mx)));
//         draw_scale=draw_scale-(double)s/95.0;
//         if(draw_scale < 0.1)draw_scale=0.1;
         ObjScale *= 0.95;
         if (ObjScale < 0.0625)ObjScale = 0.0625;
       }
//       Make3dListS();
     }
     else{
       dx=(double)mx/(double)(rc.right-rc.left);
       dy=(double)my/(double)(rc.bottom-rc.top);
       round_angle += dx * 360;
       if(round_angle >  180.0)round_angle -= 360.0;
       if(round_angle < -180.0)round_angle += 360.0;
       up_angle += dy * 180;
     }
     InvalidateRect(hWnd,NULL,FALSE);
     mx=(short)LOWORD(lParam);
     my=(short)HIWORD(lParam);
   }
   break;
 case WM_LBUTTONUP:
//   ClipCursor(NULL);
   bCaptured=FALSE;
   bZoomMode=FALSE;
   ReleaseCapture();
   if(wireframe)InvalidateRect(hWnd,NULL,FALSE);
   break;
  case WM_QUERYNEWPALETTE:
    if (ghPalette != NULL) {
      HDC     hDC;
      hDC = GetDC(hWnd);
      ghpalOld = SelectPalette(hDC, ghPalette, FALSE);
      RealizePalette(hDC);
      InvalidateRect(hWnd, NULL, TRUE);
      UpdateWindow(hWnd);
      if (ghpalOld != NULL)SelectPalette(hDC, ghpalOld, FALSE);
      ReleaseDC(hWnd, hDC);
      return TRUE;
    }
    return FALSE;
  case WM_PALETTECHANGED:{
      HDC         hDC;
      if (ghPalette != NULL) {
        if (wParam != (WPARAM)hWnd) {
          hDC = GetDC(hWnd);
          ghpalOld = SelectPalette(hDC, ghPalette, FALSE);
          RealizePalette(hDC);
          UpdateColors(hDC);
          if (ghpalOld != NULL)SelectPalette(hDC, ghpalOld, FALSE);
          ReleaseDC(hWnd, hDC);
        }
      }
    }
    break;
  default:
    lRet = DefWindowProc (hWnd, uMsg, wParam, lParam);
    break;
  }
  return lRet;
}

BOOL CALLBACK AboutDlgProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam){
 switch( msg ) {
   case WM_INITDIALOG:
     return( TRUE );
   case WM_COMMAND:
      if( wparam == IDOK ) {
        EndDialog( hwnd, TRUE );
        return( TRUE );
      }
      break;
 }
 return( FALSE );
}

static int identify_file_format(char *filename){
 char cf[256];
 int ff=FI_SFX;
 strcpy(cf,filename);
 if     (strstr(CurrentFile,".3DS") || strstr(CurrentFile,".3ds"))ff=FI_3DS;
 else if(strstr(CurrentFile,".MFX") || strstr(CurrentFile,".mfx"))ff=FI_SFX;
 return ff;
}

static void GluCommands(WORD cmd,HWND hWnd){
  DLGPROC dlgprc;
  int i;
  OPENFILENAME ofn;
  char szTitle[60]="Object to View",szFilter[128];
  switch (cmd) {
  case IDM_OPEN:
    CurrentDirFile[0]='\0'; CurrentFile[0]='\0';
    GetCurrentDirectory(sizeof(CurrentDirectory),CurrentDirectory);
    strcpy(szFilter,
           "All file formats|*.mfx;*.3ds|"
           "3D Studio Models|*.3ds|"
           "OpenFX Models|*.mfx|"
          );
    i=0; while(szFilter[i] != '\0') {
      if (szFilter[i] == '|')szFilter[i]='\0';
      i++;
    }
    memset(&ofn,0,sizeof(OPENFILENAME));
    ofn.lStructSize=sizeof(OPENFILENAME);
    ofn.hwndOwner=hWnd;
    ofn.lpstrFilter=szFilter;
    ofn.nFilterIndex=0;
    ofn.lpstrFile=CurrentDirFile;   /* will contain file + path */
    ofn.nMaxFile=sizeof(CurrentDirFile);
    ofn.lpstrFileTitle=CurrentFile;  /* file name only */
    ofn.nMaxFileTitle=sizeof(CurrentFile);
    ofn.lpstrInitialDir=CurrentDirectory;
    ofn.lpstrTitle=szTitle;
    ofn.Flags=OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST;
    if (GetOpenFileName(&ofn)) { /* load the LW object and make display LIST */
      int fid;
      LOADIT:
      FreeObject();
      fid=identify_file_format(CurrentDirFile);
      if(fid == FI_3DS)Load3dsObject(CurrentDirFile);
      else             LoadSfxObject(CurrentDirFile);
      ListAdjFaces();
      FixUpOrientation();
      SendMessage(hWnd,WM_SETTEXT,0,(LPARAM)CurrentFile);
//      Make3dListS();
      InvalidateRect(glWnd,NULL,FALSE);
    }
    break;
  case IDM_OPEN_NOW:
    goto LOADIT;
  case IDM_EXIT:
    PostQuitMessage(0);
    break;
  case IDM_ZOOM_IN:
    ObjScale *= 1.25;
    if (ObjScale > 1024.0)ObjScale = 1024.0;
//    Make3dListS();
    InvalidateRect(glWnd,NULL,FALSE);
    break;
  case IDM_ZOOM_OUT:
    ObjScale *= 0.75;
    if (ObjScale < 0.0625)ObjScale = 0.0625;
//    Make3dListS();
    InvalidateRect(glWnd,NULL,FALSE);
    break;
  case IDM_RESET_VIEW:
    ObjScale = 1.0;
    draw_scale = 1.0;
    SetScrollPos(glWnd,SB_HORZ,0,TRUE);
    SetScrollPos(glWnd,SB_VERT,0,TRUE);
    up_angle=0.0; round_angle=0.0;
//    Make3dListS();
    InvalidateRect(glWnd,NULL,FALSE);
    break;
  case IDM_WIREFRAME:
    wireframe ^= 1;
    break;
  case IDM_ACCELERATE:
    break;
  case IDM_MAPS:
    Mapped ^= 1;
//    Make3dListS();
    InvalidateRect(glWnd,NULL,FALSE);
    break;
  case IDM_BACKGROUND:
    LightBackground ^= 1;
    if(LightBackground){
      gbRed=LgbRed; gbGreen=LgbGreen; gbBlue=LgbBlue;
    }
    else{
      gbRed=DgbRed; gbGreen=DgbGreen; gbBlue=DgbBlue;
    }
    glClearColor(gbRed,gbGreen,gbBlue,1.0);
    InvalidateRect(glWnd,NULL,FALSE);
    break;
  case IDM_FOG:
    ffog ^= 1;
    if(ffog){
      GLfloat fc[4]={0.0,0.0,0.0,1.0};
      fc[0]=gbRed; fc[1]=gbGreen; fc[2]=gbBlue;
      glFogfv(GL_FOG_COLOR,fc);
      glFogf(GL_FOG_START,4.0);
      glFogf(GL_FOG_END,6.5);
      glFogi(GL_FOG_MODE,GL_LINEAR);
//      glFogi(GL_FOG_MODE,GL_EXP);
//      glFogf(GL_FOG_DENSITY,0.1);
      glEnable(GL_FOG);
    }
    else{
      glDisable(GL_FOG);
    }
    InvalidateRect(glWnd,NULL,FALSE);
    break;
  case IDM_PLAY:
    if(AnimationTimer > 0){
      KillTimer(hWnd,AnimationTimer);
      AnimationTimer=0;
      for(i=0;i<NTOOLBARBUTTONS;i++){
        if(tbb[i].idCommand != IDM_PLAY)SendMessage(hTBWnd,
        TB_ENABLEBUTTON,(WPARAM)tbb[i].idCommand,(LPARAM)MAKELONG(TRUE,0));
      }
    }
    else{
      AnimationTimer=SetTimer(hWnd,1,30,NULL);
//      AnimationTimer=SetTimer(hWnd,1,1,NULL);
      for(i=0;i<NTOOLBARBUTTONS;i++){
        if(tbb[i].idCommand != IDM_PLAY)SendMessage(hTBWnd,
        TB_ENABLEBUTTON,(WPARAM)tbb[i].idCommand,(LPARAM)MAKELONG(FALSE,0));
      }
    }
    break;
  case IDM_ABOUT:
    DialogBox(glInstance,MAKEINTRESOURCE(IDD_ABOUT),hWnd,AboutDlgProc);
    break;
  default:
    break;
  }
}

static unsigned char threeto8[8] = {
  0, 0111>>1, 0222>>1, 0333>>1, 0444>>1, 0555>>1, 0666>>1, 0377
};

static unsigned char twoto8[4] = {
  0, 0x55, 0xaa, 0xff
};

static unsigned char oneto8[2] = {
  0, 255
};

static int defaultOverride[13] = {
  0, 3, 24, 27, 64, 67, 88, 173, 181, 236, 247, 164, 91
};

static PALETTEENTRY defaultPalEntry[20] = {
  { 0,   0,   0,    0 },
  { 0x80,0,   0,    0 },
  { 0,   0x80,0,    0 },
  { 0x80,0x80,0,    0 },
  { 0,   0,   0x80, 0 },
  { 0x80,0,   0x80, 0 },
  { 0,   0x80,0x80, 0 },
  { 0xC0,0xC0,0xC0, 0 },

  { 192, 220, 192,  0 },
  { 166, 202, 240,  0 },
  { 255, 251, 240,  0 },
  { 160, 160, 164,  0 },

  { 0x80,0x80,0x80, 0 },
  { 0xFF,0,   0,    0 },
  { 0,   0xFF,0,    0 },
  { 0xFF,0xFF,0,    0 },
  { 0,   0,   0xFF, 0 },
  { 0xFF,0,   0xFF, 0 },
  { 0,   0xFF,0xFF, 0 },
  { 0xFF,0xFF,0xFF, 0 }
};

static unsigned char ComponentFromIndex(int i, UINT nbits, UINT shift){
  unsigned char val;
  val = (unsigned char) (i >> shift);
  switch (nbits) {
  case 1:
    val &= 0x1;
    return oneto8[val];
  case 2:
    val &= 0x3;
    return twoto8[val];
  case 3:
    val &= 0x7;
    return threeto8[val];
  default:
    return 0;
  }
}

static void CreateRGBPalette(HDC hDC){
  PIXELFORMATDESCRIPTOR pfd;
  LOGPALETTE *pPal;
  int n, i;
  n = GetPixelFormat(hDC);
  DescribePixelFormat(hDC, n, sizeof(PIXELFORMATDESCRIPTOR), &pfd);
  if (pfd.dwFlags & PFD_NEED_PALETTE) {
    n = 1 << pfd.cColorBits;
    pPal = (PLOGPALETTE)LocalAlloc(LMEM_FIXED, sizeof(LOGPALETTE) +
                                   n * sizeof(PALETTEENTRY));
    pPal->palVersion = 0x300;
    pPal->palNumEntries = n;
    for (i=0; i<n; i++) {
      pPal->palPalEntry[i].peRed = ComponentFromIndex(i, pfd.cRedBits, pfd.cRedShift);
      pPal->palPalEntry[i].peGreen = ComponentFromIndex(i, pfd.cGreenBits, pfd.cGreenShift);
      pPal->palPalEntry[i].peBlue = ComponentFromIndex(i, pfd.cBlueBits, pfd.cBlueShift);
      pPal->palPalEntry[i].peFlags = 0;
    }
    if((pfd.cColorBits == 8)                           &&
       (pfd.cRedBits   == 3) && (pfd.cRedShift   == 0) &&
       (pfd.cGreenBits == 3) && (pfd.cGreenShift == 3) &&
       (pfd.cBlueBits  == 2) && (pfd.cBlueShift  == 6)) {
      for(i = 1 ; i <= 12 ; i++)
        pPal->palPalEntry[defaultOverride[i]] = defaultPalEntry[i];
    }
    ghPalette = CreatePalette(pPal);
    LocalFree(pPal);
    ghpalOld = SelectPalette(hDC, ghPalette, FALSE);
    n = RealizePalette(hDC);
  }
}

static BOOL bSetupPixelFormat(HDC hDC){
  static PIXELFORMATDESCRIPTOR pfd = {
    sizeof(PIXELFORMATDESCRIPTOR),    // size of this pfd
      1,                              // version number
      PFD_DRAW_TO_WINDOW |            // support window
      PFD_SUPPORT_OPENGL |            // support OpenGL
      PFD_DOUBLEBUFFER,               // double buffered
      PFD_TYPE_RGBA,                  // RGBA type
      24,                             // 24-bit color depth
      0, 0, 0, 0, 0, 0,               // color bits ignored
      0,                              // no alpha buffer
      0,                              // shift bit ignored
      0,                              // no accumulation buffer
      0, 0, 0, 0,                     // accum bits ignored
      32,                             // 32-bit z-buffer
      0,                              // no stencil buffer
      0,                              // no auxiliary buffer
      PFD_MAIN_PLANE,                 // main layer
      0,                              // reserved
      0, 0, 0                         // layer masks ignored
      };
  int pixelformat;
  if ( (pixelformat = ChoosePixelFormat(hDC, &pfd)) == 0 ) {
    MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK);
    return FALSE;
  }
  if (SetPixelFormat(hDC, pixelformat, &pfd) == FALSE) {
    MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK);
    return FALSE;
  }
  CreateRGBPalette(hDC);
  return TRUE;
}

static GLvoid initialize(HWND hWnd){
  GLfloat   aspect;
  GLfloat d[]={1.0,1.0,1.0,1.0};
  GLfloat a[]={0.1,0.1,0.1,1.0};
  GLfloat s[]={1.0,1.0,1.0,1.0};
  GLfloat p[]={0.0,0.0,1.0,1.0};  /* (x,y,z,w  w=1 => positional light */

//{char tp[256]; unsigned char temp;
//glGetBooleanv(GL_AUX_BUFFERS,&temp);
//sprintf(tp,"Buffers %ld",(long)temp); MessageBox(NULL,tp,"Buffers",MB_OK);}
//  glDrawBuffer(GL_AUX0);
//  glClearColor(1.0,0.0,0.0,1.0);
//  glClear(GL_COLOR_BUFFER_BIT);
//  glDrawBuffer(GL_FRONT);

  GetClientRect(hWnd, &oldrect);
  glClearColor(gbRed,gbGreen,gbBlue,1.0);
  glMatrixMode(GL_PROJECTION);
  aspect = (GLfloat) oldrect.right / oldrect.bottom;
  gluPerspective( 45.0, aspect, near_plane, far_plane);
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  glClearDepth(1.0);
  glEnable(GL_DEPTH_TEST);
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_TRUE);
//  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_FALSE);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0,GL_DIFFUSE,d);
  glLightfv(GL_LIGHT0,GL_AMBIENT,a);
  glLightfv(GL_LIGHT0,GL_SPECULAR,s);
  glLightfv(GL_LIGHT0,GL_POSITION,p);
  glLightf(GL_LIGHT0,GL_LINEAR_ATTENUATION,0.15);
  glLightf(GL_LIGHT0,GL_QUADRATIC_ATTENUATION,0.05);
  glColorMaterial(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE);
  makeCheckeredImageMap();
}

static GLvoid drawScene(HWND hWnd,BOOL shaded){
 HDC hDC;
 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

// glReadBuffer(GL_AUX0);
// glCopyPixels(0,0,200,200,GL_COLOR);
// glClear(GL_DEPTH_BUFFER_BIT);

 if(smooth_shading)glShadeModel(GL_SMOOTH);
 else              glShadeModel(GL_FLAT);
// glShadeModel(GL_FLAT);

 glPushMatrix();
 glLoadIdentity();
 glTranslatef(0.0, 0.0, -5.0);
 glRotatef(up_angle,1.0,0.0,0.0);
 glRotatef(round_angle+180.0,0.0,1.0,0.0);
 glScalef(draw_scale, draw_scale, draw_scale);
 if((scrolling && wireframe) ||
    (bCaptured && wireframe))DrawWireFrame();
else {// else if(listID > 0){
   glEnable(GL_LIGHTING);
//   glCallList(listID);
   Make3dListS();
   glDisable(GL_LIGHTING);
 }
 glPopMatrix();
 glFinish();
 hDC = wglGetCurrentDC();
 SwapBuffers(hDC);
}

static GLvoid resize(HWND hWnd){
  GLfloat aspect;
  RECT  rect;
  GetClientRect(hWnd, &rect);
  glViewport(0, 0, rect.right, rect.bottom);
  if ((oldrect.right > rect.right) || (oldrect.bottom > rect.bottom))
    PostMessage (hWnd, WM_PAINT, 0, 0L);
  oldrect.right = rect.right;
  oldrect.bottom = rect.bottom;
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  aspect = (GLfloat) oldrect.right / oldrect.bottom;
  gluPerspective( 45.0, aspect, near_plane, far_plane);
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
}

void makeCheckeredImageMap(void){
 GLfloat parameter3[]={GL_SPHERE_MAP};
 int i, j, c;
 for (i = 0; i < checkImageWidth; i++) {
   for (j = 0; j < checkImageHeight; j++) {
     c = ((((i&0x8)==0)^((j&0x8))==0))*255;
     checkImage[i][j][0] = (GLubyte) c;
     checkImage[i][j][1] = (GLubyte) c;
     checkImage[i][j][2] = (GLubyte) c;
   }
 }
 glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
 glPixelStorei(GL_PACK_ALIGNMENT,1);
 glTexImage2D(GL_TEXTURE_2D, 0, 3, checkImageWidth,
              checkImageHeight, 0, GL_RGB, GL_UNSIGNED_BYTE,
              &checkImage[0][0][0]);
 glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
 glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
 if(ffastmapping){
   glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
   glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
   glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_FASTEST);
 }
 else{
   glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
   glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
   glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
 }
// glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
 /* to give good lighting conditions for maps */
 glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
// glTexGenfv(GL_S,GL_SPHERE_MAP,0);
// glTexGenfv(GL_T,GL_SPHERE_MAP,0);
 glTexGenfv(GL_S,GL_TEXTURE_GEN_MODE,parameter3);
 glTexGenfv(GL_T,GL_TEXTURE_GEN_MODE,parameter3);
}

static PSTR FileInPath(PSTR pstrPath){
 PSTR pstr;
 pstr = pstrPath + strlen(pstrPath);
 while (pstr > pstrPath) {
     pstr = (AnsiPrev(pstrPath, pstr));
     if (*pstr == '\\' || *pstr == ':' || *pstr == '/') {
         pstr = (AnsiNext(pstr));
         break;
     }
 }
 return pstr;
}

void TryCurrentDirect(char *name){
 char gszHomeDir[256],temp[256];
 GetModuleFileName(glInstance,gszHomeDir,MAX_DIR);
 *FileInPath(gszHomeDir) = '\0';
 strcpy(temp,gszHomeDir);
 strcat(temp,FileInPath(name));
 strcpy(name,temp);
}

static BOOL WriteRegistryItem(char *keyname, char *keyvalue){
 HKEY hkey;
 DWORD result;
 if(RegCreateKeyEx(HKEY_CLASSES_ROOT,keyname,0,NULL,REG_OPTION_NON_VOLATILE,
                   KEY_ALL_ACCESS,NULL,&hkey,&result) != ERROR_SUCCESS)
   return FALSE;
 if     (result == REG_CREATED_NEW_KEY    ){;}
 else if(result == REG_OPENED_EXISTING_KEY){;}
 else                                      {;}
 if(keyvalue != NULL){
   if(RegSetValueEx(hkey,NULL,0,REG_SZ,(CONST BYTE *)keyvalue,strlen(keyvalue)+1)
     != ERROR_SUCCESS)return FALSE;
 }
 RegCloseKey(hkey);
 return TRUE;
}

static void Register(HINSTANCE hInstance){
 char gszHomeDir[256],temp[512];
 HKEY hkey;
 DWORD result;
 return;
 if(RegCreateKeyEx(HKEY_CLASSES_ROOT,"ofxview",0,NULL,REG_OPTION_NON_VOLATILE,
                   KEY_ALL_ACCESS,NULL,&hkey,&result) != ERROR_SUCCESS)
   return;
 RegCloseKey(hkey);
 if(result == REG_CREATED_NEW_KEY){
   LoadString(hInstance,IDS_MESSAGE,temp,511);
   LoadString(hInstance,IDS_TITLE,gszHomeDir,255);
   MessageBox(NULL,temp,gszHomeDir,MB_OK|MB_ICONINFORMATION);
 }
 else return;
 GetModuleFileName(hInstance,gszHomeDir,MAX_DIR);
 if(!WriteRegistryItem(".mfx","mfxfile"))return;
 if(!WriteRegistryItem("mfxfile","OpenFX Model"))return;
 if(!WriteRegistryItem("mfxfile\\DefaultIcon",gszHomeDir))return;
 if(!WriteRegistryItem("mfxfile\\Extensions\\MFX","OpenFX Model File"))return;
 sprintf(temp,"%s %%1",gszHomeDir);
 if(!WriteRegistryItem("mfxfile\\shell\\open\\command",temp))return;
//#if 0
 {HRESULT hres;
  IShellLink* psl;
  CoInitialize(NULL);
  hres = CoCreateInstance(&CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
                          &IID_IShellLink, &psl);
  if(SUCCEEDED(hres)){
    IPersistFile *ppf;
    hres=psl->lpVtbl->QueryInterface(psl,&IID_IPersistFile,&ppf);
    if(SUCCEEDED(hres)){
      WORD wsz[MAX_PATH];
      psl->lpVtbl->SetPath(psl,"c:\\openfx\\ofxview.exe");
      if(!SUCCEEDED(hres))MessageBox(NULL,"Bad path",NULL,MB_OK);
      psl->lpVtbl->SetDescription(psl,"Shortcut to OpenFX-View");
      if(!SUCCEEDED(hres))MessageBox(NULL,"Bad desc",NULL,MB_OK);
      MultiByteToWideChar(CP_ACP,0,"c:\\win95\\desktop\\OpenGL Model display.LNK",-1,wsz,MAX_PATH);
      ppf->lpVtbl->Save(ppf,wsz,TRUE);
      if(!SUCCEEDED(hres))MessageBox(NULL,"Bad save",NULL,MB_OK);
      ppf->lpVtbl->Release(ppf);
    }
    psl->lpVtbl->Release(psl);
  }
  CoUninitialize();
 }
//#endif
 return;
}
