/* sfxview.h */

#define MAXUNIT 1073741824L

typedef GLfloat vector[3];
typedef long    twoLongs[2];
typedef long    point[3];

typedef struct tagVERTEX {
 long p[3];
 int  gp,nf,*flist;
 GLfloat x,y;
} VERTEX;

typedef struct tagFACE {
 long V[3],A[3],next;
 char vid,start;
 unsigned char color[3],matcol[3],texture,brush,axis;
} FACE;

typedef struct tagMAP {
        vector n,p,x,y;
        char filename[128],frefl[128],fbump[128];
        short image,irefl,ibump;           /* map     PLANE / CYL         */
        short map          ;               /* image   YES if loaded       */
        short method,moziac;               /* method  anim/still          */
        short pp,rp,bp;                    /* map percent                 */
        double angle;                      /* angle   CLY type maps only  */
        double pd,rd;
} MAP;

typedef struct tagWIREFRAME {
 long Np,Ne;
 twoLongs *e;
 point *p;
} WFRAME;

typedef GLfloat normal[3];

#ifndef min
#define min(a,b)  ( ((a) < (b)) ? (a) : (b) )
#endif
#ifndef max
#define max(a,b)  ( ((a) > (b)) ? (a) : (b) )
#endif

#define EVI_Malloc(s)    LocalAlloc(LMEM_FIXED,s)
#define EVI_Free(p)      LocalFree((HLOCAL)p)
#define EVI_Realloc(p,s) LocalReAlloc((HLOCAL)p,s,LMEM_MOVEABLE)

#define BOUND(x,min,max) ((x) < (min) ? (min) : ((x) > (max) ? (max) : (x)))
#define VECSUB(a,b,c)   { c[0]=a[0]-b[0]; c[1]=a[1]-b[1]; c[2]=a[2]-b[2];}
#define VECSUM(a,b,c)   { c[0]=a[0]+b[0]; c[1]=a[1]+b[1]; c[2]=a[2]+b[2];}
#define VECSCALE(a,b,c) { c[0]=(a)*b[0]; c[1]=(a)*b[1]; c[2]=(a)*b[2];}
#define VECCOPY(a,c)    { c[0]=a[0]; c[1]=a[1]; c[2]=a[2];}
#define DOT(a,b)        ( (a[0]*b[0]) + (a[1]*b[1]) + (a[2]*b[2]) )
#define CROSS(v1,v2,r)  { \
                          r[0] = (v1[1]*v2[2]) - (v2[1]*v1[2]);  \
                          r[1] = (v1[2]*v2[0]) - (v1[0]*v2[2]);  \
                          r[2] = (v1[0]*v2[1]) - (v2[0]*v1[1]);  \
                        }

#define checkImageWidth 64
#define checkImageHeight 64

#define YES       1
#define NO        0
